/* Created: 03.17.04 17:04:44
**
**
*/
package dbridge;

/*
 * Created: 19.03.04
 * Modified 21.03.04
 * Modified 23.12.06
 */

import java.util.*;
import java.text.DateFormat;
import java.io.File;
import java.lang.RuntimeException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import javax.xml.parsers.ParserConfigurationException;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import java.io.IOException;
import org.w3c.dom.DOMException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import javax.swing.JOptionPane;


public class Backuper {

  public Backuper() {
   try {
    DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
    DocumentBuilder docBuilder = dbFactory.newDocumentBuilder();
    document = docBuilder.newDocument();
   } catch (ParserConfigurationException pce) {
      //pce.printStackTrace();
      System.out.println("error in Backuper0");
      throw new RuntimeException("Can not configure XML parser: "+
                                  pce.getMessage());
   }
  }

  public Backuper(String fileName) {
   try {
    DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
    DocumentBuilder docBuilder = dbFactory.newDocumentBuilder();
    document = docBuilder.parse(new File (fileName));
   } catch (ParserConfigurationException pce) {
     System.out.println("error in Backuper1");
      throw new RuntimeException("Can not configure XML parser: "+
                                  pce.getMessage());
   } catch (SAXParseException spe) {
  // Error generated by the parser
     System.out.println("error in Backuper2");
     throw new RuntimeException("Parsing error:"+
                 ", line " + spe.getLineNumber()+ ", uri " + spe.getSystemId());
   }  catch (SAXException sxe) {
    // Error generated during parsing
     throw new RuntimeException("Parsing error:"+sxe.getMessage());
   } catch (IOException ioe) {
     System.out.println("error in Backuper3");
     ioe.printStackTrace();
     throw new RuntimeException("File I/O error:"+ioe.getMessage());
   }
  }

//
  private Node findSubNode(String name, Node node) {
    if (node.getNodeType() != Node.ELEMENT_NODE) {
      System.err.println("Error: Search node not of element type");
      System.exit(22);
    }

    if (! node.hasChildNodes()) return null;

    NodeList list = node.getChildNodes();
    for (int i=0; i < list.getLength(); i++) {
      Node subnode = list.item(i);
      if (subnode.getNodeType() == Node.ELEMENT_NODE) {
        if (subnode.getNodeName() == name) return subnode;
      }
    }
    return null;
  }

  private String getText(Node node) {
    StringBuffer result = new StringBuffer();
    if (! node.hasChildNodes()) return "";

    NodeList list = node.getChildNodes();
    for (int i=0; i < list.getLength(); i++) {
      Node subnode = list.item(i);
      if (subnode.getNodeType() == Node.TEXT_NODE) {
        result.append(subnode.getNodeValue());
      }
      else if (subnode.getNodeType() ==
          Node.CDATA_SECTION_NODE)
      {
        result.append(subnode.getNodeValue());
      }
      else if (subnode.getNodeType() ==
          Node.ENTITY_REFERENCE_NODE)
      {
        // Recurse into the subtree for text
        // (and ignore comments)
        result.append(getText(subnode));
      }
    }
    return result.toString();
  }
//---------------------------------------------

  private String getRoot(String pathFromFile) {
    String[] parsedPath = pathFromFile.split("[\\x2f\\x5c]");
    String restoredPath=parsedPath[0];
    for (int tokenCount=1;tokenCount<parsedPath.length-2;++tokenCount) {
      restoredPath = restoredPath + File.separator + parsedPath[tokenCount];
    }
    restoredPath = restoredPath + File.separator;
    return restoredPath;
  }
//------------------------------------------------------------------------------

  private Element makeDcmServerElement (dsDcmServerClass dcmServer) {
    Element child;
    Element server = document.createElement("DcmServer");

    child = document.createElement("Name");
    child.appendChild(document.createTextNode(dcmServer.getDcmServer()));
    child.normalize();
    server.appendChild(child);

    child = document.createElement("DcmPort");
    child.appendChild(document.createTextNode(dcmServer.getDcmPort()));
    child.normalize();
    server.appendChild(child);

    child = document.createElement("DcmAeTitle");
    child.appendChild(document.createTextNode(dcmServer.getDcmAeTitle()));
    child.normalize();
    server.appendChild(child);

    child = document.createElement("Comments");
    child.appendChild(document.createTextNode(dcmServer.getComments()));
    child.normalize();
    server.appendChild(child);

    server.normalize();
    return server;
  }
//------------------------------------------------------------------------------
  private Element makeMailServerElement (dbMailRecord cMail) {

    Element child;

    Element mailServer = document.createElement("MailServer");

    child = document.createElement("Mail");
    child.appendChild(document.createTextNode(cMail.getMail()));
    mailServer.appendChild(child);

    child = document.createElement("Domain");
    child.appendChild(document.createTextNode(cMail.getDomain()));
    mailServer.appendChild(child);

    child = document.createElement("Comments");
    child.appendChild(document.createTextNode(cMail.getComments()));
    mailServer.appendChild(child);

    child = document.createElement("TimeDelay");
    child.appendChild(
            document.createTextNode(Integer.toString(cMail.getTimeDelay())));
    mailServer.appendChild(child);

    child = document.createElement("Password");
    child.appendChild(document.createTextNode(cMail.getPassword()));
    mailServer.appendChild(child);

    child = document.createElement("PubKeyN");
    child.appendChild(document.createTextNode(cMail.getPubKeyN()));
    mailServer.appendChild(child);

    child = document.createElement("Port");
    child.appendChild(
            document.createTextNode(Integer.toString(cMail.getPort())));
    mailServer.appendChild(child);

    child = document.createElement("Protocol");
    if (cMail.isImap())
     child.appendChild(document.createTextNode("IMAP"));
    else
     child.appendChild(document.createTextNode("POP3"));
    mailServer.appendChild(child);

    child = document.createElement("SSLFlag");
    child.appendChild(document.createTextNode(Boolean.toString(cMail.isSSL())));
    mailServer.appendChild(child);

    child = document.createElement("SrvIndex");
    child.appendChild(
            document.createTextNode(Integer.toString(cMail.getSrvIndex())));
    mailServer.appendChild(child);

    child = document.createElement("MethodDN");
    child.appendChild(
		document.createTextNode(Integer.toString(cMail.getMethodDN())));
    mailServer.appendChild(child);

    child = document.createElement("MethodPGPSign");
    child.appendChild(
		document.createTextNode(Integer.toString(cMail.getMethodPGPSign())));
    mailServer.appendChild(child);

    child = document.createElement("PrivateKeyID");
    child.appendChild(
		document.createTextNode(cMail.getPrivKeyID()));
    mailServer.appendChild(child);

    mailServer.normalize();
    return mailServer;
  }
//------------------------------------------------------------------------------

  private dsDcmServerClass restoreDcmServer(Node cServer) {
   dsDcmServerClass dcmServer = new dsDcmServerClass(
                                     getText(findSubNode("Name",cServer)),
                                     getText(findSubNode("DcmPort",cServer)),
                                     getText(findSubNode("DcmAeTitle",cServer)),
                                     getText(findSubNode("Comments",cServer)));
    return dcmServer;
  }
//------------------------------------------------------------------------------
  private dbMailRecord restoreMailRecord(Node cMailRec) {
    dbMailRecord restoredRec = new dbMailRecord(
              getText(findSubNode("Mail",cMailRec)),
              getText(findSubNode("Domain",cMailRec)),
              getText(findSubNode("Comments",cMailRec)),
              getText(findSubNode("Password",cMailRec)),
              Integer.parseInt(getText(findSubNode("TimeDelay",cMailRec))));

    restoredRec.setPubKeyN(getText(findSubNode("PubKeyN",cMailRec)));
    restoredRec.setSrvInd(
                  Integer.parseInt(getText(findSubNode("SrvIndex",cMailRec))));

    Node methodDN = findSubNode("MethodDN",cMailRec);
    if (methodDN==null){
      restoredRec.setMethodDN(DBridgeClient.Bank().getBox().getMethodDN());
    }else{
      restoredRec.setMethodDN(
		  Integer.parseInt(getText(methodDN)));
    }

    Node methodSign = findSubNode("MethodPGPSign",cMailRec);
    if (methodSign==null){
      restoredRec.setMethodPGPSign(DBridgeClient.Bank().getBox().getMethodSign());
    }else{
      restoredRec.setMethodPGPSign(
		  Integer.parseInt(getText(methodSign)));
    }

    Node privKeyID = findSubNode("PrivateKeyID",cMailRec);
    if (privKeyID==null){
      restoredRec.setPrivKeyID("");
    }else{
      restoredRec.setPrivKeyID((getText(privKeyID)));
    }


    boolean bSSLFlag =
     (Boolean.valueOf(getText(findSubNode("SSLFlag",cMailRec)))).booleanValue();
    String protocol =  getText(findSubNode("Protocol",cMailRec));
    int port = Integer.parseInt(getText(findSubNode("Port",cMailRec)));

    if (protocol.equalsIgnoreCase("IMAP"))
      restoredRec.setToImap(port);
    else
      restoredRec.setToPop3(port);

    if (bSSLFlag) restoredRec.setToSSL(port);

    return restoredRec;
  }
//------------------------------------------------------------------------------
  private dbUser restoreUser(Node cUser) {
   dbUser restoredUser = new dbUser();
   restoredUser.setName(getText(findSubNode("Name",cUser)));
   restoredUser.setLogin(getText(findSubNode("Login",cUser)));
   restoredUser.setPassword(getText(findSubNode("Password",cUser)));
   restoredUser.setID(Integer.parseInt(getText(findSubNode("ID",cUser))));
   restoredUser.setKeyId(Integer.parseInt(getText(findSubNode("KeyID",cUser))));
   restoredUser.setSmtp(getText(findSubNode("Smtp",cUser)));

   //Restore SMTP table
   dbSmtpTable restoredSmtpTable = new dbSmtpTable();
   Node cSmtpTable = findSubNode("SmtpTable",cUser);
   for(int recCount=0;
           recCount<cSmtpTable.getChildNodes().getLength(); ++recCount){
     Node cSmtpRec = cSmtpTable.getChildNodes().item(recCount);
     dbSmtpRecord restoredRec = new dbSmtpRecord(
                                   getText(findSubNode("Name",cSmtpRec)),
                                   getText(findSubNode("Login",cSmtpRec)),
                                   getText(findSubNode("Password",cSmtpRec)),
                                   getText(findSubNode("Comments",cSmtpRec))
     );

     Node reply_node = findSubNode("ReplyTo",cSmtpRec);
     if (reply_node==null){
    	 restoredRec.setReplayTo("");
     }else{
    	 restoredRec.setReplayTo(getText(findSubNode("ReplyTo",cSmtpRec)));
     }

     restoredRec.setPort(
                   Integer.parseInt(getText(findSubNode("Port",cSmtpRec))));
     restoredRec.setSSL((
     Boolean.valueOf(getText(findSubNode("SSLFlag",cSmtpRec)))).booleanValue());
     restoredSmtpTable.append(restoredRec);
   }
   restoredUser.setSmtpTable(restoredSmtpTable);
   //-------------------
   restoredUser.setSmtpDefaultN(
                  Integer.parseInt(getText(findSubNode("SmtpDefaultN",cUser))));

   //Restore DCM server
   Node cServer = findSubNode("DcmServer",cUser);
   dsDcmServerClass dcmServer = restoreDcmServer(cServer);
   restoredUser.setDefDCMsrv(dcmServer);
   //-------------------
   //Restore Mail table
   Node cMailTable = findSubNode("MailTable",cUser);
   dbMailTable restoredMailTable = new dbMailTable();
   for(int recCount=0;
           recCount<cMailTable.getChildNodes().getLength(); ++recCount) {
     Node cMailRec = cMailTable.getChildNodes().item(recCount);
     dbMailRecord restoredRec = restoreMailRecord(cMailRec);
     restoredMailTable.append(restoredRec);
   }
   restoredUser.setMailTable(restoredMailTable);
   //-------------------
   //Restore AddressBook
   Node cAddrBook = findSubNode("AddressBook",cUser);
   dbMailTable restoredAddrBook = new dbMailTable();

   for(int recCount=0;
           recCount<cAddrBook.getChildNodes().getLength(); ++recCount) {
     Node cMailRec = cAddrBook.getChildNodes().item(recCount);
     dbMailRecord restoredRec = restoreMailRecord(cMailRec);
     restoredAddrBook.append(restoredRec);
   }

   restoredUser.setAddressBook(restoredAddrBook);
   //-------------------

   String pathFromFile = getText(findSubNode("LocDir",cUser));
   if ((pathFromFile!=null)&&(pathFromFile.length()!=0))
    restoredUser.createDir(getRoot(pathFromFile));

   // --- Restore KeyTable here (changed by Bob) ----
   Node keys_node = findSubNode("KeyFields",cUser);
   if (keys_node != null){
	   Vector keys = restoredUser.getGpgKeys();
	   for(int recCount=0;
       recCount<keys_node.getChildNodes().getLength(); ++recCount){
		   Node curr_key = keys_node.getChildNodes().item(recCount);


		   String key_id = getText(findSubNode("Key_ID",curr_key));
		   String passwd = getText(findSubNode("Passwd",curr_key));
		   keys.add(new KeyPasswd(key_id, passwd.toCharArray()));
	   }

   }

   restoredUser.setAutoDCMSendFlag(
       (Boolean.valueOf(
                getText(findSubNode("AutoDCMSendFlag",cUser)))).booleanValue());
   restoredUser.setLeaveFileFlag(
       (Boolean.valueOf(
                  getText(findSubNode("LeaveFileFlag",cUser)))).booleanValue());
   return restoredUser;
  }
//------------------------------------------------------------------------------

  public void writeServerXMLBackup(Vector Servers, String fileName) {
    //Document document;
    Element server;
    //Element child;

   Locale currentLocale = Locale.getDefault();
   DateFormat dateFormatter =
         DateFormat.getDateInstance(DateFormat.DEFAULT, currentLocale);
   String currentDate = dateFormatter.format(new Date());

   try {
    Element root = (Element) document.createElement("ServersDB");
    // store the actual version of the dbBank
    root.setAttribute("version",
          Integer.toString(DBridgeClient.Bank().getDBVersion().getDataBaseN()));
    root.setAttribute("date",currentDate);

    Iterator serverIt = Servers.iterator();
    while (serverIt.hasNext()) {
      dsDcmServerClass cServer = (dsDcmServerClass)serverIt.next();
      server = makeDcmServerElement(cServer);
      root.appendChild(server);
    }
    root.normalize();
    document.appendChild(root);
    document.normalize();
        //Save XML file:
    Transformer transformer = TransformerFactory.newInstance().newTransformer();
    transformer.transform( new DOMSource(document),
                           new StreamResult(new File(fileName)));
   } catch (DOMException de) {
     //de.printStackTrace();
      throw new RuntimeException("Can not create XML Document: "+de.getMessage());
   } catch (TransformerConfigurationException e) {
     //System.out.println("There's a Transformer Config Excpt");
      throw new RuntimeException("Can not save XML Document: "+e.getMessage());
   } catch (TransformerException e) {
    //System.out.println("There is a Transformer Exception");
      throw new RuntimeException("Can not save XML Document: "+e.getMessage());
   }
  }
//------------------------------------------------------------------------------

  public Vector restoreServerXMLBackup() {
    //Document document;
    Element root;
    Node cServer;

    Vector result = new Vector();

   try {
    root = document.getDocumentElement();
    //Check version and show warning if does not match.
    //TODO: Localization!!!
    int savedVersion = Integer.parseInt(root.getAttribute("version"));
    //System.out.println ("Version: " + savedVersion);
    if (savedVersion != DBridgeClient.Bank().getDBVersion().getDataBaseN()) {
      JOptionPane.showMessageDialog(null,
        "Version of DBridge database does not match the version of saved database.\n" +
        "Probably some fields will not be filled.",
        "Warning!!!",
        JOptionPane.WARNING_MESSAGE);
    }
    for (int serverCount=0;
             serverCount<root.getChildNodes().getLength(); ++serverCount) {
      cServer = root.getChildNodes().item(serverCount);
      dsDcmServerClass dcmServer = restoreDcmServer(cServer);
      result.addElement(dcmServer);
    }

   } catch (DOMException de) {
     //de.printStackTrace();
      throw new RuntimeException("Invalid XML Document: " + de.getMessage());
   }
   return result;
  }
//------------------------------------------------------------------------------

  public Vector restoreUserXMLBackup() {
    //Document document;
    Element root;
    Node cUser;
    Vector result = new Vector();

   try {
     root = document.getDocumentElement();

     int savedVersion = Integer.parseInt(root.getAttribute("version"));
     if (savedVersion != DBridgeClient.Bank().getDBVersion().getDataBaseN()) {
       JOptionPane.showMessageDialog(null,
                                     "Warning: Version of the current DBridge database does not match the version of the saved database.\n" +
                                     "Probably some fields will not be filled out by restoring the database. \n" +
                                     "Stored version Nr: " + savedVersion + ". Current Version Nr: "+DBridgeClient.Bank().getDBVersion().getDataBaseN(),
                                     "Warning!",
                                     JOptionPane.WARNING_MESSAGE);
     } //end if

     for (int userCount = 0; userCount < root.getChildNodes().getLength();
          ++userCount) {
       cUser = root.getChildNodes().item(userCount);
       dbUser restoredUser = restoreUser(cUser);
       result.addElement(restoredUser);
     }//end for
   } catch (DOMException de) {
      //de.printStackTrace();
      throw new RuntimeException("Invalid XML Document: " + de.getMessage());
   }
   return result;
  }
//------------------------------------------------------------------------------
  public UserContainer restoreUserContainerXMLBackup() { //String fileName
    //Document document;
    Element root;
    Node cUser;
    UserContainer result = new UserContainer();

   try {
    root = document.getDocumentElement();

    for (int userCount=0;
             userCount<root.getChildNodes().getLength(); ++userCount) {
      cUser = root.getChildNodes().item(userCount);
      dbUser restoredUser = restoreUser(cUser);
      result.append(restoredUser);
    }
   } catch (DOMException de) {
      //de.printStackTrace();
      throw new RuntimeException("Invalid XML Document: " + de.getMessage());
   }
   return result;
  }
//------------------------------------------------------------------------------
  public void writeUserXMLBackup(Vector Users, String fileName) {

    //Document document;
    Element user;
    Element child;
    Element child1;
    Element child2;

   Locale currentLocale = Locale.getDefault();
   DateFormat dateFormatter =
         DateFormat.getDateInstance(DateFormat.DEFAULT, currentLocale);
   String currentDate = dateFormatter.format(new Date());

   try {
    Element root = (Element) document.createElement("UsersDB");
    root.setAttribute("version",
         Integer.toString(DBridgeClient.Bank().getDBVersion().getDataBaseN()) );
    root.setAttribute("date",currentDate);

    Iterator userIt = Users.iterator();
    while (userIt.hasNext()) {
      user = document.createElement("user");
      dbUser cUser = (dbUser)userIt.next();
      child = document.createElement("Name");
      child.appendChild(document.createTextNode(cUser.getName()));
      user.appendChild(child);

      child = document.createElement("Login");
      child.appendChild(document.createTextNode(cUser.getLogin()));
      user.appendChild(child);

      child = document.createElement("Password");
      child.appendChild(document.createTextNode(cUser.getPassword()));
      user.appendChild(child);

      child = document.createElement("ID");
      child.appendChild(document.createTextNode(
                                   Integer.toString(cUser.getID())));
      user.appendChild(child);

      child = document.createElement("KeyID");
      child.appendChild(document.createTextNode(
                                   Integer.toString(cUser.getKeyId())));
      user.appendChild(child);

      child = document.createElement("Port");
      child.appendChild(document.createTextNode("8000"));
      user.appendChild(child);

      child = document.createElement("KeyN");
      child.appendChild(document.createTextNode(cUser.getKeyN()));
      user.appendChild(child);

      child = document.createElement("AETitle");
      child.appendChild(document.createTextNode("Unknown_AE"));
      user.appendChild(child);

      child = document.createElement("Smtp");
      child.appendChild(document.createTextNode(cUser.getSmtp()));
      user.appendChild(child);

      ///////////////////////////////
      child = document.createElement("SmtpTable");

      //loop over all entries in SMTPTable
      dbSmtpTable tableSmtp = cUser.getSmtpTable();
      for (int smtpCount=0;smtpCount<tableSmtp.getSize();++smtpCount) {
        dbSmtpRecord cSmtp = tableSmtp.getRecord(smtpCount);

        child1 = document.createElement("SmtpServer");

        child2 = document.createElement("Name");
        child2.appendChild(document.createTextNode(cSmtp.getIP()));
        child1.appendChild(child2);

        child2 = document.createElement("Login");
        child2.appendChild(document.createTextNode(cSmtp.getLogin()));
        child1.appendChild(child2);

        child2 = document.createElement("Password");
        child2.appendChild(document.createTextNode(cSmtp.getPassword()));
        child1.appendChild(child2);

        child2 = document.createElement("Port");
        child2.appendChild(document.createTextNode(
                                      Integer.toString(cSmtp.getPort())));
        child1.appendChild(child2);

        child2 = document.createElement("SSLFlag");
        child2.appendChild(document.createTextNode(
                                      Boolean.toString(cSmtp.isSSL())));
        child1.appendChild(child2);

        child2 = document.createElement("Comments");
        child2.appendChild(document.createTextNode(cSmtp.getComments()));
        child1.appendChild(child2);

        child2 = document.createElement("ReplyTo");
        child2.appendChild(document.createTextNode(cSmtp.getReplayTo()));
        child1.appendChild(child2);

        child.normalize();
        child.appendChild(child1);
        //end of loop over all entries in SMTPTable
      }
      user.appendChild(child);
      //////////////////////////////////////////

      child = document.createElement("SmtpDefaultN");
      child.appendChild(document.createTextNode(
                                   Integer.toString(cUser.getSmtpDefaultN())));
      user.appendChild(child);

      child = makeDcmServerElement(cUser.getDefDCMsrv());
      user.appendChild(child);

      child = document.createElement("MailTable");
      //loop over all entries in MailTable
      dbMailTable tableMail = cUser.getMailTable();
      for (int mailCount=0;mailCount<tableMail.getSize();++mailCount) {
        dbMailRecord cMail = tableMail.getRecord(mailCount);
        child1 = makeMailServerElement(cMail);
        child.appendChild(child1);
        child.normalize();
        //end of loop over all entries in MailTable
      }
      user.appendChild(child);

      child = document.createElement("AddressBook");
      //loop over all entries in AddressBook
      dbMailTable addrBook = cUser.getAddressBook();
      for (int addrCount=0;addrCount<addrBook.getSize();++addrCount) {
        dbMailRecord cMail = addrBook.getRecord(addrCount);

        child1 = makeMailServerElement(cMail);
        child.appendChild(child1);
        child.normalize();
        //end of loop over all entries in AddressBook
      }
      user.appendChild(child);
      //////////////////////////////////////////

      child = document.createElement("LocDir");
      child.appendChild(document.createTextNode(cUser.getLocDirPath()));
      user.appendChild(child);

      child = document.createElement("ExtDir");
      child.appendChild(document.createTextNode(cUser.getExtDirPath()));
      user.appendChild(child);

      child = document.createElement("DecryptedDir");
      child.appendChild(document.createTextNode(cUser.getDecryptedDirPath()));
      user.appendChild(child);

      child = document.createElement("WaitDir");
      child.appendChild(document.createTextNode(cUser.getWaitDirPath()));
      user.appendChild(child);

      child = document.createElement("ArchivDir");
      child.appendChild(document.createTextNode(cUser.getArchiveDirPath()));
      user.appendChild(child);

      child = document.createElement("field1");
      user.appendChild(child);

      child = document.createElement("field2");
      user.appendChild(child);

      child = document.createElement("field3");
      user.appendChild(child);


      //--- Save KeyTable here (changed by Bob) ----
      child = document.createElement("KeyFields");
      Vector keys = cUser.getGpgKeys();
      for (Iterator it = keys.iterator(); it.hasNext();){

    	  KeyPasswd curr = (KeyPasswd) it.next();
    	  child1 = document.createElement("Key");

    	  child2 = document.createElement("Key_ID");
    	  child2.appendChild(document.createTextNode(curr.get_keyID()));
    	  child1.appendChild(child2);
    	  child2 = document.createElement("Passwd");
    	  child2.appendChild(document.createTextNode( new String(curr.get_passwd())));
    	  child1.appendChild(child2);

    	  child.normalize();
    	  child.appendChild(child1);
      }
      user.appendChild(child);




      child = document.createElement("AutoDCMSendFlag");
      child.appendChild(document.createTextNode(
                                Boolean.toString(cUser.getAutoDCMSendFlag())));
      user.appendChild(child);

      child = document.createElement("LeaveFileFlag");
      child.appendChild(document.createTextNode(
                                Boolean.toString(cUser.getLeaveFileFlag())));
      user.appendChild(child);
      user.normalize();
      root.appendChild(user);
    }
    root.normalize();
    document.appendChild(root);
    document.normalize();
        //Save XML file:
    Transformer transformer = TransformerFactory.newInstance().newTransformer();
    transformer.transform( new DOMSource(document),
                           new StreamResult(new File(fileName)));

   } catch (DOMException de) {
      //de.printStackTrace();
      throw new RuntimeException("Can not create XML Document: "+de.getMessage());
   } catch (TransformerConfigurationException e) {
      //System.out.println("There's a Transformer Config Excpt");
      throw new RuntimeException("Can not save XML Document: "+e.getMessage());
   } catch (TransformerException e) {
      //System.out.println("There is a Transformer Exception");
      throw new RuntimeException("Can not save XML Document: "+e.getMessage());
   }
  }

//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
 private Document document;
}
