package dbridge;

import java.io.*;
import javax.mail.*;
import javax.mail.internet.*;
import javax.activation.*;
/**
 *
 * <p>Title: dbridge</p>
 *
 * <p>Description: </p>
 * Make multipart signed message and encrypt it.
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class CEncapsulatedMessageBuilder extends CSignedMessageBuilder {

    public CEncapsulatedMessageBuilder(String sComments, String sxTag,
                                                   String sPublicKey) {
      super(sComments, sxTag, sPublicKey);
    }

    private void ApplyGPG(MimeBodyPart mbpPlainPart, String sFileName)
    throws MessagingException,IOException,wrapperException {
      ByteArrayOutputStream outStream = new ByteArrayOutputStream();
      mbpPlainPart.writeTo(outStream);
      String[] sPublicKeys = {mPublicKey};
      GpgWrapper.encrypt(outStream, sPublicKeys, sFileName);
    }

    protected MimeMultipart BuildMimePgpMultipart(MimeBodyPart mbpPart,
                                                  String sFileNameGpg)
    throws MessagingException,IOException,wrapperException {

      String sFileNameSignedGpg = BridgeApp.getRoot() + FileTools.makeUniqName()
                                  + "." + DBConsts.ASC_TMP_EXT;
      //
      // PGP:
      MimeMultipart signedMultipart = super.BuildMimePgpMultipart(mbpPart,
                                                            sFileNameSignedGpg);
      MimeBodyPart tmpPart = MakeTempBodyPart(signedMultipart);
      ApplyGPG(tmpPart, sFileNameGpg);

      MimeBodyPart mbpPartWithoutFile = new MimeBodyPart();
      mbpPartWithoutFile.setText("Version: 1\n");
      mbpPartWithoutFile.setHeader("Content-Type", "application/pgp-encrypted");

      MimeBodyPart mbpPartWithFile = new MimeBodyPart();
      File dataFile = new File(sFileNameGpg);
      FileDataSource fdsData = new FileDataSource(dataFile);
      mbpPartWithFile.setDataHandler(new DataHandler(fdsData));

      MimeMultipart mpRoot = new MimeMultipart(
                        "encrypted;\n\tprotocol=\"application/pgp-encrypted\"");
      mpRoot.addBodyPart(mbpPartWithoutFile);
      mpRoot.addBodyPart(mbpPartWithFile);

      mFilesToDel.add(sFileNameSignedGpg);

      return mpRoot;
    }

}
