package dbridge;

import java.io.*;
import javax.mail.*;
import javax.mail.internet.*;
import javax.activation.*;

public class CEncryptedMessageBuilder extends CBaseMessageBuilder {
    public CEncryptedMessageBuilder(String sComments, String sxTag,
                                                      String sPublicKey) {
      super(sComments, sxTag, sPublicKey);
    }
/**
  "PlainPart" here means "unencrypted part" 
*/
    protected void ApplyGPG(MimeBodyPart mbpPlainPart, String sFileName) 
    throws MessagingException,IOException,wrapperException {
      
      ByteArrayOutputStream outStream = new ByteArrayOutputStream();
      mbpPlainPart.writeTo(outStream);
      String[] sPublicKeys = {mPublicKey};
      GpgWrapper.encrypt(outStream, sPublicKeys, sFileName);
    }

    protected MimeMultipart BuildMimePgpMultipart(MimeBodyPart mbpPart,
                                                  String sFileNameGpg) 
     throws MessagingException,IOException,wrapperException {
      // PGP:
      ApplyGPG(mbpPart,sFileNameGpg);

      MimeBodyPart mbpPartWithoutFile = new MimeBodyPart();
      mbpPartWithoutFile.setText("Version: 1\n");
      mbpPartWithoutFile.setHeader("Content-Type", "application/pgp-encrypted");

      MimeBodyPart mbpPartWithFile = new MimeBodyPart();
      File dataFile = new File(sFileNameGpg);
      FileDataSource fdsData = new FileDataSource(dataFile);
      mbpPartWithFile.setDataHandler(new DataHandler(fdsData));

      MimeMultipart mpRoot = new MimeMultipart(
                        "encrypted;\n\tprotocol=\"application/pgp-encrypted\"");
      mpRoot.addBodyPart(mbpPartWithoutFile);
      mpRoot.addBodyPart(mbpPartWithFile);

        return mpRoot;
    }
}
