package dbridge;

import javax.net.ssl.*;

import java.io.IOException;
import java.net.InetAddress;
import java.net.Socket;

import javax.net.SocketFactory;
import javax.net.ssl.SSLSocketFactory;

public class CMySSLSocketFactory extends SSLSocketFactory {
  private SSLSocketFactory factory;

  public CMySSLSocketFactory() {
//    System.out.println( "SSLSocketFactory: CMySocketFactory instantiated");
    //BridgeApp.Log.println( "SSLSocketFactory: CMySocketFactory instantiated");
    try {
      SSLContext sslcontext = SSLContext.getInstance("TLSv1","SunJSSE");
      sslcontext.init( null,
                       new TrustManager[] { new CMyTrustManager()},
                       new java.security.SecureRandom());
      factory = ( SSLSocketFactory) sslcontext.getSocketFactory();

    } catch( Exception ex) {
      ex.printStackTrace();
    }
  }

  public static SocketFactory getDefault() {
//    System.out.println( "SSLSocketFactory: CMySocketFactory.getDefault()");
    //BridgeApp.Log.println( "SSLSocketFactory: CMySocketFactory.getDefault()");
    return new CMySSLSocketFactory();
  }

  public Socket createSocket( Socket socket, String s, int i, boolean flag)
      throws IOException {
//    System.out.println( "SSLSocketFactory: CMySocketFactory.createSocket()");
    //BridgeApp.Log.println( "SSLSocketFactory: CMySocketFactory.createSocket()");
    return factory.createSocket( socket, s, i, flag);
  }

  public Socket createSocket( InetAddress inaddr, int i,
                              InetAddress inaddr1, int j) throws IOException {
//    System.out.println( "SSLSocketFactory: CMySocketFactory.createSocket()");
    //BridgeApp.Log.println( "SSLSocketFactory: CMySocketFactory.createSocket()");
    return factory.createSocket( inaddr, i, inaddr1, j);
  }

  public Socket createSocket( InetAddress inaddr, int i)
      throws IOException {
//    System.out.println( "SSLSocketFactory: CMySocketFactory.createSocket()");
    //BridgeApp.Log.println( "SSLSocketFactory: CMySocketFactory.createSocket()");
    return factory.createSocket( inaddr, i);
  }

  public Socket createSocket( String s, int i, InetAddress inaddr, int j)
      throws IOException {
//    System.out.println( "SSLSocketFactory: CMySocketFactory.createSocket()");
    //BridgeApp.Log.println( "SSLSocketFactory: CMySocketFactory.createSocket()");
    return factory.createSocket( s, i, inaddr, j);
  }

  public Socket createSocket( String s, int i) throws IOException {
//    System.out.println( "SSLSocketFactory: CMySocketFactory.createSocket()");
    //BridgeApp.Log.println( "SSLSocketFactory: CMySocketFactory.createSocket()");
    return factory.createSocket( s, i);
  }

  public String[] getDefaultCipherSuites() {
//    System.out.println( "SSLSocketFactory: CMySocketFactory.getDefaultCipherSuites()");
    //BridgeApp.Log.println( "SSLSocketFactory: CMySocketFactory.getDefaultCipherSuites()");
    return factory.getSupportedCipherSuites();
  }

  public String[] getSupportedCipherSuites() {
//    System.out.println( "SSLSocketFactory: CMySocketFactory.getSupportedCipherSuites()");
    //BridgeApp.Log.println( "SSLSocketFactory: CMySocketFactory.getSupportedCipherSuites()");
    return factory.getSupportedCipherSuites();
  }
}
