package dbridge;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.*;
//import java.text.*;
//import java.io.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

/*
 * Created: 23.01.04
 * Modified 25.01.04
 */

class CServices
{
  public CServices()
  {
    mDcmStore = new dcmStore();
    mDcmStore.setDaemon(true);
    mDcmStore.setProgram(DBridgeServer.Bank().getBox().getCmd());
    mDcmService = new CDcmSendService(DBridgeServer.Bank());
    mSmtpService = new CSmtpSendService(DBridgeServer.Bank());
    // TODO removed from parameters 15.12.06: DBridgeServer.Bank());
    mMailCheckService = new CMailCheckService();
    mDecryptService = new CDecryptService(DBridgeServer.Bank());
    // TODO removed from parameters 16.12.06: DBridgeServer.Bank());
    mCommonSchedulerService=new CCommonSchedulerService();
  }
  /*
  *  Daemons methods
  */
  public void startDaemons(){
    mDcmStore.start();
  }

   public void stopDaemons(){
    mDcmStore.kill();     // kill dcm server
  }
  //
  // Services methods
  //
  public void startServices()
  {
    UserContainer oUserContainer = DBridgeServer.Bank().getUserContainer();
    Vector vAutoUsers = oUserContainer.getAutoUserList();
    for (int i=0; i<vAutoUsers.size(); i++)
    {
      StartAutoSmtpSend( oUserContainer.getUser( (String)vAutoUsers.get(i) ) );
    }
    Vector vManualUsers = oUserContainer.getManualUserList();
    for (int i=0; i<vManualUsers.size(); i++)
    {
      dbUser l_User = oUserContainer.getUser( (String)vManualUsers.get(i) );
      StartAutoMailCheck(l_User);
      StartAutoDecrypt(l_User); //BOB 30.12.2003

      if (l_User.getAutoDCMSendFlag()) //BOB 30.12.2003
        StartAutoDicomSend(l_User);    //BOB 30.12.2003
    }
    StartGarbageCollector();
  }
  public void stopServices()
  {
    mDcmService.RemoveAllTasks();
    mSmtpService.RemoveAllTasks();
    mMailCheckService.RemoveAllTasks();
    mDecryptService.RemoveAllTasks();
    mCommonSchedulerService.RemoveAllTasks();
  }
  public void startUserServices(dbUser oUser)
  {
    if (oUser.isAutomatic())
    {
      StartAutoSmtpSend(oUser);
    }
    else
    {
      StartAutoMailCheck(oUser);
      StartAutoDecrypt(oUser); //BOB 30.12.2003
    }
  }
  public void stopUserServices(dbUser oUser)
  {
    StopAutoSmtpSend(oUser);
    StopAutoDicomSend(oUser);
    StopAutoDecrypt(oUser);
    StopAutoMailCheck(oUser);
  }
  public void restartUserServices(dbUser oUser)
  {
    if (IsAutoDecrypt(oUser))
    {
      StopAutoDecrypt(oUser);
      StartAutoDecrypt(oUser);
    }
    if (IsAutoDicomSend(oUser))
    {
      StopAutoDicomSend(oUser);
      StartAutoDicomSend(oUser);
    }
    if (IsAutoSmtpSend(oUser))
    {
      StopAutoSmtpSend(oUser);
      StartAutoSmtpSend(oUser);
    }
    if (IsAutoMailCheck(oUser))
    {
      StopAutoMailCheck(oUser);
      StartAutoMailCheck(oUser);
    }
  }

  public void StartAutoDicomSend( dbUser oUser)
  {
    mDcmService.AddUserTask(oUser);
  }
  public boolean IsAutoDicomSend(dbUser oUser)
  {
    return mDcmService.HasUserTask(oUser);
  }
  public void StopAutoDicomSend( dbUser oUser)
  {
    mDcmService.RemoveUserTask(oUser);
  }
  public void StartAutoSmtpSend( dbUser oUser)
  {
    mSmtpService.AddUserTask(oUser);
  }
  public boolean IsAutoSmtpSend(dbUser oUser)
  {
    return mSmtpService.HasUserTask(oUser);
  }
  public void StopAutoSmtpSend( dbUser oUser)
  {
    mSmtpService.RemoveUserTask(oUser);
  }
  public void StartAutoMailCheck( dbUser oUser)
  {
    mMailCheckService.AddUserTask(oUser);
  }
  public boolean IsAutoMailCheck(dbUser oUser)
  {
    return mMailCheckService.HasUserTask(oUser);
  }
  public void StopAutoMailCheck( dbUser oUser)
  {
    mMailCheckService.RemoveUserTask(oUser);
  }
  public void StartAutoDecrypt( dbUser oUser)
  {
    mDecryptService.AddUserTask(oUser);
  }
  public boolean IsAutoDecrypt(dbUser oUser)
  {
    return mDecryptService.HasUserTask(oUser);
  }
  public void StopAutoDecrypt( dbUser oUser)
  {
    mDecryptService.RemoveUserTask(oUser);
  }

  ////////////////////////////////////////////////////////////////////////
  // Garbage collector  methods
  ////////////////////////////////////////////////////////////////////////
  public void StartGarbageCollector()
  {
  	//
  	// Prepare task
  	//
  	dbBox oBankBox=DBridgeServer.Bank().getBox();
	
	Vector vExtensions=new Vector(3);
	vExtensions.add(DBConsts.DECRYPT_TMP_EXT);
	vExtensions.add(DBConsts.ASC_TMP_EXT);
	vExtensions.add(DBConsts.BUILD_TMP_EXT);
	Vector vDirs=new Vector(5);
	vDirs.add(DBConsts.ARCHIVE_DIR);
	vDirs.add(DBConsts.DECRYPTED_DIR);
	vDirs.add(DBConsts.EXT_DIR);
	vDirs.add(DBConsts.LOC_DIR);
	vDirs.add(DBConsts.WAIT_DIR);
	double dTimeoutHours = DBConsts.GARBAGE_BAD_FILE_DIR_TIMEOUT;
	
	CGarbageCollectorTask oTask = new CGarbageCollectorTask(oBankBox.getTmpDir(), 
							vDirs, dTimeoutHours, vExtensions );
  	
	//
	// Calculate start time
	//
	String sTimeForBegin= DBConsts.GARBAGE_START_TIME;
	DateFormat oDateFormat=new SimpleDateFormat("hh:mm");
	Calendar calNow=new GregorianCalendar(), calFromSettings=new GregorianCalendar();
	Date oStartTime=null;
	if ( DBConsts.GARBAGE_RUN_AT_INIT==1 ){
		oStartTime=calNow.getTime();
	} else {
	  Date dateFromSettings = new Date();
			try {
				dateFromSettings = oDateFormat.parse(sTimeForBegin);
			} catch (Exception e) {
				System.out.println(e);
			}

			calNow.setTime(new Date());
			calFromSettings.setTime(dateFromSettings);
			calFromSettings.set(Calendar.YEAR, calNow.get(Calendar.YEAR));
			calFromSettings.set(Calendar.MONTH, calNow.get(Calendar.MONTH));
			calFromSettings.set(Calendar.DAY_OF_MONTH, calNow
					.get(Calendar.DAY_OF_MONTH));
			if (calFromSettings.getTimeInMillis() < calNow.getTimeInMillis()) {
				calFromSettings.add(Calendar.DAY_OF_MONTH, 1);
			}
			oStartTime = calFromSettings.getTime();
	}
	
	//
	// Calculate period in milis
	//
	long nPeriodMillis = DBConsts.GARBAGE_REPEAT_PERIOD * 60 * 60 * 1000;
	
	//
	// Schedule task for execution
	//
	CCommonSchedulerService oSrvc=new CCommonSchedulerService();
	oSrvc.AddNamedTask(CServices.GARBAGE_COLLECOR_TASK, oTask, oStartTime, nPeriodMillis);
  }
  public void StopGarbageCollector()
  {
  	mCommonSchedulerService.RemoveNamedTask(CServices.GARBAGE_COLLECOR_TASK);
  }

  //////////////////////////////////////////////////////////////////////
  // Class members
  //////////////////////////////////////////////////////////////////////
  
  private dcmStore mDcmStore;                  // Dicom server daemon
  private CDcmSendService mDcmService;         // Dicom send service
  private CSmtpSendService mSmtpService;       // Smtp send service
  private CMailCheckService mMailCheckService; // Mail check service
  private CDecryptService mDecryptService;     // Decrypt service
  
  private CCommonSchedulerService mCommonSchedulerService;     // Service with commonly sheduled tasks
  public static final String GARBAGE_COLLECOR_TASK="GARBAGE";
}
