package dbridge;

import java.io.*;
import javax.mail.*;
import javax.mail.internet.*;
import javax.activation.*;

public class CSignedMessageBuilder extends CBaseMessageBuilder {
    public CSignedMessageBuilder(String sComments, String sxTag,
                                                   String sPublicKey) {
      super(sComments, sxTag, sPublicKey);
    }

/**
  "PlainPart" here means "unencrypted part" 
*/
    private void ApplyGPG(MimeBodyPart mbpPlainPart, String sFileName) 
    throws MessagingException,IOException,wrapperException{
      ByteArrayOutputStream outStream = new ByteArrayOutputStream();
      mbpPlainPart.writeTo(outStream);
      GpgWrapper.noChangeSign(outStream, sFileName, mSecretKey, mPass, true);
    }

    protected MimeMultipart BuildMimePgpMultipart(MimeBodyPart mbpPart,
                                                  String sFileNameGpg) 
    throws MessagingException,IOException,wrapperException {
      //
      // PGP:
      ApplyGPG(mbpPart,sFileNameGpg);

      MimeBodyPart mbpPartWithFile = new MimeBodyPart();
      File dataFile = new File(sFileNameGpg);
      FileDataSource fdsData = new FileDataSource(dataFile);
      mbpPartWithFile.setDataHandler(new DataHandler(fdsData));
      mbpPartWithFile.setHeader("Content-Type", "application/pgp-signature");
      mbpPartWithFile.setDescription("OpenPGP digital signature");
      mbpPartWithFile.setFileName(sFileNameGpg);
      mbpPartWithFile.setDisposition(Part.ATTACHMENT);

      MimeMultipart mpRoot = new MimeMultipart(
       "signed;\n\tmicalg=pgp-sha1;\n\tprotocol=\"application/pgp-signature\"");
      mpRoot.addBodyPart(mbpPart);
      mpRoot.addBodyPart(mbpPartWithFile);

        return mpRoot;
    }

}
