/**
 * 
 */
package dbridge;

import javax.mail.internet.MimeMessage;

/**
 * @author bob
 * Sends Disposition Notification Reports
 */
public class CSmtpDNSender {
	
	private Sender mSender;

	/**
	 * @param args
	 */ 
	public CSmtpDNSender(String sFrom, String sTo, String sHost, String sLogin,
			String sPass, String sPort, boolean isSSL) {
		mSender = SenderFactory.newInstance();
		mSender.setFrom(sFrom);
		mSender.setTo(sTo);
		mSender.setHost(sHost);
		mSender.setUserName(sLogin);
		mSender.setPassword(sPass);
		mSender.setPort(sPort);
		mSender.setSSL(isSSL);
		mSender.setSubject("Notification Report");
	}

	/**
	 * @param args
	 */ 
	public void SendReport(String body, String recipient,
			String disposition_type, String sOrigMessID, 
			String sContentID, String sPubKey, int methodDN, boolean needMimePgp) {
		
		boolean isRFC = false;
		if (methodDN == DBConsts.MDN_RFC){isRFC = true;}
			
		CBaseMessageBuilder builder = new CEncryptedMessageBuilder("", "", sPubKey);
		MimeMessage msg = builder.BuildReportMessage(body, recipient,
				disposition_type, sOrigMessID, sContentID, isRFC, needMimePgp);
		try{
			mSender.connect();
			mSender.sendMail(msg);
			mSender.disconnect();
		}catch (Exception e){
	         BridgeApp.LogError(Logs.Srvcs.SetText("CSmtpDNSender: " + e));
		}
		
		builder.ClearResources();
	}
}
