package dbridge;

import javax.swing.JOptionPane;
import javax.swing.UIManager;
import java.awt.event.*;
import java.io.*;
import java.sql.SQLException;

import org.omg.CORBA.*;
import BridgeApp.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

/*
 * Created: 23.01.04
 * Modified 24.01.04
 * Modified 25.01.04
 * Modified  2.03.04
 */

public class DBridgeClient  extends BridgeApp
{
	ORB orb;
	String filename;
	BufferedReader br;
	String ior;
	org.omg.CORBA.Object obj;
	static bridge bridgeRef;
	static boolean mIsAdminGUIActivated;       // set the admin gui flag
	static int mCountUserGUIActivated;         // user gui counter
	private static dbLock mLock;

	public DBridgeClient(String args[])
	{
                this.setServerFlag(false);
		//
		// create the internal DB, read parameters
		// from ini file
		mBank=new dbBank("DBridge.ini");
                BridgeApp.setRoot(mBank.getBox().getTmpDir());   // 12.05.05
		BridgeApp.SetLogger(new Logger(new Integer(mBank.getBox().getLogLevel()),mBank.getBox().getLogDir(), "cli"));
		this.SetStatistician(new CStatistician(mBank.getBox().getLogDir()+"/"+"client_stats.csv"));
		DBridgeClient.setIsAdminGUIActivated(false);  // set the admin not registered
		mCountUserGUIActivated=0;
                // tmp solution 28.05.06
                this.setSplitterOn(mBank.getBox().isSplitterOn());
                this.setSplitterSize(mBank.getBox().getSplitterSize());

		// create and initialize the ORB
		try
		{
			orb = ORB.init(args, null);

			// Get the stringified object reference and destringify it.
			filename = "."+
			System.getProperty("file.separator")+"BridgeIOR";
			br = new BufferedReader(new FileReader(filename));
			ior = br.readLine();
			obj = orb.string_to_object(ior);

			bridgeRef = bridgeHelper.narrow(obj);
		} catch (Exception e) {
			System.out.println("ERROR : " + e) ;
			e.printStackTrace(System.out);
		}    
		
	}

	public static void main(String args[])
	{
        // check singletone 
    	dbLock appLock=new dbLock(".clilock");
    	appLock.setLockText("You have already run a DBridge Client copy\n"+
        		"In case of a deadlock, run a DBunlock application\n"+
        		"before running the client.");
        if ( ! appLock.setLock() ){
        	System.exit(1); // total exit
        };
        
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		}
		catch(Exception e) {
			e.printStackTrace();
		}

		new DBridgeClient(args);
		setLocker( appLock);
		try{

			// call the server object and print results
			String str = sendRequest("flash");
			System.out.println(str);

			// start gui
			Frame1 frame = new Frame1();
			//Validate frames that have preset sizes
			//Pack frames that have useful preferred size info, e.g. from their layout
			Door door = new Door(frame);
			frame.addWindowListener(new WindowAdapter(){
				public void windowClosing(WindowEvent e){
					//System.exit(0);
				}
			}
			);
			frame.getContentPane().add("Center", door);
			frame.pack();
			frame.setVisible(true);

		} catch (Exception e) {
			e.printStackTrace(System.out);
		}
	}
	
	
	public static String sendRequest(String str){
		return bridgeRef.sendRequest(str);
		//if you have no network...
		//     return "  ";
	}

	public static void setLocker(dbLock lock){ mLock=lock;}
	// deleteLock is called from Door and XServices
	public static void deleteLock(){ mLock.deleteLock();}
	
	public static dbBank Bank() { return mBank; }
	//public static CServices Services() { return mServices; }

	public static void setIsAdminGUIActivated(boolean flag){
		mIsAdminGUIActivated=flag;
	}
	public static boolean getIsAdminGUIActivated(){
		return mIsAdminGUIActivated;
	}

	public static void setIsUserGUIActivated(boolean flag) {
		if ( flag==true )
			mCountUserGUIActivated++;
		else
			if ( getIsUserGUIActivated() )
				mCountUserGUIActivated--;
	}

	public static boolean getIsUserGUIActivated() {
		if ( mCountUserGUIActivated > 0 )
			return true;
		else
			return false;
	}

	//public static Logger Log;

	private static dbBank mBank;
	//private static CServices mServices;
}
