package dbridge;

//import javax.swing.UIManager;
//import java.awt.*;
//import javax.swing.*;
//import java.awt.event.*;
import java.util.*;
//import java.text.*;
import java.io.*;
import org.omg.CORBA.*;
import BridgeApp.*;
import java.sql.SQLException;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

/*
 * Created: 23.01.04
 * Modified 24.01.04
 * Modified 25.01.04
 * Modified  2.03.04
 * Modified 21.03.04
 * Modified 16.09.04
 * Modified 29.09.04
 * Modified 27.02.05
 * Modified 10.08.05
 * Modified 20.06.06
 */


class BridgeServant extends _bridgeImplBase
{
    dbInterpreter mInterpreter = new dbInterpreter();
    public String sendRequest(String str)
    {
        mInterpreter.setResult("\nsendRequest: Server:" + "accepted command - " + str + "\n");
        //System.out.println("send Request: interpreter setResult ist initialised");
        if (DBridgeServer.isShutingDown())
        {
            return "Shutdown";
        }
        // test comment
        //System.out.println("sendRequest: Your command is " + str + "\n");
        if ( mInterpreter.process(str) )
        {
            //System.out.println("sendRequest: Your Return command is \n\n****>\n" + mInterpreter.getResult() + "<****\n");
            return mInterpreter.getResult(); //"\nServer:" +"accepted command - "+str+"\n";
        }
        else
        {
            return "null";  // null will indicate bad command results
        }
    }
}


class BridgeApp
{
    // initialisation
    public BridgeApp()
    {
        // load MIME map
        mStatistician = new EmptyStatistician();
        mLogger = new EmptyLogger();
        supportedLocales = new Locale[2];
        supportedLocales[0] = Locale.ENGLISH;
        supportedLocales[1] = Locale.GERMAN;
        mMonitor = new CStateMonitor();
        mMimer = new dbMimeManager("mime.types");
        mMimer.setComments("#");
        mLogLevel=3;                                // change the level here to 0, to avoid messages
        mRoot="./";
        // tmp solution 28.05.06
        mSplitterOn=true;                           // SMTP plitter flag
        mSplitterSize=5*1024*1024;                  // max allowed size
        mServerFlag=true;                           // set server on
    };
    protected void SetStatistician(CStatistician oStats)
    {
        mStatistician = oStats;
    }

    public static void setRoot(String root){
            mRoot=root;
    }
    public static String getRoot(){
            return mRoot;
    }


    public static void setLogLevel(int level){
        if ( level>=0 && level<=3 )
           mLogLevel=level;
    }
    public static int getLogLevel(){
        return mLogLevel;
    }


//	protected void SetLogger(Logger oLogger)
    public static void SetLogger(Logger oLogger)
    {
        mLogger = oLogger;
    }

    // Logging interface
    public static void LogError(CLogMsg msg)
    {
        LogMsg(msg.SetType(State.ERROR));
    }
    
    public static void LogError(Vector v)
    {
    	LogVector(v, State.ERROR);
    }
    
    public static void LogError(Exception e)
    {
		CLogMsg msg = Logs.Srvcs.SetText("Exception " + e.getMessage());
		LogMsg(msg.SetType(State.ERROR));
		
    	StackTraceElement[] stack = e.getStackTrace();
    	for (int i=0; i<stack.length; ++i){
     		msg = Logs.Srvcs.SetText(stack[i].toString());
    		LogMsg(msg.SetType(State.ERROR));
    	}
        
    }   
    
    
    public static void LogWarning(CLogMsg msg){
        LogMsg(msg.SetType(State.WARNING));
    }

    public static void LogWarning(Vector v)
    {
    	LogVector(v, State.WARNING);
    }

    public static void LogInfo(CLogMsg msg)
    {
        LogMsg(msg.SetType(State.INFO));
    }
    
    public static void LogInfo(Vector v)
    {
    	LogVector(v, State.INFO);
    }  

    public static void LogDebug(CLogMsg msg) {
      LogMsg(msg.SetType(State.DEBUG));
    }
    
    public static void LogDebug(Vector v)
    {
    	LogVector(v, State.DEBUG);
    }  


    public static void LogMsg(CLogMsg msg)
    {
        mLogger.printMsg(msg);

        if (msg.Type.intValue() >= State.WARNING.intValue())
        {
            mMonitor.UpdateState(msg.Module, msg.Type);
        }
    }

    // Statistics interface
    public static CStatistician Stats()
    {
        return mStatistician;
    }

    // mimer
    public static dbMimeManager getMimer()
    {
        return mMimer;
    };
    // monitor
    public static CStateMonitor Monitor()
    {
        return mMonitor;
    }

    // locale
    public static Locale[] getSupportedLocales()
    {
        return supportedLocales;
    }

    public static Locale getLocale(int localeIndex)
    {
        return supportedLocales[localeIndex];
    }

    public static Locale getCurrentLocale()
    {
        return supportedLocales[currentLocale];
    }

    public static void setCurrentLocale(int loc)
    {
        currentLocale = loc;
    }

    // tmp solution
    public static void setSplitterOn(boolean on)
    {
        mSplitterOn = on;
    }
    public static boolean isSplitterOn()
    {
        return mSplitterOn;
    }
    public static void setSplitterSize(int size )
    {
        mSplitterSize = size;
    }
    public static int getSplitterSize()
    {
        return mSplitterSize;
    }

    public static boolean isServer(){
        return mServerFlag;
    }
    public static void setServerFlag(boolean on){
        mServerFlag=on;
    }
    
    private static void LogVector(Vector s_vec, Integer log_type){
    	for (Iterator it=s_vec.iterator(); it.hasNext();){
    		CLogMsg msg = Logs.Srvcs.SetText(it.next().toString());
    		LogMsg(msg.SetType(log_type));
    	}
    }

    private static CStatistician mStatistician;
    private static String mRoot;
    private static CStateMonitor mMonitor;
    private static Logger mLogger;
    private static dbMimeManager mMimer;
    private static int currentLocale;
    private static Locale[] supportedLocales;
    private static int mLogLevel;               // level 0  default every time, to log files
                                                // level 1  light debug level, to log files
                                                // level 2  debug level, to console
                                                // level 3  strong debug level, both to console and log files
    // tmp solution
    private static boolean mSplitterOn;
    private static int mSplitterSize;

    // server/client flag
    private static boolean mServerFlag;
}

  /**************************************************************
   *
   */

/**
 * Main Server Class
 */
  public class DBridgeServer extends BridgeApp
{
	  /**
	   * Default constructor.
	   *
	   */
    public DBridgeServer()
    {
    	
        this.setServerFlag(true);
        //System.out.println("Check the database name: "+DBConsts.TRANSACTION_DB_Name);
        mBase = new dbBase(DBConsts.TRANSACTION_DB_Name);
        //
        // create the internal DB, read parameters
        // from ini file
        mBank = new dbBank("DBridge.ini");
        initDynamicConsts();
        BridgeApp.setRoot(mBank.getBox().getTmpDir());   // 12.05.05
        this.SetLogger(new Logger(new Integer(mBank.getBox().getLogLevel()),mBank.getBox().getLogDir()));
        this.SetStatistician(new CStatistician(mBank.getBox().getLogDir() + "/" +
                                               "server_stats.csv"));
        // tmp solution
        this.setSplitterOn(mBank.getBox().isSplitterOn());
        this.setSplitterSize(mBank.getBox().getSplitterSize());

        mServices       = new CServices();

        mShutDownStatus = false;
        mShutdownThread = new ShutdownThread(60000);

        BridgeApp.LogDebug(Logs.Srvcs.SetText("Garbage Collector StartTime : "+DBConsts.GARBAGE_START_TIME));
        BridgeApp.LogDebug(Logs.Srvcs.SetText("Garbage Collector RepeateZime : "+DBConsts.GARBAGE_REPEAT_PERIOD));
        BridgeApp.LogDebug(Logs.Srvcs.SetText("Garbage Collector Not-in-use : "+DBConsts.GARBAGE_BAD_FILE_DIR_TIMEOUT));
        BridgeApp.LogDebug(Logs.Srvcs.SetText("Garbage Collector RunInit : "+DBConsts.GARBAGE_RUN_AT_INIT));

        //
        // start daemons
        //
        mServices.startDaemons();
        //
        // start services
        //
        mServices.startServices();
    }

    /**
     * Stop all services and threads.
     *
     */
    public static void stopDaemons()
    {
        Services().stopDaemons();
        mServices.stopServices();
    }

    /**
     * Start all services and threads.
     *
     */
    public static void startDaemons()
    {
        mServices.startDaemons();
        mServices.startServices();
    }

    /**
     * Restart server. 
     * First all services and daemons will be stoped. Next, the Bank is updated.
     * After this, all services and daemons are started again.
     */
    public static void restart() {
      Services().stopServices();
      // from ini file
      mBank = new dbBank("DBridge.ini");
      //
      // start services
      //
      Services().startServices();
    }

    /**
     * Restart services. 
     * An difference from the restart() method consists of in a fact that the Bank is not updated.
     */
    public static void restartServices() {
      //System.out.println("stop Services");
      Services().stopServices();

      //System.out.println("start Services");
      Services().startServices();
    }

    /**
     * Main method.
     * @param args
     */
    public static void main(String args[])
    {
        // check singletone 
    	dbLock appLock=new dbLock(".servlock");
    	appLock.setLockText("You have already run a DBridge Server copy\n"+
        		"In case of a deadlock, run a DBunlock application\n"+
        		"before running the server.");
        if ( ! appLock.setLock() ){
        	System.exit(1); // total exit
        };
    	

        try
        {

            // create and initialize the ORB
            ORB orb = ORB.init(args, null);

            // create servant and register it with the ORB
            BridgeServant bridgeRef = new BridgeServant();
            orb.connect(bridgeRef);

            // stringify the bridgeRef and dump it in a file
            String str = orb.object_to_string(bridgeRef);
            String filename = "." +
                              System.getProperty("file.separator") +
                              "BridgeIOR";
            FileOutputStream fos = new FileOutputStream(filename);
            PrintStream ps = new PrintStream(fos);
            ps.print(str);
            ps.close();

            new DBridgeServer();
            setLocker( appLock);
            // wait for invocations from clients
            java.lang.Object sync = new java.lang.Object();
            synchronized (sync)
            {
                sync.wait();
            }

        }
        catch (Exception e)
        {
            System.err.println("ERROR: " + e);
            e.printStackTrace(System.out);
        }
    }
    
    public static void setLocker(dbLock lock){ mLock=lock;}

    /**
     * Commands supported by the Server Protocol Interpreter
     */
    public static void stop()
    {
        //System.out.println("kill dcm server daemon");
        Services().stopDaemons(); // kill dcm server daemon
        //System.out.println("stop mail services");
        Services().stopServices(); // stop mail services
        //System.out.println("system exit");
        mShutDownStatus = true;
        // call shuttown as a thread
        mShutdownThread.setTimeout(60000); // 1 minute of delay
        mShutdownThread.start();
    }

    /**
     * Stop services and daemons at a given time.
     * @param time
     */
    public static void stop(int time)
    {
        //System.out.println("kill dcm server daemon");
        Services().stopDaemons(); // kill dcm server daemon
        //System.out.println("stop mail services");
        Services().stopServices(); // stop mail services
        //System.out.println("system exit");
        mShutDownStatus = true;
        // call shuttown as a thread
        mShutdownThread.setTimeout(time); // 1 minute of delay
        mShutdownThread.start();
    }

    /**
     * Shutdown the server at a given time.
     * @param time
     */
    public static void shutdown(long time)
    {
    	BridgeApp.LogDebug(Logs.Srvcs.SetText("The DBridge Server will be down in " + time / 1000 +
                           " seconds ..."));
        // timer
        try
        {
            Thread.sleep(time / 2); // 30 seconds
        }
        catch (InterruptedException ie)
        {}
        ;
        BridgeApp.LogDebug(Logs.Srvcs.SetText("The DBridge Server will be down in " + time / 2000 +
                           " seconds ..."));
        try
        {
            Thread.sleep(time / 4); // 15 seconds
        }
        catch (InterruptedException ie)
        {}
        ;
        BridgeApp.LogDebug(Logs.Srvcs.SetText("The DBridge Server will be down in " + time / 4000 +
                           " seconds ..."));
        try
        {
            Thread.sleep(time / 4); // 15 seconds
        }
        catch (InterruptedException ie)
        {}
        ;

        // close the SQL database
        try{
          mBase.close();
        }catch(SQLException e1){
            System.out.println(e1.toString());
        }
        mLock.deleteLock();
        System.exit(1); // total exit
    }

    /**
     * is true if Shutdown is finished.
     * @return
     */
    public static boolean isShutingDown()
    {
        return mShutDownStatus;
    }

    /**
     * Add a used by index in the UserContainer.
     * @param index
     */
    public static void dbAddUser(int index)
    {
        mBank.fromFile(); // read a new benk
        dbUser tmp = Bank().getUserContainer().getUser(index); // update user
        Services().startUserServices(tmp);
    }

    /**
     * Update a used by index in the UserContainer.
     * @param index
     */
    public static void dbUpdateUser(int index)
    {
        dbUser tmp = Bank().getUserContainer().getUser(index);
        Services().stopUserServices(tmp);
        mBank.fromFile(); // read a new benk
        tmp = Bank().getUserContainer().getUser(index); // update user
        Services().startUserServices(tmp);
    }

    /**
     * Delete a used by index in the UserContainer.
     * @param index
     */
    public static void dbDeleteUser(int index)
    {
        dbUser tmp = Bank().getUserContainer().getUser(index);
        Services().stopUserServices(tmp);
        mBank.fromFile(); // read a new benk
    }

    /**
     * Update the DCM server list.
     *
     */
    public static void dbUpdateServer()
    {
        mBank.readDcmServerList();
    }

    /**
     * Add a Dicom Server.
     *
     */
    public static void dbAddServer()
    {
        mBank.readDcmServerList();
    }

    /**
     * Delete a Dicom Server by an index.
     * @param index
     */
    public static void dbDeleteServer(int index)
    {
        mBank.getDcmServerList().remove(index);
    }

    /**
     * Change the password for the administrator.
     * @param str
     */
    public static void dbAdmChange(String str)
    {
        mBank.getUserContainer().getUser("admin").setPassword(str);
    }

    /**
     * Prevent sending Dicom files in automatic mode (routing) for a user described by a given index.
     * @param index
     */
    public static void dbStopAutoDCMSend(int index)
    {   //System.out.println("Stop DCM auto send ...");
        dbUser user = mBank.getUserContainer().getUser(index);
        if (Services().IsAutoDicomSend(user))
        {
            user.setAutoDCMSendFlag(false);
            Services().StopAutoDicomSend(user);
        }
    }

    /**
     * Initialize sending Dicom files in automatic mode (routing) for a user described by a given index.
     * @param index
     */
    public static void dbStartAutoDCMSend(int index)
    {   // a manual user has changed parameters for auto sending
        // These changes where stored in the Bank by the client
        // from ini file
        //System.out.println("Reread Bank ...");
        mBank = new dbBank("DBridge.ini");
        //System.out.println("restart services ...");
        dbUser user = mBank.getUserContainer().getUser(index);
        if (!Services().IsAutoDicomSend(user))
        {
            user.setAutoDCMSendFlag(true);
            Services().StartAutoDicomSend(user);
        }
    }

    /**
     * Access to the Bank.
     * @return
     */
    public static dbBank Bank()
    {
        return mBank;
    }

    /**
     * Access tothe Database.
     * @return
     */
    public static dbBase Base()
    {
        return mBase;
    }

    /**
     * Access to the servoce manager.
     * @return
     */
    public static CServices Services()
    {
        return mServices;
    }

    /**
     * Access to the mime manager.
     * @return
     */
    public static dbMimeManager Mimer()
    {
        return mMimer;
    }

    /**
     * Init Garbage Collector constants
     *
     */
    public static void initDynamicConsts()
    {
        DBConsts.GARBAGE_START_TIME           = mBank.getBox().getStartTimeGC();
        DBConsts.GARBAGE_REPEAT_PERIOD        = mBank.getBox().getRepeatePeriodGC();
        DBConsts.GARBAGE_BAD_FILE_DIR_TIMEOUT = mBank.getBox().getNotInUseGC();
        DBConsts.GARBAGE_RUN_AT_INIT          = mBank.getBox().getRunInit();

    }

    private static dbBank mBank;
    private static dbMimeManager mMimer;
    private static CServices mServices = null;
    private static boolean mShutDownStatus;
    private static ShutdownThread mShutdownThread;
    private static dbBase mBase;
    private static dbLock mLock;
} // end class

/**
 * Shutdown thread class.
 * @author aITLab
 *
 */
class ShutdownThread extends Thread
{
    long mTime;
    ShutdownThread(long time)
    {
        mTime = time;
    }

    public long getTimeout()
    {
        return mTime;
    }

    public void setTimeout(long time)
    {
        mTime = time;
    }

    public void run()
    {
        DBridgeServer.shutdown(mTime);
    }
} // end class
