package dbridge;

import java.util.*;
import java.awt.*;
import javax.swing.*;

import java.awt.event.*;
import javax.swing.border.*;
import java.net.URL;
import java.sql.*; // for tests

/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author unknown
 * @version 1.0
 *
 * First panel of the client gui. It is the entrance to communication and administration tools.
 */

/*
 * Created: 24.01.04
 * Modified 24.01.04
 * Modified 25.01.04
 * Modified  2.03.04
 * Modified  6.03.04
 * Modified 10.03.04
 * Modified 27.09.04
 * Modified 30.09.04
 * Modified 23.11.04
 * Modified 1.12.04-21.12.04
 * Modified 24.02.05-16.04.05
 */

interface ILogStatus {
  public void change(int n, String val);
}

public class Door
    extends JPanel implements ILogStatus {

  //Temp LogFile Name (The same in Logger)
  String LogName = DBridgeClient.Bank().getBox().getLogDir() +
      DBConsts.LOG_FILE; //"current.log"; // log name definition

  JButton Login = new JButton(new ImageIcon("./lib/res/door_open.jpg")); // login button
  JButton Exit = new JButton(new ImageIcon("./lib/res/door_run.jpg")); // exit button
  JButton jHelpBttn = new JButton(new ImageIcon("./lib/res/door_help.jpg")); // help button
  JButton PGP = new JButton(new ImageIcon("./lib/res/door_pgp.jpg")); // PGP button
  JButton Shutdown = new JButton(new ImageIcon("./lib/res/door_stop.jpg")); // Shutdown
  JButton MailBn = new JButton(new ImageIcon("./lib/res/door_mail.jpg")); // Mail button
  JButton jDbBn = new JButton(new ImageIcon("./lib/res/spheregreen.gif")); // LEDs
  JButton jServicesBn = new JButton(new ImageIcon("./lib/res/spheregreen.gif"));
  JButton jUserBn = new JButton(new ImageIcon("./lib/res/spheregreen.gif"));
  JButton jSqlBn = new JButton(new ImageIcon("./lib/res/data.gif"));

  JLabel jlStatus = new JLabel();
  // containers
  Box box1;
  JPanel jStatus_Panel = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  FlowLayout flowLayout1 = new FlowLayout();
  JPanel jPanel1 = new JPanel();
  FlowLayout flowLayout2 = new FlowLayout();
  TitledBorder titledBorder1;

  private LogsThread mLogsThread; // logs thread
  private int mStatus; // shows which user was made the login (0-admin, 1-user))
  private boolean isAdminLogedIn; // this flag will not allow to create two login sections
  //-----------------------------------
  private Dimension btnMinSize = new Dimension(25, 25); // Button dimension
  private Dimension btnMaxSize = new Dimension(600, 25);
  private Dimension btnPrefSize = new Dimension(30, 25);
  //-----------------------------------
  private JComboBox jcbLocale;
  //-----------------------------------

  // constructor
  private JFrame mMyFrame;
  public Door(JFrame frame) {
    mMyFrame = frame;
    Init();

  }

  private void Init() {
    mStatus = -1;
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    // start log threading
    mLogsThread = new LogsThread(30000); // 30 sec
    mLogsThread.setInterface(this);
    mLogsThread.start();
    isAdminLogedIn = false;
  };

  public void change(int n, String val) {
    switch (n) {
      case 1:
        jDbBn.setIcon(new ImageIcon(val));
        break;
      case 2:
        jServicesBn.setIcon(new ImageIcon(val));
        break;
      case 3:
        jUserBn.setIcon(new ImageIcon(val));
        break;
    }
  }

  // DEBUG method *********************************
  public static void main(String[] args) {
    JFrame frame = new JFrame("Test");
    Door door = new Door(frame);

    frame.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        return;
      }
    });
    frame.pack();
    frame.setVisible(true);
  }

  // END DEBUG ************************************

  private void jbInit() throws Exception {
    titledBorder1 = new TitledBorder("");
    this.setMinimumSize(new Dimension(10, 10));
    this.setOpaque(true);
    this.setPreferredSize(new Dimension(30, 217));
    this.setToolTipText("");
    this.setSize(new Dimension(40, 221));

    // Button box
    box1 = Box.createVerticalBox();
    // Login
    Login.setAlignmentX( (float) 0.0);
    Login.setAlignmentY( (float) 0.0);
    Login.setMaximumSize(btnMaxSize);
    Login.setMinimumSize(btnMinSize);
    Login.setPreferredSize(btnPrefSize);
    Login.setHorizontalAlignment(SwingConstants.CENTER);
    Login.setSelected(false);
    Login.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        Login_actionPerformed(e);
      }
    });
    // Exit
    Exit.setAlignmentX( (float) 0.0);
    Exit.setAlignmentY( (float) 0.0);
    Exit.setMaximumSize(btnMaxSize);
    Exit.setMinimumSize(btnMinSize);
    Exit.setPreferredSize(btnPrefSize);
    Exit.setHorizontalAlignment(SwingConstants.CENTER);
    Exit.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        Exit_actionPerformed(e);
      }
    });
    this.setLayout(borderLayout1);
    // Help
    jHelpBttn.setAlignmentX( (float) 0.0);
    jHelpBttn.setAlignmentY( (float) 0.0);
    jHelpBttn.setMaximumSize(btnMaxSize);
    jHelpBttn.setMinimumSize(btnMinSize);
    jHelpBttn.setPreferredSize(btnPrefSize);
    jHelpBttn.setMnemonic('0');
    jHelpBttn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jHelpBttn_actionPerformed(e);
      }
    });
    // PGP
    PGP.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        PGP_actionPerformed(e);
      }
    });
    PGP.setHorizontalAlignment(SwingConstants.CENTER);
    PGP.setAlignmentY( (float) 0.0);
    PGP.setMaximumSize(btnMaxSize);
    PGP.setMinimumSize(btnMinSize);
    PGP.setPreferredSize(btnPrefSize);
    PGP.setAlignmentX( (float) 0.0);

    // Status bar
    jStatus_Panel.setBorder(BorderFactory.createLoweredBevelBorder());
    jStatus_Panel.setMinimumSize(new Dimension(30, 15));
    jStatus_Panel.setPreferredSize(new Dimension(30, 15));
    jStatus_Panel.setRequestFocusEnabled(true);
    jStatus_Panel.setLayout(flowLayout1);
    flowLayout1.setAlignment(FlowLayout.LEFT);

    // Shutdown services
    Shutdown.setMaximumSize(btnMaxSize);
    Shutdown.setMinimumSize(btnMinSize);
    Shutdown.setPreferredSize(btnPrefSize);
    Shutdown.setActionCommand("Shutdown");
    Shutdown.setHorizontalAlignment(SwingConstants.CENTER);
    Shutdown.setMnemonic('0');
    Shutdown.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        Shutdown_actionPerformed(e);
      }
    });
    // Mail activation Button
    MailBn.setMaximumSize(btnMaxSize);
    MailBn.setMinimumSize(btnMinSize);
    MailBn.setPreferredSize(btnPrefSize);
    MailBn.setActionCommand("Take e-mails");
    MailBn.setHorizontalAlignment(SwingConstants.CENTER);
    MailBn.setMnemonic('0');

    MailBn.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        MailBn_actionPerformed(e);
      }
    });
    //DataBaseLogIndicator
    jDbBn.setBorder(BorderFactory.createEtchedBorder());
    jDbBn.setMaximumSize(btnMaxSize);
    jDbBn.setMinimumSize(new Dimension(20, 20));
    jDbBn.setPreferredSize(new Dimension(20, 20));
    jDbBn.setActionCommand("jDbBn");
    jDbBn.setContentAreaFilled(true);
    jDbBn.addActionListener(new Door_jDbBn_actionAdapter(this));
    //SystemServicesLogIndicator
    jServicesBn.setBorder(BorderFactory.createEtchedBorder());
    jServicesBn.setMaximumSize(btnMaxSize);
    jServicesBn.setMinimumSize(new Dimension(20, 20));
    jServicesBn.setPreferredSize(new Dimension(20, 20));
    jServicesBn.setActionCommand("jServicesBn");
    jServicesBn.setMnemonic('0');
    jServicesBn.addActionListener(new Door_jServicesBn_actionAdapter(this));
    //SystemUserLogIndicator
    jUserBn.setBorder(BorderFactory.createEtchedBorder());
    jUserBn.setMaximumSize(btnMaxSize);
    jUserBn.setMinimumSize(new Dimension(20, 20));
    jUserBn.setPreferredSize(new Dimension(20, 20));
    jUserBn.setActionCommand("jServicesBn"); // to do change
    jUserBn.setMnemonic('0');
    jUserBn.addActionListener(new Door_jUserBn_actionAdapter(this));

    jSqlBn.setBorder(BorderFactory.createEtchedBorder());
    jSqlBn.setMaximumSize(btnMaxSize);
    jSqlBn.setMinimumSize(new Dimension(20, 20));
    jSqlBn.setPreferredSize(new Dimension(20, 20));
    jSqlBn.setActionCommand("jServicesBn"); // to do change
    jSqlBn.setMnemonic('0');
    jSqlBn.addActionListener(new Door_jSqlBn_actionAdapter(this));
    jSqlBn.setToolTipText("Disposition Notification DB");

    // LEDs Panel
    jPanel1.setLayout(flowLayout2);
    flowLayout2.setAlignment(FlowLayout.LEFT);
    jPanel1.setMinimumSize(new Dimension(40, 25));
    jPanel1.setPreferredSize(new Dimension(40, 25));
    jPanel1.setRequestFocusEnabled(true);

//---------------------------------------------------------------------------
    Locale locList[] = BridgeApp.getSupportedLocales();
    String[] locString = new String[locList.length];
    int defLoc = 0;

    for (int i = 0; i < locList.length; ++i) {
      locString[i] = locList[i].toString() + " ("
          + locList[i].getDisplayName() + ")";
    }

    if ( (Locale.getDefault()).equals(Locale.GERMANY)) {
      defLoc = 1;
    }
    BridgeApp.setCurrentLocale(defLoc);
    jcbLocale = new JComboBox(locString);
    jcbLocale.setSelectedIndex(defLoc);
    jcbLocale.setAlignmentX( (float) 0.0);
    jcbLocale.setAlignmentY( (float) 0.0);
    jcbLocale.setMaximumSize(new Dimension(800, 600));
    jcbLocale.setMinimumSize(new Dimension(40, 25));
    jcbLocale.setPreferredSize(new Dimension(40, 25));
    jcbLocale.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        BridgeApp.setCurrentLocale(jcbLocale.getSelectedIndex());
        setLabels();
      }
    });
    setLabels();
//---------------------------------------------------------------------------
    this.add(box1, BorderLayout.NORTH);
    box1.add(Login, null);
    box1.add(Exit, null);
    box1.add(Shutdown, null);
    box1.add(PGP, null);
    box1.add(MailBn, null);
    box1.add(jHelpBttn, null);
//----------------------------------------------------
    box1.add(jcbLocale, null);
//----------------------------------------------------
    this.add(jStatus_Panel, BorderLayout.SOUTH);
    jStatus_Panel.add(jlStatus, null);
    this.add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(jDbBn, null);
    jPanel1.add(jServicesBn, null);
    jPanel1.add(jUserBn, null);
    jPanel1.add(Box.createHorizontalStrut(10),null);
    jPanel1.add(Box.createGlue());
    jPanel1.add(jSqlBn, null);
    checkUpdates();
  }

  void checkUpdates(){
	  Locale currentLocale = BridgeApp.getCurrentLocale();
	    ResourceBundle labels = ResourceBundle.getBundle(
	        "dbridge.prop.DoorLabelsBundle", currentLocale);
	    String updateMsg1 = labels.getString("UpdateMsg1");
	    String updateMsg2 = labels.getString("UpdateMsg2");
	    String updateMsg3 = labels.getString("UpdateMsg3");
	    String updateMsg4 = labels.getString("UpdateMsg4");
	    String updateMsg5 = labels.getString("UpdateMsg5");
	/*
	 * Check Update available
	 */
	try{  
		PageReader update= new PageReader();
		// read a vestion number from a web site and comare it with the current one
		// emit a message if necessary
		String res=update.getTextFollowing(DBridgeClient.Bank().getBox().getUpdateURL(),"Version");
		dbVersion new_version = new dbVersion(res);
		dbVersion old_version = new dbVersion(DBridgeClient.Bank().getVersion());
		String msg=updateMsg1+res+" "+updateMsg2+"\n"+
		updateMsg3+" "+DBridgeClient.Bank().getVersion()+"\n";
		boolean isNew=false;
		if ( new_version.getMainVersionN()!=old_version.getMainVersionN() ||
				new_version.getModificationN()!=old_version.getModificationN()){
			isNew=true;
			msg+=updateMsg4;
		}
		if ( new_version.getDataBaseN()!=old_version.getDataBaseN() ){
			isNew=true;
			msg+=updateMsg5;
		}
		if ( isNew ){
			JOptionPane.showMessageDialog(null, msg);
		}
	}catch(Exception e1){
           System.out.println(e1.toString());
    }
}  
  
  //
  // login processing
  //
  void Login_actionPerformed(ActionEvent e) {
    ident(1);
    BridgeApp.LogDebug(Logs.Srvcs.SetText("Send To = " + "Login processing"));
    switch (mStatus) {
      case 0: {
        // Admin GUI
        if (DBridgeClient.getIsAdminGUIActivated()) {
          Locale currentLocale = BridgeApp.getCurrentLocale();
          ResourceBundle labels = ResourceBundle.getBundle(
              "dbridge.prop.DoorLabelsBundle", currentLocale);
          String lMessage = labels.getString("AdminLogin2");
          JOptionPane.showMessageDialog(null, lMessage);
          // notify GUI
          jUserBn.setIcon(new ImageIcon("./lib/res/spherered.gif"));
          jUserBn.repaint();
          jUserBn.setToolTipText("Admin Online");
          return;
        }
        if (DBridgeClient.getIsUserGUIActivated()) {
          Locale currentLocale = BridgeApp.getCurrentLocale();
          ResourceBundle labels = ResourceBundle.getBundle(
              "dbridge.prop.DoorLabelsBundle", currentLocale);
          String lMessage = labels.getString("UserAdminLogin");
          JOptionPane.showMessageDialog(null, lMessage);

          jUserBn.setIcon(new ImageIcon("./lib/res/sphereyellow.gif"));
          jUserBn.repaint();
          jUserBn.setToolTipText("User Online");
        }
        boolean packFrame = false;
        //MainFrame frame = new MainFrame(DBridgeClient.Bank());
        dsMainForm mform = new dsMainForm();
        mform.setVisible(true);

        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
      }
      break;
      case 1: {
        //
        // User GUI
        //
        if (DBridgeClient.getIsAdminGUIActivated()) {
          Locale currentLocale = BridgeApp.getCurrentLocale();
          ResourceBundle labels = ResourceBundle.getBundle(
              "dbridge.prop.DoorLabelsBundle", currentLocale);
          String lMessage = labels.getString("AdminUserLogin");
          JOptionPane.showMessageDialog(null, lMessage);
          jUserBn.setIcon(new ImageIcon("./lib/res/sphereyellow.gif"));
          jUserBn.repaint();
          jUserBn.setToolTipText("Admin Online");
        }
        else {
          jUserBn.setToolTipText("Login OK");
        }

        String user = DBridgeClient.Bank().getCurrentUser().getUserName();
        String root_dir = DBridgeClient.Bank().getBox().getTmpDir();
        dbUser current_user = DBridgeClient.Bank().getUserContainer().getUser(
            user);
        if (current_user.isManual()) {
          JOptionPane msgbox = new JOptionPane();
          Locale currentLocale = BridgeApp.getCurrentLocale();
          ResourceBundle labels = ResourceBundle.getBundle(
              "dbridge.prop.DoorLabelsBundle", currentLocale);
          String lMessage = labels.getString("UserLogged");
          // Send Message about User login
          // TODO
          //jUserBn.setIcon(new ImageIcon("./lib/res/sphereyellow.gif"));
          //jUserBn.repaint();
          //jUserBn.setToolTipText("OK");

          //msgbox.showMessageDialog(null, lMessage + " " + user);

          //New GUI
          dsUserInfoTree_1 ds_tree = new dsUserInfoTree_1(current_user,
              root_dir);
          ds_tree.setVisible(true);
        }
      }
      break;
    } // end switch
  }

  void Exit_actionPerformed(ActionEvent e) {
    ident(1); // check exit permitions
    if (mStatus == 0) { // for the administrator
      DBridgeClient.deleteLock(); // delete a client lock
      System.exit(1);
    }
    if (mStatus == 1) { // for the user
      Locale currentLocale = BridgeApp.getCurrentLocale();
      ResourceBundle labels = ResourceBundle.getBundle(
          "dbridge.prop.DoorLabelsBundle", currentLocale);
      String lMessage = labels.getString("ExitQuest");
      String lTitle = labels.getString("ExitTitle");
      if (JOptionPane.showConfirmDialog(this, lMessage, lTitle,
                                        JOptionPane.YES_NO_OPTION) == 0) {
    	DBridgeClient.deleteLock(); // delete a lient lock
        System.exit(1);
      }
    }
  }

  // check either the login is correct or not
  private boolean checkUser(String user, String pass) {
    // returns true for manual user and admin
    boolean r = false;
    dbUser candidat = DBridgeClient.Bank().getUserContainer().getUser(user);
    if (candidat != null) { //the user exists
      // check password
      if (candidat.getPassword().compareTo(pass) == 0) {
        r = true;
      }
    }
    return r;
  }

  private void ident(int id) {
    // ask user to enter Login and Password
    Locale currentLocale = BridgeApp.getCurrentLocale();
    ResourceBundle labels = ResourceBundle.getBundle(
        "dbridge.prop.DoorLabelsBundle", currentLocale);
    String lLabel;

    mStatus = -1;
    JFrame passFrame = new JFrame();
    PassDlg passDlg = new PassDlg(passFrame, true, null); //false);
    passDlg.setLocationRelativeTo(passFrame);
    if (id == 0) {
      lLabel = labels.getString("AdmPassDlgTitle");
    }
    else {
      lLabel = labels.getString("UsrPassDlgTitle");
    }
    passDlg.setTitle(lLabel);
    passDlg.setVisible(true);
    // process information
    UserInfo data = passDlg.getUserInfo();
    passDlg.dispose();
    if (data != null) {
      if (data.isNewUser()) {
        lLabel = labels.getString("NewUsrErrorMsg");
        JOptionPane.showMessageDialog(null, lLabel);
      }
      else {
        // check user and password in the database
        if (checkUser(data.getUserName(), data.getPassword())) {
          DBridgeClient.Bank().setCurrentUser(data);
          if (data.getUserName().compareTo("admin") == 0) { // admin login
            // admin
            mStatus = 0;

          }
          else {
            mStatus = 1;
          }
        } // end if
      } // end else
      if (mStatus == -1) {
        lLabel = labels.getString("IncorrectLogMsg");
        JOptionPane.showMessageDialog(null, lLabel);
      }
    } // end if
    // if cancel  - do nothing
  }

  void jHelpBttn_actionPerformed(ActionEvent e) {
    /*
          // test code passed 21.06.06
          dbQuery obj=new dbQuery();
          dmtRecord r=new dmtRecord();
          vfilesRecord v=new vfilesRecord();

          // insert a dmt record and read it
          r.m_id=new String("original id");
          obj.setQueryInsertDmt(r.toString());   // insert the record r
          String dmtrec=obj.setQueryDmt("select * from dmt");
          r.fromString(dmtrec);                  // convert the record

          // insert a vfiles record and read it
          v.m_name=new String("original vname");
          obj.setQueryInsertFiles(v.toString()); // insert the record v
          String filesrec=obj.setQueryFiles("select * from vfiles");
          v.fromString(filesrec);                // convert the record

          // update a dmt record and read it
          int index=r.m_dn_index;
          Timestamp newtime = new Timestamp(System.currentTimeMillis());
          obj.setQueryUpdate("update dmt set id=\'door updated_id\' where dn_index="+index);
          obj.setQueryUpdate("update dmt set total=201 where dn_index="+index);
          obj.setQueryUpdate("update dmt set sent=202 where dn_index="+index);
     obj.setQueryUpdate("update dmt set received=203 where dn_index="+index);
     obj.setQueryUpdate("update dmt set warnings=204 where dn_index="+index);
     obj.setQueryUpdate("update dmt set errors=205 where dn_index="+index);
     obj.setQueryUpdate("update dmt set resent=206 where dn_index="+index);
     obj.setQueryUpdate("update dmt set deleted=207 where dn_index="+index);
          obj.setQueryUpdate("update dmt set report=\'door updated report\' where dn_index="+index);
     obj.setQueryUpdate("update dmt set status=true where dn_index="+index);
          String update_res=obj.setQueryUpdate("update dmt set start_time=to_timestamp('"+newtime+"') where dn_index="+index);
          // how to check results
     if ( update_res==null ) System.out.println("Error: the record "+ index+" does"+
     " not exists or the query is not supported");
          System.out.println("Update results:\n"+obj.setQueryDmt("select * from dmt where dn_index="+index));

          // update a vfiles record and read it
          index=v.m_dn_index;
          obj.setQueryUpdate("update vfiles set id=\'door updated_id\' where dn_index="+index);
          obj.setQueryUpdate("update vfiles set name=\'C:\\work\\openoffice.exe\' where dn_index="+index);
     obj.setQueryUpdate("update vfiles set number=301 where dn_index="+index);
          System.out.println("Update results:\n"+obj.setQueryFiles("select * from vfiles where dn_index="+index));

          // make query that cannot be correct
          String wrong=obj.setQueryUpdate("update dmt set total=201 where dn_index="+index+100);
          if ( wrong==null ) System.out.println("Wrong query test passed");
     else System.out.println("Wrong query test does not passed, res="+wrong);

          // make query using a transaction id
          String transaction_id="door updated_id";
          int file_nr=301;
          String file_name=obj.getFileName(transaction_id, file_nr);
          System.out.println("Requested file name : "+ file_name);

          String dmtres=obj.getDmtRecord(transaction_id);
          System.out.println("Requested Dmt Record : "+ dmtres);


          // delete a dmt record
          index=r.m_dn_index;
     String delete_res=obj.setQueryDelete("dmt where dmt.dn_index="+index);
     if ( delete_res==null ) System.out.println("The query has no results");
          else System.out.println("Number of deleted records = "+delete_res);

          // delete a vfiles record
          index=v.m_dn_index;
          delete_res=obj.setQueryDelete("vfiles where vfiles.dn_index="+index);
     if ( delete_res==null ) System.out.println("The query has no results");
          else System.out.println("Number of deleted records = "+delete_res);
     */
    // uncomment this code after test competing

    // show help window
    //about_box.setMessageType(new int(INFORMATION_MESSAGE));
    Locale currentLocale = BridgeApp.getCurrentLocale();
    ResourceBundle labels = ResourceBundle.getBundle(
        "dbridge.prop.DoorLabelsBundle", currentLocale);
    String sLogin = labels.getString("LoginLabel");

    URL index = ClassLoader.getSystemResource(labels.getString("HlpURL"));
    if (index != null) {
      new XHelp(labels.getString("HlpTitle") + DBridgeClient.Bank().getVersion(),
                index);
    }
    //new XHelp("DBridge Help v."+DBridgeClient.Bank().getVersion(), index);

  }

  void PGP_actionPerformed(ActionEvent e) {
    dsGPGKeyDialog gpg = new dsGPGKeyDialog(this.mMyFrame, true);
    gpg.setVisible(true);
    gpg.dispose();

  }

  void Shutdown_actionPerformed(ActionEvent e) {
    XServices obj = new XServices("DBridge Services"); //"DBridge Services");
    obj.setSize(400, 360);
    obj.setVisible(true);
  }

  void MailBn_actionPerformed(ActionEvent e) {
    // Restart Services to reinit e-mail processing
    String answer = DBridgeClient.sendRequest("DBRESTARTSERVICES");
    if (answer.compareTo("Bad Command") == 0) {
      String stopMsg = "Bad Restart";
      JOptionPane.showMessageDialog(null, stopMsg);
    }
  }

  //
  // Status Button press
  // change the respective log status to INFO (green) state
  // change the icon
  // call logview table
  void jDbBn_actionPerformed(ActionEvent e) {
    // take status
    String res1 = DBridgeClient.sendRequest("SETGREENLOGDB"); // setdb logs
    jDbBn.setIcon(new ImageIcon("./lib/res/spheregreen.gif"));
    // in log name, log file
// JOptionPane.showMessageDialog(null, "sBank: "+Logs.sBank+" LogName: "+ LogName+"  mMyFrame);
 
	dsLogViewerDlg LogViewer = new dsLogViewerDlg(Logs.sBank, LogName, mMyFrame, true);
    LogViewer.setVisible(true);
  }

  void jServicesBn_actionPerformed(ActionEvent e) {
    String res1 = DBridgeClient.sendRequest("SETGREENLOGSERVICES");
    jServicesBn.setIcon(new ImageIcon("./lib/res/spheregreen.gif"));
    jServicesBn.repaint();
    // call LogTableBuilder with sBank parameter
    dsLogViewerDlg LogViewer = new dsLogViewerDlg(Logs.sServices, LogName,
                                                  mMyFrame, true);
    LogViewer.setVisible(true);
  }

  void jUserBn_actionPerformed(ActionEvent e) {
    jUserBn.setIcon(new ImageIcon("./lib/res/spheregreen.gif"));
    jUserBn.repaint();
    //jUserBn.setToolTipText("Login");
  }

  void jSqlBn_actionPerformed(ActionEvent e) {
    JFrame frame = new JFrame();
    XDbViewer db = new XDbViewer(frame, "Disposition Notification Data Base", false);
    db.setVisible(true);
  }

//-----------------------------------------------------------------------------
  void setLabels() {
    Locale currentLocale = BridgeApp.getCurrentLocale();
    ResourceBundle labels = ResourceBundle.getBundle(
        "dbridge.prop.DoorLabelsBundle", currentLocale);
    String sLoginTT = labels.getString("LoginToolTip");
    String sExitTT = labels.getString("ExitToolTip");
    String sHelpTT = labels.getString("HelpToolTip");
    String sPGPTT = labels.getString("PGPToolTip");
    String sShutdownTT = labels.getString("ShutdownToolTip");
    String sMailBnTT = labels.getString("MailBnToolTip");
    String sDbBnTT = labels.getString("DbBnToolTip");
    String sServicesBnTT = labels.getString("ServicesBnToolTip");
    String sLocaleTT = labels.getString("LocaleToolTip");
    Login.setToolTipText(sLoginTT);
    Exit.setToolTipText(sExitTT);
    jHelpBttn.setToolTipText(sHelpTT);
    PGP.setToolTipText(sPGPTT);
    Shutdown.setToolTipText(sShutdownTT);
    MailBn.setToolTipText(sMailBnTT);
    jDbBn.setToolTipText(sDbBnTT);
    jServicesBn.setToolTipText(sServicesBnTT);
    jcbLocale.setToolTipText(sLocaleTT);
    jUserBn.setToolTipText("Login");
  }
//-----------------------------------------------------------------------------

}

class Door_jDbBn_actionAdapter
    implements java.awt.event.ActionListener {
  Door adaptee;

  Door_jDbBn_actionAdapter(Door adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jDbBn_actionPerformed(e);
  }
}

class LogsThread
    extends Thread {
  long mTime;
  private boolean mStopFlag;
  //private JButton jDbBn=null;
  //private JButton jServicesBn=null;
  ILogStatus mInterface;

  LogsThread(long time) {
    mTime = time;
  }

  public long getTimeout() {
    return mTime;
  }

  public void setTimeout(long time) {
    mTime = time;
  }

  public void setInterface(ILogStatus status) {
    mInterface = status;
  };
  //public void setButton2(JButton button){jServicesBn=button;};
  public void setStopFlag(boolean flag) {
    mStopFlag = flag;
  };

  public void run() {
    mStopFlag = false;
    while (!mStopFlag) {
      try {
        Thread.sleep(mTime); // mTime/1000 seconds
      }
      catch (InterruptedException ie) {}
      ;
      //System.out.println("Logs status ...");
      //
      //
      //
      String res1 = DBridgeClient.sendRequest("LOGDB"); // ask db logs
      //System.out.println("statusDB=" + res1 + "\n");
      if (res1.compareTo("red") == 0) {
        mInterface.change(1, "./lib/res/spherered.gif");
        //jDbBn.setIcon(new ImageIcon("./lib/res/spherered.gif"));
      }
      else {
        if (res1.compareTo("yellow") == 0) {
          mInterface.change(1, "./lib/res/sphereyellow.gif");
          //jDbBn.setIcon(new ImageIcon("./lib/res/sphereyellow.gif"));
        }
        else {
          mInterface.change(1, "./lib/res/spheregreen.gif");
          //jDbBn.setIcon(new ImageIcon("./lib/res/spheregreen.gif"));
        }
      }

      //
      //
      //
      String res2 = DBridgeClient.sendRequest("LOGSERVICES"); // ask services logs
      System.out.println("statusServices=" + res2 + "\n");
      if (res2.compareTo("red") == 0) {
        //System.out.println("red ...\n");
        mInterface.change(2, "./lib/res/spherered.gif");
        //jServicesBn.setIcon(new ImageIcon("./lib/res/spherered.gif"));
      }
      else {
        if (res2.compareTo("yellow") == 0) {
          mInterface.change(2, "./lib/res/sphereyellow.gif");
          //jServicesBn.setIcon(new ImageIcon("./lib/res/sphereyellow.gif"));
        }
        else {
          mInterface.change(2, "./lib/res/spheregreen.gif");
          //jServicesBn.setIcon(new ImageIcon("./lib/res/spheregreen.gif"));
        }
      }
    }
  }
} // end class

class Door_jServicesBn_actionAdapter
    implements java.awt.event.ActionListener {
  Door adaptee;

  Door_jServicesBn_actionAdapter(Door adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jServicesBn_actionPerformed(e);
  }
}

class Door_jUserBn_actionAdapter
    implements java.awt.event.ActionListener {
  Door adaptee;

  Door_jUserBn_actionAdapter(Door adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jUserBn_actionPerformed(e);
  }
}

class Door_jSqlBn_actionAdapter
    implements java.awt.event.ActionListener {
  Door adaptee;

  Door_jSqlBn_actionAdapter(Door adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jSqlBn_actionPerformed(e);
  }
}

/*class Door_Shutdown_actionAdapter implements java.awt.event.ActionListener {
  Door adaptee;

  Door_Shutdown_actionAdapter(Door adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.Shutdown_actionPerformed(e);
  }
 }
 */
