package dbridge;

import java.awt.Toolkit;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.swing.JTextField;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;
import javax.swing.text.PlainDocument;;

public class EmailAddrDocument extends PlainDocument {
	

//-----------------------------------------------------------
//  For future Field Validation 
//	Regular Expression Pattern for complete EMail Validation (RFC819)
//----------------------------------------------------------	
//		    //-- RegExp code according RFC819----
//			String usr = "([a-zA-Z0-9][a-zA-Z0-9_.-]*|\"([^\\\\\\x80-\\xff\\015\\012\"]|\\\\[^\\x80-\\xff])+\")";
//			String domain = "([a-zA-Z0-9][a-zA-Z0-9._-]*\\.)*[a-zA-Z0-9][a-zA-Z0-9._-]*\\.[a-zA-Z]{2,5}";
//			Pattern p = Pattern.compile("^" + usr + "@" + domain + "$");

	
	public void insertString(int offs,
            String str,
            AttributeSet a) throws BadLocationException {

		
		String m_email = this.getText(0, offs) + str;
		String new_string = str;
		//System.out.println("str = " + str);
		//System.out.println("m_email = " + m_email);
		
		//-------------------------------------------------
		// WARNING! Here we just check the symbols user enters,
		// but not a complete validation of email.
		// to perform complete validation use the Pattern from above
		//-------------------------------------------------
		
		// 1. If we have a \" as a first symbol
		Matcher m = Pattern.compile("^\".*").matcher(m_email);
		if (m.find()){
		
			// Find the begining of the domain area
			int ind = m_email.indexOf("\"@");
			if (ind >= 0 && (m_email.length() > ind + 2)) {
				// comment for connect-a-thon 20.09.07
				//Matcher m_err = Pattern.compile("[^a-zA-Z0-9._-]+").matcher(new_string);
				Matcher m_err = Pattern.compile("^a-zA-Z0-9._-+").matcher(new_string);
				
				if (m_err.find()){
					new_string = m_err.replaceAll("");
					Toolkit.getDefaultToolkit().beep();
				}
			}
		}
		//2. We do not have quotes at the beginning
		else
		{
			//Matcher m_err = Pattern.compile("[^a-zA-Z0-9\\.\\@_-]+").matcher(new_string);
			Matcher m_err = Pattern.compile("^a-zA-Z0-9\\.\\@_-+").matcher(new_string);
			
			if (m_err.find()){
				new_string = m_err.replaceAll("");
				Toolkit.getDefaultToolkit().beep();
			}
		}
		
		//System.out.println(m_email);
		
		//Insert the corrected string
		super.insertString(offs, new_string, a);
	
	}
		

}

class ServAddrDocument extends PlainDocument {

	public void insertString(int offs, String str, AttributeSet a)
			throws BadLocationException {

		Matcher m = Pattern.compile("[^a-zA-Z0-9\\.\\@_-]+").matcher(str);
		//Matcher m = Pattern.compile("^a-zA-Z0-9\\.\\@_-+").matcher(str);
		
		if (m.find()) {
			Toolkit.getDefaultToolkit().beep();
			super.insertString(offs, m.replaceAll(""), a);
		} else {
			super.insertString(offs, str, a);
		}

	}
}

class EmailField extends JTextField {
    protected Document createDefaultModel() {
      return new EmailAddrDocument();
    }
}

class ServerField extends JTextField {
   protected Document createDefaultModel() {
     return new ServAddrDocument();
   }
}
