/*
 * Created on 12.04.2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

package dbridge;

/**
 * @author mcdi
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 *
 * needed: One filter for GetAllFiles (return CFileFields), GetAllExtensions, GetAllStudyID;
 *           the Idea is to save time (1 loop over files, instead of 4)
 */

import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.TreeSet;
import java.util.Vector;
import java.util.Calendar;
import java.util.Random;
import java.io.File;
import java.io.FileFilter;
import java.io.FileInputStream;
import java.io.InputStream;

import com.pixelmed.dicom.Attribute;
import com.pixelmed.dicom.AttributeList;
import com.pixelmed.dicom.DicomInputStream;
import com.pixelmed.dicom.TagFromName;

public class FileTools
{
    public static Vector GetFilesFromDir(String sDir)
    {
        Vector vFiles = new Vector();
        File dir = new File(sDir);
        File[] oFiles = dir.listFiles();

        for (int i = 0; i < oFiles.length; i++)
        {
            if (oFiles[i].isFile())
            {
                vFiles.add(oFiles[i].getPath());
            }
        }
        return vFiles;
    }

    public static Vector GetNotHiddenFilesFromDir(String sDir)
    {
        Vector vFiles = new Vector();
        File dir = new File(sDir);
        File[] oFiles = dir.listFiles();

        for (int i = 0; i < oFiles.length; i++)
        {
            if (oFiles[i].isFile())
            {
                String fileName = (String) oFiles[i].getName();
                // isHidden works for MacOs/Unix, but we add the same check for Windows also
                if (oFiles[i].isHidden() || fileName.startsWith("."))
                {
                    // doing nothing
                    ;
                }
                else
                {
                    vFiles.add(oFiles[i].getPath());
                }
            }
        }
        return vFiles;
    }

    public static Vector GetNotHiddenFilesWithinSubdirs(String sDir)
    {
        //
        // 1. Get files
        //
        Vector vFiles = new Vector();
        vFiles=GetNotHiddenFilesFromDir(sDir);

        //
        // 2. Process all subdirs
        //
        File dir = new File(sDir);
        File[] oFiles = dir.listFiles();
        for (int i = 0; i < oFiles.length; i++)
        {
            if (oFiles[i].isDirectory())
            {
                String sSubDirPath = (String) oFiles[i].getPath();
                // isHidden works for MacOs/Unix, but we add the same check for Windows also
                if (oFiles[i].isHidden())
                {
                    // doing nothing
                    ;
                }
                else
                {
                    vFiles.addAll(GetNotHiddenFilesWithinSubdirs(sSubDirPath));
                }
            }
        }
        return vFiles;
    }

    static public String makeUniqName()
    {
        String result = new String();
        Calendar rightNow = Calendar.getInstance();
        int dayOfMonth = rightNow.get(Calendar.DAY_OF_MONTH);
        int month = rightNow.get(Calendar.MONTH) + 1;
        int year = rightNow.get(Calendar.YEAR);
        int sec = rightNow.get(Calendar.SECOND);
        int minuts = rightNow.get(Calendar.MINUTE);
        int hour = rightNow.get(Calendar.HOUR_OF_DAY);
        Random rnd = new Random(rightNow.getTimeInMillis());

        result = dayOfMonth + "-" + month + "-" + year + "_" + hour + "." +
                 minuts +
                 "." + sec + "_" + rnd.nextInt(10000);
        return result;
    }

    static public boolean isDICMfile(InputStream file) throws java.io.IOException {
      boolean result = false;
      byte[] buffer = new byte[132];

      result =  ( (file.read(buffer) != -1) &&
            ( (buffer[128] == 'D') && (buffer[129] == 'I') &&
             (buffer[130] == 'C') && (buffer[131] == 'M')));
      file.close();
      return result;
    }

    //
    // Simple listing functions
    //
    static public Collection ArrayToColl(File[] files)
    {
		LinkedList lst=new LinkedList();
		int n=files.length;
		for (int i=0; i<n; i++) lst.add(files[i]);
		return lst;
    }
    static public Collection ListFilesInFolder(File dir)
    {
    	Collection colFiles=null;
		if (dir.exists())
		{
			File[] files=dir.listFiles();
			files=(files!=null)?files:new File[0];
			colFiles=ArrayToColl(files);
		}
		else
		{
			colFiles=new LinkedList();
		}
    	return colFiles;
    }
    static public Collection ListFilesInFolders(Collection colDirs)
    {
		LinkedList colFiles=new LinkedList();
		for (Iterator it=colDirs.iterator(); it.hasNext(); )
		{
			Collection col=ListFilesInFolder((File)it.next());
			colFiles.addAll(col);
		}
		return colFiles;
    }

	//
	// File filtering methods
	//
	public static Collection GetFilteredFiles(Collection colDirs, FileFilter oFilter)
	{
		return (new CFilesFiltering(oFilter, new CCollectFilles()))
				.FilterFiles(ListFilesInFolders(colDirs));
	}
	public static Collection GetFilteredFiles(File dir, FileFilter oFilter)
	{
		return (new CFilesFiltering(oFilter, new CCollectFilles()))
				.FilterFiles(ListFilesInFolder(dir));
	}
	public static Collection FilterFiles(Collection colFiles, FileFilter oFilter)
	{
		return (new CFilesFiltering(oFilter, new CCollectFilles()))
				.FilterFiles(colFiles);
	}
	public static Collection FilterFields(Collection colFields, FileFilter oFilter)
	{
		return (new CFilesFiltering(oFilter, new CCollectFilles()))
				.FilterFiles(colFields);
	}

	//
	// StudyId retriever
	//
	public static String GetStudyId(String sFileName)
	{
		String sStudyUid = "";
		try
		{
	        AttributeList list = new AttributeList();
	        InputStream is = new FileInputStream(sFileName);
	        list.read(new DicomInputStream(is), TagFromName.SeriesInstanceUID);
	        is.close();
	        // Read required data from dicom file
	        sStudyUid = Attribute.getSingleStringValueOrDefault(list,
	                TagFromName.StudyInstanceUID, "");
		}
		catch(Exception ex)
		{
			// TODO smth
		}
        return sStudyUid;
	}
	public static Collection GetAllStudyIds(Collection colFiles)
	{
		return (new CFilesFiltering(new CEmptyFileFilter(), new CCollectStudyIds())).FilterFiles(colFiles);
	}

	//
	// Extension methods
	//
	public static Collection GetAllExtensions(Collection colFiles)
	{
		return (new CFilesFiltering(new CEmptyFileFilter(), new CCollectExtensions())).FilterFiles(colFiles);
	}
    static public String getExtension(File f) {
        String s = f.getName();
        return getExtension(s);
    }
    static public String getExtension(String sFile) {
        String ext = "";
        int i = sFile.lastIndexOf('.');

        if (i > 0 &&  i < sFile.length() - 1) {
            ext = sFile.substring(i+1).toLowerCase();
        }
        return ext;
    }

    static public Vector getExtensionAndName(String sFile)
    {
    	Vector v=new Vector(2);
        int i = sFile.lastIndexOf('.');
        if (i > 0 &&  i < sFile.length() - 1) {
        	v.add(0,sFile.substring(0,i));
        	v.add(1,sFile.substring(i+1).toLowerCase());
        } else {
        	v.add(0,sFile);
        	v.add(1,"");
        }
        return v;
    }


	//
	// Test
	//
	public static void main(String[] args) {
		CBobsSuperCollector oSuperPuperCollector=new CBobsSuperCollector();
		Collection colFiles=(new CFilesFiltering(new NotHiddenFilesFilter(),
												oSuperPuperCollector,
												new CEmptyStatusListener())).FilterFiles( FileTools.ListFilesInFolder(new File("D:\\DicomData\\2003\\20Slices\\v1\\")));
		Collection colTypes=oSuperPuperCollector.GetExtsColl();
		Collection colIds=oSuperPuperCollector.GetStudyIdsColl();

for (Iterator it=colFiles.iterator(); it.hasNext(); )
System.out.println(((CFileFieds)it.next()).Fields());
for (Iterator it=colTypes.iterator(); it.hasNext(); )
System.out.println(it.next());
for (Iterator it=colIds.iterator(); it.hasNext(); )
System.out.println(it.next());
	}
}

class XTagsFilter implements FileFilter
{
	public XTagsFilter()
	{
		SetXTags(new LinkedList());
	}
	public XTagsFilter(Collection xtags)
	{
		SetXTags(xtags);
	}
	public void SetXTags(Collection xtags)
	{
		m_xtags=new LinkedList(xtags);
	}
	public boolean accept(File file)
	{
		CFileFieds f=(CFileFieds)file;
		String xtag=f.GetXTagField();
    	for (Iterator it = m_xtags.iterator(); it.hasNext(); )
    	{
    		String xt = (String)it.next();
    		if (xtag.equals(xt))
    		{
    			return true;
    		}
    	}
	    return false;
	}
	private LinkedList m_xtags;
}

class ExtensionsFilter implements FileFilter
{
	public ExtensionsFilter()
	{
		SetTypes(new LinkedList());
	}
	public ExtensionsFilter(Collection types)
	{
		SetTypes(types);
	}
	public void SetTypes(Collection types)
	{
		m_types=new LinkedList(types);
	}

	public boolean accept(File f)
	{
	    if (f.isDirectory()) {
	    	return false;
	    }
	    String extension = FileTools.getExtension(f);
	    if (extension != null)
	    {
	    	for (Iterator it = m_types.iterator(); it.hasNext(); )
	    	{
	    		String ext = (String)it.next();
	    		if (extension.equals(ext))
	    		{
	    			return true;
	    		}
	    	}
	    }
	    return false;
	}
	private LinkedList m_types;
}

class StudyIdsFilter implements FileFilter
{
	public StudyIdsFilter()
	{
		SetIds(new LinkedList());
	}
	public StudyIdsFilter(Collection ids)
	{
		SetIds(ids);
	}
	public void SetIds(Collection ids)
	{
		m_ids=new LinkedList(ids);
	}

	public boolean accept(File f)
	{
	    if (f.isDirectory()) {
	    	return false;
	    }
	    String sStudyId = FileTools.GetStudyId(f.getPath());
    	for (Iterator it = m_ids.iterator(); it.hasNext(); )
    	{
    		String id = (String)it.next();
    		if (sStudyId.equals(id))
    		{
    			return true;
    		}
    	}
	    return false;
	}

	private LinkedList m_ids;
}

class CEmptyFileFilter implements FileFilter
{
	public boolean accept(File f)
	{
    	return true;
	}
}

class AllFilesFilter implements FileFilter
{
	public boolean accept(File f)
	{
	    if (f.isFile())
	    	return true;
	    else
	    	return false;
	}
}

class NotHiddenFilesFilter implements FileFilter
{
	public boolean accept(File f)
	{
        if (f.isFile())
        {
            String fileName = (String) f.getName();
            // isHidden works for MacOs/Unix, but we add the same check for Windows also
            if (f.isHidden() || fileName.startsWith("."))
            	return false;
            else
            	return true;
        }
        return false;
	}
}

class CFilesFiltering
{
	public CFilesFiltering()
	{
		Init(new CEmptyFileFilter(), new CEmptyFilesProcessor(), new CEmptyStatusListener());
	}
	public CFilesFiltering(FileFilter oFilter)
	{
		Init(oFilter, new CEmptyFilesProcessor(), new CEmptyStatusListener());
	}
	public CFilesFiltering(FileFilter oFilter, IFilesProcessor oProcessor)
	{
		Init(oFilter, oProcessor, new CEmptyStatusListener());
	}
	public CFilesFiltering(FileFilter oFilter, IFilesProcessor oProcessor, IStatusListener oListener)
	{
		Init(oFilter, oProcessor, oListener);
	}
	private void Init(FileFilter oFilter, IFilesProcessor oProcessor, IStatusListener oListener)
	{
		SetFilter(oFilter);
		SetStatusListener(oListener);
		SetFilesProcessor(oProcessor);
	}
	public void SetFilter(FileFilter oFilter)
	{
		mFilter=oFilter;
	}
	public void SetStatusListener(IStatusListener oListener)
	{
		mStatusListener=oListener;
	}
	public void SetFilesProcessor(IFilesProcessor oProcessor)
	{
		mProcessor=oProcessor;
	}
	public Collection FilterFiles(Collection colFiles)
	{
		int n=colFiles.size();

		mStatusListener.StatusStart(n);
		mProcessor.Begin(n);

		int i=0;
		for (Iterator it=colFiles.iterator(); it.hasNext(); )
		{
			File f=(File)it.next();

			if (mFilter.accept(f))
				mProcessor.NextFile(f);

			mStatusListener.StatusNext(++i, n);
		}

		mProcessor.End();
		mStatusListener.StatusEnd();

		return mProcessor.GetResultColl();
	}

	private FileFilter mFilter;
	private IStatusListener mStatusListener;
	private IFilesProcessor mProcessor;
}

interface IFilesProcessor
{
	  public void Begin(int n);
	  public void NextFile(File f);
	  public void End();

	  public Collection GetResultColl();
}
class CEmptyFilesProcessor implements IFilesProcessor
{
	  public void Begin(int nMax) {}
	  public void NextFile(File f) {}
	  public void End() {}

	  public Collection GetResultColl() {return new Vector();}
}

class CCollectFilles implements IFilesProcessor
{
	  public void Begin(int nMax) { mResult=new Vector(nMax); }
	  public void NextFile(File f) { mResult.add(f); }
	  public void End() {}

	  public Collection GetResultColl() { return mResult; }

	  private Vector mResult;
}
class CCollectExtensions implements IFilesProcessor
{
	  public void Begin(int nMax) { mResult=new TreeSet(); }
	  public void NextFile(File f) { mResult.add(FileTools.getExtension(f.toString())); }
	  public void End() {}

	  public Collection GetResultColl() { return mResult; }

	  private TreeSet mResult;
}
class CCollectStudyIds implements IFilesProcessor
{
	  public void Begin(int nMax) { mResult=new TreeSet(); }
	  public void NextFile(File f)
	  {
		String sId=FileTools.GetStudyId(f.getAbsolutePath());
		if (!sId.equals(""))
			mResult.add(sId);
	  }
	  public void End() {}

	  public Collection GetResultColl() { return mResult; }

	  private TreeSet mResult;
}

class CBobsSuperCollector implements IFilesProcessor
{
	  public void Begin(int nMax)
	  {
	  	mIds=new TreeSet();
	  	mExts=new TreeSet();
	  	mFiles=new Vector(nMax);
	  }
	  public void NextFile(File f)
	  {
		// Files
	  	CFileFieds ff=new CFileFieds(f);
		mFiles.add(ff);

	  	// Ids
		String sId=ff.GetXTagField();
		if (!sId.equals(""))
			mIds.add(sId);
		// Exts
		mExts.add(ff.GetTypeField());
	  }
	  public void End() {}

	  public Collection GetResultColl() { return mFiles; }
	  public Collection GetFilesColl() { return mFiles; }
	  public Collection GetExtsColl() { return mExts; }
	  public Collection GetStudyIdsColl() { return mIds; }

	  private TreeSet mIds;
	  private TreeSet mExts;
	  private Vector mFiles;
}


interface IStatusListener
{
	public void StatusStart(int n);
	public void StatusNext(int i, int n);
	public void StatusEnd();
}
class CEmptyStatusListener implements IStatusListener
{
	public void StatusStart(int n) {}
	public void StatusNext(int i, int n) {}
	public void StatusEnd() {}
}
