/**
For using this GUI you should be sure that
GnuPG is available and you have environment variable
HomeDir which point to the directory with pubring and secring.

And files:
  pubring.tmp
  pubring.gpg
  secring.gpg
  trustdb.gpg

  either not exist or can be writable
*/

/*
* Created:
* Modified 25.01.04
* Modified 10.12.04
*/


package dbridge;

import javax.swing.JDialog;
import java.awt.event.WindowEvent;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.JTextField;
import javax.swing.JFormattedTextField;
import java.text.NumberFormat;
import javax.swing.JPasswordField;
import javax.swing.JButton;
import java.awt.Container;
import javax.swing.JOptionPane;
import java.awt.event.*;
import java.util.Locale;
import java.util.ResourceBundle;

public class GenDialog extends JDialog {

  class genDialogException extends Exception{
    public genDialogException(String errStr) {
      super(errStr);
    }
  }

/** Creates new form JDialog */
  public GenDialog(JDialog parent, boolean modal) {
    super(parent, modal);
    initGUI();
  }

/** This method is called from within the constructor to initialize the form. */
  private void initGUI() {
    Container optionPane = getContentPane();
    optionPane.setLayout(null);
    Locale currentLocale = BridgeApp.getCurrentLocale();
    ResourceBundle labels = ResourceBundle.getBundle("dbridge.prop.GenDialLabelsBundle",currentLocale);

    setTitle(labels.getString("Title"));
    setResizable(false);

//Key Type:
    jlKeyType = new JLabel(labels.getString("KeyType"));
    jlKeyType.setBounds(new java.awt.Rectangle(7, 12, 65, 16));
    optionPane.add(jlKeyType);

    String[] vKeyTypes = {labels.getString("ktDSAElG"),labels.getString("ktDSA"),
                          labels.getString("ktRSA")};

    jcbKeyType = new JComboBox(vKeyTypes);
    jcbKeyType.setBounds(new java.awt.Rectangle(73, 11, 125, 20));
    jcbKeyType.setToolTipText(labels.getString("KeyTypeTT"));
    optionPane.add(jcbKeyType);

//Key Length:
    jlKeyLegth = new JLabel(labels.getString("KeyLength"));
    jlKeyLegth.setBounds(new java.awt.Rectangle(257, 12, 70, 16));
    optionPane.add(jlKeyLegth);
    jftfKeyLength = new JFormattedTextField(keyLengthFormat);
    jftfKeyLength.setValue(new Integer(1024));
    jftfKeyLength.setBounds(new java.awt.Rectangle(330, 11, 45, 20));
    jftfKeyLength.setToolTipText(labels.getString("KeyLengthTT"));
    optionPane.add(jftfKeyLength);

//Key expiraton time:
    jlKeyExpTime = new JLabel(labels.getString("KeyExpTime")+" ");
    jlKeyExpTime.setBounds(new java.awt.Rectangle(433, 12, 90, 16));
    optionPane.add(jlKeyExpTime);

    jftfExpTime = new JFormattedTextField(expTimeFormat);
    jftfExpTime.setValue(new Integer(0));
    jftfExpTime.setBounds(new java.awt.Rectangle(523, 11, 30, 20));
    jftfExpTime.setToolTipText(labels.getString("KeyLengthTT"));
    optionPane.add(jftfExpTime);

    String[] vTimeFrame = {labels.getString("TimeFrameDays"), labels.getString("TimeFrameWeeks"),
                           labels.getString("TimeFrameMonth"),labels.getString("TimeFrameYears")};
    jcbExpTime = new JComboBox(vTimeFrame);
    jcbExpTime.setBounds(new java.awt.Rectangle(558, 11, 75, 20));
    jcbExpTime.setToolTipText(labels.getString("TimeFrameTT"));
    optionPane.add(jcbExpTime);

    jlHint1 = new JLabel(labels.getString("Hint1"));
    jlHint1.setBounds(new java.awt.Rectangle(7, 50, 250, 16));
    optionPane.add(jlHint1);
    jlHint2 = new JLabel(labels.getString("Hint2"));
    jlHint2.setBounds(new java.awt.Rectangle(7, 62, 500, 16));
    optionPane.add(jlHint2);

//Name:
    jlName = new JLabel(labels.getString("Name"));
    jlName.setBounds(new java.awt.Rectangle(7, 85, 40, 16));
    optionPane.add(jlName);

    jtfName = new JTextField("");
    jtfName.setBounds(new java.awt.Rectangle(12, 100, 200, 20));
    jtfName.setToolTipText(labels.getString("NameTT"));
    optionPane.add(jtfName);

//Comments:
    jlComment = new JLabel(labels.getString("Comment"));
    jlComment.setBounds(new java.awt.Rectangle(218, 85, 72, 16));
    optionPane.add(jlComment);

    jtfComment = new JTextField("");
    jtfComment.setBounds(new java.awt.Rectangle(223, 100, 200, 20));
    jtfComment.setToolTipText(labels.getString("CommentTT"));
    optionPane.add(jtfComment);

//Mail:
    jlMail = new JLabel(labels.getString("Mail"));
    jlMail.setBounds(new java.awt.Rectangle(427, 85, 120, 16));
    optionPane.add(jlMail);

    jtfMail = new JTextField();
    jtfMail.setText("");
    jtfMail.setBounds(new java.awt.Rectangle(433, 100, 200, 20));
    jtfMail.setToolTipText(labels.getString("MailTT"));
    optionPane.add(jtfMail);

//Pass:
    jlPass = new JLabel(labels.getString("Pass"));
    jlPass.setBounds(new java.awt.Rectangle(76, 138, 88, 16));
    optionPane.add(jlPass);

    jpfPass = new JPasswordField("");
    jpfPass.setBounds(new java.awt.Rectangle(82, 156, 200, 20));
    jpfPass.setToolTipText(labels.getString("PassTT"));
    optionPane.add(jpfPass);

//Confirm Pass:
    jlConfPass = new JLabel(labels.getString("ConfPass"));
    jlConfPass.setBounds(new java.awt.Rectangle(353, 138, 160, 16));
    optionPane.add(jlConfPass);

    jpfConfirmPass = new JPasswordField("");
    jpfConfirmPass.setBounds(new java.awt.Rectangle(363, 156, 200, 20));
    jpfConfirmPass.setToolTipText(labels.getString("ConfPassTT"));
    optionPane.add(jpfConfirmPass);

//Generate
    jbGen = new JButton(labels.getString("Gen"));
    jbGen.setBounds(new java.awt.Rectangle(209, 185, 93, 27));
    jbGen.setPreferredSize(new java.awt.Dimension(90, 27));
    jbGen.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        if (generateKey()) {
           setVisible(false);
           dispose();
        }
      }
    });
    optionPane.add(jbGen);

//Cancel:
    jbCancel = new JButton(labels.getString("Cancel"));
    jbCancel.setBounds(new java.awt.Rectangle(317, 185, 93, 27));
    jbCancel.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        setVisible(false);
        dispose();
      }
    });
    optionPane.add(jbCancel);

    addWindowListener(
      new java.awt.event.WindowAdapter() {
        public void windowClosing(java.awt.event.WindowEvent evt) {
          closeDialog(evt);
        }
      });

    pack();
    this.setSize(650, 250);
  }

/** Generate key pair*/

  private boolean generateKey() {
    boolean result=true;
    Locale currentLocale = BridgeApp.getCurrentLocale();
    ResourceBundle labels = ResourceBundle.getBundle("dbridge.prop.GenDialLabelsBundle",currentLocale);
    try {
      //chek pass:
      String pass = new String (jpfPass.getPassword());
      String confirmPass = new String (jpfConfirmPass.getPassword());
      if((pass!=null)&&(pass.length()!=0)) {
        if (!pass.equals(confirmPass)) {
          jpfPass.setText("");
          jpfConfirmPass.setText("");
          throw new wrapperException(labels.getString("PassNotSameMessage"));
        }
      } else {
        if(JOptionPane.showConfirmDialog(this,labels.getString("PassBlankQuest"),labels.getString("PassBlankTitle"),JOptionPane.YES_NO_OPTION)==1)  {
          throw new wrapperException(labels.getString("PassBlankMessage"));
        }
      }

//      gpg
        GpgWrapper.generateKey(jcbKeyType.getSelectedIndex(),
                  ((Number)jftfKeyLength.getValue()).intValue(),
                  jtfName.getText(), jtfComment.getText(), jtfMail.getText(),
                  ((Number)jftfExpTime.getValue()).intValue(),
                  jcbExpTime.getSelectedIndex(),
                  pass);

    } catch (wrapperException e) {
      JOptionPane.showMessageDialog(this, e.getMessage(), labels.getString("ErrorString"), JOptionPane.ERROR_MESSAGE);
      result=false;
    }
    jpfPass.setText("");
    jpfConfirmPass.setText("");
    return result;
  }//end generateKey()

/** Closes the dialog */
  private void closeDialog(WindowEvent evt) {
    setVisible(false);
    dispose();
  }

  public static void main(String[] argv) {
    GenDialog myDlg = new GenDialog(null,true);//,"");
    myDlg.setVisible(true);
    System.exit(0);
  }

//  private String gpgPath;
  private JLabel jlKeyType;
  private JComboBox jcbKeyType;

  private JLabel jlKeyLegth;
  private JFormattedTextField jftfKeyLength;

  private JLabel jlKeyExpTime;
  private JFormattedTextField jftfExpTime;
  private JComboBox jcbExpTime;

  private JLabel jlName;
  private JTextField jtfName;

  private JLabel jlComment;
  private JTextField jtfComment;

  private JLabel jlMail;
  private JTextField jtfMail;

  private JLabel jlPass;
  private JPasswordField jpfPass;

  private JLabel jlConfPass;
  private JPasswordField jpfConfirmPass;

  private JButton jbGen;
  private JButton jbCancel;

  private JLabel jlHint1;
  private JLabel jlHint2;

  private NumberFormat keyLengthFormat;
  private NumberFormat expTimeFormat;
}
