package dbridge;

import java.io.*;
import java.util.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @K&S
 * @version 1.0
 */

/*
 * Created 29.09.04
 */

//=======================================================================
//    CLogRecord
//======================================================================
class CLogRecord {
  public CLogRecord() {
    dateAndTime = "";
    type = 0;
    typeString = "";
    source = "";
    sourceThread = "";
    message = "";
  }

  public String dateAndTime;
  public int type;
  public String typeString;
  public String source;
  public String sourceThread;
  public String message;
}

//=======================================================================
//    Log Parser
//======================================================================

public class LogParser {

  private final static int TAGPOSITION = 0;
  private final static int DATEPOSITION = 1;
  private final static int TYPEPOSITION = 2;
  private final static int TYPESTRINGPOSITION = 3;
  private final static int SOURCEPOSITION = 4;
  private final static int SOURCETHREADPOSITION = 5;

  public LogParser(/*LogTableBuilder oTableBuilder, String filename*/) {
 /* Commented out  13.12.06
  * Vector logs = LogParser.Parse(filename);
    oTableBuilder.build(logs);*/
  }

  /* Added 13.12.06*/
  public static void BuildTable(LogTableBuilder oTableBuilder, String filename) {
	    Vector logs = LogParser.Parse(filename);
	    oTableBuilder.build(logs);
  }
  //----------------------------------------------------------------
  public static Vector Parse(String filename) {
    String currLine;
    CLogRecord logRec = null;
    Vector results = new Vector();

    try {
      BufferedReader logFile = new BufferedReader(new InputStreamReader(new
          FileInputStream(filename)));

      while ( (currLine = logFile.readLine()) != null) {
        if (currLine.startsWith("<--msg-->;")) {
          if (logRec != null) {
            results.add(logRec);
          }
          logRec = new CLogRecord();
          String[] parsed = currLine.split(";");
          logRec.dateAndTime = parsed[DATEPOSITION];
          logRec.type = Integer.parseInt(parsed[TYPEPOSITION]);
          logRec.typeString = parsed[TYPESTRINGPOSITION];
          logRec.source = parsed[SOURCEPOSITION];
          logRec.sourceThread = parsed[SOURCETHREADPOSITION];
          int indexOfMessage = currLine.indexOf(logRec.sourceThread) +
              logRec.sourceThread.length() + 1;
          logRec.message = currLine.substring(indexOfMessage);
        }
        else {
          if (logRec != null) {
            logRec.message = logRec.message + "\n" + currLine;
          }
        }
      }
      if (logRec != null) {
        results.add(logRec);
      }
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    return results;
  }


}

//======================================================================
//   LogTableBuilder;
//   Builds the Table according some condition (key)
//======================================================================

class LogTableBuilder{

  private String keyString;
  private Vector mTableData;

  //
  // The LogTableBuilder which builds the Table by specified module name
  // If necessary one could add the other builder constructors
  //
  public LogTableBuilder(String sourceName){
    keyString = sourceName;
    mTableData = new Vector();
  }

  public void build(Vector logs) {
    //Vector mTableData = new Vector();
    for (int i=0; i<logs.size(); ++i){
      if (((CLogRecord)logs.get(i)).source.equals(keyString)){

        Vector currRecord = new Vector();
        currRecord.add(((CLogRecord)logs.get(i)).dateAndTime);
        currRecord.add(((CLogRecord)logs.get(i)).typeString);
//        currRecord.add(((CLogRecord)logs.get(i)).source);
//        currRecord.add(((CLogRecord)logs.get(i)).sourceThread);
        currRecord.add(((CLogRecord)logs.get(i)).message);

        mTableData.add(currRecord);
      }
    }
    //return result;
  }
  //---------------------------------------------------------
  public Vector getTableData(){
    return mTableData;
  }

}
