package dbridge;

import javax.swing.JOptionPane;
import javax.swing.JLabel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.*;

import javax.swing.ImageIcon;
import java.awt.Dimension;

/*
 * Modified 28.09.04
 * Modified 15.04.05
 */

public class PassDlg extends javax.swing.JDialog {
  public PassDlg() {
    try {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  private UserInfo user=null;
    private JOptionPane optionPane;
    private JLabel jLabel1;
    private JLabel jLabel3;
    private JLabel jLabel2;
    private JPasswordField jpfConfirmPass;
    private JPasswordField jpfPass;
    private JTextField jtfUser;

    public UserInfo getUserInfo() {
      return user;
    }

//=========== BOB ===================================
//TODO: Change this to have same code only once!!!

  public PassDlg(java.awt.Frame parent, boolean modal, String user_name) {
    super(parent, modal);
    Locale currentLocale = BridgeApp.getCurrentLocale();
    ResourceBundle labels = ResourceBundle.getBundle("dbridge.prop.PassDlgLabelsBundle",currentLocale);

    setResizable(false);
    jpfPass = new JPasswordField("",17);
    Dimension fmax=new Dimension(200,27);
    Dimension fmin=new Dimension(200,27);
    Dimension fpref=new Dimension(200,27);
    jpfPass.setMaximumSize(fmax);
    jpfPass.setMinimumSize(fmin);
    jpfPass.setPreferredSize(fpref);

    jpfConfirmPass = new JPasswordField("",17);
    jpfConfirmPass.setMaximumSize(fmax);
    jpfConfirmPass.setMinimumSize(fmin);
    jpfConfirmPass.setPreferredSize(fpref);

    String lLabel = labels.getString("User");
    jLabel1 = new JLabel(lLabel);
    jLabel1.setIcon(new ImageIcon("./lib/res/users.gif"));
    lLabel = labels.getString("Pass");
    jLabel2 = new JLabel(lLabel);
    jLabel2.setIcon(new ImageIcon("./lib/res/key.gif"));
    lLabel = labels.getString("ConfPass");
    jLabel3 = new JLabel(lLabel);
    jLabel3.setIcon(new ImageIcon("./lib/res/key.gif"));
    if ((user_name!=null) && (user_name.length()!=0)) {
      lLabel = labels.getString("ChPassTitle");
      setTitle(lLabel);
	    jtfUser = new JTextField(user_name,14);
    	jtfUser.setEnabled(false);
    } else {
      lLabel = labels.getString("AuthTitle");
      setTitle(lLabel);
      jtfUser = new JTextField("",14);
      jtfUser.setMaximumSize(fmax);
      jtfUser.setMinimumSize(fmin);
      jtfUser.setPreferredSize(fpref);

      jpfConfirmPass.setVisible(false);
      jLabel3.setVisible(false);
    }

    Object[] array = {jLabel1, jtfUser, jLabel2, jpfPass,jLabel3, jpfConfirmPass};
    final String btnString1 = labels.getString("OKString");//"Ok";
    final String btnString2 = labels.getString("CancelString");//"Cancel";
    Object[] options = {btnString1, btnString2};

    optionPane = new JOptionPane(array,JOptionPane.QUESTION_MESSAGE,JOptionPane.YES_NO_OPTION,
                                 null, options, options[0]);
    setContentPane(optionPane);
    setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent we) {
        optionPane.setValue(new Integer(JOptionPane.CLOSED_OPTION));
      }
    });

    optionPane.addPropertyChangeListener(new java.beans.PropertyChangeListener() {
      public void propertyChange(java.beans.PropertyChangeEvent e) {
        String prop = e.getPropertyName();
        if (isVisible() && (e.getSource() == optionPane) &&
           (prop.equals(JOptionPane.VALUE_PROPERTY) ||
            prop.equals(JOptionPane.INPUT_VALUE_PROPERTY))) {
              Object value = optionPane.getValue();
              if (value == JOptionPane.UNINITIALIZED_VALUE) {
               //ignore reset
                return;
              }
              optionPane.setValue(JOptionPane.UNINITIALIZED_VALUE);
              if (value.equals(btnString1)) {
                String pass = new String (jpfPass.getPassword());
                if (jLabel3.isVisible()) {
		              String confirmPass = new String (jpfConfirmPass.getPassword());
                  if (pass.equals(confirmPass)) {
		                user = new UserInfo (jtfUser.getText(),pass,true);
		                setVisible(false);
                  } else {
                    Locale currentLocale = BridgeApp.getCurrentLocale();
                    ResourceBundle labels = ResourceBundle.getBundle("PassDlgLabelsBundle",currentLocale);
                    String errorMsg = labels.getString("ErrorMsg");
                    String errorTitle = labels.getString("ErrorTitle");
                    JOptionPane.showMessageDialog(PassDlg.this,errorMsg, errorTitle, JOptionPane.ERROR_MESSAGE);
                    jpfPass.setText("");
                    jpfConfirmPass.setText("");
                  }
                } else {
                  user = new UserInfo(jtfUser.getText(),pass, false);
                  setVisible(false);
                }

              } else { // user closed dialog or clicked cancel
                user = null;
                setVisible(false);
                dispose();
              }
        }
      }
    });

    pack();
    this.setSize(400,240);
  }

//============= END BOB =====================================
    public static void main(String[] args){
      //JFrame passFrame=new JFrame();
      PassDlg passDlg=new PassDlg(null, true, "User1");
      //passDlg.setLocationRelativeTo(passFrame);

        passDlg.setTitle("User login");
        passDlg.setVisible(true);
    }

  private void jbInit() throws Exception {
  }
}
