
package dbridge;

import java.util.*;

import javax.activation.DataHandler;
import javax.activation.DataSource;
import javax.mail.*;
import javax.mail.internet.*;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.security.Security;

/*
 * Created: 01.11.03
 * Modified 25.01.04
 * Modified 25.01.06
 * Modified 13.02.06
 * Modified 15.02.06
 * Modified 16.02.06
 */

class SenderFactory
{
	public static Sender newInstance()
	{
		if (BridgeApp.isSplitterOn())
                //if (DBConsts.SMTP_SEND_SPLITTED)
                        return new SplittingSender(BridgeApp.getSplitterSize());
			//return new SplittingSender(DBConsts.SMTP_SPLIT_SIZE);
		else
			return new Sender(0);
	}
}

public class Sender {

    public Sender(int tmp) {
        this.to="";
        this.from="";
        this.subject="";
        this.host="";
        this.mPort=null;
        this.sslFlag=true;
        isConnected = false;
//        this.mMethodDN = DBConsts.MDN_NONE;
//        this.mMethodSign = DBConsts.PGPSIGN_NONE;
//        this.mReplayTo = "";
    }

//    public Sender(dbSmtpRecord smtpRec){
//	this.to = "test@test.net";
//	this.from = "test.test.org";
//	this.subject = "mail for test";
//	this.host = smtpRec.getIP();
//	this.userName = smtpRec.getLogin();
//	this.password = smtpRec.getPassword();
//        this.mPort = Integer.toString(smtpRec.getPort());
//	this.sslFlag = smtpRec.isSSL();
//        this.isConnected = false;
//        this.mMethodDN = DBConsts.MDN_NONE;
//        this.mMethodSign = DBConsts.PGPSIGN_NONE;
//        this.mReplayTo = "";
//    }
//
//    public Sender(String host) {
//        this.to="";
//        this.from="";
//        this.subject="";
//        this.host=host;
//        this.mPort=null;
//        this.sslFlag=true;
//        isConnected = false;
//        this.mMethodDN = DBConsts.MDN_NONE;
//        this.mMethodSign = DBConsts.PGPSIGN_NONE;
//        this.mReplayTo = "";
//    }

    public void setSSL(boolean flag) {
      this.sslFlag=flag;
    }

    public void setPort(String port) {
      this.mPort=port;
    }

    public String getPort() {
      return this.mPort;
    }

    public String getUserName(){
            return userName;
    }

    public void setUserName(String user){
	this.userName=user;
    }

    public void setPassword(String pass){
	this.password=pass;
    }

    public String getHost(){
            return host;
    }

    public void setHost(String host){
	this.host=host;
    }

    public String getTo(){
            return to;
    }

    public void setTo(String to){
            this.to = to;
    }

    public String getFrom(){
            return from;
    }

    public void setFrom(String from){
            this.from = from;
    }

    public String getSubject(){
            return subject;
    }

    public void setSubject(String subject){
            this.subject = subject;
    }
/*
    public int getMethodDN(){
            return this.mMethodDN;
    }

    public void setMethodDN(int method){
            this.mMethodDN = method;
    }
    public int getMethodSign(){
        return this.mMethodSign;
    }

    public void setMethodSign(int method){
        this.mMethodSign = method;
    }

    public String getReplayTo(){
        return this.mReplayTo;
    }

    public void setReplayTo(String addr){
        this.mReplayTo = addr;
    }
*/
    /**
     * mcdi introduced this logically separated method
     * @return
     */
    public Session constructSessionObject()
    {
        Properties props = new Properties();
        props.setProperty("mail.smtp.auth","true");

        if (sslFlag) {

          final String SSL_FACTORY = "dbridge.CMySSLSocketFactory";
          props.setProperty( "mail.smtp.socketFactory.class", SSL_FACTORY);
          props.setProperty( "mail.smtp.socketFactory.fallback", "false");
          props.setProperty( "mail.smtp.port", "465");
          props.setProperty( "mail.smtp.socketFactory.port", "465");
        }

        // REM mcdi have corrected '||' to '&&'
        if ((mPort!=null) && (mPort.length()!=0)) {
           props.setProperty( "mail.smtp.port", mPort);
           props.setProperty( "mail.smtp.socketFactory.port", mPort);
        }

        return Session.getInstance(props);
    }

    public void connect() throws Exception
	{
        Security.addProvider( new com.sun.net.ssl.internal.ssl.Provider());

        Session mSession = constructSessionObject();
        mSession.setDebug(false);
        mTransport = mSession.getTransport("smtp");
        mTransport.connect(host, userName, password);
        isConnected = true;
	}

    public void disconnect()
	{
      if (isConnected)
	  {
       try
	   {
        mTransport.close();
        isConnected = false;
       }catch (Exception ex)
	   {
         BridgeApp.LogError(Logs.Srvcs.SetText("Disconnect error: "+ex));
         throw (new RuntimeException("Disconnect error"));
       }
      }
    }

    public boolean check() {
      try {
        boolean result = false;
        connect();
        result = isConnected;
        disconnect();
        return result;
      } catch (Exception ex) {
        return false;
      }
    }

    /**
     * Prevential connection reinitialization (required for some servers)
     * @return boolean
     */
    public boolean reconnect() {
      try {
        disconnect();
        connect();
        return isConnected;
      } catch (Exception ex) {
        return false;
      }
    }


//If you need SMTP authentication set auth=true
    public void sendMail(Message msg) {
 //   tetsSend ();
      if ((to.length()==0) || (from.length()==0) || (host.length()==0))
      {
        throw new RuntimeException("Not enough information for sending. Please, set all parameters (to, from, host and fileName).");
      }

      if (subject.length()==0)
      {
        subject = "no subject";
      }

      try{

      // create a message
        msg.setFrom(new InternetAddress(from));
        //InternetAddress[] address = {new InternetAddress(to)};
        InternetAddress[] address = InternetAddress.parse(to);
        msg.setRecipients(Message.RecipientType.TO, address);
        msg.setSubject(subject);

      // set the Date: header
        msg.setSentDate(new Date());

      // send the message
          boolean shouldDisconnect=false;
          if (!isConnected) {
            connect();
            shouldDisconnect=true;
            BridgeApp.LogWarning(Logs.Srvcs.SetText("Sender: selfconnection!"));
          }
          msg.saveChanges();	// don't forget this
          sendMessage(msg,mTransport);
          //mTransport.sendMessage(msg, msg.getAllRecipients());
          if (shouldDisconnect) {
            disconnect();
            shouldDisconnect=false;
            BridgeApp.LogWarning(Logs.Srvcs.SetText("Sender: selfdisconnection!"));
          }
//          tr.close();

      } catch (Exception ex) {
        BridgeApp.LogError(Logs.Srvcs.SetText("Send error: "+ex));
        throw (new RuntimeException("Send error"));
      }

    }
	protected void sendMessage(Message in_msg, Transport transp) throws MessagingException, IOException
	{
        transp.sendMessage(in_msg, in_msg.getAllRecipients());
	}


    /**
    String with recepient address
    */
    private String to;

    /**
    String with sender address
    */
    private String from;

    /**
    String with mail subject
    */
    private String subject;

    /**
    SMTP host name
    */
    private String host;

    /**
    User name for SMTP auth.
    */
    private String userName;

    /**
    password for SMTP auth.
    */
    private String password;

    /**
     Port for connection
    */
    private String mPort;

    /**
     type of transport:
     if true - ssl connection will be used
     */
    private boolean sslFlag;

    //Session for sending:
    protected Session mSession;
    private Transport mTransport;
    private boolean isConnected;
    /**
     * disposition notification method
     * takes values from DBConsts
     */
//    private int mMethodDN;
    /**
     * PGP Signature method
     * takes values from DBConsts
     */
//    private int mMethodSign;

    /**
     * Replay Address
     * takes values from DBConsts
     */
//    private String mReplayTo;


/*      public void tetsSend () {
  try{
  //-------------------------
      //Properties props = new Properties();
      Properties props = System.getProperties();
          //props.put("mail.transport.protocol","smtp");
          props.setProperty("mail.smtp.auth","true");
          String host="10.3.22.128";
          String userName="ruggiero";
          String password="test98";
          String from="ruggiero@10.3.22.128";

          String to="test_1111@tut.by";
          String subject="hi";

//---------------SSL----------------------
          Security.addProvider( new com.sun.net.ssl.internal.ssl.Provider());
          final String SSL_FACTORY = "CMySSLSocketFactory";
          props.setProperty( "mail.smtp.socketFactory.class", SSL_FACTORY);
          props.setProperty( "mail.smtp.socketFactory.fallback", "false");
          props.setProperty( "mail.smtp.port", "465");
          props.setProperty( "mail.smtp.socketFactory.port", "465");
//----------------------------------------
System.out.println("Port in prop: "+props.getProperty("mail.smtp.port"));
        Session session = Session.getInstance(props);      //Default
        session.setDebug(true);
System.out.println("Port in ses1: "+session.getProperty("mail.smtp.port"));
      // create a message
          MimeMessage msg = new MimeMessage(session);
          msg.setText("Hi there");

        msg.setFrom(new InternetAddress(from));
        //InternetAddress[] address = {new InternetAddress(to)};
        InternetAddress[] address = InternetAddress.parse(to);
        msg.setRecipients(Message.RecipientType.TO, address);
        msg.setSubject(subject);

      // set the Date: header
        msg.setSentDate(new Date());

      // send the message
          Transport tr = session.getTransport("smtp");
System.out.println("Port in ses2: "+session.getProperty("mail.smtp.port"));
          tr.connect(host, userName, password);
          msg.saveChanges();	// don't forget this
          tr.sendMessage(msg, msg.getAllRecipients());
          tr.close();
      } catch (Exception ex) {
        System.out.println("Send error: "+ex);
        throw (new RuntimeException("Send error"));
      }
  //-------------------------
    System.out.println("Starting sslsmtptst...");
  }
  public static void main(String args[]) {
  Sender mySend=new Sender();
      mySendKaktyzaebal.tetsSend();
  }
 */
}
/**
 * Sender that send message aplitting it into smaller parts as described in RFC2046
 * @author mcdi
 *
 */
class SplittingSender extends Sender
{
	private int m_split_size;

	public SplittingSender(int split_size)
	{
		super(0);
		m_split_size=split_size;
	}

	private String createUnquePartialMessageId(String host)
	{
		return FileTools.makeUniqName()+"@"+host;
	}
	protected void sendMessage(Message in_msg, Transport transp) throws MessagingException, IOException
	{
		String message_partial_id=createUnquePartialMessageId(transp.getURLName().getHost());

    	//
    	// Split message into the smaller parts
    	//
		ByteArrayOutputStream os=new ByteArrayOutputStream();
		in_msg.writeTo(os);
		if (os.size()<=m_split_size)
		{
			//
			// Send message in usual way
			//
			super.sendMessage(in_msg,transp);
		}
		else
		{
			//
			// Send message in smaller parts
			//
			Collection parts_coll=MessageBufferParser.parse(m_split_size,os.toByteArray());
			Iterator it=parts_coll.iterator();
			int i=0;
			while (it.hasNext())
			{
				MimeMessage msg=new MimeMessage(mSession);
				byte[] part_bytes=(byte[])it.next();
		        msg.setDataHandler(new DataHandler(
		        				new DataSource4PartialMsgContentType(part_bytes,message_partial_id,++i,parts_coll.size())));
	            msg.setFrom(in_msg.getFrom()[0]);
	            msg.setRecipients(Message.RecipientType.TO, in_msg.getAllRecipients());
	            msg.setSubject(in_msg.getSubject()+" ("+i+"/"+parts_coll.size()+")");
	            msg.setSentDate(new Date());
	            //
	            // send the message
	            //
	            msg.saveChanges();
	            transp.sendMessage(msg, msg.getAllRecipients());
			}
		}
	}
}

/**
 * Class to process special Content-Type=Message/Partial
 * @author mcdi
 *
 */
class DataSource4PartialMsgContentType implements DataSource
{
	public DataSource4PartialMsgContentType(byte[] part_bytes,String id,int i,int n)
	{
		m_part_bytes=part_bytes;
		//mContentType="Message/Partial;id=\""+id+"\";number="+i+";total="+n;
		mContentType=Rfc2046Names.TYPE_MESSAGE_PARTIAL+";"
					+ Rfc2046Names.ATTR_ID+"=\""+id+"\";"
					+ Rfc2046Names.ATTR_NUMBER+"="+i+";"
					+ Rfc2046Names.ATTR_TOTAL+"="+n;
	}

	public String getContentType() {
		return mContentType;
	}

	public InputStream getInputStream() throws IOException {
		return new ByteArrayInputStream(m_part_bytes);
	}

	public String getName() {
		return "part";
	}

	public OutputStream getOutputStream() throws IOException {
		return new ByteArrayOutputStream();
	}
	byte[] m_part_bytes;
	String mContentType;
}
/**
 * Class to split original message to the parts accordingly to RFC2046
  * @author mcdi
 *
 */
class MessageBufferParser
{
	public static Collection parse(int max_part_size, byte[] message)
	{
		LinkedList out=new LinkedList();
		int curr_pos=0;
		while (message.length-curr_pos>0)
		{
        	// 1. Fragmentation agents must split messages at line
            // boundaries only. This restriction is imposed because
            // splits at points other than the ends of lines in turn
            // depends on message transports being able to preserve
            // the semantics of messages that don't end with a CRLF
            // sequence. Many transports are incapable of preserving
            // such semantics.

			//
			// Find end of next part
			//
			int eos_fwd=searchEosForward(curr_pos+max_part_size, message);
			int eos_bwd=searchEosBack(curr_pos+max_part_size, message);

			int dist_bwd=curr_pos+max_part_size-eos_bwd;
			int dist_fwd=eos_fwd-curr_pos-max_part_size;
			int next_part_sz=0;
			if ( dist_bwd<=dist_fwd && dist_bwd<max_part_size )
			// using backward point
			{
				next_part_sz=max_part_size-dist_bwd;
			}
			else
			// using forward point
			{
				next_part_sz=dist_fwd+max_part_size;
			}
			//
			// Form next part
			//
			byte[] buf_for_part=new byte[next_part_sz];
			System.arraycopy(message,curr_pos, buf_for_part,0,next_part_sz);
			out.add(buf_for_part);
			//
			// Increment iteration params
			//
			curr_pos=findNextNotCRLF(curr_pos+next_part_sz, message);

		}
		return out;
	}
	static private int findNextNotCRLF(int from, byte[] arr)
	{
		for (int i=from; i<arr.length; ++i)
		{
			if (arr[i]!='\r' && arr[i]!='\n' )
				return i;
		}
		return arr.length;
	}
	static private int searchEosForward(int from, byte[] arr)
	{
		for (int i=from; i<arr.length; ++i)
		{
			if (arr[i]=='\r' )
				return i;
		}
		return arr.length;
	}
	static private int searchEosBack(int from, byte[] arr)
	{
		int n=from<arr.length?from:arr.length-1;
		for (int i=n; i>=0; --i)
		{
			if (arr[i]=='\r' )
				return i;
		}
		return 0;
	}
}

