package dbridge;

/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author unknown
 * @version 1.0
 */
import java.util.*;
import java.io.*;
import java.util.zip.*;

/**
 * This is a vector of objects, which consist of users infos.
 * It includes also read/write file operations.
 * public methods
 * @UserContainer()
 * @UserContainer(dbUser obj)
 * @void append(dbUser obj)
 * @void reset()
 * @void print()
 * @void toFile(String name)
 * @void fromFile(String name)
 *
 */

/*
 * Created: 22.01.03
 * Modified 24.01.04
 * Modified 05.03.04
 * Modified 07.03.04
 * Modified 21.03.04
 * Modified 15.12.04  Cloneable and copy-consructor, add delete (dbUser)
 */

public class UserContainer implements Cloneable{
Vector v;
int size;
  public UserContainer() { // default constructor
    v=new Vector();
    size=0;
  }
  public UserContainer(dbUser obj) { // parametrized constructor
    v=new Vector();
    size=1;
    v.add(obj);
  }

  public UserContainer(UserContainer obj){ // copy constructor
    v = (Vector) obj.getUsersVector().clone(); //ok, since dbUser also Cloneable
    size = v.size();
  }

  public void append(dbUser obj){ // add new object into the vector
    v.setSize(size);
    v.add(obj);
    size++;
  }// end append

  public Object clone(){
    return new UserContainer(this); // call copy-constructor
  }

  public void delete(int index){ // delete an object from the vector
    if (index>=0 && index<size){
      v.removeElementAt(index);
      size--;
    } else {
      BridgeApp.LogError(Logs.Srvcs.SetText("Error: wrong index in UserContainer::delete method"));
	}
  }// end delete

  public void delete(dbUser obj) { //delete the specified object
    v.remove(obj);
    size = v.size();
  }

  public void reset(){ // reset the vector
    size=0;
    v.removeAllElements();
  }// end reset

  public Vector getUserLoginList(){ //return a vector of user's logins
    Vector list=new Vector();
    for (int i=0; i<size; i++){
      list.add(((dbUser)v.get(i)).getLogin());
    }
    return list;
  }/// end getUserList

  public Vector getUsersVector(){
    return v;
  }

  public void setUsersVector(Vector new_v){
    v.clear();
    v = new_v;
    size = v.size();
  }

  public Vector getAutoUserList(){ //return a vector of autouser's logins
    Vector list=new Vector();
    for (int i=0; i<size; i++){
      if ( ((dbUser)v.get(i)).isAutomatic() )
      list.add(((dbUser)v.get(i)).getLogin());
    }
    return list;
  }/// end getUserList

  public Vector getManualUserList(){ //return a vector of manualuser's logins
    Vector list=new Vector();
    for (int i=0; i<size; i++){
      if ( ((dbUser)v.get(i)).isManual() )
      list.add(((dbUser)v.get(i)).getLogin());
    }
    return list;
  }/// end getUserList

  public boolean isLoginValid(String Login){
    boolean result = true;
    for (int i=0; i<size; i++){
      //Verify if the same login exists
      if (((dbUser)v.get(i)).getLogin().compareTo(Login)==0) result = false;

      //Insert any other checks here ....
    }
    if (Login.equals("")) result = false;

    return result;
  }

  public boolean isPassValid(String Login, String Pass){
    int index = this.getUserIndex(Login);
    if (index==-1) return false;
    if (((dbUser)v.get(index)).getPassword().compareTo(Pass)==0) return true;
    else return false;
  }

 public int getUserIndex(String login){ //return an index
    int r=-1; // no such user stored
    int i=0;
    while (i<size){
      if ( login.compareTo( ((dbUser)v.get(i)).getLogin() )==0 ){
         r=i; i=size;
      } else {
         i++;
      }
    }
    return r;
  }/// end getUserIndex

  public int getUserIndex(dbUser user){ //return an index
     return getUserIndex(user.getLogin());
  }

  public dbUser getUser(int index){ //return a user if exists or null esle
    if ( index<0 || index >= size ) return null;
      return (dbUser)v.get(index);
  }/// end getUser

  public dbUser getUser(String user){ //return a user if exists or null esle
    int ind=getUserIndex(user);
    return getUser(ind);
  }/// end getUser

  // important if user date base was exported
  public void activateHomes(String root){
    for (int i=0; i<size; i++){
      if ( ((dbUser)v.get(i)).isManual() || ((dbUser)v.get(i)).isAutomatic() )
      ((dbUser)v.get(i)).createDir(root);
    }
  }

 
/**
 * Depricated method  TODO Remove
 * @deprecated
 * @param name
 * @return
 */
 
  public boolean toFile(String name){ // write the vector into a file
    boolean r=false;
    try {
/*       String key="BridgeApp";
       SecretKeySpec keyspec = new SecretKeySpec (key.getBytes(), "Blowfish");
       Cipher cipher = Cipher.getInstance("Blowfish/ECB/PKCS5Padding");
       cipher.init(Cipher.ENCRYPT_MODE, keyspec);
       ObjectOutputStream oFile=new ObjectOutputStream(new CipherOutputStream(new FileOutputStream(name), cipher));
*/
       ObjectOutputStream oFile=new ObjectOutputStream(new GZIPOutputStream(new FileOutputStream(name)));

       for ( int i=0; i<size; i++ ){
          dbUser obj=(dbUser)v.get(i);
          //if ( obj.isAutomatic() ) obj.print();  // Debug
          oFile.writeObject(obj.getPermanentBase());
          oFile.flush();
       }
       oFile.close();
       r=true;
    }
    catch(Exception e){
      BridgeApp.LogError(Logs.Srvcs.SetText(e.getMessage()));
      r=false;
    }
    return r;
  }// end toFile

  public boolean toFile(String name, dbVersion version){ // write the vector into a file
    boolean r=false;
    try {
/*       String key="BridgeApp";
       SecretKeySpec keyspec = new SecretKeySpec (key.getBytes(), "Blowfish");
       Cipher cipher = Cipher.getInstance("Blowfish/ECB/PKCS5Padding");
       cipher.init(Cipher.ENCRYPT_MODE, keyspec);
       ObjectOutputStream oFile=new ObjectOutputStream(new CipherOutputStream(new FileOutputStream(name), cipher));
*/
       ObjectOutputStream oFile=new ObjectOutputStream(new GZIPOutputStream(new FileOutputStream(name)));
       try {
         oFile.writeObject(version); // save the version
       }catch(Exception e){
           BridgeApp.LogError(Logs.Bank.SetText("Cannot copy the version " + version.getMainVersionN() +":"+ version.getModificationN() +":"+ version.getDataBaseN() + "into the user database"));
       }
       for ( int i=0; i<size; i++ ){
          dbUser obj=(dbUser)v.get(i);
          //if ( obj.isAutomatic() ) obj.print();   // Debug
          oFile.writeObject(obj.getPermanentBase());
          oFile.flush();
       }
       oFile.close();
       r=true;
    }
    catch(Exception e){
      //BridgeApp.LogError(Logs.Srvcs.SetText(e.getMessage()));
      r=false;
    }
    return r;
  }// end toFile

  /**
   * Depricated method  TODO Remove
   * @deprecated
   * @param name
   * @return
   */  
  public boolean fromFile(String name){ // read the vector from a file
    boolean r=false;
    try {
/*       String key="BridgeApp";
       SecretKeySpec keyspec = new SecretKeySpec (key.getBytes(), "Blowfish");
       Cipher cipher = Cipher.getInstance("Blowfish/ECB/PKCS5Padding");
       cipher.init(Cipher.DECRYPT_MODE, keyspec);
       ObjectInputStream iFile=new ObjectInputStream(new CipherInputStream(new FileInputStream(name), cipher));
*/
        ObjectInputStream iFile=new ObjectInputStream(new GZIPInputStream(new FileInputStream(name)));

        size=0;
        boolean done=false;
       while(!done){
          try{
            dbUser obj=new dbUser( (DPermanentBase)iFile.readObject() );
            //obj.print();
            append(obj);
          } catch(IOException ioe){
            // end of file is reached
            iFile.close();
            done=true;
            r=true;
          }// end catch
      }// end while
    } catch(Exception e){
            r=false;
    }
    return r;
  }// end fromFile

  public boolean fromFile(String name, dbVersion version){ // read the vector from a file
    boolean r=false;
    try {
/*       String key="BridgeApp";
       SecretKeySpec keyspec = new SecretKeySpec (key.getBytes(), "Blowfish");
       Cipher cipher = Cipher.getInstance("Blowfish/ECB/PKCS5Padding");
       cipher.init(Cipher.DECRYPT_MODE, keyspec);
       ObjectInputStream iFile=new ObjectInputStream(new CipherInputStream(new FileInputStream(name), cipher));
*/
        ObjectInputStream iFile=new ObjectInputStream(new GZIPInputStream(new FileInputStream(name)));
        //
        // Check the version
        //
        dbVersion ver;
        try {
          ver = new dbVersion( (dbVersion)iFile.readObject() );
        }catch(Exception e){
          BridgeApp.LogError(Logs.Bank.SetText("Cannot read the version number from the user database"));
          iFile.close();
          return false;
        }
        if ( ver.getDataBaseN()!=version.getDataBaseN() ){
          BridgeApp.LogError(Logs.Bank.SetText(
              "The version of the software ("+version.getDataBaseN()+") is not coinsident with the version of the user database ("+ ver.getDataBaseN() +")"));
          iFile.close();
          //
          // bachup the old DB
          //
          File source=new File(name);
          File dest=new File(new String(name+".bcp"));
          if (dest.exists()){
            if (!dest.delete()) {
              BridgeApp.LogInfo(Logs.Bank.SetText("Cannot delete bachup"));
            }
            else {
              BridgeApp.LogInfo(Logs.Bank.SetText("Backup file was deleted"));
            }
          }// end destination exists
          if ( source.renameTo(dest) ){
            BridgeApp.LogInfo(Logs.Bank.SetText("User database has been backuped into a file with the *.bcp extension "));
          } else {
                    BridgeApp.LogInfo(Logs.Bank.SetText(
                        "User database has been not backuped into a file with the *.bcp extension"));
          }// end else
          return false;
        }// end if version
        //
        // loading
        //
        size=0;
        boolean done=false;
        while (!done) {
          try {
            dbUser obj = new dbUser( (DPermanentBase) iFile.readObject());
            append(obj);
          }
          catch (IOException ioe) {
            // end of file is reached
            iFile.close();
            done = true;
            r = true;
          } // end catch
        } // end while
    } catch(Exception e){
            r=false;
    }
    return r;
  }// end fromFile

  // change default dicom server for automatic users
  // TODO test this  (former - for all users)
   public void setDefaultServer(dsDcmServerClass srv){
    for (int i=0; i<size; i++){
        if ( ((dbUser)v.get(i)).isAutomatic() )
        ((dbUser)v.get(i)).setDefDCMsrv(srv);
    }
  }

  // from Backup
  public boolean fromBackup(Vector restoredUsers){ // read the vector from a Backup user list
    boolean r=false;
    if ( restoredUsers.size()>0 ){
         this.reset();
         for ( int i=0; i<restoredUsers.size(); i++ ){
            append((dbUser)restoredUsers.get(i));
         }
         return true;
    }
    return r;
  }


  // check links to a given DCM server with a number "index"

  // BOB: What if 2 manual users has the same SMTP servers?
  // I think the result is not correct.
  // Need first to check the MASTER user ...

  public Vector getLinkedSmtpServers(String uname, int index){
    // OOO to do
    Vector list=new Vector();
    dbSmtpRecord rec = this.getUser(uname).getSmtpTable().getRecord(index);
    // compare this record with records from DB
    dbUser user=null;
    for (int i=0; i<size; i++){
      if ( ((dbUser)v.get(i)).isAutomatic() ){
         user=(dbUser)v.get(i);
         if ( uname.compareTo( ((dbUser)v.get(i)).getName() )==0 ){
            int n=user.getSmtpTable().getSize();
            int j=0;
            while (j<n){
              if ( rec.isEqual( user.getSmtpTable().getRecord(j)) ){
                list.add((String)user.getLogin());
                j=n;
              } else {
                j++;
              }
            }// end while
         }
      }
    }// end for
    return list;
  }
    // find an old user with the same login as a new user has
    // find a linked automatic user
    // find which smtp record was changed
    // update the automatic user
    // the old user will not be updated here
  public Vector updateLinkedSmtpServers(dbUser newuser){
    // OOO to do
    Vector list=new Vector();
    dbUser user=null;
    dbUser olduser=null;
    // get an old user
    olduser=this.getUser(newuser.getLogin());
    // find automatic users, connected to the olduser and fine an index of the used smtp server
    for (int i=0; i<size; i++){
      if ( ((dbUser)v.get(i)).isAutomatic() ){
         user=(dbUser)v.get(i);
         if ( olduser.getLogin().compareTo( ((dbUser)v.get(i)).getName() )==0 ){
            // linked user is found
            int n=olduser.getSmtpTable().getSize();
            int j=0;
            while (j<n){
              if ( user.getSmtpTable().getRecord(0).isEqual( olduser.getSmtpTable().getRecord(j)) ){
                // update the record
                user.getSmtpTable().setElementAt( newuser.getSmtpTable().getRecord(j), 0 );
                list.add(user.getLogin());
                j=n;
              } else {
                j++;
              }
            }// end while
          }
      }
    }// end for

    return list;
  }

  // check links to a given user "index"
  public Vector getLinkedUsers(int index){
    // OOO to do
    dbUser user=null;
    Vector list=new Vector();
    user=this.getUser(index);  // Master
    for (int i=0; i<size; i++){
      if ( ((dbUser)v.get(i)).isAutomatic() ){
         // compare user login with user Name of automatic users
         if ( user.getLogin().compareTo( ((dbUser)v.get(i)).getName() )==0 ){
              list.add((String)((dbUser)v.get(i)).getLogin());
         }
      }
    }// end for
    return list;
  }

   // DEBUG
   public void print(){ // print the vector
    for ( int i=0; i<size; i++ ){
      System.out.println("############ record N ###########");
      dbUser obj=(dbUser)v.get(i);
      obj.print();
    }
  }// end print

  // DEBUG
  public static void main(String[] args) {
    UserContainer uc = new UserContainer();

    int ch=0;//System.in.read();
    if ( ch==0 ){
      // write to file
      dbUser obj=new dbUser("user0","usr0","","");
      uc.append(obj);
      dbUser obj1=new dbUser("user1","usr1","","");
      uc.append(obj1);
      uc.print();
      uc.toFile("my_file.txt");
    } else{
      // read from file
      uc.fromFile("my_file.txt");
    }
    System.out.println("data from file");
    uc.print();
    dbUser obj2=new dbUser();
    obj2.setName("user2");
    obj2.setLogin("usr2");
    uc.append(obj2);
    // check if user usr2  exists
    int ind=uc.getUserIndex("usr2");
    System.out.println("User usr2 has the index " + ind);
    ind=10;
    ind=uc.getUserIndex("usr2");
    System.out.println("!!!!User usr2 has the index " + ind);
    dbUser uu=uc.getUser("usr2");
    System.out.println("print");
    uu.print();
    System.out.println("******************************************");
    // delete usr2
    uc.delete(ind);
    uc.print();
    // display the list of users
    Vector l=new Vector();
    l=uc.getUserLoginList();
    for (int i=0; i<l.size(); i++)
      System.out.println((String)l.get(i));
  }
}// end of class
