package dbridge;

import javax.swing.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.border.*;

import java.util.Iterator;
import java.util.Vector;
import java.util.Locale;
import java.util.ResourceBundle;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class XAddrBookRecDlg extends JDialog {

  private dbMailRecord mMailRecord;
  private dbSmtpTable mSmtpTable = null;
  private int mSelSrvInd = 0;
  private boolean mOk = false;
 
  JPanel button_pan = new JPanel();
  JPanel comment_pan = new JPanel();
  JPanel main_pan = new JPanel();
  JScrollPane comments_ScrollPane = new JScrollPane();
  JButton jbOk = new JButton();
  JTextArea comments_TextArea = new JTextArea();
  JButton jbCancel = new JButton();
  EmailField jtfLogin = new EmailField();
  Box main_pan_box;
  TitledBorder titledBorder1;
  TitledBorder titledBorder2;
  BorderLayout borderLayout1 = new BorderLayout();
  JButton jbKey = new JButton();
  JTextField jtfKey = new JTextField();
  TitledBorder titledBorder3;
  JPanel smtp_pan = new JPanel();
  ServerField jtfSmtpSrv = new ServerField();
  JButton jbSelSmtp = new JButton();
  TitledBorder titledBorder6;
  TitledBorder titledBorder7;

  JComboBox notif_cb;
  JComboBox sign_cb;
  JComboBox priv_keys_cb;
  
  private String mTitle;
  private String mErr;
  private String mNoSmtp_err;
  private String mAddr_err;
  private String mServ_err;
  private String mKey_err;
  
 

  //-------------------------------------------------------------------------
  public XAddrBookRecDlg(Dialog frame, String title, boolean modal) {
    super(frame, title, modal);
    //setIconImage(Toolkit.getDefaultToolkit().getImage(BridgeApp.getConstants().mWindowIcon));
    mMailRecord=new dbMailRecord("","","",10);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }
  //-------------------------------------------------------------------------
  public XAddrBookRecDlg(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    mMailRecord=new dbMailRecord("","","",10);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }
//----------------------------------------------------------------------
  public XAddrBookRecDlg(Dialog frame, String title, boolean modal,
         dbSmtpTable oSmtpTable) {
    super(frame, title, modal);
    this.mSmtpTable = oSmtpTable;
    mMailRecord=new dbMailRecord("","","",10);
    try {
      jbInit();
      pack();
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }

    if (mSmtpTable.getSize()>0){
      this.jtfSmtpSrv.setText(mSmtpTable.getRecord(0).getIP());
    }
  }
  //-------------------------------------------------------------------------
  public void setSmtpTable(dbSmtpTable oSmtpTable){
      this.mSmtpTable = oSmtpTable;
  }
  //--------------------------------------------------------------------------

  public void setMethodDN(int method){
    notif_cb.setSelectedIndex(method);
  }

  public void setMethodPGPSign(int method){
	    sign_cb.setSelectedIndex(method);
	  }
  
  public void setPrivKeys(Vector keys){
	  priv_keys_cb.removeAll();
	  for(Iterator it = keys.iterator(); it.hasNext();){
		  priv_keys_cb.addItem(((KeyPasswd) it.next()).get_keyID());
	  }
	  priv_keys_cb.updateUI();
  }
  
  
  public void setFields (dbMailRecord oMailRecord){
      this.mMailRecord = oMailRecord;
       int iDefSmtp = mMailRecord.getSrvIndex();

      //TODO: fixed (BOB) testing
      if (this.mSmtpTable.getRecord(iDefSmtp)!=null){
        this.jtfSmtpSrv.setText(this.mSmtpTable.getRecord(iDefSmtp).getIP());
      }else{
        this.jtfSmtpSrv.setText("");
      }
      
      priv_keys_cb.setSelectedItem(mMailRecord.getPrivKeyID());

      this.jtfLogin.setText(mMailRecord.getMail());
      this.jtfKey.setText(mMailRecord.getPubKeyN());
      this.comments_TextArea.setText(mMailRecord.getComments());


      notif_cb.setSelectedIndex(mMailRecord.getMethodDN());
      sign_cb.setSelectedIndex(mMailRecord.getMethodPGPSign());


  }
  //-----------------------------------------------------------------------
  public dbMailRecord getFields(){
    return this.mMailRecord;
  }
  //-----------------------------------------------------------------------
  public boolean isOk(){
    return mOk;
  }
  //-------------------------------------------------------------------------
  public static void main(String[] args) {
    XAddrBookRecDlg XAddrBookRecDlg1 = new XAddrBookRecDlg();
    XAddrBookRecDlg1.setVisible(true);
  }

  //========================================================================
  public XAddrBookRecDlg() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {

    Locale currentLocale = BridgeApp.getCurrentLocale();
    ResourceBundle lbls = ResourceBundle.getBundle("dbridge.prop.XAddrBookRecDlgBundle",
                                currentLocale);

    mTitle = lbls.getString("addr_book");
    mAddr_err = lbls.getString("err_addr");
    mServ_err = lbls.getString("err_smtp");
    mKey_err = lbls.getString("err_key");
    mErr = lbls.getString("err");
    mNoSmtp_err = lbls.getString("err_no_smtp");
                            
    this.setSize(new Dimension(350, 321));
	this.setTitle(lbls.getString("addr"));                            

 
    JPanel notif_pan = new JPanel(new GridLayout(0,1));
    notif_pan.setBorder(BorderFactory.createTitledBorder(lbls.getString("methodDN")));

    notif_cb = new JComboBox();
    notif_cb.addItem(lbls.getString("mdn_none"));
    notif_cb.addItem(lbls.getString("mdn_rfc"));
    notif_cb.addItem(lbls.getString("mdn_pgp"));
    notif_cb.addItem(lbls.getString("mdn_mix"));
    notif_pan.add(notif_cb);

    
    JPanel sign_pan = new JPanel(new GridLayout(0,1));
    sign_pan.setBorder(BorderFactory.createTitledBorder(lbls.getString("methodSign")));
    
    sign_cb = new JComboBox();
    sign_cb.addItem(lbls.getString("ms_none"));
    sign_cb.addItem(lbls.getString("ms_rfc"));
    sign_cb.addItem(lbls.getString("ms_pgp"));
    sign_cb.addItem(lbls.getString("ms_mix"));
    sign_pan.add(sign_cb);
    
    JPanel priv_key_pan = new JPanel(new GridLayout(0,1));
    priv_keys_cb = new JComboBox();
    priv_key_pan.setBorder(BorderFactory.createTitledBorder(lbls.getString("privKey")));
    priv_key_pan.add(priv_keys_cb);

    FlowLayout login_pan_layout = new FlowLayout();
    login_pan_layout.setAlignment(FlowLayout.LEFT);
    login_pan_layout.setVgap(0);
    JPanel login_pan = new JPanel();
    login_pan.setLayout(login_pan_layout);
    login_pan.setBorder(BorderFactory.createTitledBorder(lbls.getString("email")));
    login_pan.add(jtfLogin, null);
    
    jtfLogin.setBounds(new Rectangle(103, 27, 63, 21));
    jtfLogin.setPreferredSize(new Dimension(200, 25));
    jtfLogin.setMinimumSize(new Dimension(200, 25));

    titledBorder7 = BorderFactory.createTitledBorder(lbls.getString("smtp"));
    titledBorder3 = BorderFactory.createTitledBorder(lbls.getString("comments"));

    main_pan_box = Box.createVerticalBox();
    titledBorder1 = BorderFactory.createTitledBorder(lbls.getString("recipient"));
    titledBorder2 = BorderFactory.createTitledBorder(lbls.getString("comments"));
    button_pan.setLayout(new FlowLayout());
    
    BorderLayout borderLayout3 = new BorderLayout();
    borderLayout3.setHgap(5);
    borderLayout3.setVgap(5);
    comment_pan.setLayout(borderLayout3);
    
    main_pan.setLayout(new BorderLayout());

    jbOk.setText(lbls.getString("b_ok"));
    jbOk.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbOk_actionPerformed(e);
      }
    });
    comments_TextArea.setBorder(BorderFactory.createLoweredBevelBorder());
    comments_TextArea.setText("");
    jbCancel.setText(lbls.getString("b_cancel"));
    jbCancel.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbCancel_actionPerformed(e);
      }
    });

    main_pan.setBorder(BorderFactory.createEtchedBorder());
    comment_pan.setBorder(BorderFactory.createEtchedBorder());
    this.getContentPane().setLayout(borderLayout1);
    jbKey.setBounds(new Rectangle(22, 23, 41, 17));
    jbKey.setMaximumSize(new Dimension(100, 25));
    jbKey.setMinimumSize(new Dimension(100, 25));
    jbKey.setPreferredSize(new Dimension(100, 25));
    jbKey.setMargin(new Insets(0, 0, 0, 0));
    jbKey.setMnemonic('0');
    jbKey.setText(lbls.getString("sel_key"));
    jbKey.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbKey_actionPerformed(e);
      }
    });
    
    FlowLayout key_pan_layout = new FlowLayout();
    key_pan_layout.setAlignment(FlowLayout.LEFT);
    key_pan_layout.setVgap(0);
    JPanel key_pan = new JPanel();
    key_pan.setLayout(key_pan_layout);
    key_pan.setBorder(BorderFactory.createTitledBorder(lbls.getString("p_key")));
    key_pan.add(jtfKey, null);
    key_pan.add(jbKey, null);
    
    
    jtfKey.setBounds(new Rectangle(103, 27, 63, 21));
    jtfKey.setPreferredSize(new Dimension(200, 25));
    jtfKey.setMinimumSize(new Dimension(300, 25));
    comments_ScrollPane.setBorder(titledBorder3);
    
    jtfSmtpSrv.setMinimumSize(new Dimension(200, 25));
    jtfSmtpSrv.setPreferredSize(new Dimension(200, 25));
    jtfSmtpSrv.setText("");
    
    
    FlowLayout smtp_pan_layout = new FlowLayout();
    smtp_pan_layout.setAlignment(FlowLayout.LEFT);
    smtp_pan.setLayout(smtp_pan_layout);
    smtp_pan.setBorder(titledBorder7);
    
    jbSelSmtp.setText(lbls.getString("sel"));
    jbSelSmtp.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbSelSmtp_actionPerformed(e);
      }
    });
 
    
    button_pan.add(jbOk, null);
    button_pan.add(jbCancel, null);
    this.getContentPane().add(main_pan, BorderLayout.NORTH);
    main_pan.add(main_pan_box, BorderLayout.CENTER);
    main_pan_box.add(login_pan, null);
    main_pan_box.add(smtp_pan, null);
    main_pan_box.add(notif_pan, null);
    main_pan_box.add(key_pan, null);
    main_pan_box.add(priv_key_pan, null);
    main_pan_box.add(sign_pan, null);
    smtp_pan.add(jtfSmtpSrv, null);
    this.getContentPane().add(comment_pan, BorderLayout.CENTER);
    comment_pan.add(comments_ScrollPane, BorderLayout.CENTER);

    comments_ScrollPane.getViewport().add(comments_TextArea, null);
    this.getContentPane().add(button_pan, BorderLayout.SOUTH);
    smtp_pan.add(jbSelSmtp, null);
  }

  //------------------------------------------------------------------------
  private boolean chkErrors(){

    if (jtfLogin.getText().length()<1){
      JOptionPane.showMessageDialog(this, mAddr_err,
                                    mTitle, JOptionPane.QUESTION_MESSAGE);
      return false;
    }

    if (mSmtpTable.getIndex(this.jtfSmtpSrv.getText())==-1){
      JOptionPane.showMessageDialog(this, mServ_err,
                                    mTitle, JOptionPane.QUESTION_MESSAGE);
      return false;
    }

    if (jtfKey.getText().length()<1){
      JOptionPane.showMessageDialog(this, mKey_err,
                                    mTitle, JOptionPane.QUESTION_MESSAGE);
      return false;
    }

    return true;
  }
  //--------------------------------------------------------------------------
  void jbOk_actionPerformed(ActionEvent e) {
    if (this.chkErrors()) {

      mSelSrvInd = mSmtpTable.getIndex(this.jtfSmtpSrv.getText());
      this.mMailRecord.setSrvInd(mSelSrvInd);
      this.mMailRecord.setMail(this.jtfLogin.getText());
      this.mMailRecord.setComments(this.comments_TextArea.getText());
      this.mMailRecord.setPubKeyN(this.jtfKey.getText());
      
      this.mMailRecord.setPrivKeyID((String) priv_keys_cb.getSelectedItem());

      mMailRecord.setMethodDN(notif_cb.getSelectedIndex());
      mMailRecord.setMethodPGPSign(sign_cb.getSelectedIndex());


      this.mOk = true;
      this.setVisible(false);
    }
  }
  //-------------------------------------------------------------------------
  void jbCancel_actionPerformed(ActionEvent e) {
    this.mOk = false;
    this.setVisible(false);
  }

  //-------------------------------------------------------------------------
  void jbKey_actionPerformed(ActionEvent e) {
   dsGPGKeyDialog gpg = new dsGPGKeyDialog(null, true);
   gpg.setVisible(true);
   if (gpg.isOk()) {
     jtfKey.setText(gpg.getSelectedKey());
   }
   gpg.dispose();


  }

  void jbSelSmtp_actionPerformed(ActionEvent e) {
    Vector smtp_vec = mSmtpTable.getVector();

    if (smtp_vec.size()<1) {
      JOptionPane.showMessageDialog(this, mNoSmtp_err,
                                    mErr, 1);
      return;
    }

    XSelSmtpSrvDlg mSelDlg = new XSelSmtpSrvDlg(null, true, smtp_vec);
    mSelDlg.setVisible(true);
    if (mSelDlg.isOk())
      this.jtfSmtpSrv.setText(mSelDlg.getSelectedServer().getIP());
  }
  //------------------------------------------------------------------------
}
