package dbridge;

import java.awt.*;
import javax.swing.*;

import java.util.Vector;
import javax.swing.JTable;
import javax.swing.table.AbstractTableModel;
import java.awt.event.*;
import java.util.*;

import javax.swing.DefaultCellEditor;
import javax.swing.text.*;

/**
 * <p>Title: dbridge</p>
 * <p>Description: Display and manage the routing table of automatic users</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company:  </p>
 * @author OOO
 * @version 1.0
 */

/*
 * Modified 28.02.04-18.04.05
 */

public class XDERouter extends JDialog {
  JPanel panel1 = new JPanel();
  JScrollPane jScrollPane1;       // = new JScrollPane();
  JTable jTable1;                 // = new JTable();
  JPanel topPanel = new JPanel(); // label panel
  JPanel middlePanel = new JPanel(); // table and bottons panel
  JPanel bottomPanel = new JPanel(); // control buttons panel
  Box box1; // buttons
  Box box2; // control buttons
  Box box3; // labels
  JButton jButton1 = new JButton(); // Apply changes (save to DB))
  JButton jButton2 = new JButton(); // Cancel
  JButton jButton3 = new JButton(); // Delete route
  JButton jButton4 = new JButton(); // Dublicate route
  JButton jButton5 = new JButton(); // Ping route
  JButton jButton6 = new JButton(); // Refresh (reread from DB but keep changes)
  private Vector mTableData = new Vector();
  JLabel jLabel1 = new JLabel();
  JLabel jLabel2 = new JLabel();
  JLabel jLabel3 = new JLabel(new ImageIcon("./lib/res/spheregreen.gif"));
  boolean isChanged = false;

  private Dimension mButtonDim;

  // labels strings
  private String mLabelTitle;
  private String mLabel1;
  private String mLabel2;
  private String mLabelButton1;
  private String mLabelButton2;
  private String mLabelButton3;
  private String mLabelButton4;
  private String mLabelButton5;
  private String mLabelButton6;
  private String mLabelApplyMsg1;
  private String mLabelApplyMsg1Ttl;
  private String mLabelCol1;
  private String mLabelCol2;
  private String mLabelCol3;

  FlowLayout flowLayout1 = new FlowLayout();
  Vector mUsers = new Vector();
  Vector mUsersDelete = new Vector();
  DBReloadInterface mDBcontroller = null;

//---- Table Model subclass -------------------------
  class DERouterTableModel
      extends AbstractTableModel {
    private Vector table_data = new Vector();

    public DERouterTableModel(Vector data) {
      super();
      table_data = data;
    }

    private String[] columnNames = {
        mLabelCol1, mLabelCol2, mLabelCol3};

    public int getColumnCount() {
      return columnNames.length;
    }

    public int getRowCount() {
      return table_data.size();
    }

    public String getColumnName(int col) {
      return columnNames[col];
    }

    /*
    * JTable uses this method to determine the default renderer/
    * editor for each cell.
    */
    public Class getColumnClass(int c) {
            return getValueAt(0, c).getClass();
    }


    public Object getValueAt(int row, int col) {
      return ( (Vector) table_data.get(row)).get(col);
    }

    // make the left collumn editable
    public boolean isCellEditable(int row, int col) {
      if (col == 0)return true;
      return false;
    }

    public void setValueAt(Object value, int row, int col) {
      ( (Vector) table_data.get(row)).setElementAt(value, col);
      fireTableCellUpdated(row, col);
    }
  }

//---- END of Table Model subclass --------------------------

  /**
   * Parametrized constructor
   * @param res_int DBReloadInterface - a refference to the database Reload interface
   * @param frame Frame - parent frame
   * @param title String - title
   * @param modal boolean - modal flag
   */
  public XDERouter(DBReloadInterface res_int, Frame frame, String title,
                   boolean modal) {
    super(frame, title, modal);
    setLocale(); // national labels
    mDBcontroller = res_int;
    if (title == null)this.setTitle(mLabelTitle);
    try {
      jbInit();
      pack();
      this.setSize(new Dimension(600, 345));
      this.updateDB();
      //fillRoutingTable();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  /*
   * Parametrized constructor.
   */
  public XDERouter(DBReloadInterface res_int) {
    this(res_int, null, null, true);
    this.setSize(new Dimension(600, 345));
  }

  /**
   *  Internationalization method.
   */
  private void setLocale() {
    Locale currentLocale = BridgeApp.getCurrentLocale();
    ResourceBundle labels = ResourceBundle.getBundle(
        "dbridge.prop.XDERouterLabelsBundle", currentLocale);
    mLabelTitle = labels.getString("Title");

    mLabel1 = labels.getString("Label1");
    mLabel2 = labels.getString("Label2");

    mLabelButton1 = labels.getString("Button1"); // Apply
    mLabelButton2 = labels.getString("Button2"); // Cancel
    mLabelButton3 = labels.getString("Button3"); // Delete
    mLabelButton4 = labels.getString("Button4"); // Dublicate
    mLabelButton5 = labels.getString("Button5"); // Ping
    mLabelButton6 = labels.getString("Button6"); // Refresh

    mLabelApplyMsg1 = labels.getString("ApplyMsg1");
    mLabelApplyMsg1Ttl = labels.getString("ApplyMsg1Ttl");

    mLabelCol1 = labels.getString("Col1");
    mLabelCol2 = labels.getString("Col2");
    mLabelCol3 = labels.getString("Col3");
  }

  private void jbInit() throws Exception {
    mButtonDim = new Dimension(120, 25);
    box1 = Box.createVerticalBox();
    box2 = Box.createHorizontalBox();
    box3 = Box.createVerticalBox();

    // panel1 - main panel
    this.getContentPane().add(panel1, BorderLayout.CENTER);

    BorderLayout border_layout = new BorderLayout();
    panel1.setLayout(border_layout);

    BorderLayout label_layout = new BorderLayout();
    topPanel.setLayout(label_layout);

    BorderLayout center_layout = new BorderLayout();
    middlePanel.setLayout(center_layout);

    FlowLayout bottom_layout = new FlowLayout();
    bottomPanel.setLayout(bottom_layout);

    //
    // Define labels
    //
    // Labels
    jLabel1.setText(mLabel1);
    jLabel2.setText(mLabel2);
    setStatusChanged(false);
    // add to the topPanel
    JPanel status_panel1 = new JPanel(new FlowLayout(FlowLayout.LEFT));
    status_panel1.add(jLabel1);
    JPanel status_panel2 = new JPanel(new FlowLayout(FlowLayout.LEFT));
    status_panel2.add(jLabel2);
    status_panel2.add(jLabel3);
    box3.add(status_panel1, null);
    box3.add(status_panel2, null);
    topPanel.add(box3, BorderLayout.CENTER);
    topPanel.add(Box.createHorizontalStrut(10), BorderLayout.WEST);

    //
    // Define buttons
    //
    // Apply
    jButton1.setMaximumSize(mButtonDim);
    jButton1.setMinimumSize(mButtonDim);
    jButton1.setPreferredSize(mButtonDim);
    jButton1.setText(mLabelButton1);
    jButton1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton1_actionPerformed(e);
      }
    });

    // Cancel
    jButton2.setMaximumSize(mButtonDim);
    jButton2.setMinimumSize(mButtonDim);
    jButton2.setPreferredSize(mButtonDim);
    jButton2.setText(mLabelButton2);
    jButton2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton2_actionPerformed(e);
      }
    });

    //Delete
    jButton3.setMaximumSize(mButtonDim);
    jButton3.setMinimumSize(mButtonDim);
    jButton3.setPreferredSize(mButtonDim);
    jButton3.setText(mLabelButton3);
    jButton3.setIcon(new ImageIcon("./lib/res/small_delete2.gif"));
    jButton3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton3_actionPerformed(e);
      }
    });

    // Dublicate
    jButton4.setMaximumSize(mButtonDim);
    jButton4.setMinimumSize(mButtonDim);
    jButton4.setPreferredSize(mButtonDim);
    jButton4.setText(mLabelButton4);
    jButton4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton4_actionPerformed(e);
      }
    });

    // Ping Server
    jButton5.setMaximumSize(mButtonDim);
    jButton5.setMinimumSize(mButtonDim);
    jButton5.setPreferredSize(mButtonDim);
    jButton5.setText(mLabelButton5);
    jButton5.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton5_actionPerformed(e);
      }
    });

    // Refresh
    jButton6.setMaximumSize(mButtonDim);
    jButton6.setMinimumSize(mButtonDim);
    jButton6.setPreferredSize(mButtonDim);
    jButton6.setText(mLabelButton6);
    jButton6.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton6_actionPerformed(e);
      }
    });

    // box1 - Right Buttons vertical box
    box1.add(Box.createVerticalStrut(21), null);
    box1.add(jButton3, null);
    box1.add(Box.createVerticalStrut(8), null);
    box1.add(jButton4, null);
    box1.add(Box.createVerticalStrut(8), null);
    box1.add(jButton5, null);
    box1.add(Box.createVerticalStrut(8), null);
    box1.add(jButton6, null);
    box1.setMaximumSize(new Dimension(125, 120));
    box1.setMinimumSize(new Dimension(125, 120));
    box1.setPreferredSize(new Dimension(125, 120));

    // box2 - down vertical button box
    box2.add(jButton1, null);
    box2.add(Box.createHorizontalStrut(44), null);
    box2.add(jButton2, null);
    bottomPanel.add(box2, null);

    jTable1 = new JTable(new DERouterTableModel(mTableData));
    jTable1.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    jTable1.setDragEnabled(false);

    // Add the table to a container
    jScrollPane1 = new JScrollPane(jTable1);

    //Set up real input validation for the left column.
    this.setUpCellEditor(jTable1);

    middlePanel.add(Box.createHorizontalStrut(10), BorderLayout.WEST);
    middlePanel.add(jScrollPane1, BorderLayout.CENTER);
    JPanel bpanel = new JPanel(new BorderLayout());
    bpanel.add(Box.createHorizontalStrut(5), BorderLayout.WEST);
    bpanel.add(box1, BorderLayout.CENTER);
    middlePanel.add(bpanel, BorderLayout.EAST);

    // insert panels
    panel1.add(topPanel, BorderLayout.NORTH);
    panel1.add(middlePanel, BorderLayout.CENTER);
    panel1.add(bottomPanel, BorderLayout.SOUTH);

    this.setResizable(true);
  }

  private void setUpCellEditor(JTable table) {
    //Set up the editor for the correct AET.
    final LoginField loginField = new LoginField("", 0);

    //Construct a DefaultCellEditor that uses a text field.
    DefaultCellEditor loginEditor = new DefaultCellEditor(loginField) {
      //Override DefaultCellEditor's getCellEditorValue method
      //to return the correct String:
      public Object getCellEditorValue() {
        return new String(loginField.getValue());
      }
    };
    jTable1.setDefaultEditor(String.class, loginEditor);
  }

  /**
   * Change the status icon. The possible status is Modified (true) oe
   * not changed (false)
   * @param status boolean
   */
  private void setStatusChanged(boolean status) {
    if (isChanged != status) {
      isChanged = status;
    }
    if (isChanged) {
      jLabel3.setIcon(new ImageIcon("./lib/res/sphereyellow.gif"));
    }
    else {
      jLabel3.setIcon(new ImageIcon("./lib/res/spheregreen.gif"));
    }
  }

  /**
   * Read the local database and fill up the router table. The method clears
   * all previous made changes.
   */
  public void updateDB() {
    // read autoimatic users from DB and display into the table
    this.mUsersDelete.clear();
    this.mUsers.clear();
    this.fillRoutingTable();
  }

  /**
   * Fill the table context. Read a list of automatic users from the database.
   */
  private void fillRoutingTable() {

    mTableData.clear();

    // find routes in the UserContainer
    // only automatic users have the hard defined routes
    Vector users_vec = mDBcontroller.getUserContainer().getAutoUserList();
    for (int i = 0; i < users_vec.size(); i++) {
      Vector data1 = new Vector();
      dbUser user = mDBcontroller.getUserContainer().getUser( (String)
          users_vec.
          get(i));
      mUsers.addElement(user); // copy users

      // find comment for the email
      String mail_addr = "";
      String receiver = "";
      if (user.getAddressBook().getRecord(0) != null) {
        mail_addr = user.getAddressBook().getRecord(0).getMail();
        receiver = user.getAddressBook().getRecord(0).getComments();
      }

      // write fields
      data1.add(user.getLogin());
      data1.add(receiver);
      data1.add(mail_addr);
      mTableData.add(0, (Vector) data1);
    } // end for
    updateTable();
  }

  /**
   * Uptate the routing table GUI.
   */
  private void updateTable() {
    DERouterTableModel model = new DERouterTableModel(mTableData);
    jTable1.setModel(model);
    jTable1.updateUI();
  }

  /**
   * Rerutn false if the routing table is empty. Else return true.
   * @return boolean
   */
  private boolean testTableData() {
    boolean res = true;
    if (mTableData.size() < 0) res = false;
    return res;
  }

  /* Button Press Actions */
  // Apply
  void jButton1_actionPerformed(ActionEvent e) {
    if (JOptionPane.showConfirmDialog(this, mLabelApplyMsg1, mLabelApplyMsg1Ttl,
                                      JOptionPane.YES_NO_OPTION) == 0) {
      // conditions: mUsersDelete - a vector of all automatic users to be deleted
      //             mUsers - a vector of all new automatic users to be inserted

      // first delete users
      for (int i = 0; i < mUsersDelete.size(); i++) {
        // delete from user container mUsersDelete.get(i).getLogin();
        dbUser user = (dbUser) mUsersDelete.get(i);
        if (!mDBcontroller.getUserContainer().isLoginValid(user.getLogin())) {
          // user exist
          mDBcontroller.getUserContainer().delete(user);
          mDBcontroller.getChangesTracker().UsersChanged = true;
        }
      }

      // insert new users
      for (int i = 0; i < mUsers.size(); i++) {
        // insert into if necessary user container mUsers.get(i).getLogin();
        dbUser user = (dbUser) mUsers.get(i);
        Vector row = (Vector)this.mTableData.get(i);
        user.setLogin( (String) row.firstElement()); // update name
        if (mDBcontroller.getUserContainer().isLoginValid(user.getLogin())) {
          // new user
          user.createDir(BridgeApp.getRoot());
          mDBcontroller.getUserContainer().append(user);
          mDBcontroller.getChangesTracker().UsersChanged = true;
        }
      }
      // notify dsMainForm about changes in the user db
      mDBcontroller.saveDB(true);
      this.setStatusChanged(false); // green led

      this.dispose();
    }
  }

  // Cancel
  void jButton2_actionPerformed(ActionEvent e) {
    this.setStatusChanged(false); // green led
    this.updateDB();
    this.dispose();
  }

  // Delete
  void jButton3_actionPerformed(ActionEvent e) {
    if (!testTableData())return;
    int i = jTable1.getSelectedRow();
    if (i < 0)return;
    mTableData.removeElementAt(i);
    mUsersDelete.addElement(mUsers.get(i)); // store the user to be deleted
    mUsers.removeElementAt(i);
    jTable1.updateUI();
    setStatusChanged(true);
  }

  // Dublicate
  void jButton4_actionPerformed(ActionEvent e) {
    if (!testTableData())return;
    int i = jTable1.getSelectedRow();
    if (i < 0)return;
    //insert new line
    Vector row = new Vector( (Vector) mTableData.get(i));
    String newaet = "LoginAet";
    String str = "LoginAet";
    int j = 1;
    while (this.isExist(newaet)) {
      j++;
      newaet = str + j;
    }

    row.setElementAt(newaet, 0); // change aet
    mTableData.addElement(row);
    dbUser newuser = new dbUser( (dbUser) mUsers.get(i)); // clone
    // Warning!!! The home directory of this user belongs to his parent
    // It is necessary to create a new home directory. It will be done after
    // apply button pressed
    newuser.setLogin(newaet);
    mUsers.addElement(newuser);

    jTable1.updateUI();
    setStatusChanged(true);
  }

  // Ping Route
  // test the related SMTP server
  void jButton5_actionPerformed(ActionEvent e) {
    if (!testTableData())return;
    int i = jTable1.getSelectedRow();
    if (i < 0)return;
    // ping the SMTP server
    dbUser user = (dbUser) mUsers.get(i);

    dbSmtpRecord rec = user.getSmtpTable().getDefaultRecord();
    ChkThread thread = new ChkThread(rec);
    thread.start();

  }

  // Refresh
  /**
   Read the user DB, update the routing table, but keep previous changes
   @param e action event
   */
  void jButton6_actionPerformed(ActionEvent e) {
    if (!testTableData())return;

    // if no changes have been made, just read the database
    if (!this.isChanged) {
      this.updateDB();
      return;
    }

    // track changes
    Vector data1 = new Vector(); // row
    Vector users_vec = mDBcontroller.getUserContainer().getAutoUserList(); // new data
    for (int i = 0; i < users_vec.size(); i++) {
      dbUser user = mDBcontroller.getUserContainer().getUser( (String)
          users_vec.get(i));
      String aet = user.getLogin();
      // if the user is not in the table and has been not deleted
      // insert the user into the table
      if (!isExist(aet) && !isDeleted(aet)) {
        mUsers.addElement(user); // copy users

        // find comment for the email
        String mail_addr = "";
        String receiver = "";
        if (user.getAddressBook().getRecord(0) != null) {
          mail_addr = user.getAddressBook().getRecord(0).getMail();
          receiver = user.getAddressBook().getRecord(0).getComments();
        }
        // write fields
        data1.add(user.getLogin());
        data1.add(receiver);
        data1.add(mail_addr);
        mTableData.add(0, (Vector) data1);
      } // end if
    } // end for
    jTable1.updateUI();
  }

  // check either the user exists or not
  boolean isExist(String aet) {
    int i = 0;
    if (aet.compareTo("error") == 0) {
        return true;
    }

    if (mUsers.contains((String)aet)) { // list of new users
        return true;
    }

    while (i < mUsers.size()) {
      dbUser newuser = (dbUser) mUsers.get(i);
      // check existance of the user in database
      // and into the list of new users
      Vector row = (Vector)this.mTableData.get(i);
      if ( aet.compareTo( (String)row.firstElement() ) == 0 ){
          return true;
      }

      if (aet.compareTo(newuser.getLogin()) == 0) {
        return true;
      }
      i++; // increase the current number
    }
    return false;
  }

  // check either the user has been deleted or not
  boolean isDeleted(String aet) {
    int i = 0;
    while (i < mUsersDelete.size()) {
      dbUser newuser = (dbUser) mUsersDelete.get(i);
      if (aet.compareTo(newuser.getLogin()) == 0) {
        return true;
      }
      i++;
    }
    return false;
  }

  // DEBUG
  public static void main(String[] args) {
    XDERouter obj = new XDERouter(null);
    obj.setVisible(true);
    //obj.setSize(new Dimension(500,300));
  }

  /**
   * Cell Corrector
   */

  class LoginField extends JTextField {
    private String mValue=new String();

    public LoginField(String value, int columns) {
      super(columns);
      setValue(value);
    }

    public String getValue() {
      mValue=new String(getText());
      if ( isExist(mValue) ){
        return "error";
      } else {
          return getText();
      }
    }

    public void setValue(String value) {
      mValue = value; // TODO correction here
      setText(mValue);
    }

    protected Document createDefaultModel() {
      return new LoginFieldDocument();
    }
  }

}// end main class

