package dbridge;

import java.awt.*;
import javax.swing.*;
import javax.swing.JScrollPane;
import javax.swing.JPanel;
import java.awt.event.*;
import java.awt.Frame;
import java.util.GregorianCalendar;
import java.util.Date;
import java.util.Calendar;
import java.sql.Timestamp;

/**
 *
 * <p>Title: dbridge</p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class XDbViewer
    extends JDialog {
  JPanel panel1 = new JPanel();
  JScrollPane jScrollPane1; // = new JScrollPane();
  JPanel topPanel = new JPanel(); // label panel
  JPanel middlePanel = new JPanel(); // table and bottons panel
  JPanel bottomPanel = new JPanel(); // control buttons panel
  Box box1; // buttons
  Box box2; // control buttons

  JTextArea textarea = new JTextArea();

  JButton jButton1 = new JButton(new ImageIcon("./lib/res/world2.png")); // Clear
  JButton jButton2 = new JButton(new ImageIcon("./lib/res/thumbdown.gif")); // Cancel
  JButton jButton3 = new JButton(new ImageIcon("./lib/res/greenflag.gif")); // Search

  JLabel label1 = new JLabel(new ImageIcon("./lib/res/key.gif"));
  JTextField id = new JTextField();

  private Dimension mButtonDim;

  // labels strings
  private String mLabelTitle;
  private String mLabelButton1;
  private String mLabelButton2;
  private String mLabelButton3;

  FlowLayout flowLayout1 = new FlowLayout();

  /**
   * Parametrized constructor
   * @param frame Frame - parent frame
   * @param title String - title
   * @param modal boolean - modal flag
   */
  public XDbViewer(Frame frame, String title,
                   boolean modal) {
    super(frame, title, modal);
    setLocale(); // national labels
    if (title == null) {
      this.setTitle(mLabelTitle);
    }
    try {
      jbInit();
      pack();
      this.setSize(new Dimension(640, 480));
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  /**
   *  Internationalization method.
   */
  private void setLocale() {
    //Locale currentLocale = BridgeApp.getCurrentLocale();
    //ResourceBundle labels = ResourceBundle.getBundle(
    //    "dbridge.prop.XDbViewerLabelsBundle", currentLocale);
    mLabelTitle = "Title"; //"labels.getString("Title");

    //mLabel1 = labels.getString("Label1");
    //mLabel2 = labels.getString("Label2");

    mLabelButton1 = "Clear"; //labels.getString("Button1"); // Apply
    mLabelButton2 = "Cancel"; //labels.getString("Button2"); // Cancel
    mLabelButton3 = "Search"; //labels.getString("Button3"); // Delete

  }

  private void jbInit() throws Exception {
    mButtonDim = new Dimension(120, 25);
    box1 = Box.createHorizontalBox();
    box2 = Box.createHorizontalBox();

    // panel1 - main panel
    this.getContentPane().add(panel1, BorderLayout.CENTER);

    BorderLayout border_layout = new BorderLayout();
    panel1.setLayout(border_layout);

    BorderLayout label_layout = new BorderLayout();
    topPanel.setLayout(label_layout);

    BorderLayout center_layout = new BorderLayout();
    middlePanel.setLayout(center_layout);

    FlowLayout bottom_layout = new FlowLayout();
    bottomPanel.setLayout(bottom_layout);

    //
    // Define buttons
    //
    // OK
    jButton1.setMaximumSize(mButtonDim);
    jButton1.setMinimumSize(mButtonDim);
    jButton1.setPreferredSize(mButtonDim);
    jButton1.setText(mLabelButton1);
    jButton1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton1_actionPerformed(e);
      }
    });

    // Cancel
    jButton2.setMaximumSize(mButtonDim);
    jButton2.setMinimumSize(mButtonDim);
    jButton2.setPreferredSize(mButtonDim);
    jButton2.setText(mLabelButton2);
    jButton2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton2_actionPerformed(e);
      }
    });

    //Delete
    jButton3.setMaximumSize(mButtonDim);
    jButton3.setMinimumSize(mButtonDim);
    jButton3.setPreferredSize(mButtonDim);
    jButton3.setText(mLabelButton3);
    //jButton3.setIcon(new ImageIcon("./lib/res/small_delete2.gif"));
    jButton3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton3_actionPerformed(e);
      }
    });

    label1.setText("Message ID/X-SETID : ");

    id.setMaximumSize(new Dimension(250, 25));
    id.setMinimumSize(new Dimension(250, 25));
    id.setPreferredSize(new Dimension(250, 25));

    // box1 - Right Buttons vertical box
    box1.add(Box.createHorizontalStrut(44), null);
    box1.add(label1, null);
    box1.add(id, null);
    box1.add(jButton3, null);

    box1.setMaximumSize(new Dimension(125, 120));
    box1.setMinimumSize(new Dimension(125, 120));
    box1.setPreferredSize(new Dimension(125, 120));

    // box2 - down vertical button box
    box2.add(jButton1, null);
    box2.add(Box.createHorizontalStrut(44), null);
    box2.add(jButton2, null);
    bottomPanel.add(box2, null);

    textarea.setEditable(false);
    Font font = new Font("Times", Font.PLAIN, 12);
    textarea.setFont(font);
    textarea.append("Data Base:\n");

    // Add the table to a container
    jScrollPane1 = new JScrollPane(textarea);
    topPanel.add(box1, BorderLayout.NORTH);
    middlePanel.add(jScrollPane1, BorderLayout.CENTER);
    bottomPanel.add(box2, BorderLayout.SOUTH);

    // insert panels
    panel1.add(topPanel, BorderLayout.NORTH);
    panel1.add(middlePanel, BorderLayout.CENTER);
    panel1.add(bottomPanel, BorderLayout.SOUTH);

    this.setResizable(false);
  }

  /* Button Press Actions */
  // Clear
  void jButton1_actionPerformed(ActionEvent e) {
    textarea.setText("");

  }

  // Cancel
  void jButton2_actionPerformed(ActionEvent e) {
    this.dispose();
  }

  // Search
  void jButton3_actionPerformed(ActionEvent e) {
    textarea.append("\n--------------------------------------------\n");
    String transaction_id = id.getText();
    System.out.println(transaction_id);
    dmtRecord r = new dmtRecord();
//    vfilesRecord v = new vfilesRecord();
    String res = "";
    int maxcount = 20; // limit display
//    String blacklist = "id not like ''";
    if (transaction_id != null) {
      if (transaction_id.startsWith("*")) {
        showAllRecords(maxcount);
      }
      else { // any command
        if (transaction_id.startsWith("#")) {
          maxcount = 100;
          showAnyQueryResult(transaction_id.substring(1), maxcount);
        }
        else {
          if (transaction_id.startsWith("+")) {
            maxcount = 100;
            char ch  = transaction_id.charAt(1);
            if ( ch >='0' && ch <='9'){
              Integer n = new Integer(ch);
              this.showAllOpened(n.intValue(), 10);
            }
          }
          else {
            if (transaction_id.startsWith("-")) {
            maxcount = 100;
            char ch  = transaction_id.charAt(1);
            if ( ch >='0' && ch <='9'){
              Integer n = new Integer(ch);
              this.showAllClosed(n.intValue(), 10);
            }
          }
          else {

            // search by a given transaction id
//21.12.06: was "query" instead of "dbQuery"
            res = dbQuery.setQueryDmt("select * from dmt where id like '" +
                                    transaction_id + "'");

            if (res != null) {
              r.fromString(res);
              textarea.append(r.toReportString());
              showAllFiles(transaction_id, 20);
            }
            else {
              textarea.append("No such ID found\n");
            }
          }
          }
        }
      }
    }
    else {
      textarea.append("No records found ...\n");
    }
    textarea.append("\n--------------------------------------------\n");
  }

  void showAllRecords(int maxcount) {
    //String transaction_id=id.getText();
    dmtRecord r = new dmtRecord();
    //vfilesRecord v=new vfilesRecord();
    String res = "";
    String blacklist = "id not like ''";
    // display first maxcount records of the database
//  21.12.06: was "query" instead of "dbQuery"
    res = dbQuery.setQueryDmt("select * from dmt");
    while (res != null && maxcount > 0) {
      r.fromString(res);
      textarea.append(r.toReportString());
      blacklist += " and id not like '" + r.m_id + "'";
      res = null;
//   21.12.06: was "query" instead of "dbQuery"
      res = dbQuery.setQueryDmt("select * from dmt where " + blacklist);
      maxcount--;
    }
  }

  void showAnyQueryResult(String str, int maxcount) {
    // TODO search only one record
// 21.12.06: was "query" instead of "dbQuery"
    String res = dbQuery.setQueryDmt(str);
    while (res != null && maxcount > 0) {
      textarea.append(res + "\n");
      res = null;
//    21.12.06: was "query" instead of "dbQuery"
      res = dbQuery.setQueryDmt(str);
      maxcount--;
    }
  }

  void showAllFiles(String id, int maxcount) {
    String limit = " and number!=0";
//  21.12.06: was "query" instead of "dbQuery"
    String res = dbQuery.setQueryFiles("select * from vfiles where id like '" +
                                     id + "'" + limit);
    while (res != null && maxcount > 0) {
      vfilesRecord v = new vfilesRecord(res);
      textarea.append(v.toReportString());
      res = null;
      limit += " and number!=" + v.m_number;
//    21.12.06: was "query" instead of "dbQuery"
      res = dbQuery.setQueryFiles("select * from vfiles where id like '" +
                                id + "'" + limit);
      maxcount--;
    }
    res = null; // only one record
  }

  /**
   * Show all dmt records ( maximal maxcount) that are still opened and
   * are not older than n days
   * @param day int - 0: today, 1: up to yesterday
   * @param maxcount int - maximal number of displayed records
   */
  void showAllOpened(int n, int maxcount) {
    System.out.println("Opened "+n);
    if (n < 0) {
      n = 0;
    }
    Timestamp newtime = new Timestamp(System.currentTimeMillis());
    Date t = new Date(newtime.getTime());
    Calendar calendar = new GregorianCalendar();
    calendar.setTime(t);
    long day = 24 * 60 * 60 * 1000; // 1 day
    long period = calendar.getTimeInMillis() - day * n;
    Timestamp oldtime = new Timestamp(period);
    dmtRecord r = new dmtRecord();
    String dmt_str = dbQuery.setQueryDmtReport(
        "select * from dmt where status=true and start_time>=to_timestamp('" +
        oldtime + "')");
    int count = 0;
    if (dmt_str != null && count < maxcount) {
      textarea.append(dmt_str);
    } // end if
  }

  void showAllClosed(int n, int maxcount) {
    System.out.println("Closed "+n);
    if (n < 0) {
      n = 0;
    }
    Timestamp newtime = new Timestamp(System.currentTimeMillis());
    Date t = new Date(newtime.getTime());
    Calendar calendar = new GregorianCalendar();
    calendar.setTime(t);
    long day = 24 * 60 * 60 * 1000; // 1 day
    long period = calendar.getTimeInMillis() - day * n;
    Timestamp oldtime = new Timestamp(period);
    dmtRecord r = new dmtRecord();
    String dmt_str = dbQuery.setQueryDmtReport(
        "select * from dmt where status=false and start_time>=to_timestamp('" +
        oldtime + "')");
    int count = 0;
    if (dmt_str != null && count < maxcount) {
      textarea.append(dmt_str);
    } // end if
  }

  // DEBUG
  public static void main(String[] args) {
    JFrame frame = new JFrame();
    XDbViewer obj = new XDbViewer(frame, "My Title", true);
    obj.setVisible(true);
    System.exit(0);
  }

} // end main class
