package dbridge;

import java.util.Collection;
import java.util.LinkedList;
import java.util.Vector;
import java.util.Iterator;

/**
 * <p>Title: XTagCollection</p>
 * <p>Description: list of files linked by XTag</p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author bob
 * @version 1.0
 */

public class XTagCollection {

  // Xtag for Collection
  private XTag mXTag = null;

  // File fields Table data & File data
  private LinkedList mFileFields = new LinkedList();

  public XTagCollection(XTag oXTag){
    mXTag = oXTag;
  }

  public void addFileFields(Collection cFileFields){
    mFileFields.addAll(cFileFields);
  }

  public void addField(CFileFieds oField) {
    mFileFields.add(oField);
  }

  public void removeField(CFileFieds oField) {
  mFileFields.remove(oField);
}


  public Object clone(){
    XTagCollection res = new XTagCollection(mXTag);
    res.addFileFields((LinkedList) mFileFields.clone());
    return res;
  }


  public Vector getFileFields(){
    return new Vector(mFileFields);
  }

  public Vector getFiles () {
    Vector res = new Vector();
    for (Iterator it = mFileFields.iterator(); it.hasNext(); ) {
      CFileFieds oFields = (CFileFieds) it.next();
      res.add(oFields.GetFileObject());
    }
    return res;
  }

  public Vector getFileNames () {
  Vector res = new Vector();

  for (Iterator it = mFileFields.iterator(); it.hasNext(); ) {
    CFileFieds oFields = (CFileFieds) it.next();
    String name = oFields.GetFileObject().getPath();
    res.add(name);
  }
  return res;
}

  public XTag getXTag() {return mXTag;}
  public String toString (){return mXTag.toString();}
}
