package dbridge;


import javax.swing.text.BadLocationException;
import java.awt.Toolkit;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.swing.text.AttributeSet;
import javax.swing.text.PlainDocument;

/**
 * <p>Title: dbridge</p>
 *
 * <p>Description: </p>
 * This class realises a change-validation mechanism for the XTag class
 * In accorthing to XTag definition the following symbols are allowed
 * "-" | "_" | "." | "," | 0 | ... 9 | a | ... | z | A | ... Z
 * <p>Copyright: Copyright (c) 2004</p>
 *
 * <p>Company: </p>
 * aITLab
 * @author
 * @version 1.0
 */

public class XTagDocument
    extends PlainDocument {
  public void insertString(int offs,
                           String str,
                           AttributeSet a) throws BadLocationException {

    //super.insertString(offs, str.replaceAll("[^a-zA-Z0-9\\.\\,\\_-]+", ""), a);  
    Matcher m = Pattern.compile("[^a-zA-Z0-9\\.\\,\\_-]+").matcher(str);
    if (m.find()) {
    	Toolkit.getDefaultToolkit().beep();
    	super.insertString(offs, m.replaceAll(""), a);
    }else {super.insertString(offs, str, a);}
	
  }
}// end class


