package dbridge;

/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author unascribed
 * @version 1.0
 */

/*
 * Modified 10.02.06
 * Modified 11.06.06
 * Modified 29.06.06
 * Modified  2.07.06
 */

import java.sql.*;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.io.File;

public class dbBase
{
    /**
     * Default constructor
     */
    public dbBase(String name){
        //System.out.println("Starting SQL Base constructor ...");
        try{
            Class.forName("org.simplesql.Driver");
        }
        catch(Exception e){
            System.out.println("Driver class org.simplesql.Driver not found.");
            System.exit(0);
        };

        File f=new File(name);
        String cmd="jdbc:simplesql:"+name;
        if (!f.exists()){
            cmd+="?fmode=co";
            try{
            //System.out.println("cmd="+cmd);
            conn= DriverManager.getConnection(cmd);
            st= conn.createStatement();
            }
            catch(SQLException e1){
                System.out.println(e1.toString());
            }
            //System.out.println("Create DMT record");
            try{
            boolean res2=st.execute("create table vfiles ("+
                "id varchar(256),"+
                "dn_index autoincrement,"+
                "name varchar(1024),"+
                "number int,"+
                "report varchar(256),"+
                "mid varchar(256),"+
                "status boolean,"+
                "primary key(dn_index) )");
            }
            catch(SQLException e2){
                System.out.println(e2.toString());
            }
            try{
            boolean res1=st.execute("create table dmt ("+
                "id varchar(256),"+
                "total integer,"+
                "sent integer,"+
                "received integer,"+
                "warnings integer,"+
                "errors integer,"+
                "resent integer,"+
                "deleted integer,"+
                "report varchar(256),"+
                "status boolean,"+
                "start_time datetime,"+
                "end_time datetime,"+
                "name varchar(256),"+
                "memo1 varchar(256),"+
                "memo2 varchar(256),"+
                "dn_index autoincrement,"+
                "primary key(dn_index) )");
            //System.out.println("DMT record has been created");
            }
            catch(SQLException e3){
                System.out.println(e3.toString());
            }

        } else {
        try{
            //System.out.println("cmd="+cmd);
            conn= DriverManager.getConnection(cmd);
            st= conn.createStatement();
            }
            catch(SQLException e1){
                System.out.println(e1.toString());
            }
        }

        Init(name);
 //       System.out.println("The Data base has been initialised ...");
    }

    /**
     * close the connection
     */
    public int close() throws SQLException{
        int res=0;
        if ( m_locked ) return res;
        st.close();
        conn.close();
        if ( !conn.isClosed() ){
            throw new SQLException("Error in connection closing");
        }
        res=1;
        m_closed=true;
        return res;
    }
    /**
     * reconnect the connection
     */
    public int reconnect() throws SQLException{
        st.close();
        conn.close();
        if ( !conn.isClosed() ){
            throw new SQLException("Error in connection closing");
        }
        conn= DriverManager.getConnection("jdbc:simplesql:"+m_name);
        st= conn.createStatement();
        m_closed=false;
        return 1;
    }


    private Connection conn;
    private Statement st;
    /**
     * make all what you want if the SQL is known
     */
    public Statement getStatement(){ return st;};

    private String  m_name=new String();   // db name
    private boolean m_locked;              // db semafore
    private boolean m_debug;               // debug flag
    private boolean m_closed;              // close flag

    /**
     * Set/Get Methods
     */
    public void setName(String str){m_name=str;};
    public String getName(){return m_name;};
    public void setDebugMode(boolean on){m_debug=on;};
    public boolean isClosed(){ return m_closed;};

    /**
     * Init method
     */
    private void Init(String name){
        //System.out.println("db name : "+ name);
        m_name   = name;
        m_locked = false;
        m_debug  = false;
        m_closed = false;
    }

    /**
     * synchronization
     */
    private void lock(){
        while (this.m_locked) ; // wait until the db is unlocked
        this.m_locked=true;
    }
    private void unlock(){
        this.m_locked=false;
    }

    /**
     * execute an SQL query. The last record is stored into variables.
     * @params a query string
     * @returns number of found records
     * @throws SQLExeption
     */
    public int execute(String sql, dmtRecord r) throws SQLException {
        lock();
 //   System.out.println("Execute query dmt: "+ sql);
        ResultSet rs= st.executeQuery(sql);
        int counts=0;
        while(rs.next()){
            counts++;
            r.m_dn_index   = rs.getInt("dn_index");
            r.m_id         = rs.getString("id");
            r.m_total      = rs.getInt("total");
            r.m_sent       = rs.getInt("sent");
            r.m_received   = rs.getInt("received");
            r.m_warnings   = rs.getInt("warnings");
            r.m_errors     = rs.getInt("errors");
            r.m_resent     = rs.getInt("resent");
            r.m_deleted    = rs.getInt("deleted");
            r.m_report     = rs.getString("report");
            r.m_status     = rs.getBoolean("status");
            r.m_start_time = rs.getTimestamp("start_time");
            r.m_end_time   = rs.getTimestamp("end_time");
            r.m_name     = rs.getString("name");
            r.m_memo1     = rs.getString("memo1");
            r.m_memo2     = rs.getString("memo2");
            if (m_debug){
              r.print(); // Debug
            }
        }
        rs.close();
        unlock();
//System.out.println("Execute query dmt resulted n = "+ counts);
        return counts;
    }
    /**
     * execute an SQL query. The last record is stored into variables.
     * @params a query string
     * @returns number of found records
     * @throws SQLExeption
     */
    public int execute(String sql, vfilesRecord r) throws SQLException {
        lock();
        int counts=0;
        ResultSet rs= st.executeQuery(sql);
        while(rs.next()){
            counts++;
            r.m_dn_index = rs.getInt("dn_index");
            r.m_id       = rs.getString("id");
            r.m_name     = rs.getString("name");
            r.m_number   = rs.getInt("number");
            r.m_report   = rs.getString("report");
            r.m_mid      = rs.getString("mid");
            r.m_status   = rs.getBoolean("status");
            if (m_debug){
              r.print();  // Debug
            }
        }
        rs.close();
        unlock();
        return counts;
    }

    /**
     * insert a records into the database dmt table
     * @throws SQLExeption
     */
    public int insert(dmtRecord r)throws SQLException {
        lock();

        String cmd=new String("insert into dmt(id,total,sent,"+
        "received,warnings,errors,resent,deleted,report,status,start_time,end_time,name,memo1,memo2)"+
        " values("+"'"+
        r.m_id+"',"+
        r.m_total+","+
        r.m_sent+","+
        r.m_received+","+
        r.m_warnings+","+
        r.m_errors+","+
        r.m_resent+","+
        r.m_deleted+",'"+
        r.m_report+"',"+
        r.m_status+",'"+
        r.m_start_time+"','"+
        r.m_end_time+"','"+
        r.m_name+"','"+
        r.m_memo1+"','"+
        r.m_memo2+"')");

        //System.out.println("insert : "+cmd);
        int res= st.executeUpdate(cmd);

        unlock();
        return res;
    }
        /**
     * insert a records into the database vfiles table
     * @throws SQLExeption
     */
    public int insert(vfilesRecord r)throws SQLException {
        lock();
        String cmd="insert into vfiles(id,name,number,report,mid,status)"+
        " values('"+r.m_id+"','"+
        r.m_name+"',"+
        r.m_number+",'"+
        r.m_report+"','"+
        r.m_mid+"',"+
        r.m_status+")";
        int res= st.executeUpdate(cmd);
        System.out.println(cmd);
        unlock();
        return res;
    }
    /**
     * delete a records into the database
     * @params an SQL message " [ WHERE search_condition ]"
     * @throws SQLExeption
     */
    public int delete(String sql)throws SQLException {
        lock();
        int res=0;
        //System.out.println("dbBase delete : "+sql);
        res= st.executeUpdate("delete from "+sql);
        unlock();
        return res;
    }

    /**
     * update a records into the database
     * @params an SQL message "name set set_clause [, ...] [ WHERE search_condition ]"
     * set_clause  	::=  	 column_name = value_expression
     * @returns result code int
     * @throws SQLExeption
     */
    public int update(String sql)throws SQLException {
        lock();
        //System.out.println("update name set : "+sql);
        int res= st.executeUpdate("update "+sql);
        //System.out.println("Base Update res="+res);
        unlock();
        return res;
    }

    /**
     * general Update query
     * @params an SQL message
     * @throws SQLExeption
     * @returns result code int
     */
    public int executeUpdate(String sql)throws SQLException {
        lock();
        //System.out.println("executeUpdate name set : "+sql);
        int res= st.executeUpdate(sql);
        //System.out.println("Base ExecuteUpdate res="+res);
        unlock();
        return res;
    }


    /**
    * Specific methods, no lock required
    */

    /**
     * Obtain a file name from the collection
     * @params transaction id, a file number into the collection
     * @returns result code String or null if failed or there is not such records
     */
    public String getFileName(String transaction_id, int file_number){
       vfilesRecord v=new vfilesRecord();
       int res=0;
       try{
         res=this.execute("select * from vfiles where vfiles.id like \'"+transaction_id +"\' and vfiles.number="+file_number, v);
         if ( res==0 ) return null;
       }catch(SQLException el){
            System.out.println(el.toString());
            return null;
       }
       if ( res==0 ) return null;
       return v.m_name;
    }

    /**
     * Obtain a transaction record
     * @params transaction id
     * @returns result code dmtRecord or null if failed or there is not such records
     */
    public dmtRecord getDmtRecord(String transaction_id){
       dmtRecord r=new dmtRecord();
       int res=0;
       try{
         //System.out.println("getDmtRecord transaction_id="+transaction_id);
         res=this.execute("select * from dmt where dmt.id like \'"+transaction_id+"\'", r);
         if ( res==0 ) return null;
       }catch(SQLException el){
            System.out.println(el.toString());
            return null;
       }
       if ( res==0 ) return null;
       return r;
    }

    /**
     * Obtain a transaction record
     * @params db_field - field in db to identify
     * @param value - value of above field
     * @returns result code dmtRecord or null if failed or there is not such records
     */
    public dmtRecord getDmtRecord(String db_field, String value){
       dmtRecord r=new dmtRecord();
       int res=0;
       try{
         //System.out.println("getDmtRecord transaction_id="+transaction_id);
         res=this.execute("select * from dmt where dmt."+db_field+" like \'"+value+"\'", r);
         if ( res==0 ) return null;
       }catch(SQLException el){
            System.out.println(el.toString());
            return null;
       }
       if ( res==0 ) return null;
       return r;
    }

    public String getAllDmt(String sql){

      String res    = "";
      dmtRecord r   = new dmtRecord();
      ResultSet rs  = null;
      int counts    = 0;
      try {
        lock();
        rs = st.executeQuery(sql);
        while (rs.next()) {
          counts++;
          r.m_dn_index = rs.getInt("dn_index");
          r.m_id = rs.getString("id");
          r.m_total = rs.getInt("total");
          r.m_sent = rs.getInt("sent");
          r.m_received = rs.getInt("received");
          r.m_warnings = rs.getInt("warnings");
          r.m_errors = rs.getInt("errors");
          r.m_resent = rs.getInt("resent");
          r.m_deleted = rs.getInt("deleted");
          r.m_report = rs.getString("report");
          r.m_status = rs.getBoolean("status");
          r.m_start_time = rs.getTimestamp("start_time");
          r.m_end_time = rs.getTimestamp("end_time");
          r.m_name = rs.getString("name");
          r.m_memo1 = rs.getString("memo1");
          r.m_memo2 = rs.getString("memo2");
          if (m_debug) {
            r.print(); // Debug
          }
          res += r.toReportString();
        }
        rs.close();
        unlock();
      }
       catch (SQLException ex) {
         System.out.println(ex);
         return null;
      }
     if ( counts==0 ) return null;
     return res;
    }

    /**
     * Debug method
     */
    public static void main(String[] args){

        dbBase obj=new dbBase("dbmdb.dbs");     // connect to the data base
        obj.setDebugMode(true);                 // see results of select in console
        try{
          //insert
          System.out.println("Inserting vfiles ...");
          vfilesRecord v = new vfilesRecord();
          obj.insert(v);

          System.out.println("Inserting dmt ...");
          dmtRecord r = new dmtRecord();
          obj.insert(r);

          // read from the database

          obj.execute("select * from dmt", r);
          obj.execute("select * from vfiles", v);
          obj.delete("dmt where dmt.dn_index>6");
          obj.executeUpdate("update dmt set sent=1 where dn_index=7");
          /*
           * How to update
           */
          System.out.println("Update the record 6");
          Timestamp newtime = new Timestamp(System.currentTimeMillis());
          System.out.println(newtime);
          java.sql.Date t = new Date(newtime.getTime());
          Calendar calendar = new GregorianCalendar();
          calendar.setTime(t);
          System.out.println("Year = " + calendar.get(Calendar.YEAR));
          System.out.println("Month = " + calendar.get(Calendar.MONTH)); // from 0 to 11
          System.out.println("Day = " + calendar.get(Calendar.DAY_OF_MONTH)); // from 1
          System.out.println("Hour = " + calendar.get(Calendar.HOUR_OF_DAY)); // from 0
          System.out.println("Date = " + calendar.get(Calendar.DATE)); // the same as Day_OF_MONTH
          Timestamp ts = new Timestamp(calendar.getTimeInMillis());
          System.out.println("the cloned timestamp: " + ts);

          //System.out.println(calendar.getTime().getMonth());
          int index=1;
          obj.executeUpdate("update dmt set id=\'updated_id\' where dn_index="+index);
          obj.executeUpdate("update dmt set total=101 where dn_index="+index);
          obj.executeUpdate("update dmt set sent=102 where dn_index="+index);
          obj.executeUpdate("update dmt set received=103 where dn_index="+index);
          obj.executeUpdate("update dmt set warnings=104 where dn_index="+index);
          obj.executeUpdate("update dmt set errors=105 where dn_index="+index);
          obj.executeUpdate("update dmt set resent=106 where dn_index="+index);
          obj.executeUpdate("update dmt set deleted=107 where dn_index="+index);
          obj.executeUpdate("update dmt set report=\'updated report\' where dn_index="+index);
          obj.executeUpdate("update dmt set status=true where dn_index="+index);
          System.out.println("try timestamp");
          //int update_res=obj.executeUpdate("update dmt set start_time=to_timestamp('2006 05 12 06 09 24', 'YYYY MM DD HH24 MI SS') where dn_index=6");
          //int update_res=obj.executeUpdate("update dmt set start_time=to_timestamp('2006-06-19 '||'10:54:20') where dn_index=6");
          int update_res = obj.executeUpdate("update dmt set start_time=to_timestamp('" +
                                             newtime + "') where dn_index="+index);

          // how to check results
          if (update_res == 0) System.out.println("Error: the record does" +
                                                  " not exists or the query is not supported");
          System.out.println("Update resulted code " + update_res);

          // how to compare timestamps
          long yesterday=calendar.getTimeInMillis()-1000*60*60*24;
          Timestamp oldtime = new Timestamp(yesterday);
          dmtRecord rt=new dmtRecord(); //status=true and
          int n=obj.execute("select * from dmt where start_time<to_timestamp('"+oldtime+"')",rt);
          if ( n!=0 ){
            System.out.println(rt.toString());
          }

            // print the updated record
            obj.execute("select * from dmt where dn_index="+index,r);
            r.print();
            /*
            * How to update vfiles
            */
            System.out.println("Update vfiles ...");
            obj.executeUpdate("update vfiles set name=\'aaa\' where dn_index="+index);
            obj.executeUpdate("update vfiles set report=\'ok\' where dn_index="+index);
            obj.execute("select * from vfiles",v);
            System.out.println("Print results ...");
            v.print();
            //obj.close();

        }
        catch(SQLException e1){
            System.out.println(e1.toString());
        }
        try{
        obj.close();
        } catch(SQLException eclose){
            System.out.println(eclose.toString());
        }

    }
}// end dbBase class
