package dbridge;

/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003-2008</p>
 * <p>Company: a</p>
 * @author unknown
 * @version 1.0
 */

public class dbBox  implements java.io.Serializable {

  public dbBox() {
    mName="Unknown Box";
    mIP="";
    mPort="";
    mTmpDir="./";
    mStartTimeGC="0:1";
    mRepeatePeriodGC=2;
    mNotInUseGC=1;
    mRunInit=0;
    //mUserList=new UserContainer();
    mTimeDelay=10;
    mAET="test";
    mAET_Prefix=""; // aet 
    mAEC_Prefix=""; // aec 
    mServer="";
    mServerOptions="";
    mExtCmd="";
    mCmd=new String[1];
    mCmd[0]=new String("");
    mDCMSender = "";
    mDCMSenderOptions = "";
    mIntSender=false;
    mLogDir = "Logs";
    mLogLevel = 1; // dissable logs
    mMethodDN = 0; // no DN messages
    mMethodSign = 0; // no DN messages
    mSplitterOn = true; // allways splitt
    mSplitterSize = 5*1024*1024; // 5 Mb max file size allowed
    mUpdateURL = "";
  }
  // private fields
  private String mName;         // computer name
  private String mIP;           // IP address
  private String mPort;         // port for communications
  private String mTmpDir;       // directory where to save incoming data
  // garbage collector
  private String mStartTimeGC;  // start the garbage collector at this time
  private long   mRepeatePeriodGC; // restart the collector every xx hours
  private double mNotInUseGC;   // if a file is in use, skip its processing for xx hours
  private int    mRunInit;      // start the Garbage Collector at the initialization phase
  //UserContainer mUserList;      // list of all available users
  private int mTimeDelay;       // delay for looking in temp dir
  private String mAET;          // AE title for the computer box
  private String mAET_Prefix;   // AE title for the computer box when listening
  private String mAEC_Prefix;   // AE title for the computer box when calling
  private String mServer;       // name of the dicom software
  private String mServerOptions;// Options
  private String mExtCmd;       // run extewrnal command
  private String mCmd[];        // run command, assembled from the above fields
  private String mDCMSender;    // sends DICOM files to DICOM servers
  private String mDCMSenderOptions;    // Options
  private boolean mIntSender;   // sends DICOM files using the internal sender
  private String mGpgPath;      // path where pgp software is located
  private String mLogDir;       // directory for storing log-files
  private int mLogLevel;        // log flag
  private int mMethodDN;        // Used Disposition Notification Method
  private int mMethodSign;      // Used Signature PGP Method
  private boolean mSplitterOn;  // allows SMTP splitting
  private int mSplitterSize;    // Size in bytes
  private String mUpdateURL;    // URL for checking and updates

  // set/get methods
  public void setName(String name){mName=name;}
  public String getName(){return mName;}
  public void setIP(String ip){mIP=ip;}
  public String getIP(){return mIP;}
  public void setPort(String ip){mPort=ip;}
  public String getPort(){return mPort;}
  public void setTmpDir(String dir){mTmpDir=dir;}
  public String getTmpDir(){return mTmpDir;}
  // 10.08.05
  public void setStartTimeGC(String time){mStartTimeGC=time;}
  public String getStartTimeGC(){return mStartTimeGC;}
  public void setRepeatePeriodGC(long h){mRepeatePeriodGC=h;}
  public long getRepeatePeriodGC(){return mRepeatePeriodGC;}
  public void setNotInUseGC(double h){mNotInUseGC=h;}
  public double getNotInUseGC(){return mNotInUseGC;}
  public void setRunInit(int v){mRunInit=v;}
  public double getRunInit(){return mRunInit;}

  public void setTimeDelay(int t){mTimeDelay=t;}
  public int getTimeDelay(){return mTimeDelay;}
  public void setAET(String str){mAET=str;}
  public String getAET(){return mAET;}
  public void setServer(String str){mServer=str;}
  public String getServer(){return mServer;}
  // 14.07.08
  public void setAetPrefix(String str){mAEC_Prefix=str;}
  public String getAetPrefix(){return mAEC_Prefix;}
  public void setAecPrefix(String str){mAEC_Prefix=str;}
  public String getAecPrefix(){return mAEC_Prefix;}
  
  public void setServerOptions(String str){mServerOptions=str;}
  public String getServerOptions(){return mServerOptions;}
  public void setExtCmd(String str){mExtCmd=str;}
  public String getExtCmd(){return mExtCmd;}
  public void setCmd(String str[]){mCmd=str;}
  public String[] getCmd(){return mCmd;}
  public void setDCMSender(String str){mDCMSender=str;}
  public String getDCMSender(){return mDCMSender;}
  public void setDCMSenderOptions(String str){mDCMSenderOptions=str;}
  public String getDCMSenderOptions(){return mDCMSenderOptions;}
  public void setIntSender(boolean on){mIntSender=on;}
  public boolean getIntSender(){return mIntSender;}
  public void setGpgPath(String str){mGpgPath=str;}
  public String getGpgPath(){return mGpgPath;}
  public void setLogDir(String str){mLogDir=str;}
  public String getLogDir(){return mLogDir;}
  public void setLogLevel(int flag){mLogLevel=flag;}
  public int getLogLevel(){return mLogLevel;}
  public void setMethodDN(int m){mMethodDN=m;}
  public int getMethodDN(){return mMethodDN;}
  public void setMethodSign(int m){mMethodSign=m;}
  public int getMethodSign(){return mMethodSign;}
  // may 2006
  public void setSplitterOn(boolean on){ mSplitterOn=on;}
  public boolean isSplitterOn(){ return mSplitterOn;}
  public void setSplitterSize(int size){ mSplitterSize=size;}
  public int getSplitterSize(){ return mSplitterSize;}
  public void setUpdateURL(String url){ mUpdateURL=url;}
  public String getUpdateURL(){ return mUpdateURL;}


  /* Log message */
  void printLog(String msg){ ;}

  public void print(){
    System.out.println(mName);
    System.out.println(mIP);
    System.out.println(mPort);
    System.out.println(mTmpDir);
    System.out.println(mStartTimeGC);
    System.out.println(mRepeatePeriodGC);
    System.out.println(mNotInUseGC);
    System.out.println(mRunInit);
    //mUserList.print();
    System.out.println(mTimeDelay);
    System.out.println(mAET);
    System.out.println(mAET_Prefix);
    System.out.println(mAEC_Prefix);
    System.out.println(mServer);
    System.out.println(mServerOptions);
    System.out.println(mExtCmd);
    System.out.println(mCmd[0]);
    System.out.println(mDCMSender);
    System.out.println(mDCMSenderOptions);
    String int_sender="on";
    if (!mIntSender) int_sender="off";
    System.out.println(int_sender);
    System.out.println(mGpgPath);
    System.out.println(mLogDir);
    System.out.println("DN Method "+mMethodDN);
    System.out.println("Sign Method "+mMethodSign);
    System.out.println("Splitter "+mSplitterOn);
    System.out.println("Splitter Size "+mSplitterSize);
    System.out.println("Update URL "+mUpdateURL);
  }
  public static void main(String[] args) {
    dbBox dbBox1 = new dbBox();
    dbBox1.print();
  }
}
