package dbridge;

/**
 * <p>Title: dbridge</p>
 *
 * <p>Description: </p> Generate a GUID
 *
 * <p>Copyright: Copyright (c) 2003-2005</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.rmi.server.UID;

public class dbGUID {

  String mGUID;
  /**
  * Nonparametrized constructor
  */
  public dbGUID(){
    mGUID=new String("");
  }

  /**
  * Return a stored GUID
  */
  public String getGUID(){
    return mGUID;
  }

  /**
  * Generate a global UID using the host network MAC address.
  * Returns a GUID or "" if failed.
  */
  public String generateGUID () {
    try {
      //Get a global host specified ID
      UID userId = new UID();

      //get its digest
      MessageDigest sha = MessageDigest.getInstance("SHA-1");
      byte[] result =  sha.digest( userId.toString().getBytes() );

      mGUID=hexEncode(result);
    }
    catch ( NoSuchAlgorithmException ex ) {
      System.err.println(ex);
      mGUID="";
    }
    return mGUID;
  }

  /**
  * Convert to Hexagonal string.
  * @param input byte[]
  */
  static private String hexEncode( byte[] input){
    StringBuffer res = new StringBuffer();
    char[] digits = {'0', '1', '2', '3', '4','5','6','7','8','9','a','b','c','d','e','f'};
    for ( int idx = 0; idx < input.length; ++idx) {
      byte b = input[idx];
      res.append( digits[ (b&0xf0) >> 4 ] );
      res.append( digits[ b&0x0f] );
    }
    return res.toString();
  }

  /**
  * Debug method. Generates 10 GUIDs.
  */
  public static void main (String[] arguments) {
     dbGUID idObj=new dbGUID();
     for (int i=0;i<10;i++)
     	System.out.println("MD "+ i+ ": "+idObj.generateGUID());
     idObj.getGUID();
  }
}

