package dbridge;

import java.util.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

 /*
 * This class is a simple interpeter. Input: a string in format:
 * COMMAND$arg1$Arg2$Arg3$...$Argn
 * $ is a separator by default
 */

 /*
 * Created: 24.01.04
 * Modified 24.01.04
 * Modified 25.01.04
 * Modified  2.03.04
 * Modified 21.03.04
 * Modified 29.09.04
 * Modified 21.10.04
 * Modified 1.12.04-22.12.04
 * Modified 25.05.06-20.06.06
 */
public class dbInterpreter {
  String mSeparators;
  Vector mLexems;
  String mResult;

  public dbInterpreter() {
    Init("$");
  }
  public dbInterpreter(String s) {
    Init(s);
  }

  public boolean process(String str){
    mLexems.removeAllElements();  // clear vector
    if ( scanner(str) )
      if ( analysator() ){
        mLexems.removeAllElements();
      }
    return true;
  }
  public void setResult(String str){
    mResult=new String(str);
  }
  public String getResult(){
    return mResult;
  }


  /*
  * Protected Methods
  */
  protected void Init(String s) {
    mSeparators=new String(s);
    mLexems = new Vector();
  }
  protected boolean scanner(String str){
    StringTokenizer token=new StringTokenizer(str,mSeparators);
    String lex = new String(token.nextToken());
    if ( lex==null ) return false;
    mLexems.add( lex );
    if ( token.hasMoreTokens()) {
      lex = new String(token.nextToken());
      while ( lex!=null ){
        mLexems.add(lex);
        if ( token.hasMoreTokens()) lex = new String(token.nextToken());
        else lex=null;
      }
    }
    return true;
  }

  protected boolean analysator(){
    if ( ((String)mLexems.firstElement()).compareTo("STOP")==0 ){
      if (mLexems.size()==2 ){
        //take an argument and call the method
        Integer time=new Integer( (String) mLexems.get(1) );
        DBridgeServer.stop(time.intValue());
        return true;
      } else {// TODO delete this code
        DBridgeServer.stop();
        return true;
      }
    }
    if ( ((String)mLexems.firstElement()).compareTo("STOPDAEMONS")==0 ){
        DBridgeServer.stopDaemons();
        return true;
    }
    if ( ((String)mLexems.firstElement()).compareTo("STARTDAEMONS")==0 ){
        DBridgeServer.startDaemons();
        return true;
    }
    if ( ((String)mLexems.firstElement()).compareTo("DBRESTART")==0 ){
      //System.out.println("Interpretator: Restart Server");
      DBridgeServer.restart();
      //System.out.println("Interpretator: Server has been restarted");
      return true;
    }
    if ( ((String)mLexems.firstElement()).compareTo("DBRESTARTSERVICES")==0 ){
      //System.out.println("Restart Serverices");
      DBridgeServer.restartServices();
      return true;
    }
    if ( ((String)mLexems.firstElement()).compareTo("DBADMCHANGE")==0 ){
      if (mLexems.size()==2 ){
        //take an argument and call the method
        DBridgeServer.dbAdmChange( (String)mLexems.get(1) );
        return true;
      } else {
        return false;
      }
    }
    if ( ((String)mLexems.firstElement()).compareTo("DBADDUSER")==0 ){
      if (mLexems.size()==2 ){
        //take an argument and call the method
        int index = Integer.parseInt( (String)mLexems.get(1) );
        DBridgeServer.dbAddUser( index );
        return true;
      } else {
        return false;
      }
    }
    if ( ((String)mLexems.firstElement()).compareTo("DBUPDATEUSER")==0 ){
      if (mLexems.size()==2 ){
        //take an argument and call the method
        int index = Integer.parseInt( (String)mLexems.get(1) );
        DBridgeServer.dbUpdateUser( index );
        return true;
      } else {
        return false;
      }
    }
    if ( ((String)mLexems.firstElement()).compareTo("DBDELETEUSER")==0 ){
      if (mLexems.size()==2 ){
        //take an argument and call the method
        int index = Integer.parseInt( (String)mLexems.get(1) );
        DBridgeServer.dbDeleteUser( index );
        return true;
      } else {
        return false;
      }
    }
    if ( ((String)mLexems.firstElement()).compareTo("DBADDSERVER")==0 ){
      if (mLexems.size()==1 ){
        //take an argument and call the method
        DBridgeServer.dbAddServer( );
        return true;
      } else {
        return false;
      }
    }
    if ( ((String)mLexems.firstElement()).compareTo("DBUPDATESERVER")==0 ){
      if (mLexems.size()==1 ){
        //take an argument and call the method
        DBridgeServer.dbUpdateServer( );
        return true;
      } else {
        return false;
      }
    }
    if ( ((String)mLexems.firstElement()).compareTo("DBDELETESERVER")==0 ){
      if (mLexems.size()==2 ){
        //take an argument and call the method
        int index = Integer.parseInt( (String)mLexems.get(1) );
        DBridgeServer.dbDeleteServer( index );
        return true;
      } else {
        return false;
      }
    }
    if ( ((String)mLexems.firstElement()).compareTo("HELLO")==0 ){
      return true;
    }
    if ( ((String)mLexems.firstElement()).compareTo("DBSTOPAUTODCMSEND")==0 ){
      if (mLexems.size()==2 ){
        //take an argument and call the method
        int index = Integer.parseInt( (String)mLexems.get(1) );
        DBridgeServer.dbStopAutoDCMSend( index );
        return true;
      } else {
        return false;
      }
    }
    if ( ((String)mLexems.firstElement()).compareTo("DBSTARTAUTODCMSEND")==0 ){
      if (mLexems.size()==2 ){
        //take an argument and call the method
        int index = Integer.parseInt( (String)mLexems.get(1) );
        DBridgeServer.dbStartAutoDCMSend( index );
        return true;
      } else {
        return false;
      }
    }

    // DB Logger state
    if ( ((String)mLexems.firstElement()).compareTo("LOGDB")==0 ){
      if (mLexems.size()==1 ){
        //take status
        Integer state=BridgeApp.Monitor().GetState(Logs.sBank);  // TODO
        if ( state==State.ERROR ) mResult=new String("red");
        else if ( state==State.WARNING ) mResult=new String("yellow");
        else mResult=new String("green");
        return true;
      } else {
        return false;
      }
    }
    // DB Logger state
    if ( ( (String) mLexems.firstElement()).compareTo("SETGREENLOGDB") == 0) {
      if (mLexems.size() == 1) {
        //take status
        BridgeApp.Monitor().SetState(Logs.sBank,State.INFO); // TODO
        return true;
      }
      else {
        return false;
      }
    }

    // Services Logger state
    if ( ((String)mLexems.firstElement()).compareTo("LOGSERVICES")==0 ){
      if (mLexems.size()==1 ){
        //take status
        Integer state=BridgeApp.Monitor().GetState(Logs.sServices);  // TODO
        if ( state==State.ERROR ) mResult=new String("red");
        else if ( state==State.WARNING ) mResult=new String("yellow");
        else mResult=new String("green");
        return true;
      } else {
        return false;
      }
    }
    // Services Logger state reset
    if ( ( (String) mLexems.firstElement()).compareTo("SETGREENLOGSERVICES") == 0) {
      if (mLexems.size() == 1) {
        //take status
        BridgeApp.Monitor().SetState(Logs.sServices,State.INFO); // TODO
        return true;
      }
      else {
        return false;
      }
    }
    // SQL SECTION
    // This section is very important to build correct return messages.
    // No default reurn message is allowed, while it will be not correctly
    // interpreted by the client. Every request has to return either dmtecord,
    // vfilesRecord in their string representation or "null".
    // Sql Query DMT
    if ( ( (String) mLexems.firstElement()).compareTo("SQLDMT") == 0) {
      if (mLexems.size() == 2) {
        //take status
        String dmtres=dbQuery.setQueryDmt( (String)mLexems.get(1));
        if ( dmtres==null ) dmtres="null";
        mResult=new String( dmtres );
        return true;
      }
      else {
        mResult=new String("null");
        return false;
      }
    }

    /**
     * Sql Query files. SQLFILES$SqlQueryStr
     */
    if ( ( (String) mLexems.firstElement()).compareTo("SQLFILES") == 0) {
      if (mLexems.size() == 2) {
        //take status
        String vres=dbQuery.setQueryFiles( (String)mLexems.get(1));
        if ( vres==null ) vres="null";
        mResult=new String( vres );
        return true;
      }
      else {
        mResult=new String("null");
        return false;
      }
    }
    /**
     * Sql Query a file name. SQLFILENAME$Transaction_id$fiel_nr
     */
    if ( ( (String) mLexems.firstElement()).compareTo("SQLFILENAME") == 0) {
      if (mLexems.size() == 3) {
        //take status
        int file_nr=Integer.parseInt( (String)mLexems.get(2) );
        String fn_res=dbQuery.getFileName( (String)mLexems.get(1),
                                           file_nr );
        if ( fn_res== null ) fn_res="null";
        mResult=new String( fn_res );
        return true;
      }
      else {
        mResult=new String("null");
        return false;
      }
    }

    // Sql Query a file name
    if ( ( (String) mLexems.firstElement()).compareTo("SQLDMTRECORD") == 0) {
      if (mLexems.size() == 2) {
        //take status
        //System.out.println("SQLDMTRECORD query= "+(String)mLexems.get(1) );
        String dmt_res=dbQuery.getDmtRecord( (String)mLexems.get(1) );
        if ( dmt_res== null ) dmt_res="null";
        mResult=new String( dmt_res );
        return true;
      }
      else {
        mResult=new String("null");
        return false;
      }
    }

    // Sql Query delete
    if ( ( (String) mLexems.firstElement()).compareTo("SQLDELETE") == 0) {
      if (mLexems.size() == 2) {
        //take status
        String delete_res=dbQuery.setQueryDelete( (String)mLexems.get(1) );
        if ( delete_res== null ) delete_res="null";
        mResult=new String( delete_res );
        return true;
      }
      else {
        mResult=new String("null");
        return false;
      }
    }

    // Sql Query a file name
    if ( ( (String) mLexems.firstElement()).compareTo("SQLUPDATE") == 0) {
      if (mLexems.size() == 2) {
        //take status
        mResult=new String("null"); // to guarantee correctness
        String update_res=dbQuery.setQueryUpdate( (String)mLexems.get(1) );
        if ( update_res== null ) update_res="null";
        //System.out.println("update_res="+update_res);
        mResult=new String( update_res );
        return true;
      }
      else {
        mResult=new String("null");
        return false;
      }
    }

    // Sql Query Insert DMT. SQLINSERTDMT$DMTStr
    if ( ( (String) mLexems.firstElement()).compareTo("SQLINSERTDMT") == 0) {
      if (mLexems.size() == 2) {
        //take status
        String insert_res=dbQuery.setQueryInsertDmt( (String)mLexems.get(1));
        if ( insert_res== null ) insert_res="null";
        mResult=new String( insert_res );
        return true;
      }
      else {
        mResult=new String("null");
        return false;
      }
    }

    /**
     * Sql Query files. SQLINSERTFILES$FILESStr
     */
    if ( ( (String) mLexems.firstElement()).compareTo("SQLINSERTFILES") == 0) {
      if (mLexems.size() == 2) {
        //take status
        String insert_res=dbQuery.setQueryInsertFiles( (String)mLexems.get(1) );
        if ( insert_res== null ) insert_res="null";
        mResult=new String( insert_res );
        return true;
      }
      else {
        mResult=new String("null");
        return false;
      }
    }

    /**
     * Sql Query files. SQLALLDMT$Str
     */
    if ( ( (String) mLexems.firstElement()).compareTo("SQLALLDMT") == 0) {
      if (mLexems.size() == 2) {
        //take status
        String insert_res=dbQuery.setQueryDmtReport( (String)mLexems.get(1) );
        if ( insert_res== null ) insert_res="null";
        mResult=new String( insert_res );
        return true;
      }
      else {
        mResult=new String("null");
        return false;
      }
    }



  // TODO: Needed for dsUserInfoFrame
  // DBridgeClient.sendRequest("DBSTOPAUTODCMSEND$"+index.toString());
  // DBridgeClient.sendRequest("DBSTARTAUTODCMSEND$"+index.toString());
  // Need to read Bank for both!!!

  return false;
  }

  /*
  * Debug Methods
  */
  public static void main(String[] args) {
    dbInterpreter dbInterpreter1 = new dbInterpreter();
    dbInterpreter1.process("HELLO"+"$"+"server");
  }
}
