package dbridge;

/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author unknown
 * @version 1.0
 */

public class dbMailRecord  implements java.io.Serializable {


  private static final long serialVersionUID = 837936649315820049L;
  protected String mMail;         // represent user and e-mail server user@server
  protected String mDomain;       // domain/server
  protected String mComments;
  protected int mTimeDelay;       // time period between two server requests
  protected String mPassword;
  protected String mPubKeyN;      // file name where the pgp public key was stored
  protected String mPrivKeyID;
  protected int mPort;            // Port used on the server
  protected boolean mProtocol;    // false if POP3, frue IMAP
  protected boolean mSSL_flag;     // true if SSL
  protected int mSrvIndex;         // need for address book default SMTP
  protected int mMethodDN;
  protected int mMethodPGPSign;

  public dbMailRecord(){
  mMail=new String();
  mDomain=new String();
  mComments=new String();
  mPassword=new String();
  mPubKeyN=new String();
  mPrivKeyID=new String();
  mPort=993; //mPort=143;  // imap
  mProtocol=true;
  mSSL_flag=true;
  mSrvIndex = 0;
  mMethodDN = DBConsts.MDN_NONE;
  mMethodPGPSign = DBConsts.PGPSIGN_NONE;
  }

  public dbMailRecord(String mail, String comments, String password, int time){
    mMail=mail;
    mDomain="";
    mComments=comments;
    mPassword=password;
    mTimeDelay=time;
    mPubKeyN="";
    mPrivKeyID="";
    mPort=993;  // imap
    mProtocol=true;
    mSSL_flag=true;
    mSrvIndex = 0;
    mMethodDN = DBConsts.MDN_NONE;
    mMethodPGPSign = DBConsts.PGPSIGN_NONE;
  }

  public dbMailRecord(String mail, String domain, String comments, String password, int time){
    mMail=mail;
    mDomain=domain;
    mComments=comments;
    mPassword=password;
    mTimeDelay=time;
    mPubKeyN="";
    mPrivKeyID="";
    mPort=993;  // imap
    mProtocol=true;
    mSSL_flag=true;
    mSrvIndex = 0;
    mMethodDN = DBConsts.MDN_NONE;
    mMethodPGPSign = DBConsts.PGPSIGN_NONE;
  }

  public dbMailRecord(dbMailRecord obj){
    mMail=obj.mMail;
    mDomain=obj.mDomain;
    mComments=obj.mComments;
    mPassword=obj.mPassword;
    mTimeDelay=obj.mTimeDelay;
    mPubKeyN=obj.mPubKeyN;
    mPrivKeyID=obj.mPrivKeyID;
    mPort=obj.mPort;
    mProtocol=obj.mProtocol;
    mSSL_flag=obj.mSSL_flag;
    mSrvIndex = obj.mSrvIndex;
    mMethodDN = obj.mMethodDN;
    mMethodPGPSign = obj.mMethodPGPSign;

  }
  // set/get methods
  public String getMail(){return mMail;}
  public void setMail(String mail){mMail=mail;}
  public String getDomain(){return mDomain;}
  public void setDomain(String domain){mDomain=domain;}
  //public void setMailDomainAddr(String addr){};
  public String getMailDomainAddr(){if (mDomain.compareTo("")==0) return mMail;
                                    else return (String)(mMail+"@"+mDomain); }
  public String getComments(){return mComments;}
  public void setComments(String c){mComments=c;}
  public String getPassword(){return mPassword;}
  public void setPassword(String p){mPassword=p;}
  public int getTimeDelay(){return mTimeDelay;}
  public void setTimeDelay(int t){mTimeDelay=t;}
  public String getPubKeyN(){return mPubKeyN;}
  public void setPubKeyN(String name){mPubKeyN=name;}
  public String getPrivKeyID(){return mPrivKeyID;}
  public void setPrivKeyID(String key_id){mPrivKeyID=key_id;}
  public int getSrvIndex(){return mSrvIndex;}
  public void setSrvInd(int iInd){mSrvIndex = iInd;}
  // IMAP/POP3 settings
  public void setToImap(){ mPort=143; mProtocol=true; mSSL_flag=false;}
  public void setToImap(int port){ mPort=port; mProtocol=true; mSSL_flag=false;}
  public void setToPop3(){ mPort=110; mProtocol=false; mSSL_flag=false;}
  public void setToPop3(int port){ mPort=port; mProtocol=false; mSSL_flag=false;}
  public boolean isImap(){ return mProtocol;}
  public boolean isPop3(){ return (!mProtocol);}
  public int getPort(){return mPort;}
  public void setToSSL(int port){mPort=port; mSSL_flag=true;}
  public void setToSSL(){
   if (isImap()) mPort=993; else mPort=995;
    mSSL_flag=true;}
  public boolean isSSL(){return mSSL_flag;}
  public void setMethodDN(int method){mMethodDN = method;}
  public int getMethodDN(){return mMethodDN;}
  public void setMethodPGPSign(int method){mMethodPGPSign = method;}
  public int getMethodPGPSign(){return mMethodPGPSign;}
  public String toString() {return mMail;}

  // DEBUG
  public void print(){
    System.out.println(mMail);
    System.out.println(mDomain);
    System.out.println(mComments);
    System.out.println("********");
    System.out.println(mTimeDelay);
    System.out.println(mPubKeyN);
    System.out.println(mPrivKeyID);
    System.out.println(mPort);
    System.out.println("MethodDN:" + this.mMethodDN);
    System.out.println("MethodSign:" + this.mMethodPGPSign);
    //if (!mProtocol)
    //  System.out.println("IMAP");
    //else
    //  System.out.println("POP3");
  }
  public static void main(String[] args) {
    System.out.println("Test table");
    //dbMailRecord obj = new dbMailRecord();
  }
  // END DEBUG
}
