package dbridge;

/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author unascribed
 * @version 1.0
 */

/*
 * Modified 11.06.06
 * Modified 19.06.06
 */

import java.sql.*;

public class dbQuery
{
    /**
     * Default constructor
     */
    public dbQuery(){
    }

    /*
     * Query Methods
     */
    /**
     * Set Query and return the found dmt record as a string
     * @param query String
     * @return String  "null" or the record structure
     */
    public static String setQueryDmt(String query){
       dmtRecord r=new dmtRecord();

         if (BridgeApp.isServer()) {
           //System.out.println("Server calls QueryDmt...");
           try{
             if ( DBridgeServer.Base().execute(query, r)==0 )
               return null;
             //System.out.println("Query result: "+r.toString());
           }catch(SQLException e1){
            System.out.println(e1.toString());
            return null;
           }
         }
         else {
           //System.out.println("Client calls QueryDmt...");
           String query_res=DBridgeClient.sendRequest("SQLDMT$"+query);
           if ( ((String)query_res).compareTo("null")==0 ) return null;
           //System.out.println("Query result: "+ query_res);
           r.fromString(query_res);
         }
       return r.toString();
    }
    /**
     * Set Query and return the found vfiles record as a string
     * @param query String
     * @return String "null" or the record structure
     */
    public static String setQueryFiles(String query){
       vfilesRecord r=new vfilesRecord();
         if (BridgeApp.isServer()) {
           //System.out.println("Server calls QueryFiles... with query="+query);
           try{
             int nrecords=DBridgeServer.Base().execute(query, r);
             //System.out.println("Files records found "+ nrecords);
             if ( nrecords==0 ) return null;

           }catch(SQLException e1){
            System.out.println(e1.toString());
            return null;
           }
         }
         else {
           //System.out.println("Client calls QueryFiles ...");
           String query_res=DBridgeClient.sendRequest("SQLFILES$"+query);
           if ( ((String)query_res).compareTo("null")==0 ) return null;
           //System.out.println("Query result: "+ query_res);
           r.fromString(query_res);
           // TODO check results from String
         }
       return r.toString();
    }

    /**
     * Delete records in a table
     * @param query String - specifies the SQL delete query
     * @return String      - returns a result code
     */
    public static String setQueryDelete(String query){
       int res=0;
         if (BridgeApp.isServer()) {
           //System.out.println("Server calls QueryDelete...");
           try{
             res = DBridgeServer.Base().delete(query);
             if ( res==0 ) return null;
           }catch(SQLException e1){
            System.out.println(e1.toString());
            return null;
           }
         }
         else {
           //System.out.println("Client calls QueryDelete ...");
           String str_res= DBridgeClient.sendRequest("SQLDELETE$"+query);
           if ( str_res.compareTo("null")==0 ) str_res=null;
           return str_res;
           // TODO check results
         }
       //if ( res==0 ) return null;
       return String.valueOf(res);
    }
    /**
     * Set a query, find a record and update specified fileds. Return a code as string
     * Works with all records. The record name is specified in the query.
     * @param query String
     * @return String
     */
    public static String setQueryUpdate(String query){
      int res=0;
        if (BridgeApp.isServer()) {
          //System.out.println("Server calls QueryUpdate...");
          try{
            //System.out.println("DBridgeServer.Base().executeUpdate(query) " +query);
            res = DBridgeServer.Base().executeUpdate(query);
            //System.out.println("QueryUpdate results ..."+res);
          }catch(SQLException e1){
            System.out.println(e1.toString());
            return null;
          }
        }
        else {
          //System.out.println("Client calls QueryUpdate ...");
          String str_res= DBridgeClient.sendRequest("SQLUPDATE$"+query);
          if ( str_res.compareTo("null")==0 ) str_res=null;
          return str_res;
        }
      if ( res==0 ) return null;
      return String.valueOf(res);
    }
    /**
     * Fing a file name under specified Id and number
     * @param transaction_id String
     * @param file_number int
     * @return String
     */
    public static String getFileName(String transaction_id, int file_number){
      String res=null;
        if (BridgeApp.isServer()) {
          //System.out.println("Server calls QueryFileName...");
          res = DBridgeServer.Base().getFileName(transaction_id, file_number);
        }
        else {
          //System.out.println("Client calls QueryFileName ...");
          res=DBridgeClient.sendRequest("SQLFILENAME$"+
                                                 transaction_id+"$"+
                                                 new Integer(file_number).toString() );
          if ( res.compareTo("null")==0 ) res=null;
          return res;
          // TODO check results from String
        }
      return res;
    }
    /**
     * Find a dmt record with a specified id. Return as a string.
     * @param transaction_id String
     * @return String or null
     */
    public static String getDmtRecord(String transaction_id){
      dmtRecord r=new dmtRecord();
        if (BridgeApp.isServer()) {
          //System.out.println("Server calls get QueryDMTRecord ...");
          r = DBridgeServer.Base().getDmtRecord(transaction_id);
          if ( r==null ) return null;
        }
        else {
          //System.out.println("Client calls get QueryDMTRecord ...");
          String res=DBridgeClient.sendRequest("SQLDMTRECORD$"+transaction_id);
          if ( ((String)res).compareTo("null")==0 ) return null;
          return res;
           // TODO check results from String
        }
       return r.toString();
    }
    /**
     * Insert a dmt record, given as a string. Return a code.
     * @param query String
     * @return String
     */
    public static String setQueryInsertDmt(String query){
      dmtRecord r=new dmtRecord(query);
      int res=0;
         if (BridgeApp.isServer()) {
           //System.out.println("Server calls QueryInsertDmt ...");
           try{
             res=DBridgeServer.Base().insert(r);
           }catch(SQLException e1){
            System.out.println(e1.toString());
            return null;
           }
         }
         else {
           //System.out.println("Client calls QueryInsertDmt ...");
           String str_res= DBridgeClient.sendRequest("SQLINSERTDMT$"+query);
           if ( str_res.compareTo("null")==0 ) str_res=null;
           return str_res;
         }
       if ( res==0 ) return null;
       return String.valueOf(res);
    }
    /**
     * Insert a vfiles record, given as a string. Return a code.
     * @param query String
     * @return String
     */
    public static String setQueryInsertFiles(String query){
      vfilesRecord v=new vfilesRecord(query);
      int res=0;
         if (BridgeApp.isServer()) {
           //System.out.println("Server calls QueryInsertVfiles ...");
           try{
             res=DBridgeServer.Base().insert(v);
           }catch(SQLException e1){
            System.out.println(e1.toString());
            return null;
           }
         }
         else {
           //System.out.println("Client calls QueryInsertVfiles ...");
           String str_res= DBridgeClient.sendRequest("SQLINSERTFILES$"+query);
           if ( str_res.compareTo("null")==0 ) str_res=null;
           return str_res;
         }
       if ( res==0 ) return null;
       return String.valueOf(res);
    }

    public static String setQueryDmtReport(String query){
         String query_res = null;
         if (BridgeApp.isServer()) {
            return DBridgeServer.Base().getAllDmt(query);
         }
         else {
           query_res=DBridgeClient.sendRequest("SQLALLDMT$"+query);
           if ( ((String)query_res).compareTo("null")==0 ) return null;
         }
       return query_res;
    }


    /**
     * Debug method
     */
    public static void main(String[] args){
        // Note: All queryes will return null in case of
        // wrong fields names, wrong values or if results are empty.
        // Please compare every time results with null.

        // test code
        dmtRecord r=new dmtRecord();
        vfilesRecord v=new vfilesRecord();

        // insert a dmt record and read it
        r.m_id=new String("original id");
        dbQuery.setQueryInsertDmt(r.toString());   // insert the record r
        String dmtrec=dbQuery.setQueryDmt("select * from dmt");
        r.fromString(dmtrec);                  // convert the record

        // insert a vfiles record and read it
        v.m_name=new String("original vname");
        dbQuery.setQueryInsertFiles(v.toString()); // insert the record v
        String filesrec=dbQuery.setQueryFiles("select * from vfiles");
        v.fromString(filesrec);                // convert the record

        // update a dmt record and read it
        int index=r.m_dn_index;
        Timestamp newtime = new Timestamp(System.currentTimeMillis());
        dbQuery.setQueryUpdate("update dmt set id=\'door updated_id\' where dn_index="+index);
        dbQuery.setQueryUpdate("update dmt set total=201 where dn_index="+index);
        dbQuery.setQueryUpdate("update dmt set sent=202 where dn_index="+index);
        dbQuery.setQueryUpdate("update dmt set received=203 where dn_index="+index);
        dbQuery.setQueryUpdate("update dmt set warnings=204 where dn_index="+index);
        dbQuery.setQueryUpdate("update dmt set errors=205 where dn_index="+index);
        dbQuery.setQueryUpdate("update dmt set resent=206 where dn_index="+index);
        dbQuery.setQueryUpdate("update dmt set deleted=207 where dn_index="+index);
        dbQuery.setQueryUpdate("update dmt set report=\'door updated report\' where dn_index="+index);
        dbQuery.setQueryUpdate("update dmt set status=true where dn_index="+index);
        String update_res=dbQuery.setQueryUpdate("update dmt set start_time=to_timestamp('"+newtime+"') where dn_index="+index);
        // how to check results
        if ( update_res==null ) System.out.println("Error: the record "+ index+" does"+
                                                " not exists or the query is not supported");
        System.out.println("Update results:\n"+dbQuery.setQueryDmt("select * from dmt where dn_index="+index));

        // update a vfiles record and read it
        index=v.m_dn_index;
        dbQuery.setQueryUpdate("update vfiles set id=\'door updated_id\' where dn_index="+index);
        dbQuery.setQueryUpdate("update vfiles set name=\'C:\\work\\openoffice.exe\' where dn_index="+index);
        dbQuery.setQueryUpdate("update vfiles set number=301 where dn_index="+index);
        System.out.println("Update results:\n"+dbQuery.setQueryFiles("select * from vfiles where dn_index="+index));

        // make query that cannot be correct
        String wrong=dbQuery.setQueryUpdate("update dmt set total=201 where dn_index="+index+100);
        if ( wrong==null ) System.out.println("Wrong query test passed");
        else System.out.println("Wrong query test does not passed, res="+wrong);

        // make query using a transaction id
        String transaction_id="door updated_id";
        int file_nr=301;
        String file_name=dbQuery.getFileName(transaction_id, file_nr);
        System.out.println("Requested file name : "+ file_name);

        String dmtres=dbQuery.getDmtRecord(transaction_id);
        System.out.println("Requested Dmt Record : "+ dmtres);


        // delete a dmt record
        index=r.m_dn_index;
        String delete_res=dbQuery.setQueryDelete("dmt where dmt.dn_index="+index);
        if ( delete_res==null ) System.out.println("The query has no results");
        else System.out.println("Number of deleted records = "+delete_res);

        // delete a vfiles record
        index=v.m_dn_index;
        delete_res=dbQuery.setQueryDelete("vfiles where vfiles.dn_index="+index);
        if ( delete_res==null ) System.out.println("The query has no results");
        else System.out.println("Number of deleted records = "+delete_res);

    }
}

