package dbridge;

/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author unascribed
 * @version 1.0
 */

/*
 * Modified 22.06.06
 */

import java.util.*;

// generate and recognize disposition-notification report messages
// a report message is in a special format:
// message-type : message text
// NOTE: use getMessageText method before recognition
public class dbReportCode
{
    /**
     * Default constructor
     */
    public dbReportCode(){
    }

    /**
     * print free textfields
     * @params code, message number, text body
     * @return text code
     */
    public static String printText(String type,String txt){
            return new String(type+" : "+TEXT+" "+txt);
    }
    public static String printMailText(String type,String txt){
            return new String(type+" : "+MAIL_TEXT+" "+txt);
    }
    public static String printGpgText(String type,String txt){
            return new String(type+" : "+GPG_TEXT+" "+txt);
    }
    public static String printAppText(String type,String txt){
            return new String(type+" : "+APP_TEXT+" "+txt);
    }
    public static String print(String type,String code){
            return new String(type+" : "+code);
    }


    // recognise text codes (after theis extraction from a report)
    public static  boolean isText(String str){
       return str.startsWith("0.");
    }

    // Mail
    public static boolean isMailCode(String str){
       return str.startsWith("1.");
    }
    public static boolean isMailText(String str){
       return str.startsWith("1.0.");
    }
    public static  boolean isMailReceiptFailed(String str){
       return str.startsWith("1.1.");
    }
    public static boolean isMailCorruptSyinax(String str){
       return str.startsWith("1.2.");
    }
    public static boolean isMailCorruptAttachment(String str){
       return str.startsWith("1.3.");
    }
    public static boolean isMailCorruptMime(String str){
       return str.startsWith("1.4.");
    }
    public static boolean isMailWrongMime(String str){
       return str.startsWith("1.5.");
    }
    public static boolean isMailNoSign(String str){
       return str.startsWith("1.6.");
    }
    public static boolean isMailNoEncryption(String str){
       return str.startsWith("1.7.");
    }

    // GPG
    public static boolean isGpgCode(String str){
       return str.startsWith("2.");
    }
    public static boolean isGpgText(String str){
       return str.startsWith("2.0.");
    }
    public static boolean isGpgNoPubKey(String str){
       return str.startsWith("2.1.");
    }
    public static boolean isGpgKeyExp(String str){
       return str.startsWith("2.2.");
    }
    // subcode
    public static boolean isGpgSignExp(String str){
       return str.startsWith("2.2.1");
    }
    public static boolean isGpgEncyptKeyExp(String str){
       return str.startsWith("2.2.2");
    }
    // end subcode
    public static boolean isGpgUntrustSign(String str){
       return str.startsWith("2.3.");
    }
    public static boolean isGpgCorruptSign(String str){
       return str.startsWith("2.4.");
    }
    public static boolean isGpgCorruptEncypt(String str){
       return str.startsWith("2.5.");
    }

    // Application
    public static boolean isAppCode(String str){
       return str.startsWith("3.");
    }
    public static boolean isAppUnknownMime(String str){
       return str.startsWith("3.1.");
    }
    public static boolean isAppInternalError(String str){
       return str.startsWith("3.2.");
    }

    // extract text message
    public static String getTextMessage(String message){
      String res="";
      StringTokenizer token=new StringTokenizer(message,": ");
      String var = new String(token.nextToken() );
      int item=0;
      System.out.println("Token "+item+"  "+var);
      while ( var!=null ){
       if ( item == 0 ){
         if ( var.compareTo(WARNING)!=0 &&
              var.compareTo(FAILURE)!=0 &&
              var.compareTo(ERROR)!=0 ) return null;
       } else {
         res+=var;
       }

       if (token.hasMoreTokens()) {
           var = new String(token.nextToken());
           res+=" ";
       } else {
           var = null;
       }
       item++;
     }// end while
     if ( item<2 ) return null;
     return res;
    }

    // Type
    public static boolean isWarning(String str){
       return str.startsWith(WARNING);
    }
    public static boolean isFailure(String str){
       return str.startsWith(FAILURE);
    }
    public static boolean isError(String str){
       return str.startsWith(ERROR);
    }

    // constants
    public final static String TEXT                  ="0.0";         // any text

    public final static String MAIL_TEXT             ="1.0.0";  // any mail text
    public final static String MAIL_RECEIPT_FAILED   ="1.1.0 receipt failed";
    public final static String MAIL_CORRUPT_SYNTAX   ="1.2.0 corrupt mail syntax";
    public final static String MAIL_CORRUPT_ATTACHMET="1.3.0 corrupt attachment";
    public final static String MAIL_CORRUPT_MIMETYPE ="1.4.0 corrupt mimetype";
    public final static String MAIL_WRONG_MIME       ="1.5.0 mimetype not supported";
    public final static String MAIL_NO_SIGNATURE     ="1.6.0 no signature";
    public final static String MAIL_NO_ENCRYPTION    ="1.7.0 no encryption";

    public final static String GPG_TEXT                 ="2.0";
    public final static String GPG_NO_PUB_KEY           ="2.1.0 no public key avalable";
    public final static String GPG_KEY_EXPIRIED         ="2.2.0 key expired";
    public final static String GPG_SIGNING_KEY_EXPIRIED ="2.2.1 signing key expired"; // sender
    public final static String GPG_ENCRYPT_KEY_EXPIRIED ="2.2.2 Encryption key expired"; // receiver
    public final static String GPG_UNTRUSTED_PUB_KEY    ="2.3.0 valid signature from untrusted public key";
    public final static String GPG_CORRUPT_SIGN         ="2.4.0 corrupt signature";
    public final static String GPG_CORRUPT_ENCRYPTION   ="2.5.0 corrupt encryption";

    public final static String APP_TEXT              ="3.0.0";
    public final static String APP_UNKNOWN_MIME      ="3.1.0 unknown mimetype not processed";
    public final static String APP_INTERNAL_ERROR    ="3.2.0 internal error";

    public final static String WARNING = "Warning";
    public final static String FAILURE = "Failure";
    public final static String ERROR = "Error";

    public static void main(String[] args){
        //dbReportCode obj=new dbReportCode();
        System.out.println("Code :"+dbReportCode.TEXT);

        // generate a report message
        String report=dbReportCode.print(dbReportCode.WARNING, dbReportCode.GPG_SIGNING_KEY_EXPIRIED);
        System.out.println("Report :"+report);

        // recognize the message
        String message=dbReportCode.getTextMessage(report);
        System.out.println("Message :"+message);
        if ( dbReportCode.isAppCode(message) ) System.out.println("App Code");

        if ( dbReportCode.isGpgCode(message) ){
          System.out.println("GPG Code");
          if (dbReportCode.isGpgKeyExp(message) ) {
            System.out.println("Key Expired Code");
            if ( dbReportCode.isGpgSignExp(message) ) System.out.println("Sign Key Expired Code");
            if ( dbReportCode.isGpgEncyptKeyExp(message) ) System.out.println("Encryption Key Expired Code");
          }
        }

        if ( dbReportCode.isMailCode(message) ) System.out.println("Mail Code");

        if ( dbReportCode.isText(message) ) System.out.println("Text Code");

    }
}
