package dbridge;

/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author unknown
 * @version 1.0
 */

/*
 * Created 21.09.2003
 * Modified 04.12.2004 BOB: deleteEllement (directly delete the object)
 */

import java.util.*;
import java.io.*;


public class dbSmtpTable implements java.io.Serializable {
  Vector v;
  int mDefaultN;

  public dbSmtpTable() {
    v= new Vector();
    mDefaultN=-1;
  }

  public dbSmtpTable(dbSmtpTable other){
    mDefaultN = other.getDefaultN();
    v = new Vector(other.getVector());
  }

  public Vector getVector(){
    return v;
  }

  public dbSmtpTable(dbSmtpTable obj, int n) {
    Init(obj,n);
  }

  private void Init(dbSmtpTable obj, int n){
    v= new Vector();
    mDefaultN=n;
  }

  public void append(dbSmtpRecord obj) { // add an item to the end
    v.add(obj);
    if ( v.size()==1 )   mDefaultN=0;
  }

  public void setElementAt(dbSmtpRecord obj, int pos){
    v.setElementAt(obj, pos);
    if ( v.size()==1 )   mDefaultN=0;
    else if ( mDefaultN >= pos ) mDefaultN++;
  }

  public void delete(int key) { // remove the key-th item
    if ( isIndex(key) ){
      v.removeElementAt(key); //.removeElementAt(new Integer(key));
      if ( mDefaultN>key) mDefaultN--;
      else
          if ( mDefaultN==key) {
              if ( mDefaultN==0 && v.size()==1 ) mDefaultN=-1;
              else mDefaultN=0;
          }
      }
  }
  public void deleteLast() { // remove the last item
    if ( v.size()>0 ){
       if ( v.size()==1 ) mDefaultN=-1;
       else if ( mDefaultN==v.size() ) mDefaultN=0;
       v.removeElementAt(v.size()-1);
    }
  }

  public void deleteEllement(dbSmtpRecord obj){
    v.remove(obj);
  }


  public int getSize(){ return v.size();}

  public dbSmtpRecord getRecord(int key){
    if ( isIndex(key) ) return (dbSmtpRecord)v.get(key);
    else return null;
  }

  public Vector getList(){  // return a list of all IP  or null
    Vector list=new Vector();
    for (int i=0; i<v.size(); i++){
      list.add(((dbSmtpRecord)v.get(i)).getIP());
    }
     return list;
  }

/*  public boolean isExists( int index ){
    boolean res=false;
    int i=0;
    while ( i<v.size() ){
      if ( ((dbSmtpRecord)v.get(i)).getIP() );
    }
     return list;
  }
*/
  public boolean isIndex(int i){
    if ( i>=0 && i<v.size() ) return true;
    else return false;
  }

  public int getIndex(String oIP){
    int r=-1; //no such server
    int i=0;
    while(i<v.size())
    {
      dbSmtpRecord t_rec = (dbSmtpRecord)v.elementAt(i);
      if (oIP.compareTo(t_rec.getIP())==0){
        r = i; i=v.size();
      }else i++;
    }
    return r;
  }

  public void setDefaultN(int n){ mDefaultN=n;}
  public int getDefaultN(){return mDefaultN;}

  public dbSmtpRecord getDefaultRecord(){
    return (dbSmtpRecord)v.get(mDefaultN);
  }
  // DEBUG
  public void print() {
    System.out.println("Table size " + v.size());
    for ( int i=0; i<v.size(); i++ ){
      if ( i==mDefaultN ) System.out.println("############ Default record " + i +" ###########");
      else System.out.println("############ record " + i +" ###########");
      dbSmtpRecord obj=(dbSmtpRecord)v.get(i);
      if ( obj!=null ) obj.print();
    }
  }// end print


  public static void main(String[] args) {
    System.out.println("Test table");
    dbSmtpTable obj = new dbSmtpTable();
    obj.append(new dbSmtpRecord("aaa@de","first","passwd1",""));
    obj.append(new dbSmtpRecord("aab@de","","passwd2","comments2"));
    obj.append(new dbSmtpRecord("aba@de","third","passwd3","comments3"));
    obj.append(new dbSmtpRecord("abb@de","fourth","passwd4","comments4"));
    obj.append(new dbSmtpRecord("baa@de","fives","passwd5","comments5"));
    obj.setDefaultN(3);
    obj.print();
    System.out.println("You see the list of 5 records, record 4th is default");
    obj.delete(3);
    obj.deleteLast();
    obj.print();
    System.out.println("You see the list of 3 records, record 1th is default");
    obj.delete(0);
    // save in file
    try {
       FileOutputStream file = new FileOutputStream("smtptable.db");
       ObjectOutputStream oFile=new ObjectOutputStream(file);

          oFile.writeObject(obj);
          oFile.flush();
      oFile.close();
    }
    catch(Exception e){System.err.println(e);}
    //resd object
    try {
       FileInputStream file = new FileInputStream("smtptable.db");
       ObjectInputStream iFile=new ObjectInputStream(file);
       System.out.println("You will see the list of 2 records, record 1th is default");
        System.out.println("Data from file #########################");
          try{
            dbSmtpTable obj2=(dbSmtpTable)iFile.readObject();
            obj2.print();
          } catch(IOException ioe){
            iFile.close();
            System.out.println("End of file reached #########################");
          }// end catch
    } catch(Exception e){System.err.println(e);}
  }

}
