package dbridge;

import java.io.*;
import java.util.Vector;

/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author unknown
 * @version 1.0
 *
 *
 * This class is a user information record
 * It is used by UserContainer
 */

/*
* Created:
* Modified 29.12.2003
* Modified 14.01.04
* Modified 25.01.04
* Modified  5.03.04
* Modified  16.08.04
* Modified 15.12.04 BOB add Cloneable
*/

/**
 * Key Passwd-keyID storage
 */

class KeyPasswd implements Cloneable, Serializable{
	
	public KeyPasswd(String keyid, char[] passwd){
		set_keyID(keyid);
		set_passwd(passwd);
	}
	
	public KeyPasswd(KeyPasswd other){
		this.copy(other);
	}
	
	public void copy(KeyPasswd other){
		m_keyID= new String(other.m_keyID);
		m_passwd=(char []) other.m_passwd.clone();
	}
	
	protected Object clone() throws CloneNotSupportedException {
		return new KeyPasswd(this);
	}
	public String toString() {
		return m_keyID;
	}
	public String get_keyID() {
		return m_keyID;
	}
	public void set_keyID(String keyid) {
		m_keyID = keyid;
	}
	public char[] get_passwd() {
		return m_passwd;
	}
	public void set_passwd(char[] passwd) {
		this.m_passwd = passwd;
	}
	
	  /**
	   * Check if keyID matches with ours
	   * @param keyID
	   * @return
	   */
	  public boolean checkKeyID(String keyID){
		  boolean result = false;
		  if ((this.get_keyID().compareTo(keyID)==0) && 
				  (keyID.compareTo("bad_id")!=0)) result=true;
		  return result;
	  }
	
	private String m_keyID;
	private char[] m_passwd;
}

class DPermanentBase implements java.io.Serializable{
	
  String mName;                 // User description for a manual user, and Login name of a user
                                // whos smtp accout is used (for automatic user).
  String mLogin;
  String mPasswd;
  int mID;                      // 0 - admin; 100 - 999 user (manual); >999 user (automatic)
  int mKeyId;                   // 0 - no crypt, 1 - full, 2 - partial (no decrypt), 3 - partial (no encrypt)
  int mPort;                    // reserved
  String mKeyN;                 // key nomber in the key ring
  String mAETitle;              // reserved
  String mSmtp;                 // reserved
  dbSmtpTable mSmtpTable;       // SMTP server's vector
  int mSmtpDefaultN;            // Default SMTP server number (from the vector)
  dsDcmServerClass mDefDCMSrv;  // Default DCM server (currently only for auto-user)
  dbMailTable mMailTable;       // table of the user POP/IMAP servers
  dbMailTable mAddressBook;     // table of friends e-mail servers
  String mLoc_Dir;              // store files from DCM servers
  String mExt_Dir;              // store files from POP3/IMAP servers
  String mDecrypted_Dir;        // put here all decrypted files
  String mWait_Dir;             // put here files that can't be decrypted
  String mArchive_Dir;          // put here files from decrypted dir, which were processed by an application
  String field1;                // reserved
  String field2;                // reserved
  String field3;                // reserved
  Vector mKeyFields;
  boolean mAutoDCMSend_flag;    //
  boolean mAutoNotify_flag;    //
  boolean mLeaveFileFlag = false;               // true - messages are sent and
                                                // are not delited from a harddisk
  //30.12.2004
  String mMailDir;              // store a dir of last selected e-mails (send to SMTP Server)
  String mDcmDir;               // store a dir of last selected DICOM files (send to DCM Server)
};

public class dbUser implements Cloneable{//implements java.io.Serializable {
// public fields

  DPermanentBase db=new DPermanentBase();

  public dbUser() {
    db.mName="";
    db.mLogin="";
    db.mPasswd="";
    
    db.mKeyFields = new Vector();
    
    db.mAutoDCMSend_flag=false;
    db.mAutoNotify_flag=false;
    db.mID=100;
    db.mKeyId=0;
    db.mPort=8000;
    db.mKeyN="";
    db.mAETitle="";
    db.mSmtp="";
    db.mSmtpDefaultN=1;
    db.mSmtpTable=new dbSmtpTable();
    db.mMailTable=new dbMailTable();
    db.mAddressBook=new dbMailTable();
    db.mDefDCMSrv = new dsDcmServerClass();
    db.mLoc_Dir = "";
    db.mExt_Dir = "";
    db.mDecrypted_Dir = "";
    db.mWait_Dir = "";
    db.mArchive_Dir = "";
    db.mLeaveFileFlag = false;
    db.mMailDir="";
    db.mDcmDir="";
  }
  public dbUser(String name, String login, String pass, String smtp) {
    db.mName=name;
    db.mLogin=login;
    db.mPasswd=pass;
    
    db.mKeyFields = new Vector();
    
    db.mAutoDCMSend_flag=false;
    db.mAutoNotify_flag=false;
    db.mID = 100;
    db.mKeyId=0;
    db.mPort=8000;
    db.mKeyN="none";
    db.mAETitle="Unknown_AE";
    db.mSmtp=smtp;
    db.mSmtpDefaultN=1;
    db.mSmtpTable=new dbSmtpTable();
    db.mMailTable=new dbMailTable();
    db.mAddressBook=new dbMailTable();
    db.mLoc_Dir = "";
    db.mExt_Dir = "";
    db.mDecrypted_Dir = "";
    db.mWait_Dir = "";
    db.mArchive_Dir = "";
    db.mLeaveFileFlag = false;
    db.mMailDir="";
    db.mDcmDir="";
  }

  public dbUser(String name, String login, String pass, int ID, String smtp) {
    db.mName=name;
    db.mLogin=login;
    db.mPasswd=pass;
    
    db.mKeyFields = new Vector();
    
    db.mAutoDCMSend_flag=false;
    db.mAutoNotify_flag=false;
    db.mID = ID;
    db.mKeyId=0;
    db.mPort=8000;
    db.mKeyN="none";
    db.mAETitle="Unknown_AE";
    db.mSmtp=smtp;
    db.mSmtpDefaultN=1;
    db.mSmtpTable=new dbSmtpTable();
    db.mMailTable=new dbMailTable();
    db.mAddressBook=new dbMailTable();
    db.mLoc_Dir = "";
    db.mExt_Dir = "";
    db.mDecrypted_Dir = "";
    db.mWait_Dir = "";
    db.mArchive_Dir = "";
    db.mLeaveFileFlag = false;
    db.mMailDir="";
    db.mDcmDir="";
  }

  public dbUser(String name, String login, String pass, int ID, String smtp, dsDcmServerClass DCMSrv) {
    db.mName=name;
    db.mLogin=login;
    db.mPasswd=pass;
    db.mID = ID;
    db.mKeyId=0;
    db.mPort=8000;
    db.mKeyN="none";
    db.mAETitle="Unknown_AE";
    db.mSmtp=smtp;                     // vector of smtp servers
    db.mSmtpDefaultN=1;
    db.mSmtpTable=new dbSmtpTable();
    db.mMailTable=new dbMailTable();
    db.mAddressBook=new dbMailTable();
    db.mLoc_Dir = "";
    db.mExt_Dir = "";
    db.mDecrypted_Dir = "";
    db.mWait_Dir = "";
    db.mArchive_Dir = "";
    db.mDefDCMSrv = DCMSrv;
    db.mLeaveFileFlag = false;
    db.mMailDir="";
    db.mDcmDir="";
    
    db.mKeyFields = new Vector();
  }

  // copy constructor
  public dbUser(dbUser obj) {
    this.copy(obj);
  }

  public Object clone(){
    return new dbUser(this);
  }

  public void copy(dbUser obj){
    db.mName=obj.getName();
    db.mLogin=obj.getLogin();
    db.mPasswd=obj.getPassword();
    
    db.mKeyFields = (Vector) obj.getGpgKeys().clone();
    
    db.mAutoDCMSend_flag = obj.getAutoDCMSendFlag();
    db.mAutoNotify_flag = obj.getAutoNotifyFlag();
    db.mID = obj.getID();
    db.mKeyId=obj.getKeyId();
    db.mKeyN=obj.getKeyN();
    db.mSmtpDefaultN=1;
    db.mSmtpTable=new dbSmtpTable( obj.getSmtpTable() );
    db.mMailTable=new dbMailTable( obj.getMailTable() );
    db.mAddressBook=new dbMailTable( obj.getAddressBook() );
    db.mLoc_Dir = obj.getLocDirPath();
    db.mExt_Dir = obj.getExtDirPath();
    db.mDecrypted_Dir = obj.getDecryptedDirPath();
    db.mWait_Dir = obj.getWaitDirPath();
    db.mArchive_Dir = obj.getArchiveDirPath();
    db.mDefDCMSrv = new dsDcmServerClass( obj.getDefDCMsrv() );
    db.mLeaveFileFlag = obj.getLeaveFileFlag();
    db.mMailDir=obj.getMailDirPath();
    db.mDcmDir=obj.getDcmDirPath();
  }

   public dbUser(DPermanentBase base){
     db=base;  // copy
   }

  // set/get methods
  public void setName(String name){db.mName=name;}
  public String getName(){return db.mName;}
  public void setLogin(String log){db.mLogin=log;}
  public String getLogin(){return db.mLogin;}
  public void setPassword(String pass){db.mPasswd=pass;}
  public String getPassword(){return db.mPasswd;}
  public void setID(int ID){db.mID=ID;}
  public int getID(){return db.mID;}
  public void setSmtp(String smtp){db.mSmtp=smtp;}
  public String getSmtp(){return db.mSmtp;}
  public void setSmtpTable(dbSmtpTable mt){db.mSmtpTable=mt;}
  public dbSmtpTable getSmtpTable(){return db.mSmtpTable;}
  public void setMailTable(dbMailTable mt){db.mMailTable=mt;}
  public dbMailTable getMailTable(){return db.mMailTable;}
  public void setAddressBook(dbMailTable ab){db.mAddressBook=ab;}
  public dbMailTable getAddressBook(){return db.mAddressBook;}
  public String getLocDirPath(){return db.mLoc_Dir;}
  public String getExtDirPath(){return db.mExt_Dir;}
  public String getDecryptedDirPath(){return db.mDecrypted_Dir;}
  public String getWaitDirPath(){return db.mWait_Dir;}
  public String getArchiveDirPath(){return db.mArchive_Dir;}
  public void setDefDCMsrv(dsDcmServerClass DCMSrv){db.mDefDCMSrv = DCMSrv;}
  public dsDcmServerClass getDefDCMsrv(){return db.mDefDCMSrv;}
  public void setKeyId(int id){ db.mKeyId=id;}
  public int getKeyId(){ return db.mKeyId;}
  public void setLeaveFileFlag(boolean flag){ db.mLeaveFileFlag=flag;}
  public boolean getLeaveFileFlag(){ return db.mLeaveFileFlag;}
  public void setAutoDCMSendFlag(boolean flag){ db.mAutoDCMSend_flag=flag;}
  public boolean getAutoDCMSendFlag(){ return db.mAutoDCMSend_flag;}
  public void setAutoNotifyFlag(boolean flag){ db.mAutoNotify_flag=flag;}
  public boolean getAutoNotifyFlag(){ return db.mAutoNotify_flag;}
  public void setMailDirPath(String str){ db.mMailDir=str;}
  public String getMailDirPath(){ return db.mMailDir;}
  public void setDcmDirPath(String str){ db.mDcmDir=str;}
  public String getDcmDirPath(){ return db.mDcmDir;}

  public String toString() {return db.mLogin;}

  public void setSmtpDefaultN(int n){
              //
              db.mSmtpTable.setDefaultN(n);
  }
  public int getSmtpDefaultN(){return db.mSmtpTable.getDefaultN();}
  public void setKeyN(String n){ db.mKeyN=n;}
  public String getKeyN(){ return db.mKeyN;}
  public DPermanentBase getPermanentBase(){ return db;}
  public void setPermanentBase(DPermanentBase base){ db=base;}
  
  // methods
  public void appendToSmtpTable(dbSmtpRecord ab){db.mSmtpTable.append(ab);}
  public void appendToTable(dbMailRecord ab){db.mMailTable.append(ab);}
  public void appendToAddressBook(dbMailRecord ab){db.mAddressBook.append(ab);}
  public void deleteFromSmtpTable(int i){ db.mSmtpTable.delete(i);}
  public void deleteFromMailTable(int i){ db.mMailTable.delete(i);}
  public void deleteFromAddressBook(int i){ db.mAddressBook.delete(i);}
  
  /**
   * set the Password for the default Key
   * @deprecated Use setDecryptPwd(int index, String pwd) instead
   * @param pwd
   */
  public void setDecryptPwd(String pwd){ 
	  	if (db.mKeyFields.size()>0){
	  		db.mKeyFields.set(0, pwd.toCharArray());
	  	}
	  }
  
  /**
   * get the Password for the default Key
   * @deprecated Use getDecryptPwd(int index) instead
   * @return password
   */
  public String getDecryptPwd() {
		String res = null;
		if (db.mKeyFields.size() > 0) {
			res = new String(((KeyPasswd) db.mKeyFields.get(0)).get_passwd());
			//System.out.println("getDecryptPwd() = " + res);
		}
		return res;
	}
  
  
 
  /**
   * set the Password for index Key
   * @param index
   * @param pwd
   */
  public void setDecryptPwd(int index, String pwd) {
	  KeyPasswd key_info = (KeyPasswd) db.mKeyFields.get(index);
	  if (key_info != null){
		  key_info.set_passwd(pwd.toCharArray());
		  //System.out.println("input passwd = " + key_info);
	  }
	}
  
  /**
   * set the Password for the key, specified by keyID string 
   * @param keyID
   * @param pwd
   */
  public void setDecryptPwd(String keyID, String pwd){
	  this.setDecryptPwd(this.getGpgKeyIndex(keyID), pwd);
  }
  
 
  /**
   * get the Password for the index Key
   * @param index
   * @return password
   */
  public String getDecryptPwd(int index){
	  String res = null;
		if (index >= 0) {
			KeyPasswd key_info = (KeyPasswd) db.mKeyFields.get(index);
			if (key_info != null) {
				res = new String(key_info.get_passwd());
			}
		}
		return res;
  }
  
  /**
   * get the Password for the key, specified by keyID string
   * @param keyID
   * @return password
   */
  public String getDecryptPwd(String keyID){
	  
	  return getDecryptPwd(this.getGpgKeyIndex(keyID));
	  
  }
  
  /**
   * get the index for mGpgKeys vector by keyID string
   * @param keyID
   * @return index
   */
  private int getGpgKeyIndex(String keyID){
	  int index = -1;
	  int i=0;
	  boolean found = false;
	  while(!found && i<db.mKeyFields.size()){
		  KeyPasswd key_info = (KeyPasswd) db.mKeyFields.get(i);
		  if (key_info.checkKeyID(keyID)){
			  index = i;
			  found = true;
		  }
		  i++;
	  }
	  return index;
  }
  
  
  /**
   * get the Vector of Gpg Keys
   * This methid should be used as a main method to set 
   * all the key parameters (like password etc.) 
   * @return GpgKeys vector
   */
  public Vector getGpgKeys(){return db.mKeyFields;}



  public boolean isAdmin(){
     if ( db.mID == 0 ) return true;
     else return false;
  }
  public boolean isAutomatic(){
    if ( db.mID>=1000 ) return true;
    else return false;
  }
  public boolean isManual(){
    if ( db.mID>0 && db.mID <1000 ) return true;
    else return false;
  }

  // user home dir manager ( creation )
  public void createDir(String root){
     // create the user home dir
     String home = root +db.mLogin;  // note: home is ended by "/"
     File dir=new File( home );
     if (!dir.exists()){ dir.mkdir();}

     // create user_Loc
     db.mLoc_Dir = home + File.separator + DBConsts.LOC_DIR;
     dir=new File( db.mLoc_Dir );
     if (!dir.exists()){ dir.mkdir();}
     // create user_Ext
     db.mExt_Dir= home + File.separator + DBConsts.EXT_DIR;
     dir=new File( db.mExt_Dir );
     if (!dir.exists()){ dir.mkdir();}
     // create user_Decypted
     db.mDecrypted_Dir= home + File.separator + DBConsts.DECRYPTED_DIR;
     dir=new File( db.mDecrypted_Dir );
     if (!dir.exists()){ dir.mkdir();}
     // create user_Wait
     db.mWait_Dir= home + File.separator + DBConsts.WAIT_DIR;
     dir=new File( db.mWait_Dir );
     if (!dir.exists()){ dir.mkdir();}
     // create user_Archive
     db.mArchive_Dir= home + File.separator + DBConsts.ARCHIVE_DIR;
     dir=new File( db.mArchive_Dir );
     if (!dir.exists()){ dir.mkdir();}
  }

  public void print(){
    System.out.println(db.mName);
    System.out.println(db.mLogin);
    System.out.println("********");
    System.out.println(db.mKeyId);
    System.out.println(db.mPort);
    System.out.println(db.mAETitle);
    System.out.println(db.mSmtp);
    db.mSmtpTable.print();
    db.mMailTable.print();
    db.mAddressBook.print();
  }
  public static void main(String[] args) {
    dbUser dbUser1 = new dbUser();
    dbUser1.db.mSmtpTable.append(new dbSmtpRecord("smtp1@de","user0","passwd1","user "));
    dbUser1.db.mSmtpTable.append(new dbSmtpRecord("smtp2@de","user1","passwd1","another user"));
    dbUser1.db.mMailTable.append(new dbMailRecord("aa1@de","first","passwd1",1));
    dbUser1.db.mMailTable.append(new dbMailRecord("aa2@de","first","passwd1",1));
    dbUser1.db.mAddressBook.append(new dbMailRecord("bb1@de","first","passwd1",1));
    dbUser1.db.mAddressBook.append(new dbMailRecord("bb2@de","first","passwd1",1));
    dbUser1.print();
    System.out.println("UserName " + dbUser1.getName());
  }
}
