package dbridge;

/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author unascribed
 * @version 1.0
 */

/*
 * Modified 10.02.06
 */


import java.sql.*;
import java.util.*;

public class dmtRecord
{
    /**
     * Default constructor
     */
    public dmtRecord(){
        Init();
    }

    public dmtRecord(String rec){
        Init(rec);
    }

    /**
     * print fields
     * @params a result set
     * @throws SQLExeption
     */
    public void print() throws SQLException {
            System.out.println("i: "+m_dn_index +
            "\n id s: "+m_id +
            "\n total i: "+m_total +
            "\n sent i: "+m_sent +
            "\n received i: "+m_received +
            "\n warnings i: "+m_warnings +
            "\n errors i: "+m_errors +
            "\n resent i: "+m_resent +
            "\n deleted i: "+m_deleted +
            "\n report s: "+m_report +
            "\n status b: "+m_status +
            "\n start_time t: "+m_start_time +
            "\n end_time t: "+m_end_time+
            "\n name s: "+m_name +
            "\n memo1 s: "+m_memo1 +
            "\n memo2 s: "+m_memo2);
        System.out.println();
    }
    /**
     * Convert the record to a string
     * @return String
     */
    public String toString(){
      String status="1";
      if ( !m_status ) status="0";
      String res= (new Integer(m_dn_index)).toString();
            res+="\n" + m_id;
            res+="\n" + (new Integer(m_total)).toString();
            res+="\n" + (new Integer(m_sent)).toString();
            res+="\n" + (new Integer(m_received)).toString();
            res+="\n" + (new Integer(m_warnings)).toString();
            res+="\n" + (new Integer(m_errors)).toString();
            res+="\n" + (new Integer(m_resent)).toString();
            res+="\n" + (new Integer(m_deleted)).toString();
            res+="\n" + m_report;
            res+="\n" + status;
            res+="\n" + m_start_time.toString(); // JDBC Format
            res+="\n" + m_end_time.toString();   // JDBC Format
            res+="\n" + m_name;
            res+="\n" + m_memo1;
            res+="\n" + m_memo2;

      return res;
    }
    /**
     * convert a record from a string
     * @param str String
     */
    public void fromString(String str){
      // to do
      StringTokenizer token=new StringTokenizer(str,"\n");
      String var = new String(token.nextToken() );
      int item=0;
      while ( var!=null ){
        switch (item) {
          case 0:
            m_dn_index = Integer.parseInt(var);
            break;
          case 1:
            m_id = var;
            break;
          case 2:
            m_total = Integer.parseInt(var);
            break;
          case 3:
            m_sent = Integer.parseInt(var);
            break;
          case 4:
            m_received = Integer.parseInt(var);
            break;
          case 5:
            m_warnings = Integer.parseInt(var);
            break;
          case 6:
            m_errors = Integer.parseInt(var);
            break;
          case 7:
            m_resent = Integer.parseInt(var);
            break;
          case 8:
            m_deleted = Integer.parseInt(var);
            break;
          case 9:
            m_report = var;
            break;
          case 10:
            if ( var.equals("1") ) m_status = true;
            else m_status = false;
            break;
          case 11:
            m_start_time = Timestamp.valueOf(var);
            break;
          case 12:
            m_end_time = Timestamp.valueOf(var);
            break;
          case 13:
            m_name = var;
            break;
          case 14:
            m_memo1 = var;
            break;
          case 15:
            m_memo2 = var;
            break;

        }
        if (token.hasMoreTokens()) {
            var = new String(token.nextToken());
        } else {
            var = null;
        }
        item++;
      }// end while
    }

    /**
     * Convert the record to a string
     * @return String
     */
    public String toReportString(){
      String status="Transaction is still opened";
      if ( !m_status ) status="Transaction has been closed";
      String res= "### Record Number : "+(new Integer(m_dn_index)).toString();
         res+="\nTransaction ID : " + m_id;
         res+="\nTotal file number : " + (new Integer(m_total)).toString();
         res+="\nFile number that have been sent : " + (new Integer(m_sent)).toString();
         res+="\nFile number that have been received : " + (new Integer(m_received)).toString();
         res+="\nNumber of warnings : " + (new Integer(m_warnings)).toString();
         res+="\nNumber of errors : " + (new Integer(m_errors)).toString();
         res+="\nNumber of file that have been resent :" + (new Integer(m_resent)).toString();
         res+="\nNumber of files that have been deleted :" + (new Integer(m_deleted)).toString();
         res+="\nReport : " + m_report;
         res+="\nStatus : " + status;
         res+="\nStart time : " + m_start_time.toString(); // JDBC Format
         res+="\nEnd time : " + m_end_time.toString();   // JDBC Format
         res+="\nName : " + m_name;
         res+="\nMemo1 : " + m_memo1;
         res+="\nMemo2 : " + m_memo2 + "\n";             // end
      return res;
    }


    public String m_name=new String();  // db name
    public String m_id=new String();    // Global Message ID
    public int m_dn_index;              // table index (key)
    public int m_total;                 // total file number
    public int m_sent;                  // number of files
    public int m_received;              // number of files
    public int m_warnings;              // number of files
    public int m_errors;                // number of files
    public int m_resent;                // number of files
    public int m_deleted;               // number of files
    public String m_report=new String();// see @GIT specification
    public boolean m_status;            // false - transaction completed
    public Timestamp m_start_time=new Timestamp(0); // transaction start
    public Timestamp m_end_time=new Timestamp(0);   // transaction end
    public String m_memo1=new String();  // memo1
    public String m_memo2=new String();  // memo2

    /**
     * Init method
     */
    private void Init(){
        m_id="null";
        m_dn_index=0;
        m_total=0;
        m_sent=0;
        m_received=0;
        m_warnings=0;
        m_errors=0;
        m_resent=0;
        m_deleted=0;
        m_report="null";
        m_status=true;
        m_start_time.setTime(0);
        m_end_time.setTime(0);
        m_name="null";
        m_memo1="null";
        m_memo2="null";
    }
    private void Init(String str){
        this.fromString(str);
    }

    public static void main(String[] args){
        dmtRecord rec1=new dmtRecord();
        System.out.println("Get the record as a string");
        rec1.m_start_time=new Timestamp(0);
        String copy=rec1.toString();
        System.out.println(copy);


        System.out.println("Create a new record using the string");
        dmtRecord rec2= new dmtRecord(copy);
        System.out.println(rec2.toString());
    }
}
