package dbridge;

import java.awt.event.*;
import java.awt.Frame;
import java.util.Vector;
import java.util.Locale;
import java.util.ResourceBundle;
import java.awt.FileDialog;
import javax.swing.JOptionPane;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */
class ChkThread
    extends Thread {
  private ResourceBundle lbls;
  private dbSmtpRecord mSmtpRec;
  private dbMailRecord mMailRec;
  private boolean mFinished = false;
  private boolean chkSMTP = false;
  private boolean chkPOP = false;

  ChkThread(dbSmtpRecord rec) {
    mSmtpRec = rec;
    chkSMTP = true;
    Locale currentLocale = BridgeApp.getCurrentLocale();
    lbls = ResourceBundle.getBundle(
        "dbridge.prop.dsServerCheckerDlgBundle",
        currentLocale);
  }

  ChkThread(dbMailRecord rec) {
    mMailRec = rec;
    chkPOP = true;
    Locale currentLocale = BridgeApp.getCurrentLocale();
    lbls = ResourceBundle.getBundle(
        "dbridge.prop.dsServerCheckerDlgBundle",
        currentLocale);
  }

  public boolean isFinished() {
    return mFinished;
  }

  public void run() {
    // show dialog
    dsServerCheckerDlg dlg = new dsServerCheckerDlg();
    dlg.setVisible(true);

    if (chkSMTP) {
      
    Sender snd=SenderFactory.newInstance();
  	snd.setTo("test@test.net");
  	snd.setFrom("test.test.org");
  	snd.setSubject("mail for test");
  	snd.setHost(mSmtpRec.getIP());
  	snd.setUserName(mSmtpRec.getLogin());
  	snd.setPassword(mSmtpRec.getPassword());
    snd.setPort(Integer.toString(mSmtpRec.getPort()));
  	snd.setSSL(mSmtpRec.isSSL());
      boolean res = snd.check();
      // hide dialog
      dlg.setVisible(false);

      if (res) {
        JOptionPane.showMessageDialog(null, lbls.getString("smtp_ok"),
                                      lbls.getString("info"),
                                      JOptionPane.INFORMATION_MESSAGE);
      }
      else {
        JOptionPane.showMessageDialog(null,
                                      lbls.getString("smtp_failed"),
                                      lbls.getString("error"),
                                      JOptionPane.ERROR_MESSAGE);
      }
    }

    if (chkPOP) {
      Receiver receiver = new Receiver(mMailRec);
      boolean res = receiver.check();
      // hide dialog
      dlg.setVisible(false);

      if (res) {
        JOptionPane.showMessageDialog(null, lbls.getString("pop_ok"),
                                      lbls.getString("info"),
                                      JOptionPane.INFORMATION_MESSAGE);
      }
      else {
        JOptionPane.showMessageDialog(null, lbls.getString("pop_failed"),
                                      lbls.getString("error"),
                                      JOptionPane.ERROR_MESSAGE);
      }

    }

    mFinished = true;

  }
}

class dsServersChecker {

  static public void CheckSMTP(dbSmtpRecord rec) {
    ChkThread thread = new ChkThread(rec);
    thread.start();
  }

  static public void CheckPOP_IMAP(dbMailRecord rec) {
    ChkThread thread = new ChkThread(rec);
    thread.start();
  }
}

//TODO: Problem with linked users ...
//
//
class dsSMTPPanelActionListener
    implements ActionListener {

  private dsSMTPPanel mSmtpPanel = null;

  public dsSMTPPanelActionListener(dsSMTPPanel obj) {
    mSmtpPanel = obj;
  }

  public void actionPerformed(ActionEvent e) {
    String CMD = e.getActionCommand();
    //
    // ADD SMTP command
    //
    if (CMD.equals(dsSMTPPanel.ADD_COMMAND)) {

      //Create and show SMTP dialog
      dsSmtpRecordDlg dlg = new dsSmtpRecordDlg( (Frame)null, true);
      dlg.setVisible(true);

      //if dialog succedes
      if (dlg.isOk()) {
        dbSmtpRecord rec = new dbSmtpRecord("", "", "", "");
        rec = dlg.getFields();
        mSmtpPanel.getUser().getSmtpTable().append(rec);
        mSmtpPanel.Update();
        mSmtpPanel.getUserController().getChangesTracker().UsersChanged = true;
      }
    }
    //
    // EDIT SMTP command
    //
    if (CMD.equals(dsSMTPPanel.EDIT_COMMAND)) {
      //get selected record
      //if nothing was selected just exit, the message was already generated

      Object obj = mSmtpPanel.getSelectedObj();
      if (obj == null) {
        return;
      }

      dbSmtpRecord rec = (dbSmtpRecord) obj;

      //
      // 1. Define the selected index
      //
      dbUser user = mSmtpPanel.getUser();
      int ind = user.getSmtpTable().getIndex(rec.getIP());

      //
      // 2. Find links
      //
      Vector linked_users = mSmtpPanel.getUserController().
          getUserContainer().
          getLinkedSmtpServers(user.getLogin(), ind);
      if (linked_users.size() > 0) {
        // OOO to do: select dialog
        Locale currentLocale = BridgeApp.getCurrentLocale();
        ResourceBundle lbls = ResourceBundle.getBundle(
            "dbridge.prop.dsActionListeners",
            currentLocale);

        JOptionPane.showMessageDialog(null,
                                      lbls.getString("serverIsUsed") + " " +
                                      (String) linked_users.get(0) +
                                      lbls.getString("ifPress"),
                                      lbls.getString("Error"),
                                      JOptionPane.ERROR_MESSAGE);
      }

      //Create SMTP dlg and fill it with the record data
      dsSmtpRecordDlg dlg = new dsSmtpRecordDlg( (Frame)null, true);
      dlg.setFields(rec);
      dlg.setVisible(true);

      if (dlg.isOk()) {
//         rec = dlg.getFields();


        //Implement linked servers here
        //
        //
        // check either other user use this server or not
        // Vector linked_users=null;
        // linked_users=DBridgeClient.Bank().getUserContainer().getLinkedSmtpServers(mUser.getLogin(), select);
        // if ( linked_users.size()>0 ){
        // OOO to do: select dialog
        // JOptionPane.showMessageDialog(this, "This server is used at least by a user "+(String)linked_users.get(0)+"\nIf you press Apply,\n all changes will be repeated for connected users", "Error", 1);
        //} //else {
        //   this.mUser.getSmtpTable().setElementAt(rec, select);
        //   this.mList3.setElementAt(rec.getIP(), select);
        //   this.jSMTPList1.setListData(mList3);
        //   this.jSMTPList1.setSelectedIndex(select);
        //}

        mSmtpPanel.Update();
        mSmtpPanel.getUserController().getChangesTracker().UsersChanged = true;

      }

    }
    //
    //REMOVE SMTP command
    //
    if (CMD.equals(dsSMTPPanel.REMOVE_COMMAND)) {
      //get selected record
      Object obj = mSmtpPanel.getSelectedObj();
      //if nothing was selected just exit, the message was already generated
      if (obj == null) {
        return;
      }
      dbSmtpRecord rec = (dbSmtpRecord) obj;
      mSmtpPanel.getUser().getSmtpTable().deleteEllement(rec);
      mSmtpPanel.Update();
      mSmtpPanel.getUserController().getChangesTracker().UsersChanged = true;
    }
    //
    // Check SMTP command
    //
    if (CMD.equals(dsSMTPPanel.CHECK_COMMAND)) {
      //get selected record
      Object obj = mSmtpPanel.getSelectedObj();
      //if nothing was selected just exit, the message was already generated
      if (obj == null) {
        return;
      }
      dbSmtpRecord rec = (dbSmtpRecord) obj;
      dsServersChecker.CheckSMTP(rec);
      /*      ResourceBundle lbls = mSmtpPanel.getUserController().getResourceBundle();
            if (dsServersChecker.CheckSMTP(rec)){
       JOptionPane.showMessageDialog(null, lbls.getString("smtp_ok"),
                                    lbls.getString("info"),
                                    JOptionPane.PLAIN_MESSAGE);
            }else{
       JOptionPane.showMessageDialog(null, lbls.getString("smtp_failed"),
                                    lbls.getString("error"),
                                    JOptionPane.ERROR_MESSAGE);
            }
       */
    }

  }

}

//-------------------------------------------------------------------------
//            POP sever Table listener
//-------------------------------------------------------------------------
class dsPOPPanelActionListener
    implements ActionListener {

  private dsPOPPanel mPOPPanel;

  public dsPOPPanelActionListener(dsPOPPanel obj) {
    mPOPPanel = obj;
  }

  public void actionPerformed(ActionEvent e) {
    ResourceBundle lbls = ResourceBundle.getBundle(
        "dbridge.prop.dsActionListeners",
        BridgeApp.getCurrentLocale());

    String CMD = e.getActionCommand();
    //
    // ADD POP command
    //
    if (CMD.equals(dsPOPPanel.ADD_COMMAND)) {
      XPop_ImapDlg obj = new XPop_ImapDlg( (Frame)null,
                                          lbls.getString("newMail"), true);
      obj.setVisible(true); // call dialog

      if (obj.isOk()) {
        dbMailRecord data = new dbMailRecord();
        data = obj.getFields();
        mPOPPanel.getMailTable().append(data);
        mPOPPanel.Update();
        mPOPPanel.UserUpdated();
      }
    }

    //
    // EDIT POP command
    //
    if (CMD.equals(dsPOPPanel.EDIT_COMMAND)) {
      //get selected record
      //if nothing was selected just exit, the message was already generated
      Object obj = mPOPPanel.getSelectedObj();
      if (obj == null) {
        return;
      }

      dbMailRecord rec = (dbMailRecord) obj;

      //Create SMTP dlg and fill it with the record data
      XPop_ImapDlg dlg = new XPop_ImapDlg( (Frame)null,
                                          lbls.getString("editMail"), true);
      dlg.setFields(rec);
      dlg.setVisible(true);

      if (dlg.isOk()) {
        mPOPPanel.Update();
        mPOPPanel.UserUpdated();

      }

    }

    //
    // DEL POP command
    //
    if (CMD.equals(dsPOPPanel.REMOVE_COMMAND)) {
      //get selected record
      Object obj = mPOPPanel.getSelectedObj();
      //if nothing was selected just exit, the message was already generated
      if (obj == null) {
        return;
      }
      dbMailRecord rec = (dbMailRecord) obj;
      mPOPPanel.getMailTable().deleteEllement(rec);
      mPOPPanel.Update();
      mPOPPanel.UserUpdated();


    }

    //
    // CHECK POP command
    //
    if (CMD.equals(dsPOPPanel.CHECK_COMMAND)) {
      //get selected record
      Object obj = mPOPPanel.getSelectedObj();
      //if nothing was selected just exit, the message was already generated
      if (obj == null) {
        return;
      }
      dbMailRecord rec = (dbMailRecord) obj;
      dsServersChecker.CheckPOP_IMAP(rec);
      /*       ResourceBundle lbls = mPOPPanel.getUserController().getResourceBundle();
             if (dsServersChecker.CheckPOP_IMAP(rec)){
       JOptionPane.showMessageDialog(null, lbls.getString("pop_ok"),
                                     lbls.getString("info"),
                                     JOptionPane.PLAIN_MESSAGE);
             }else{
       JOptionPane.showMessageDialog(null, lbls.getString("pop_failed"),
                                     lbls.getString("error"),
                                     JOptionPane.ERROR_MESSAGE);
             }
       */
    }

  }

}

//-------------------------------------------------------------------------
//            ADDR sever Table listener
//-------------------------------------------------------------------------
class dsADDRPanelActionListener
    implements ActionListener {

  private dsADDRPanel mADDRPanel;

  public dsADDRPanelActionListener(dsADDRPanel obj) {
    mADDRPanel = obj;
  }

  public void actionPerformed(ActionEvent e) {

    ResourceBundle lbls = ResourceBundle.getBundle(
        "dbridge.prop.dsActionListeners",
        BridgeApp.getCurrentLocale());

    String CMD = e.getActionCommand();
    //
    // ADD ADDR command
    //
    if (CMD.equals(dsADDRPanel.ADD_COMMAND)) {
      XAddrBookRecDlg obj = new XAddrBookRecDlg( (Frame)null,
                                                lbls.getString("newMail"), true);
      obj.setSmtpTable(mADDRPanel.getUser().getSmtpTable());
      obj.setMethodDN(DBridgeClient.Bank().getBox().getMethodDN());
      obj.setPrivKeys(mADDRPanel.getUser().getGpgKeys());
      obj.setVisible(true); // call dialog

      if (obj.isOk()) {
        dbMailRecord data = new dbMailRecord();
        data = obj.getFields();
        mADDRPanel.getUser().getAddressBook().append(data);
        mADDRPanel.Update();
        mADDRPanel.UserUpdated();

      }
    }

    //
    // EDIT ADDR command
    //
    if (CMD.equals(dsADDRPanel.EDIT_COMMAND)) {
      //get selected record
      //if nothing was selected just exit, the message was already generated
      Object obj = mADDRPanel.getSelectedObj();
      if (obj == null) {
        return;
      }

      dbMailRecord rec = (dbMailRecord) obj;

      //Create SMTP dlg and fill it with the record data
      XAddrBookRecDlg dlg = new XAddrBookRecDlg( (Frame)null,
                                                lbls.getString("editMail"), true);
      dlg.setSmtpTable(mADDRPanel.getUser().getSmtpTable());
      dlg.setFields(rec);
      dlg.setPrivKeys(mADDRPanel.getUser().getGpgKeys());
      dlg.setVisible(true);

      if (dlg.isOk()) {
        mADDRPanel.Update();
        mADDRPanel.UserUpdated();

      }
    }

    //
    // DEL ADDR command
    //
    if (CMD.equals(dsADDRPanel.REMOVE_COMMAND)) {
      //get selected record
      Object obj = mADDRPanel.getSelectedObj();
      //if nothing was selected just exit, the message was already generated
      if (obj == null) {
        return;
      }
      dbMailRecord rec = (dbMailRecord) obj;
      mADDRPanel.getUser().getAddressBook().deleteEllement(rec);
      mADDRPanel.Update();
      mADDRPanel.UserUpdated();

    }

  }
}

//---------------------------------------------------------------------------
//              ADD COPY REMOVE User Buttons Listener
//---------------------------------------------------------------------------
class UserBtnListener
    implements ActionListener {

  private UserController mController = null;
  private String ADD_COMMAND = "add";
  private String REMOVE_COMMAND = "remove";
  private String COPY_COMMAND = "copy";

  public UserBtnListener(UserController parent) {
    mController = parent;
  }

  public void actionPerformed(ActionEvent e) {
    String command = e.getActionCommand();

    if (ADD_COMMAND.equals(command)) {
      //-----------------------------------
      //              ADD_USER
      //------------------------------------
      dsUserLoginDlg dlg = new dsUserLoginDlg( (Frame) mController,
                                              mController.getResourceBundle(), true);
      dlg.setVisible(true);
      if (dlg.isOK()) {
        dbUser newUser = new dbUser();
        newUser.setLogin(dlg.getLogin());
        if (dlg.isAUTO()) {
          //
          // Verify if at least ONE manual user exists!!!!
          //
          newUser.setID(1000);
          dbMailRecord rec = new dbMailRecord("","","",10);
          newUser.getAddressBook().append(rec);
        }
        else {
          newUser.setID(100);
        }
        mController.addUser(newUser);
      }

    }
    else if (COPY_COMMAND.equals(command)) {
      //-----------------------------------
      //              COPY_USER
      //------------------------------------
      //1 getSelectedUser
      dbUser temp = mController.getSelectedUser();
      if (temp != null) {
        //2 create copy user
        dbUser u_copy = new dbUser(temp);

        dsUserLoginDlg dlg = new dsUserLoginDlg( (Frame) mController,
                                                mController.getResourceBundle(), true);
        dlg.setCopyMode(u_copy);
        dlg.setVisible(true);
        if (dlg.isOK()) {
          u_copy.setLogin(dlg.getLogin());

          mController.addUser(u_copy);
        }
      }
    }
    else if (REMOVE_COMMAND.equals(command)) {
      //-----------------------------------
      //              REMOVE_USER
      //------------------------------------

      mController.deleteSelectedUser();
    }
  }

}

//---------------------------------------------------------------------------
//              ADD COPY REMOVE Srv Buttons Listener
//---------------------------------------------------------------------------
class SrvBtnListener
    implements ActionListener {
  private ServerController mController = null;
  private String ADD_COMMAND = "add";
  private String REMOVE_COMMAND = "remove";
  private String COPY_COMMAND = "copy";

  public SrvBtnListener(ServerController parent) {
    mController = parent;
  }

  public void actionPerformed(ActionEvent e) {
    String command = e.getActionCommand();

    if (ADD_COMMAND.equals(command)) {
      mController.addServer();
    }
    else if (COPY_COMMAND.equals(command)) {

    }
    else if (REMOVE_COMMAND.equals(command)) {
      mController.deleteSelectedServer();
    }
  }
}

//----------------------------------------------------------------
//   BACKUP DB buttons
//----------------------------------------------------------------

class BackupBtnListener
    implements ActionListener {

  private String BCKP_USERS_CMD = "bckp_users";
  private String REST_USERS_CMD = "rest_users";
  private String BCKP_SRVRS_CMD = "bckp_srv";
  private String REST_SRVRS_CMD = "rest_srv";

  private String sCaption = "Save as";
  private String sCaption2 = "Read from";
  private String sError = "Error";

  private DBReloadInterface mGUIreloader = null;

  public BackupBtnListener(DBReloadInterface GUIreloader) {

    Locale currentLocale = BridgeApp.getCurrentLocale();
    ResourceBundle labels = ResourceBundle.getBundle(
        "dbridge.prop.BackupGUILabelsBundle", currentLocale);
    sCaption = labels.getString("SaveDlgLbl");
    sCaption2 = labels.getString("ReadDlgLbl");
    sError = labels.getString("ErrorLbl");

    mGUIreloader = GUIreloader;
  }

  public void actionPerformed(ActionEvent e) {
    String command = e.getActionCommand();

    //==============================
    //  BACKUP USERS
    //=============================
    if (BCKP_USERS_CMD.equals(command)) {
      try {
        Backuper backuper = new Backuper();
        FileDialog fileDlg = new FileDialog( (Frame) mGUIreloader,
                                            sCaption, FileDialog.SAVE);
        fileDlg.setFile("usersdb.xml");
        fileDlg.setVisible(true);
        if (fileDlg.getFile() != null) {
          String name = fileDlg.getDirectory() + fileDlg.getFile();
          backuper.writeUserXMLBackup(DBridgeClient.Bank().
                                      getUserContainer()
                                      .getUsersVector(), name);
        }
      }
      catch (RuntimeException re) {
        System.out.println("BACKUP USER ERROR");
        JOptionPane.showMessageDialog(null, re.getMessage(), sError,
                                      JOptionPane.ERROR_MESSAGE);
      }
      //==============================
      //  RESTORE USERS
      //=============================
    }
    else if (REST_USERS_CMD.equals(command)) {
      String name = "usersdb.xml";
      try {
        FileDialog fileDlg = new FileDialog( (Frame) mGUIreloader,
                                            sCaption2, FileDialog.LOAD);
        fileDlg.setFile("usersdb.xml");
        fileDlg.setVisible(true);

        if (fileDlg.getFile() != null) {
          name = fileDlg.getDirectory() + fileDlg.getFile();
          Backuper backuper = new Backuper(name);
          Vector restoredUsers = backuper.restoreUserXMLBackup();
          if (DBridgeClient.Bank().getUserContainer().fromBackup(
              restoredUsers) == false) {
            BridgeApp.LogError(Logs.Bank.SetText(
                "Wrong results of fromBackuper"));
          }

          if (DBridgeClient.Bank().flush() != true) {
            BridgeApp.LogError(Logs.Bank.SetText(
                "Wrong flush of the user database"));
          }

          // Restart Servers
          String aaa = DBridgeClient.sendRequest("DBRESTART");

          mGUIreloader.reloadDB();
        }

      }
      catch (RuntimeException re) {
        JOptionPane.showMessageDialog(null,
                                      name + ": \n" + re.getMessage(),
                                      sError,
                                      JOptionPane.ERROR_MESSAGE);
      }

      //==============================
      //  BACKUP SERVERS
      //=============================
    }
    else if (BCKP_SRVRS_CMD.equals(command)) {
      try {
        Backuper backuper = new Backuper();
        FileDialog fileDlg = new FileDialog( (Frame) mGUIreloader,
                                            sCaption, FileDialog.SAVE);
        fileDlg.setFile("serversdb.xml");
        fileDlg.setVisible(true);
        if (fileDlg.getFile() != null) {
          String name = fileDlg.getDirectory() + fileDlg.getFile();
          backuper.writeServerXMLBackup(DBridgeClient.Bank().
                                        getDcmServerList(), name);
        }

      }
      catch (RuntimeException re) {
        System.out.println("re.getMessage " + re.getMessage());
        JOptionPane.showMessageDialog(null, re.getMessage(), sError,
                                      JOptionPane.ERROR_MESSAGE);
      }

      //==============================
      //  RESTORE SERVERS
      //=============================

    }
    else if (REST_SRVRS_CMD.equals(command)) {
      String name = "serversdb.xml";
      try {
        FileDialog fileDlg = new FileDialog( (Frame) mGUIreloader,
                                            sCaption2, FileDialog.LOAD);
        fileDlg.setFile("serversdb.xml");
        fileDlg.setVisible(true);
        if (fileDlg.getFile() != null) {
          name = fileDlg.getDirectory() + fileDlg.getFile();

          Backuper backuper = new Backuper(name);
          DBridgeClient.Bank().setDcmServerList(backuper.
                                                restoreServerXMLBackup());
          DBridgeClient.Bank().flushDcmServerList();
          // update the server DB
          DBridgeClient.sendRequest("DBUPDATESERVER");
          // update GUI
          mGUIreloader.reloadDB();
        }
      }
      catch (RuntimeException re) {
        JOptionPane.showMessageDialog(null,
                                      name + ": \n" + re.getMessage(),
                                      sError,
                                      JOptionPane.ERROR_MESSAGE);
      }

    }
  }
}

//-------------------------------------------------------------------------
//      Main Form Buttons e.g. Apply Cancel etc ...
//------------------------------------------------------------------------
class ApplyBtnListener
    implements ActionListener {
  private dsMainForm mForm;

  public ApplyBtnListener(dsMainForm parent) {
    mForm = parent;
  }

  public void actionPerformed(ActionEvent e) {
    mForm.ApplyChanges();
  }
}

class CloseBtnListener
    implements ActionListener {
  private dsMainForm mForm;

  public CloseBtnListener(dsMainForm parent) {
    mForm = parent;
  }

  public void actionPerformed(ActionEvent e) {
    mForm.closeButtonPressed();
  }
}

class CancelBtnListener
    implements ActionListener {
  private dsMainForm mForm;

  public CancelBtnListener(dsMainForm parent) {
    mForm = parent;
  }

  public void actionPerformed(ActionEvent e) {
    mForm.cancelButtonPressed();
  }
}

class HelpBtnListener
    implements ActionListener {
  private dsMainForm mForm;

  public HelpBtnListener(dsMainForm parent) {
    mForm = parent;
  }

  public void actionPerformed(ActionEvent e) {
    mForm.helpButtonPressed();
  }

  //=======================================================================
}
