package dbridge;

import javax.swing.JComponent;
import java.awt.Dimension;
import java.awt.BorderLayout;
import javax.swing.Box;

/**
 * <p>Title: Geometry Alignments</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @Dzmitry Stsepankou
 * @version 1.0
 */

public class dsAlignments {

  static final Dimension NORMAL_SIZE = new Dimension(800, 600);

  static void MakeSameFixedWidth(JComponent[] c_array) {
    int wC1 = c_array[0].getPreferredSize().width;

    for (int i=0; i<c_array.length; i++){
      wC1 = Math.max(wC1, c_array[i].getPreferredSize().width);
    }

    for (int i=0; i<c_array.length; i++){
      c_array[i].setMinimumSize(new Dimension(wC1, c_array[i].getMinimumSize().height));
      c_array[i].setPreferredSize(new Dimension(wC1, c_array[i].getPreferredSize().height));
      c_array[i].setMaximumSize(new Dimension(wC1, c_array[i].getMaximumSize().height));
    }

  }

  static void MakeSameFixedHeight(JComponent[] c_array) {
    int hC1 = c_array[0].getPreferredSize().height;

    for (int i=0; i<c_array.length; i++){
        hC1 = Math.max(hC1, c_array[i].getPreferredSize().height);
     }

    for (int i=0; i<c_array.length; i++){
      c_array[i].setMinimumSize(new Dimension(c_array[i].getMinimumSize().width, hC1));
      c_array[i].setPreferredSize(new Dimension(c_array[i].getPreferredSize().width, hC1));
      c_array[i].setMaximumSize(new Dimension(c_array[i].getMaximumSize().width, hC1));
    }

  }



  static void MakeSameSize_max(JComponent[] c_array){

    int wMax = 0;
    int hMax = 0;

    for (int i=0; i<c_array.length; i++){
      wMax = Math.max(wMax, c_array[i].getPreferredSize().width);
      hMax = Math.max(hMax, c_array[i].getPreferredSize().height);
    }

    for (int i = 0; i < c_array.length; i++) {
      c_array[i].setMinimumSize(new Dimension(wMax, hMax));
      c_array[i].setPreferredSize(new Dimension(wMax, hMax));
      c_array[i].setMaximumSize(new Dimension(wMax, hMax));
    }

  }
  /**
   * Creates the Border size frame_size around CENTER
   * /WARNING: holder must have BorderLayout!
   * @param holder JComponent
   * @param frame_size int
   */
  static void CreateBorder(JComponent holder, int frame_size){

    holder.add(Box.createVerticalStrut(frame_size), BorderLayout.NORTH);
    holder.add(Box.createVerticalStrut(frame_size), BorderLayout.SOUTH);
    holder.add(Box.createHorizontalStrut(frame_size), BorderLayout.EAST);
    holder.add(Box.createHorizontalStrut(frame_size), BorderLayout.WEST);

  }

}
