package dbridge;

import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableCellEditor;
import javax.swing.table.TableColumn;
import java.util.Vector;
import java.awt.*;
import javax.swing.border.*;
import javax.swing.*;
import java.io.File;
import java.awt.event.*;
import java.util.ResourceBundle;

/**
 * <p>Title: Application Chooser dialog</p>
 * <p>Description: GUI to choose the applications to process certain files</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author bob
 * @version 1.0
 */

/*
* Modified 17.08.04
* 06.10.2004
* 03.05.2005
*/


interface ILastLineController{
  public void needLine(int Row);
}


public class dsAppChooserDlg
    extends JDialog implements ILastLineController{

  private dsXMLAppTable m_TableIO = new dsXMLAppTable();
  private Vector AppChooserData = new Vector();
  private String filename = new String();
  private boolean mOk = false;
  private ICAppExecuteServiceUpdt mServiceHolder=null;

  BorderLayout borderLayout1 = new BorderLayout();
  JScrollPane jScrollPane1 = new JScrollPane();
  JTable jTable1;
  TitledBorder titledBorder1;
  JPanel jPanel1 = new JPanel();
  JButton jbCancel = new JButton();
  JButton jbOk = new JButton();
  TitledBorder titledBorder2;
  TitledBorder titledBorder3;
  TitledBorder titledBorder4;

  private String mTitle = null;
  JButton jbApply = new JButton();
  //JButton jbWrite = new JButton();
  //JButton jbNew = new JButton();

//============================================================================
//                        AppChooserTableModel
//               The TableModel subclass for JTable object
//===========================================================================

//----------------------------------------------------------------------------
  class AppChooserTableModel
      extends AbstractTableModel {
    private Vector table_data = new Vector();

    public AppChooserTableModel(Vector data) {
      super();
      table_data = data;
    }

    //TODO: Get it also from outside (in this case XML file)
    //Comment: If one will take this from XML it will be hard to
    //make internationalization.
    ResourceBundle lbls = ResourceBundle.getBundle(
                                            "dbridge.prop.dsAppChooserDlg",
                                            BridgeApp.getCurrentLocale());
    private String[] columnNames = {
        lbls.getString("Extension"), lbls.getString("Application"),
        lbls.getString("Options"),lbls.getString("Comments")};

    public final Object[] longValues = {
        "XXXX",
        "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX", "XXXXXXX",
        "XXXXXXXXXXXXXXXXXX"};

    public int getColumnCount() {
      return columnNames.length;
    }

    public int getRowCount() {
      return table_data.size();
    }

    public String getColumnName(int col) {
      return columnNames[col];
    }

    public Object getValueAt(int row, int col) {
      return ( (Vector) table_data.get(row)).get(col);
    }

    //Since we have all the Strings objects here we don't need this
    //but usually it's necessary to implement this (for different objects)
    /* public Class getColumnClass(int c) {
        //return getValueAt(0, c).getClass();
     }*/

    public boolean isCellEditable(int row, int col) {
      return true;
    }

    public void setValueAt(Object value, int row, int col) {
      ( (Vector) table_data.get(row)).setElementAt(value, col);
      fireTableCellUpdated(row, col);
    }

  }

  //===========================================================================
  //                         PathStringRenderer
  //            The Renderer subclass for JTable's second column
  //===========================================================================
  // Draw the same stuff like in editor subclass
  public class PathStringRenderer
      extends JPanel
      implements TableCellRenderer {

    Border unselectedBorder = null;
    Border selectedBorder = null;

    JTextField edit1 = new JTextField();
    JButton button1 = new JButton();
    BorderLayout Layout1 = new BorderLayout();

    public PathStringRenderer() {
      this.setLayout(Layout1);
      button1.setMinimumSize(new Dimension(10, 10));
      button1.setMaximumSize(new Dimension(20, 20));
      button1.setPreferredSize(new Dimension(20, 10));
      this.add(edit1, BorderLayout.CENTER);
      this.add(button1, BorderLayout.EAST);
      button1.setText("...");
      //edit1.setOpaque(true);
      //edit1.setHorizontalAlignment(JTextField.RIGHT);
    }

    public Component getTableCellRendererComponent(
        JTable table, Object path,
        boolean isSelected, boolean hasFocus,
        int row, int column) {
      if (isSelected) {
        edit1.setBackground(table.getSelectionBackground());
      }
      else {
        edit1.setBackground(table.getBackground());

      }
      edit1.setText( (String) path);
      return this;

    }

  }

  //===========================================================================
  //                           PathStringEditor
  //              The Editor subclass for JTable's second column
  //===========================================================================

  public class PathStringEditor
      extends AbstractCellEditor
      implements TableCellEditor {
    private String result;
    private int mRow;
    ILastLineController mGui;

    JPanel editorPanel = new JPanel();
    JTextField edit1 = new JTextField();
    JButton button1 = new JButton();
    BorderLayout Layout1 = new BorderLayout();


    public PathStringEditor(ILastLineController gui) {
      mGui = gui;
      button1.setMinimumSize(new Dimension(10, 10));
      button1.setMaximumSize(new Dimension(20, 20));
      button1.setPreferredSize(new Dimension(20, 10));
      button1.setBorder(BorderFactory.createLineBorder(Color.black));
      edit1.setBorder(BorderFactory.createLineBorder(Color.black));
      button1.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(ActionEvent e) {
          Button_clicked(e);
        }
      });
      editorPanel.setLayout(Layout1);
      editorPanel.add(edit1, BorderLayout.CENTER);
      editorPanel.add(button1, BorderLayout.EAST);
      button1.setText("...");

    }

    public void Button_clicked(ActionEvent e) {
      String c = "\"";
      JFileChooser jFileChooser1 = new JFileChooser();
      //
      //set current directory to the dir of an application given earlier
      //is the dir is not correct or does not exists, take the standard directory
      //
      //System.out.println("Possible application :"+ edit1.getText());
      //File currentdir=jFileChooser1.getCurrentDirectory();
      if ( edit1.getText()!=null ){ // analyse
        // get the parent dir
        int index=edit1.getText().lastIndexOf(System.getProperty("file.separator"));
        if ( index>=0 ){ // there is a subdirectory in the path
          String parent = new String();
          if (edit1.getText().startsWith(c)) {  // if starts with ", then skip the symbol
            parent = edit1.getText().substring(1, index);
          }
          else {
            parent = edit1.getText().substring(0, index);
          }
          System.out.println("Possible dir :" + parent);
          if (parent != null) {
            File dir = new File(parent);
            if (dir.exists()) {
              jFileChooser1.setCurrentDirectory(dir);
              //System.out.println("dir exists:");
            }
            else {
              //System.out.println("dir does not exists:");
            }
          }
        }
      }
      int RetVal = jFileChooser1.showOpenDialog(editorPanel);
      if (RetVal == JFileChooser.APPROVE_OPTION) {
        result = jFileChooser1.getSelectedFile().getPath();
        // add "" if necessary

        if (result.indexOf(" ")!=-1) { // if contains spaces
          if (!result.startsWith(c) && !result.endsWith(c)) { //and does not have ""
            result = new String(c + result + c);
            //System.out.println("File name new " + result);
          }
        }
        edit1.setText(result);
        //jFileChooser1.setCurrentDirectory(currentdir);
        //fireEditingStopped();
      }

    }

    public Object getCellEditorValue() {
      result = edit1.getText();
      if (result.length()>0) mGui.needLine(mRow);
      return result;
    }

    public Component getTableCellEditorComponent(JTable table,
                                                 Object value,
                                                 boolean isSelected,
                                                 int row,
                                                 int column) {
      result = (String) value;
      edit1.setText(result);
      mRow = row;
      return editorPanel;

    }

  }

  //=================== end of subclasses =====================================

  //--------------------------------------------------------------------------
  public void setAppExecServiceHolder(ICAppExecuteServiceUpdt ServiceHolder){
      mServiceHolder=ServiceHolder;
  }

  public void needLine(int Row){
    if (AppChooserData.size()==Row+1) this.addTableLine();
  // System.out.println(Row); System.out.println(AppChooserData.size());
  // System.out.println(" ");
  }

  private void setData(Vector m_data) {
    AppChooserData.clear();

    for (int i = 0; i < m_data.size(); i++) {
      AppChooserData.add(m_data.get(i));
    }
    this.addTableLine();
    jTable1.updateUI();
  }

 // set application XML file
  public void setFilename(String name) {
    filename = name;
    setData(m_TableIO.ReadTableData(filename));
  }

 public String toString(){
   return mTitle;
 }

 public void setPanelMode(){
   //this.jPanel1.setVisible(false);
   this.jbOk.setVisible(false);
   this.jbCancel.setVisible(false);
 }

  public dsAppChooserDlg(String title, JFrame parent, boolean modal) throws HeadlessException {
    super(parent, modal);

    mTitle = title;
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }

    if (filename.length() > 0) {
      Vector data = m_TableIO.ReadTableData(filename);
      setData(data);
    }
  }

  //--------------------------------------------------------------------------
  private void initColumnSizes(JTable table) {
    AppChooserTableModel model = (AppChooserTableModel) table.getModel();
    TableColumn column = null;
    Component comp = null;
    int headerWidth = 0;
    int cellWidth = 0;
    Object[] longValues = model.longValues;
    TableCellRenderer headerRenderer =
        table.getTableHeader().getDefaultRenderer();

    for (int i = 0; i < 4; i++) {
      column = table.getColumnModel().getColumn(i);

      comp = headerRenderer.getTableCellRendererComponent(
          null, column.getHeaderValue(),
          false, false, 0, 0);
      headerWidth = comp.getPreferredSize().width;

      comp = table.getDefaultRenderer(model.getColumnClass(i)).
          getTableCellRendererComponent(
          table, longValues[i],
          false, false, 0, i);

      cellWidth = comp.getPreferredSize().width;

      //XXX: Before Swing 1.1 Beta 2, use setMinWidth instead.
      column.setPreferredWidth(Math.max(headerWidth, cellWidth));
      column.setMinWidth(Math.max(headerWidth, cellWidth));
    }
  }

//-------------------------------------------------------------------
  private void setUpPathColumn(TableColumn PathColumn) {
    PathColumn.setCellEditor(new PathStringEditor(this));
    PathColumn.setCellRenderer(new PathStringRenderer());

  }

  //--------------------------------------------------------------------

  private void jbInit() throws Exception {
    jTable1 = new JTable(new AppChooserTableModel(AppChooserData));
    titledBorder4 = new TitledBorder("");
    jTable1.setCellSelectionEnabled(true);
    jTable1.setDragEnabled(false);
    jTable1.setSurrendersFocusOnKeystroke(true);

    ResourceBundle lbls = ResourceBundle.getBundle(
                                            "dbridge.prop.dsAppChooserDlg",
                                            BridgeApp.getCurrentLocale());

    titledBorder3 = new TitledBorder(BorderFactory.createEtchedBorder(), "");
    this.setSize(new Dimension(600, 200));
    this.setTitle(lbls.getString("Title"));

    this.initColumnSizes(jTable1);
    setUpPathColumn(jTable1.getColumnModel().getColumn(1));

    titledBorder1 = new TitledBorder(BorderFactory.createEtchedBorder(), lbls.getString("Applications"));
    this.getContentPane().setLayout(borderLayout1);
    jScrollPane1.setAlignmentX((float) 0.0);
    jScrollPane1.setAlignmentY((float) 0.0);
    jScrollPane1.setBorder(titledBorder1);
    jScrollPane1.setPreferredSize(new Dimension(500, 150));
    jPanel1.setAlignmentX((float) 0.0);
    jPanel1.setAlignmentY((float) 0.0);
    jPanel1.setBorder(BorderFactory.createEtchedBorder());
    jbCancel.setText(lbls.getString("Cancel"));
    jbCancel.addActionListener(new dsAppChooserDlg_jbCancel_actionAdapter(this));
    jbOk.setText(lbls.getString("Ok"));
    jbOk.addActionListener(new dsAppChooserDlg_jbOk_actionAdapter(this));
    borderLayout1.setHgap(0);
    jbApply.setText(lbls.getString("Apply"));
    jbApply.addActionListener(new dsAppChooserDlg_jbApply_actionAdapter(this));
    this.getContentPane().add(jScrollPane1, BorderLayout.CENTER);
    this.getContentPane().add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(jbApply, null);
    jPanel1.add(jbOk, null);
    jPanel1.add(jbCancel, null);
    jScrollPane1.getViewport().add(jTable1, null);
  }

//============== DEBUG main method ============================================
  public static void main(String[] args) /*throws HeadlessException*/ {
    dsAppChooserDlg dsAppChooserDlg1 = new dsAppChooserDlg("", null, false);
    dsAppChooserDlg1.setFilename("temp.xml");
    dsAppChooserDlg1.setVisible(true);
  }

//=============================================================================

  void jbWrite_actionPerformed(ActionEvent e) {

    //TODO: Check if necessary?
    //Now, if length of 1 and 2 column < 1 it's automatically discarded (see dsXMLparser)
    /*for (int i=0; i<AppChooserData.size(); i++){
      if (((String) ((Vector) AppChooserData.get(i)).get(0)).length()<1){
     JOptionPane.showMessageDialog(this, "", "Error!!!", JOptionPane.ERROR_MESSAGE);
      }
         }*/

    if (filename.length() > 0) {
      m_TableIO.WriteTableData(AppChooserData, filename);
    }
  }

  void jbNew_actionPerformed(ActionEvent e) {
    this.addTableLine();
  }

  private void addTableLine() {
    Vector temp = new Vector();
    temp.add(new String());
    temp.add(new String());
    temp.add(new String());
    temp.add(new String());
    AppChooserData.add(temp);
  }

  void jbOk_actionPerformed(ActionEvent e) {
    if (filename.length() > 0) {
      //we just need to switch the focus here to generate edit finish event
      if (AppChooserData.size()>0) jTable1.editCellAt(0,0);
      m_TableIO.WriteTableData(AppChooserData, filename);
    }
    mOk = true;
    this.setVisible(false);
  }

  void jbCancel_actionPerformed(ActionEvent e) {
    mOk = false;
    this.setVisible(false);
  }

  boolean isOk(){return mOk;}

  void jbApply_actionPerformed(ActionEvent e) {
    if (filename.length() > 0) {
      //we just need to switch the focus here to generate edit finish event
      if (AppChooserData.size()>0) jTable1.editCellAt(0,0);
      m_TableIO.WriteTableData(AppChooserData, filename);

      if (mServiceHolder!=null){
        mServiceHolder.updateAppExecService();
      }
    }
    mOk = true;
  }

}

class dsAppChooserDlg_jbWrite_actionAdapter
    implements java.awt.event.ActionListener {
  dsAppChooserDlg adaptee;

  dsAppChooserDlg_jbWrite_actionAdapter(dsAppChooserDlg adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jbWrite_actionPerformed(e);
  }
}

class dsAppChooserDlg_jbNew_actionAdapter
    implements java.awt.event.ActionListener {
  dsAppChooserDlg adaptee;

  dsAppChooserDlg_jbNew_actionAdapter(dsAppChooserDlg adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jbNew_actionPerformed(e);
  }
}

class dsAppChooserDlg_jbOk_actionAdapter
    implements java.awt.event.ActionListener {
  dsAppChooserDlg adaptee;

  dsAppChooserDlg_jbOk_actionAdapter(dsAppChooserDlg adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jbOk_actionPerformed(e);
  }
}

class dsAppChooserDlg_jbCancel_actionAdapter implements java.awt.event.ActionListener {
  dsAppChooserDlg adaptee;

  dsAppChooserDlg_jbCancel_actionAdapter(dsAppChooserDlg adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jbCancel_actionPerformed(e);
  }
}

class dsAppChooserDlg_jbApply_actionAdapter implements java.awt.event.ActionListener {
  dsAppChooserDlg adaptee;

  dsAppChooserDlg_jbApply_actionAdapter(dsAppChooserDlg adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jbApply_actionPerformed(e);
  }
}
