package dbridge;

import javax.swing.*;
import java.awt.BorderLayout;
import java.io.*;

import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeCellRenderer;


/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

/**
 * A class to hold the Files
 * implemented because File.toString returns full path,
 * but we want short version here
 */

class dsDirTreeLeaf{
  private String mName="";
  private File   mFile=null;

  public dsDirTreeLeaf(File file) {
   mFile = file;
   mName = mFile.getName();
  }

  public dsDirTreeLeaf(String name, File file){
    mName=name;
    mFile=file;
  }

  public String toString(){
    return mName;
  }

  public File getFile(){
    return mFile;
  }
}

public class dsDirTree extends JPanel{

  JTree mDirTree = null;
  String sRoot = null;

  /**
   * Default constructor
   */

  public dsDirTree(String path) {

    sRoot = path;
    File fRoot = new File (sRoot);
    DefaultMutableTreeNode rootNode = createTree(fRoot);
    DefaultTreeModel treeModel = new DefaultTreeModel(rootNode);
    DefaultTreeCellRenderer renderer = 	new DefaultTreeCellRenderer();
    renderer.setLeafIcon(renderer.getClosedIcon());

    mDirTree = new JTree(treeModel);
    mDirTree.setCellRenderer(renderer);

    JScrollPane jspMain = new JScrollPane();
    jspMain.getViewport().add(mDirTree);
    this.setLayout(new BorderLayout());
    this.add(jspMain, BorderLayout.CENTER);
    dsAlignments.CreateBorder(this, 10);

  }

  /**
   * A recursion function for folders search
   * @param root File
   * @return DefaultMutableTreeNode
   */

  public DefaultMutableTreeNode createTree(File root){
    DefaultMutableTreeNode rootNode = null;
    if (root.isDirectory()){
      rootNode = new DefaultMutableTreeNode(new dsDirTreeLeaf(root));
      File fFiles[] = root.listFiles();
        for (int i = 0; i < fFiles.length; i++) {
          if (fFiles[i].isDirectory()) rootNode.add(createTree(fFiles[i]));
        }
    }
    return rootNode;
  }

  /**
   * DEBUG method
   * @param args String[]
   */
  public static void main(String[] args) {
      dsDirTree dsDirTree1 = new dsDirTree("/home/");
      dsDirTree1.setVisible(true);
  }

}
