package dbridge;

import javax.swing.*;
import java.awt.*;
import java.io.File;
import javax.swing.border.*;

//import java.util.Locale;
import java.util.Vector;
import javax.swing.JTable;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;
import java.awt.Component;
import java.awt.event.*;
import java.util.ResourceBundle;
import javax.swing.JRadioButton;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

/*
* Created:
* Modified 25.01.04
* Modified 14.04.05
*/


public class dsGPGKeyDialog extends JDialog {

  private Vector pubKeyTableData = new Vector();
  private Vector secKeyTableData = new Vector();
  private boolean mOk = false;
  private boolean mSelKey = false;

  private final static int FINGERPRINTCOL = 4;

  JScrollPane jScrollPane1 = new JScrollPane();
  JScrollPane jScrollPane2 = new JScrollPane();

  TitledBorder titledBorder1;
  TitledBorder titledBorder2;

  JPanel jPanel1 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel2 = new JPanel();
  JPanel jPanel3 = new JPanel();
  JButton jButton2 = new JButton();
  JButton jButton4 = new JButton();
  JButton jButton1 = new JButton();
  JButton jbGenKey = new JButton();
  JButton jButton3 = new JButton();
  BorderLayout borderLayout2 = new BorderLayout();
  JButton jbCancel = new JButton();
  JButton jbOk = new JButton();
  ResourceBundle mLbls = ResourceBundle.getBundle("dbridge.prop.dsGPGKeyDialog",
		  BridgeApp.getCurrentLocale());
  String mError = mLbls.getString("Error");

  JTable jTable1 = new JTable(new PGPKeyTableModel(pubKeyTableData));
  JTable jTable2 = new JTable(new PGPKeyTableModel(secKeyTableData));

  JLabel key = new JLabel();
  JRadioButton secretButton = new JRadioButton(mLbls.getString("SecretKey"));
  JRadioButton publicButton = new JRadioButton(mLbls.getString("PublicKey"),true);
 //Group the radio buttons.
  ButtonGroup rbGroup = new ButtonGroup();

  //---- Table Model subclass -------------------------
  class PGPKeyTableModel extends AbstractTableModel {
    private Vector table_data = new Vector();

 //   private ResourceBundle mLblsTab = ResourceBundle.getBundle(
   //                                         "dbridge.prop.dsGPGKeyDialog",
     //                                       new Locale("en"));
								                             //BridgeApp.getCurrentLocale());

    public PGPKeyTableModel(Vector data) {
      super();
      table_data=data;
    }

    private String [] columnNames = {mLbls.getString("UserID"),
                 mLbls.getString("Created"),mLbls.getString("Expired"),
                 mLbls.getString("TrustLevel"),mLbls.getString("Fingerprint")};

    public final Object[] longValues = {"XXXXXXX <XXXXXXXX@XXX.XXX.XX.XX>",
        "XXXX-XX-XX", "XXXX-XX-XX", "The key is ultimately trusted",
        "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"};


    public int getColumnCount() {
      return columnNames.length;
    }

    public int getRowCount() {
      return table_data.size();
   }

    public String getColumnName(int col) {
      return columnNames[col];
    }

    public Object getValueAt(int row, int col) {
      return ((Vector) table_data.get(row)).get(col);
    }

     public boolean isCellEditable(int row, int col) {
          return false;
     }

    public void setValueAt(Object value, int row, int col) {
      ((Vector) table_data.get(row)).setElementAt(value, col);
      fireTableCellUpdated(row, col);
    }

  }

  //---- END of Table Model subclass --------------------------
  private void initColumnSizes(JTable table) {
       PGPKeyTableModel model = (PGPKeyTableModel)table.getModel();
       TableColumn column = null;
       Component comp = null;
       int headerWidth = 0;
       int cellWidth = 0;
       Object[] longValues = model.longValues;
       TableCellRenderer headerRenderer =
           table.getTableHeader().getDefaultRenderer();

       for (int i = 0; i < 5; i++) {
           column = table.getColumnModel().getColumn(i);

           comp = headerRenderer.getTableCellRendererComponent(
                                null, column.getHeaderValue(),
                                false, false, 0, 0);
           headerWidth = comp.getPreferredSize().width;

           comp = table.getDefaultRenderer(model.getColumnClass(i)).
                             getTableCellRendererComponent(
                                 table, longValues[i],
                                 false, false, 0, i);

           cellWidth = comp.getPreferredSize().width;

           //XXX: Before Swing 1.1 Beta 2, use setMinWidth instead.
           column.setPreferredWidth(Math.max(headerWidth, cellWidth));
           column.setMinWidth(Math.max(headerWidth, cellWidth));
       }
   }

  public dsGPGKeyDialog(JFrame parent, boolean modal) /*throws HeadlessException*/ {
    super(parent, modal);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
    this.scanKeys();
    if (jTable2.getRowCount()>0)
    jTable2.addRowSelectionInterval(0,0);
  }

  private void jbInit() throws Exception {
    this.setSize(new Dimension(800, 600));
    this.setTitle(mLbls.getString("Title"));
    //this.setIconImage(Toolkit.getDefaultToolkit().getImage(BridgeApp.getConstants().mWindowIcon));

    this.initColumnSizes(jTable1);
    jTable1.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    jTable1.setDragEnabled(false);
    jTable1.setPreferredScrollableViewportSize(new Dimension(800, 200));
    titledBorder1 = new TitledBorder(mLbls.getString("AvbPubKeys"));


    jScrollPane1.setBorder(titledBorder1);
    jScrollPane1.setPreferredSize(new Dimension(300, 250));


    this.initColumnSizes(jTable2);

    jTable2.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    jTable2.setDragEnabled(false);
    jTable2.setPreferredScrollableViewportSize(new Dimension(800, 200));
    titledBorder2 = new TitledBorder(mLbls.getString("AvbSecretKeys"));


    jScrollPane2.setBorder(titledBorder2);
    jScrollPane2.setMinimumSize(new Dimension(300, 40));
    jScrollPane2.setPreferredSize(new Dimension(300, 250));

    this.getContentPane().setLayout(borderLayout1);
    jPanel1.setBorder(BorderFactory.createEtchedBorder());
    jPanel1.setPreferredSize(new Dimension(357, 80));
    jPanel1.setLayout(borderLayout2);
    jButton2.setText(mLbls.getString("Import"));
    jButton2.addActionListener(new dsGPGKeyDialog_jButton2_actionAdapter(this));
    jButton4.setText(mLbls.getString("Delete"));
    jButton4.setIcon(new ImageIcon("./lib/res/small_delete2.gif"));
    jButton4.addActionListener(new dsGPGKeyDialog_jButton4_actionAdapter(this));

    jButton1.setText(mLbls.getString("Sign"));
    jButton1.addActionListener(new dsGPGKeyDialog_jButton1_actionAdapter(this));

    jbGenKey.setText(mLbls.getString("Generate"));
    jbGenKey.addActionListener(new dsGPGKeyDialog_jbGenKey_actionAdapter(this));

    jButton3.setText(mLbls.getString("Export"));
    jButton3.addActionListener(new dsGPGKeyDialog_jButton3_actionAdapter(this));

    jbCancel.setText(mLbls.getString("Cancel"));
    jbCancel.setMinimumSize(new Dimension(100, 23));
    jbCancel.setPreferredSize(new Dimension(100, 23));
    //jbCancel.setIcon(new ImageIcon("./lib/res/door_pgp.jpg"));
    jbCancel.addActionListener(new dsGPGKeyDialog_jbCancel_actionAdapter(this));

    jbOk.setText(mLbls.getString("Ok"));
    jbOk.setMinimumSize(new Dimension(100, 23));
    jbOk.setPreferredSize(new Dimension(100, 23));
    //jbOk.setIcon(new ImageIcon("./lib/res/door_pgp.jpg"));

    jbOk.addActionListener(new dsGPGKeyDialog_jbOk_actionAdapter(this));
    jPanel3.setBorder(BorderFactory.createEtchedBorder());
    jPanel2.setBorder(BorderFactory.createEtchedBorder());
//---------------------------------------------------------------
    secretButton.setMnemonic(KeyEvent.VK_S);
    secretButton.setMaximumSize(new Dimension(100, 23));
    secretButton.setMinimumSize(new Dimension(100, 23));
    secretButton.setPreferredSize(new Dimension(100, 23));
    //secretButton.setActionCommand(rabbitString);
    publicButton.setMnemonic(KeyEvent.VK_P);
    publicButton.setMaximumSize(new Dimension(100, 23));
    publicButton.setMinimumSize(new Dimension(100, 23));
    publicButton.setPreferredSize(new Dimension(100, 23));

    key.setIcon(new ImageIcon("./lib/res/door_pgp.jpg"));
    key.setToolTipText(mLbls.getString("KeyIconTip"));
//  Group the radio buttons.
    rbGroup.add(secretButton);
    rbGroup.add(publicButton);
//------------------------------------------
    this.getContentPane().add(jScrollPane1,  BorderLayout.CENTER);

    this.getContentPane().add(jScrollPane2,  BorderLayout.NORTH);

    this.getContentPane().add(jPanel1,  BorderLayout.SOUTH);
    jPanel1.add(jPanel3,  BorderLayout.SOUTH);
    jPanel3.add(jbOk, null);
    jPanel3.add(jbCancel, null);
    jPanel1.add(jPanel2, BorderLayout.CENTER);

    jPanel2.add(key);
    jPanel2.add(secretButton,null);
    jPanel2.add(publicButton,null);
    jPanel2.add(jbGenKey, null);
    jPanel2.add(jButton3, null);
    jPanel2.add(jButton2, null);
    jPanel2.add(jButton1, null);
    jPanel2.add(jButton4, null);

    jScrollPane1.getViewport().add(jTable1, null);

    jScrollPane2.getViewport().add(jTable2, null);

  }

  private void scanKeys(){
    Vector gpgPubKeys = new Vector();
    Vector gpgSecKeys = new Vector();

    //table_data.clear();
    pubKeyTableData.clear();
    secKeyTableData.clear();
    try{
      gpgPubKeys = GpgWrapper.getKeys(false);
      gpgSecKeys = GpgWrapper.getKeys(true);
    }catch(Exception e) {
      JOptionPane.showMessageDialog(this, e.getMessage(), mError, JOptionPane.ERROR_MESSAGE);
      return;
    }
    for (int i=0; i<gpgPubKeys.size(); i++){
      GpgKeyInfo gpgKey = (GpgKeyInfo)(gpgPubKeys.get(i));

      Vector mData = new Vector();
      mData.add(gpgKey.getUserID());
      mData.add(gpgKey.getCreationDate());
      mData.add(gpgKey.getExpirationDate());
      mData.add(gpgKey.getTrust(true));
      mData.add(gpgKey.getFingerPrint());

      //table_data.add(mData);
      pubKeyTableData.add(mData);
     }
     jTable1.updateUI();

 ///Sec keys:
    for (int i=0; i<gpgSecKeys.size(); i++){
      GpgKeyInfo gpgKey = (GpgKeyInfo)(gpgSecKeys.get(i));

      Vector mData = new Vector();
      mData.add(gpgKey.getUserID());
      mData.add(gpgKey.getCreationDate());
      mData.add(gpgKey.getExpirationDate());
      mData.add(mLbls.getString("ItIsSecKey"));
      mData.add(gpgKey.getFingerPrint());

      secKeyTableData.add(mData);
     }
     jTable2.updateUI();

  }

  public static void main(String[] args) /*throws HeadlessException*/ {
  dsGPGKeyDialog dsGPGKeyDialog1 = new dsGPGKeyDialog(null, false);
  dsGPGKeyDialog1.setVisible(true);
}

  void jbOk_actionPerformed(ActionEvent e) {
    mOk = true;
    this.setVisible(false);
 //   this.dispose();
  }

  void jbCancel_actionPerformed(ActionEvent e) {
    mOk = false;
    this.setVisible(false);
//    this.dispose();
  }

  boolean isOk(){return mOk;}

  public String getSelectedKey(){
    String res = "";
    if (jTable1.getSelectedRowCount()>0){
      int row = jTable1.getSelectedRow();
      res = (String) jTable1.getValueAt(row, FINGERPRINTCOL);
    }
    return res;
  }

  public String getSelectedSecretKey(){
    String res = "";
    if (jTable2.getSelectedRowCount()>0){
      int row = jTable2.getSelectedRow();
      res = (String) jTable2.getValueAt(row, FINGERPRINTCOL);
    }
    return res;
  }

  public String getSelectedSecretKeyID(){
	  String fingerPrint = getSelectedSecretKey();
	  int n = fingerPrint.length();
	  return fingerPrint.substring(n-8, n);
  }

  void jbGenKey_actionPerformed(ActionEvent e) {
    GenDialog mGenDial = new GenDialog(this, true);
    mGenDial.setVisible(true);
    this.scanKeys();
  }

  void jButton4_actionPerformed(ActionEvent e) {
     if(JOptionPane.showConfirmDialog(this,
    mLbls.getString("Sure"),mLbls.getString("DelKey"),JOptionPane.YES_NO_OPTION)==0){
       try {
        if (secretButton.isSelected()) {
          GpgWrapper.deleteKey(this.getSelectedSecretKey(),true);
        } else {
          GpgWrapper.deleteUser(this.getSelectedKey());
        }
       }catch(Exception ex){
           JOptionPane.showMessageDialog(this, ex.getMessage(),
            mError, JOptionPane.ERROR_MESSAGE);
       }
    }
    this.scanKeys();
  }

  void jButton3_actionPerformed(ActionEvent e) {
    JFileChooser jFileChooser1 = new JFileChooser(".");
    JCheckBox jcbArmor = new JCheckBox(mLbls.getString("Armored"), true);
    jFileChooser1.setAccessory(jcbArmor);

    if (JFileChooser.APPROVE_OPTION == jFileChooser1.showSaveDialog(this)) {
      File selFile = jFileChooser1.getSelectedFile();
      try{
       if (secretButton.isSelected()) {
          GpgWrapper.exportKey(this.getSelectedSecretKey(),
          selFile.getPath(), true, jcbArmor.isSelected());
       } else {
          GpgWrapper.exportKey(this.getSelectedKey(),
          selFile.getPath(), false, jcbArmor.isSelected());
       }
      }catch(Exception ex){
           JOptionPane.showMessageDialog(this, ex.getMessage(),
            mError, JOptionPane.ERROR_MESSAGE);
      }
    }
    this.scanKeys();

  }

  void jButton2_actionPerformed(ActionEvent e) {
    JFileChooser jFileChooser1 = new JFileChooser(".");
    if (JFileChooser.APPROVE_OPTION == jFileChooser1.showDialog(this, mLbls.getString("Select"))) {
      File selFile = jFileChooser1.getSelectedFile();
      try{
          GpgWrapper.importKey(selFile.getPath());
      }catch(Exception ex){
           JOptionPane.showMessageDialog(this, ex.getMessage(),
            mError, JOptionPane.ERROR_MESSAGE);
      }
    }
    this.scanKeys();
  }

  void jButton1_actionPerformed(ActionEvent e) {
    dsSignKeyDialog mSignDlg = new dsSignKeyDialog(this, true);
    mSignDlg.setVisible(true);
    if (mSignDlg.isOk()){
      try{
          GpgWrapper.signKey(this.getSelectedSecretKey(), this.getSelectedKey(),
                                                 mSignDlg.getLevel(),
                                                 mSignDlg.getPass());
      }catch(Exception ex){
           JOptionPane.showMessageDialog(this, ex.getMessage(),
            mError, JOptionPane.ERROR_MESSAGE);
      }
       this.scanKeys();
    }
  }

  public void setPanelMode(){
    this.jPanel3.setVisible(false);
  }


}

class dsGPGKeyDialog_jbOk_actionAdapter implements java.awt.event.ActionListener {
  dsGPGKeyDialog adaptee;

  dsGPGKeyDialog_jbOk_actionAdapter(dsGPGKeyDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jbOk_actionPerformed(e);
  }
}

class dsGPGKeyDialog_jbCancel_actionAdapter implements java.awt.event.ActionListener {
  dsGPGKeyDialog adaptee;

  dsGPGKeyDialog_jbCancel_actionAdapter(dsGPGKeyDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jbCancel_actionPerformed(e);
  }
}

class dsGPGKeyDialog_jbGenKey_actionAdapter implements java.awt.event.ActionListener {
  dsGPGKeyDialog adaptee;

  dsGPGKeyDialog_jbGenKey_actionAdapter(dsGPGKeyDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jbGenKey_actionPerformed(e);
  }
}

class dsGPGKeyDialog_jButton4_actionAdapter implements java.awt.event.ActionListener {
  dsGPGKeyDialog adaptee;

  dsGPGKeyDialog_jButton4_actionAdapter(dsGPGKeyDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton4_actionPerformed(e);
  }
}

class dsGPGKeyDialog_jButton3_actionAdapter implements java.awt.event.ActionListener {
  dsGPGKeyDialog adaptee;

  dsGPGKeyDialog_jButton3_actionAdapter(dsGPGKeyDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton3_actionPerformed(e);
  }
}

class dsGPGKeyDialog_jButton2_actionAdapter implements java.awt.event.ActionListener {
  dsGPGKeyDialog adaptee;

  dsGPGKeyDialog_jButton2_actionAdapter(dsGPGKeyDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton2_actionPerformed(e);
  }
}

class dsGPGKeyDialog_jButton1_actionAdapter implements java.awt.event.ActionListener {
  dsGPGKeyDialog adaptee;

  dsGPGKeyDialog_jButton1_actionAdapter(dsGPGKeyDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jButton1_actionPerformed(e);
  }
}
