package dbridge;

import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;
//import java.util.Vector;
import java.awt.*;
import javax.swing.border.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;

/**
 * <p>Title: Log View dialog</p>
 * <p>Description: Show classified messages from the log file</p>
 * <p>Copyright: Copyright (c) 2004-2007</p>
 * <p>Company: </p>
 * @author aITLab
 * @version 1.0
 */

/*
* Created 29.09.04
* Modified 30.09.04
* Modified 1.05.05-12.05.05
* Modified 14.06.05-16.06.05
* Modified 28.03.07-29.03.07
*/
interface IScrollStatus {
  public void setToBottom();
  public void fillTable();
}

class ScrollInitThread extends Thread{
  long mTime;
  boolean mStopFlag;
  boolean mIsLocked;
  IScrollStatus mInterface;

  ScrollInitThread(long time){
    mTime=time;
  }
  public long getTimeout(){ return mTime; }
  public void setTimeout(long time){ mTime=time; }
  public void setStop(){ mStopFlag=true; }
  public void setLocked(boolean on){ mIsLocked=on; }
  public void setInterface(IScrollStatus status){mInterface=status;};

  public void run(){
	  mStopFlag = false;
	  while (!mStopFlag) {
		if (!mIsLocked ){  
		  try {
				Thread.sleep(mTime); // mTime/1000 seconds
		  } catch (InterruptedException ie) {};
		  mIsLocked=true;
		  mInterface.fillTable();
		  mIsLocked=false;
		}
	 }// end while
  }
}// end class

public class dsLogViewerDlg
    extends JDialog implements IScrollStatus{

  private boolean mOk = false;
  private Vector LogViewerData = new Vector();

  Locale currentLocale;
  ResourceBundle labels;
  BorderLayout borderLayout1 = new BorderLayout();
  JScrollPane jScrollPane1 = new JScrollPane();
  JTable jTable1 = null;
  TitledBorder titledBorder1;
  JPanel jPanel1 = new JPanel();
  JButton jbCancel = new JButton();
  JButton jbOk = new JButton();
  JButton jbRefresh = new JButton();
  TitledBorder titledBorder2;
  String mLogName = null;
  String mFileName = null;
  ScrollInitThread mInitThread = null;
  int mSleepTime = 5000;
//  TitledBorder titledBorder3;
//  TitledBorder titledBorder4;
  //JButton jbWrite = new JButton();
  //JButton jbNew = new JButton();

//============================================================================
//                        LogViewerTableModel
//               The TableModel subclass for JTable object
//===========================================================================

//----------------------------------------------------------------------------
  class LogViewerTableModel
      extends AbstractTableModel {
    private Vector table_data = new Vector();
    public int columns = 3;
    //private String dummy_string = new String();

    public LogViewerTableModel(Vector data) {
      super();
      table_data = data;
    }

    private String[] columnNames = {
        labels.getString("date"),
        labels.getString("type"),
//        labels.getString("module"),
//        labels.getString("thread"),
        labels.getString("message")};

    public final Object[] longValues = {
        "XXXXXX XXXX",
        //"XXXXX", "XXXXXX",
        "XXXXX", "XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"};

    public int getColumnCount() {
      return columnNames.length;
    }

    public int getRowCount() {
      return table_data.size();
    }

    public String getColumnName(int col) {
      return columnNames[col];
    }

    public Object getValueAt(int row, int col) {
      return ( (Vector) table_data.get(row)).get(col);
    }

    //Since we have all the Strings objects here we don't need this
    //but usually it's necessary to implement this (for different objects)
    /* public Class getColumnClass(int c) {
        //return getValueAt(0, c).getClass();
     }*/

    public boolean isCellEditable(int row, int col) {
      return false;
    }

    public void setValueAt(Object value, int row, int col) {
      ( (Vector) table_data.get(row)).setElementAt(value, col);
      fireTableCellUpdated(row, col);
    }

  }

  public void Button_clicked(ActionEvent e) {

    //fireEditingStopped();
  }

  //=================== end of subclasses =====================================

  private void setData(Vector m_data) {
    LogViewerData.clear();
    LogViewerData.addAll(m_data);

    if (jTable1 != null) {
      this.initColumnSizes(jTable1);
      jTable1.updateUI();
      //mInitThread=new ScrollInitThread(mSleepTime); // wait window rendering and set scrollbar to bottom
    }

  }

  /**
   * Constructor
   * @param parent
   * @param modal
   * @throws HeadlessException
   */
  public dsLogViewerDlg(JFrame parent, boolean modal) throws HeadlessException {
    super(parent, modal);
    mSleepTime=500;
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    mInitThread=new ScrollInitThread(mSleepTime); // wait window rendering and set scrollbar to bottom
    mInitThread.setInterface(this);
//  mInitThread.run();
    mInitThread.start();
    mSleepTime=5000;
    mInitThread.setTimeout(mSleepTime);
  }

  //-----------------------------------------------------------------------
  /**
   * Constructor
   */
  public dsLogViewerDlg(Vector tabledata, JFrame parent, boolean modal) throws
      HeadlessException {
    super(parent, modal);
    mSleepTime=500;
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    this.setData(tabledata);
    mInitThread=new ScrollInitThread(mSleepTime); // wait window rendering and set scrollbar to bottom
    mInitThread.setInterface(this);
//  mInitThread.run();
    mInitThread.start();
    mSleepTime=5000;
    mInitThread.setTimeout(mSleepTime);
  }

  /**
   * Constructor
   * @param logname
   * @param logfilename
   * @param parent
   * @param modal
   * @throws HeadlessException
   */
  public dsLogViewerDlg(String logname, String logfilename, JFrame parent,
                        boolean modal) throws HeadlessException {
    super(parent, modal);
    mSleepTime=500;
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    mLogName = new String(logname);
    mFileName = new String(logfilename);
    fillTable();
 //System.out.println("Starting timer Logname="+mLogName+"...");
    mInitThread=new ScrollInitThread(mSleepTime); // wait window rendering and set scrollbar to bottom
    mInitThread.setInterface(this);
    ////mInitThread.run();
    mInitThread.start();
    ////System.out.println("Timer runs...");
    mSleepTime=5000;
    mInitThread.setTimeout(mSleepTime);
  }

  public void fillTable() {
    LogTableBuilder mTableBuilder = new LogTableBuilder(mLogName); // in string
    //LogParser mParser = new LogParser(mTableBuilder, mFileName);
       LogParser mParser = new LogParser();
       mParser.BuildTable(mTableBuilder, mFileName);

    Vector tabledata = mTableBuilder.getTableData();
    this.setData(tabledata);
    setToBottom();
  }

  public void setToBottom(){
    int max_val = jScrollPane1.getVerticalScrollBar().getMaximum();
    jScrollPane1.getVerticalScrollBar().setValue(max_val);
  }

  //--------------------------------------------------------------------------
  private void initColumnSizes(JTable table) {
    LogViewerTableModel model = (LogViewerTableModel) table.getModel();
    TableColumn column = null;
    Component comp = null;
    int headerWidth = 0;
    int cellWidth = 0;
    Object[] longValues = model.longValues;
    TableCellRenderer headerRenderer =
        table.getTableHeader().getDefaultRenderer();

    for (int i = 0; i < model.columns; i++) {
      column = table.getColumnModel().getColumn(i);

      comp = headerRenderer.getTableCellRendererComponent(
          null, column.getHeaderValue(),
          false, false, 0, 0);
      headerWidth = comp.getPreferredSize().width;

      comp = table.getDefaultRenderer(model.getColumnClass(i)).
          getTableCellRendererComponent(
          table, longValues[i],
          false, false, 0, i);


      cellWidth = comp.getPreferredSize().width;

      //XXX: Before Swing 1.1 Beta 2, use setMinWidth instead.
      column.setPreferredWidth(Math.max(headerWidth, cellWidth));
      column.setMinWidth(Math.max(headerWidth, cellWidth));
//      column.setPreferredWidth(cellWidth);
//      column.setMaxWidth(2);
//System.out.println("TABLE SIZE");
    }
  }

//-------------------------------------------------------------------
  private void setUpPathColumn(TableColumn PathColumn) {
  }

  //--------------------------------------------------------------------

  private void jbInit() throws Exception {

    currentLocale = BridgeApp.getCurrentLocale();
    labels = ResourceBundle.getBundle("dbridge.prop.dsLogViewerDlgBundle",currentLocale);


    jTable1 = new JTable(new LogViewerTableModel(LogViewerData));

    jTable1.setCellSelectionEnabled(true);
    jTable1.setDragEnabled(false);
    jTable1.setSurrendersFocusOnKeystroke(true);


    this.setSize(new Dimension(800, 600));
    this.setTitle(labels.getString("title"));

    this.initColumnSizes(jTable1);
    setUpPathColumn(jTable1.getColumnModel().getColumn(1));

    titledBorder1 = BorderFactory.createTitledBorder(labels.getString("log"));
    this.getContentPane().setLayout(borderLayout1);
    jScrollPane1.setAlignmentX((float) 0.0);
    jScrollPane1.setAlignmentY((float) 0.0);
    jScrollPane1.setBorder(titledBorder1);
    jPanel1.setAlignmentX((float) 0.0);
    jPanel1.setAlignmentY((float) 0.0);
    jPanel1.setBorder(BorderFactory.createEtchedBorder());
    jbCancel.setText(labels.getString("bCancel"));
    jbCancel.addActionListener(new dsLogViewerDlg_jbCancel_actionAdapter(this));
    jbOk.setText(labels.getString("bOk"));
    jbOk.addActionListener(new dsLogViewerDlg_jbOk_actionAdapter(this));
    jbRefresh.setText(labels.getString("bRefresh"));
    jbRefresh.addActionListener(new dsLogViewerDlg_jbRefresh_actionAdapter(this));
    borderLayout1.setHgap(0);
    this.getContentPane().add(jScrollPane1, BorderLayout.CENTER);
    this.getContentPane().add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(jbOk, null);
    jPanel1.add(jbCancel, null);
    jPanel1.add(jbRefresh, null);
    jScrollPane1.getViewport().add(jTable1, null);
  }

//============== DEBUG main method ============================================
//  public static void main(String[] args) /*throws HeadlessException*/ {
//    dsLogViewerDlg dsLogViewerDlg1 = new dsLogViewerDlg(null, false);
//
//    LogTableBuilder mTableBuilder = new LogTableBuilder("Bank");
//    LogParser mParser = new LogParser(mTableBuilder, "2004-9-29-14.log");
//    Vector data = mTableBuilder.getTableData();
//    dsLogViewerDlg1.setData(data);

//    dsLogViewerDlg1.setVisible(true);
//  }
//=============================================================================

  void jbOk_actionPerformed(ActionEvent e) {
    mOk = true;
    mInitThread.setStop();
	this.dispose();
    //this.setVisible(false);
  }

  void jbCancel_actionPerformed(ActionEvent e) {
    mOk = false;
    mInitThread.setStop();
	this.dispose();
    //this.setVisible(false);
  }

  void jbRefresh_actionPerformed(ActionEvent e) {
     // reread the table from the logfile
	 //mInitThread.setStop();
     if ( mLogName!=null && mFileName!=null ){
       fillTable();
     }
     //int max_val=jScrollPane1.getVerticalScrollBar().getMaximum();
     //System.out.println("Scroll max Value = "+max_val);
     //int val=jScrollPane1.getVerticalScrollBar().getValue();
     //jScrollPane1.getVerticalScrollBar().setValue(max_val);
     //System.out.println("Scroll Value = "+val);
  }

  boolean isOk(){return mOk;}

}// end class

class dsLogViewerDlg_jbOk_actionAdapter implements java.awt.event.ActionListener {
  dsLogViewerDlg adaptee;

  dsLogViewerDlg_jbOk_actionAdapter(dsLogViewerDlg adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jbOk_actionPerformed(e);
  }
}

class dsLogViewerDlg_jbCancel_actionAdapter implements java.awt.event.ActionListener {
  dsLogViewerDlg adaptee;

  dsLogViewerDlg_jbCancel_actionAdapter(dsLogViewerDlg adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jbCancel_actionPerformed(e);
  }
}

class dsLogViewerDlg_jbRefresh_actionAdapter implements java.awt.event.ActionListener {
  dsLogViewerDlg adaptee;

  dsLogViewerDlg_jbRefresh_actionAdapter(dsLogViewerDlg adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.jbRefresh_actionPerformed(e);
  }
}



