package dbridge;

import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;

import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreeSelectionModel;
import javax.swing.tree.MutableTreeNode;
import javax.swing.tree.TreePath;
import javax.swing.event.*;
import java.net.URL;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

/*
 * Created 30.10.04 BOB
 * Modified 7.11.04 BOB
 * Modified 9.11.04 BOB
 * Modified 10.11.04 BOB
 * Modified 28.11.04 BOB
 * Modified 1.03.05-15.04.05
 * Modified 14.06.05-19.06.05
 */

interface DBReloadInterface {
  public void reloadDB();

  public void saveDB(boolean updateGUI);

  public UserContainer getUserContainer();

  public ResourceBundle getResourceBundle();

  public ChangesTracker getChangesTracker();
}

interface UserController {
  public void addUser(dbUser user);

  public void deleteSelectedUser();

  public dbUser getSelectedUser();

  public ResourceBundle getResourceBundle();

  public UserContainer getUserContainer();

  public ChangesTracker getChangesTracker();
}

interface ServerController {
  public void addServer();

  public void deleteSelectedServer();

  public dsDcmServerClass getSelectedDcmServer();

  public ResourceBundle getResourceBundle();

  public Vector getDcmServers();

  public ChangesTracker getChangesTracker();

  public void changeDCMName(String name);
}

class ChangesTracker {
  public boolean PasswordChanged = false;
  public boolean MIMEChanged = false;
  public boolean INIChanged = false;
  public boolean UsersChanged = false;
  public boolean ServersChanged = false;

  public boolean needDBupdate() {
    boolean result = false;
    if (PasswordChanged || MIMEChanged || INIChanged || UsersChanged ||
        ServersChanged) {
      result = true;

    }
    return result;

  }
}

class userGUIObject {

  private Object mObj = null;
  private UserController mController = null;

  public userGUIObject(Object obj, UserController container) {
    mObj = obj;
    mController = container;
  }

  public Object getObject() {
    return mObj;
  }

  public UserContainer getContainer() {
    return mController.getUserContainer();
  }

  public String toString() {
    return mObj.toString();
  }

}

public class dsMainForm
    extends JFrame
    implements DBReloadInterface,
    UserController,
    ServerController {

  public static String ADD_COMMAND = "add";
  public static String REMOVE_COMMAND = "remove";
  public static String COPY_COMMAND = "copy";
  private dsUserSettings mManUserGUI = null;
  private dsAutoUserSettings mAutoUserGUI = null;
  private dsSMTPPanel mSMTPPan = null;
  private dsPOPPanel mPOPPan = null;
  private dsADDRPanel mADDRPan = null;
  private dsDcmServPan mDcmServGUI = null;
  private dsDcmServPan mDcmServGUI_static = null;
  

  //-------- Local copy of DB --------------------------
  private UserContainer mUserContainer = null;
  private Vector mDCMServers = null;

  //----------------------------------------------------

  private ChangesTracker mChangesTracker = null;

  private dsAdminTreeSelListener mAdmTreeListener = null;

  public ResourceBundle lbls;
  BorderLayout borderLayout1 = new BorderLayout();

  //JScrollPane jspMainContainer = new JScrollPane();
  dsMainTreeSelListener jspMainContainer = new dsMainTreeSelListener();
  JPanel jPanel1 = new JPanel();
  JButton jbHelp = new JButton();
  JButton jbCancel = new JButton();
  JButton jbClose = new JButton();
  JButton jbApply = new JButton();
  JTabbedPane jTabbedPane1 = new JTabbedPane();

  JScrollPane jspAdminTree = new JScrollPane();

  JTree mAdminTree = null;
  JTree mUserTree = null;
  JTree mServerTree = null;

  private DefaultMutableTreeNode rootNode;
  private DefaultMutableTreeNode DCMrootNode;
  private DefaultMutableTreeNode AdminrootNode;
  private DefaultTreeModel treeModel;

  private class dsUserTreeTab
      extends JPanel {
    Box mBox;
    BorderLayout mainLayout = new BorderLayout();
    JScrollPane jScrollPane1 = new JScrollPane();
    JTree mTree = null;
    JPanel jpButtons = new JPanel();
    Box mButtonBox;
    JButton jbAdd = new JButton();
    JButton jbRemove = new JButton();
    JButton jbCopy = new JButton();

    private String mName;

    //private ActionListener mActionHandler;

    public dsUserTreeTab(ActionListener actionHandler, String Name, JTree jTree) {
      mName = Name;
      mTree = jTree;
      //mActionHandler = actionHandler;

      mBox = Box.createVerticalBox();

      mButtonBox = Box.createVerticalBox();
      Dimension bt_max = new Dimension(200, 23);
      Dimension bt_min = new Dimension(80, 23);
      Dimension bt_pref = new Dimension(120, 23);
      jbAdd.setMaximumSize(bt_max);
      jbAdd.setMinimumSize(bt_min);
      jbAdd.setPreferredSize(bt_pref);
      jbAdd.setText(lbls.getString("bAdd"));
      jbAdd.setIcon(new ImageIcon("./lib/res/plus.gif"));
      jbAdd.setActionCommand(ADD_COMMAND);
      jbAdd.addActionListener(actionHandler);
      //jbAdd.addActionListener(new dsUserTreeTab_jbAdd_actionAdapter(this));

      jbRemove.setMaximumSize(bt_max);
      jbRemove.setMinimumSize(bt_min);
      jbRemove.setPreferredSize(bt_pref);
      jbRemove.setText(lbls.getString("bRemove"));
      jbRemove.setIcon(new ImageIcon("./lib/res/minus.gif"));
      jbRemove.setActionCommand(REMOVE_COMMAND);
      jbRemove.addActionListener(actionHandler);

      jbCopy.setMaximumSize(bt_max);
      jbCopy.setMinimumSize(bt_min);
      jbCopy.setPreferredSize(bt_pref);
      jbCopy.setText(lbls.getString("bCopy"));
      jbCopy.setIcon(new ImageIcon("./lib/res/copy.png"));
      jbCopy.setActionCommand(COPY_COMMAND);
      jbCopy.addActionListener(actionHandler);

      mButtonBox.add(jbAdd);
      mButtonBox.add(jbRemove);
      mButtonBox.add(jbCopy);

      jpButtons.add(mButtonBox);
      jpButtons.setBorder(BorderFactory.createEtchedBorder());

      jScrollPane1.setBorder(BorderFactory.createEtchedBorder());
      jScrollPane1.getViewport().add(mTree, null);

      mBox.add(jScrollPane1);
      mBox.add(jpButtons);

      this.setLayout(mainLayout);
      this.add(mBox, BorderLayout.CENTER);

    }

    public String toString() {
      return mName;
    }

//    public void actionPerformed(ActionEvent e) {
//      mActionHandler.actionPerformed(e);
//    }
  }

  public dsMainForm() throws HeadlessException {

    Locale currentLocale = BridgeApp.getCurrentLocale();
    lbls = ResourceBundle.getBundle("dbridge.prop.dsMainFormBundle",
                                    currentLocale);
    this.makeLocalDBCopy();
    DBridgeClient.setIsAdminGUIActivated(true);

    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public void closeButtonPressed() {

    this_windowClosed(null);

  }

  public void helpButtonPressed() {

    URL index = ClassLoader.getSystemResource(lbls.getString("HlpURL"));
    if (index != null) {
      new XHelp(lbls.getString("HlpTitle"), index);
    }
    //new XHelp("DBridge Admin Help"+DBridgeClient.Bank().getVersion(), index);
  }

  public void cancelButtonPressed() {
    if (mChangesTracker.needDBupdate()) {
      this.reloadDB();
    }
  }

  public void addUser(dbUser user) {
    // Update GUI
    addNewUserGUI(user);
    // Update Local DB copy
    mUserContainer.append(user);
    mChangesTracker.UsersChanged = true;
  }

  public void deleteSelectedUser() {
    //1 getSelectedUser
    dbUser temp = this.getSelectedUser();
    if (temp != null) {
      //2 RM from GUI
      this.RemoveSelUserGUI();
      //3 RM from DB
      this.getUserContainer().delete(temp);

      mChangesTracker.UsersChanged = true;
    }

  }

  public void addServer() {
    dsDcmServerClass new_srv = new dsDcmServerClass();
    new_srv.setDcmServer("New Server");
    //add GUI
    this.addNewDcmSrvGUI(new_srv);
    //add DB entry
    this.getDcmServers().add(new_srv);

    mChangesTracker.ServersChanged = true;
  }

  public void deleteSelectedServer() {
    dsDcmServerClass sel_srv = this.getSelectedDcmServer();
    if (sel_srv != null) {
      this.RemoveSelSrvGUI();
      this.getDcmServers().remove(sel_srv);

      mChangesTracker.ServersChanged = true;
    }
  }

  public ResourceBundle getResourceBundle() {
    return lbls;
  }

  public void reloadDB() {
    this.makeLocalDBCopy();
    this.load_User_Srv_TreeData();
    mUserTree.updateUI();
    mServerTree.updateUI();

    JOptionPane.showMessageDialog(this, lbls.getString("db_restored"),
                                  lbls.getString("info"),
                                  JOptionPane.PLAIN_MESSAGE);
  }

  public ChangesTracker getChangesTracker() {
    return mChangesTracker;
  }

  public void makeLocalDBCopy() {
    mUserContainer = (UserContainer) DBridgeClient.Bank().
        getUserContainer().clone();
    mDCMServers = (Vector) DBridgeClient.Bank().getDcmServerList().clone();
  }

  public UserContainer getUserContainer() {
    return mUserContainer;
  }

  public Vector getDcmServers() {
    return mDCMServers;
  }

  public void this_windowClosed(WindowEvent e) {
    DBridgeClient.setIsAdminGUIActivated(false);

    if (mManUserGUI != null) {
      mManUserGUI.invalidate();
    }
    if (mAutoUserGUI != null) {
      mAutoUserGUI.invalidate();
    }
    if (mSMTPPan != null) {
      mSMTPPan.invalidate();
    }
    if (mPOPPan != null) {
      mPOPPan.invalidate();
    }
    if (mADDRPan != null) {
      mADDRPan.invalidate();
    }
    if (mDcmServGUI != null) {
      mDcmServGUI.invalidate();
    }
    if (mDcmServGUI_static != null) {
        mDcmServGUI_static.invalidate();
    }
    this.setVisible(false);
    this.invalidate();
  }

  private void jbInit() throws Exception {
    setIconImage(Toolkit.getDefaultToolkit().getImage(DBConsts.
        WINDOW_ICON_FILENAME));
    mChangesTracker = new ChangesTracker();

    this.addWindowListener(new dsMainForm_windowAdapter(this));

    mManUserGUI = new dsUserSettings(this);
    mAutoUserGUI = new dsAutoUserSettings(this);
    mSMTPPan = new dsSMTPPanel(this);
    mPOPPan = new dsPOPPanel(this);
    mADDRPan = new dsADDRPanel(this);
    mDcmServGUI = new dsDcmServPan(this);
    mDcmServGUI_static = new dsDcmServPan(this);
    mDcmServGUI_static.setEditableFlag(false);
    

    this.setSize(dsAlignments.NORMAL_SIZE);
    this.setTitle(lbls.getString("FormTitle"));

    this.getContentPane().setLayout(borderLayout1);

    jbApply.setText(lbls.getString("bApply"));
    jbApply.addActionListener(new ApplyBtnListener(this));
    jbApply.setIcon(new ImageIcon("./lib/res/thumbup.gif"));
    jbCancel.setText(lbls.getString("bCancel"));
    jbCancel.setIcon(new ImageIcon("./lib/res/fingerleft.png"));
    jbCancel.addActionListener(new CancelBtnListener(this));
    jbHelp.setText(lbls.getString("bHelp"));
    jbHelp.setIcon(new ImageIcon("./lib/res/opendoc.gif"));
    jbHelp.addActionListener(new HelpBtnListener(this));
    jbClose.setText(lbls.getString("bClose"));
    jbClose.setIcon(new ImageIcon("./lib/res/thumbdown.gif"));
    jbClose.addActionListener(new CloseBtnListener(this));
    jPanel1.setBorder(BorderFactory.createEtchedBorder());
    //this.getContentPane().add(box1,  BorderLayout.WEST);
    jTabbedPane1.setMinimumSize(new Dimension(200, 121));
    jTabbedPane1.setPreferredSize(new Dimension(200, 424));
    jTabbedPane1.addChangeListener(new dsMainForm_jTabbedPane1_changeAdapter(this));
    this.getContentPane().add(jspMainContainer, BorderLayout.CENTER);
    this.getContentPane().add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(jbApply, null);
    jPanel1.add(jbCancel, null);
    jPanel1.add(jbClose, null);
    jPanel1.add(jbHelp, null);

    this.getContentPane().add(jTabbedPane1, BorderLayout.WEST);

    //
    //       USER TREE CREATION
    //
    rootNode = new DefaultMutableTreeNode("Root Node");
    treeModel = new DefaultTreeModel(rootNode);
    treeModel.addTreeModelListener(new MyTreeModelListener());

    mUserTree = new JTree(treeModel);
    mUserTree.addTreeSelectionListener(jspMainContainer);

    //======= Reload User Tree ========
    //rootNode.removeAllChildren();
    //this.createUsersNodes(rootNode);
    //treeModel.reload();
    //=========================

    mUserTree.setRootVisible(false);
    mUserTree.getSelectionModel().setSelectionMode
        (TreeSelectionModel.SINGLE_TREE_SELECTION);
    mUserTree.setShowsRootHandles(true);
    mUserTree.setSelectionRow(0);
    dsUserTreeTab mUsersTab = new dsUserTreeTab(new UserBtnListener(this),
                                                "users1", mUserTree);

    //
    //     SERVER TREE CREATION
    //

    DCMrootNode = new DefaultMutableTreeNode("Root Node");

    //===========Reload srv tree================
    //DCMrootNode.removeAllChildren();
    //this.createDcmServsNodes(DCMrootNode);
    //=======================================

    //Vector vectorServerData = mBank.getDcmServerList();
    mServerTree = new JTree(DCMrootNode);
    mServerTree.addTreeSelectionListener(jspMainContainer);
    mServerTree.setRootVisible(false);
    mServerTree.getSelectionModel().setSelectionMode
        (TreeSelectionModel.SINGLE_TREE_SELECTION);
    mServerTree.setSelectionRow(0);
    // OOO set fields unchanged !!!
    //
    dsUserTreeTab mServerTab = new dsUserTreeTab(new SrvBtnListener(this),
                                                 "servers1", mServerTree);

    this.load_User_Srv_TreeData();
    mUserTree.updateUI();
    mServerTree.updateUI();
    //
    //    ADMIN TREE CREATION
    //

    AdminrootNode = new DefaultMutableTreeNode("Root Node");

    AdminrootNode.removeAllChildren();
    this.createAdminNodes(AdminrootNode);

    mAdminTree = new JTree(AdminrootNode);

    mAdmTreeListener = new dsAdminTreeSelListener(mAdminTree,
                                                  jspMainContainer,
                                                  this);
    mAdminTree.addTreeSelectionListener(mAdmTreeListener);
    mAdminTree.setRootVisible(false);
    mAdminTree.getSelectionModel().setSelectionMode
        (TreeSelectionModel.SINGLE_TREE_SELECTION);
    mAdminTree.setSelectionRow(0);
    jspAdminTree.getViewport().add(mAdminTree, null);

    //
    // Set Panel Listeners
    //
    dsSMTPPanelActionListener listener = new dsSMTPPanelActionListener(mSMTPPan);
    mSMTPPan.setActionListener(listener);

    dsPOPPanelActionListener listener2 = new dsPOPPanelActionListener(mPOPPan);
    mPOPPan.setActionListener(listener2);

    dsADDRPanelActionListener listener3 = new dsADDRPanelActionListener(
        mADDRPan);
    mADDRPan.setActionListener(listener3);

    jTabbedPane1.add(jspAdminTree, lbls.getString("TAB_admin"));
    jTabbedPane1.add(mUsersTab, lbls.getString("TAB_users"));
    jTabbedPane1.add(mServerTab, lbls.getString("TAB_servers"));

    jTabbedPane1.setBorder(BorderFactory.createEmptyBorder());

  }

  private void load_User_Srv_TreeData() {

    //======= Reload User Tree ========
    rootNode.removeAllChildren();
    this.createUsersNodes(rootNode);
    treeModel.reload();

    //===========Reload srv tree================
    DCMrootNode.removeAllChildren();
    this.createDcmServsNodes(DCMrootNode);
    //=======================================
  }

  public void ApplyChanges() {
    boolean result = false;

    //0. Save all not saved Tree objects
    dsTreeObject sel;
    //a. SAVE USER TREE object
    if (mUserTree.getLastSelectedPathComponent() != null) {
      sel = (dsTreeObject) ( (DefaultMutableTreeNode)
                            mUserTree.getLastSelectedPathComponent()).
          getUserObject();
      sel.saveState();

    }

    //b. SAVE SERVER TREE object
    if (mServerTree.getLastSelectedPathComponent() != null) {
      sel = (dsTreeObject) ( (DefaultMutableTreeNode)
                            mServerTree.getLastSelectedPathComponent()).
          getUserObject();
      sel.saveState();
    }

    //1. Verify Admin Password
    if (mChangesTracker.PasswordChanged) {
      if (!mAdmTreeListener.InfoPanel.check()) {
        //1.2 Show the Panel
        return;
      }
      else {
        mUserContainer.getUser("admin").setPassword(
            mAdmTreeListener.InfoPanel.getPassword());
      }
    }

    //2. Save Mime Changes
    if (mChangesTracker.MIMEChanged) {
      if (mAdmTreeListener.mimeEdit.isChanged()) {
        mAdmTreeListener.mimeEdit.saveFile();
      }
    }
    //3. Save Ini Changes
    if (mChangesTracker.INIChanged) {
      if (mAdmTreeListener.iniEdit.isChanged()) {
        mAdmTreeListener.iniEdit.saveFile();
      }
    }

    saveDB(false);

  }

  public void saveDB(boolean updateGUI) {
    //4. Save Users Changes
    if (mChangesTracker.UsersChanged || mChangesTracker.PasswordChanged) {
      //TODO: Check if user has correct servers
        
      //Save Users
      DBridgeClient.Bank().setUserContainer(mUserContainer);
      DBridgeClient.Bank().flush();
    }

    //5. Save Servers Changes
    if (mChangesTracker.ServersChanged) {
      //TODO Check

      // Save servers
      DBridgeClient.Bank().setDcmServerList(mDCMServers);
      DBridgeClient.Bank().flushDcmServerList();
    }

    if (mChangesTracker.needDBupdate()) {
      DBridgeClient.sendRequest("DBRESTART");

      JOptionPane.showMessageDialog(this, lbls.getString("db_changed"),
                                    lbls.getString("info"),
                                    JOptionPane.PLAIN_MESSAGE);
    }

    if (updateGUI) {
      this.load_User_Srv_TreeData();
      mUserTree.updateUI();
      mServerTree.updateUI();
    }

  }

  private void createUsersNodes(DefaultMutableTreeNode top) {
//System.out.println("Create Users");
    Vector vectorUserData = mUserContainer.getUsersVector();
    for (int i = 0; i < vectorUserData.size(); i++) {
      //dbUser currUser = new dbUser();
      //currUser.copy((dbUser) vectorUserData.get(i));
      dbUser currUser = (dbUser) vectorUserData.get(i);
//System.out.println(currUser);
      int uID = currUser.getID();
      if (uID > 99 && uID < 999) {
        top.add(createManualUserNodes(currUser));
      }
      else if (currUser.getID() > 999) {
        dsTreeObject currLeaf = new dsTreeObject(new userGUIObject(currUser, this),
                                                 mAutoUserGUI);
        DefaultMutableTreeNode currNode =
            new DefaultMutableTreeNode(currLeaf);
        top.add(currNode);

      }
    }
  }

  private DefaultMutableTreeNode createManualUserNodes(dbUser user) {
    dsTreeObject currLeaf = new dsTreeObject(new userGUIObject(user, this),
                                             mManUserGUI);
    DefaultMutableTreeNode currNode =
        new DefaultMutableTreeNode(currLeaf);
    DefaultMutableTreeNode currSubNode1 =
        new DefaultMutableTreeNode(new dsTreeObject(
        lbls.getString("SMTP"),
        new userGUIObject(user, this),
        mSMTPPan));
    DefaultMutableTreeNode currSubNode2 =
        new DefaultMutableTreeNode(new dsTreeObject(
        lbls.getString("POP"),
        user.getMailTable(),
        mPOPPan));
    DefaultMutableTreeNode currSubNode3 =
        new DefaultMutableTreeNode(new dsTreeObject(
        lbls.getString("ADDR_BOOK"),
        user,
        mADDRPan));

    currNode.add(currSubNode1);
    currNode.add(currSubNode2);
    currNode.add(currSubNode3);

    return currNode;
    //top.add(currNode);

  }

  private void createDcmServsNodes(DefaultMutableTreeNode top) {

	if (mDCMServers.size()>0){
		DefaultMutableTreeNode curr = new DefaultMutableTreeNode(
		          new dsTreeObject(
		          mDCMServers.get(0),
		          mDcmServGUI_static));
		      top.add(curr);
	}  
    for (int i = 1; i < mDCMServers.size(); i++) {
      DefaultMutableTreeNode curr = new DefaultMutableTreeNode(
          new dsTreeObject(
          mDCMServers.get(i),
          mDcmServGUI));
      top.add(curr);
    }

  }

  private void createAdminNodes(DefaultMutableTreeNode top) {
    DefaultMutableTreeNode nodeSett = null;
    DefaultMutableTreeNode nodeMIME = null;
    DefaultMutableTreeNode nodePGP = null;
    DefaultMutableTreeNode nodeINI = null;
    DefaultMutableTreeNode nodeBACKUP = null;
    DefaultMutableTreeNode nodeROUT = null;

    nodeSett = new DefaultMutableTreeNode(new dsTreeLeaf(lbls.getString(
        "settings"), null));
    nodeMIME = new DefaultMutableTreeNode(new dsTreeLeaf(lbls.getString("mime"), null));
    nodePGP = new DefaultMutableTreeNode(new dsTreeLeaf(lbls.getString("pgp"), null));
    nodeINI = new DefaultMutableTreeNode(new dsTreeLeaf(lbls.getString(
        "iniFile"), null));
    nodeBACKUP = new DefaultMutableTreeNode(new dsTreeLeaf(lbls.getString(
        "backup"), null));
    nodeROUT = new DefaultMutableTreeNode(new dsTreeLeaf(lbls.getString(
        "rout"), null));

    top.add(nodeSett);
    top.add(nodeMIME);
    top.add(nodePGP);
    top.add(nodeINI);
    top.add(nodeROUT);
    top.add(nodeBACKUP);

  }

  public void addNewUserGUI(dbUser user) {
    if (user.isManual()) {
      DefaultMutableTreeNode curr = this.createManualUserNodes(user);
      treeModel.insertNodeInto(curr,
                               rootNode,
                               rootNode.getChildCount());
      mUserTree.expandPath(new TreePath(curr.getPath()));

    }
    else if (user.isAutomatic()) {
      dsTreeObject currLeaf = new dsTreeObject(new userGUIObject(user, this),
                                               mAutoUserGUI);
      addObject(mUserTree, currLeaf, true);
    }
  }

  public void addNewDcmSrvGUI(dsDcmServerClass srv) {
    String name = srv.getDcmServer() + ":" + srv.getDcmPort() +
        "                        ";
    DefaultMutableTreeNode curr = new DefaultMutableTreeNode(
        new dsTreeObject(name, srv, mDcmServGUI));
    DCMrootNode.add(curr);
    mServerTree.updateUI();
  }

  public void changeDCMName(String name) {
    DefaultMutableTreeNode sel_node = (DefaultMutableTreeNode)
        mServerTree.getLastSelectedPathComponent();

    if (sel_node != null) {
      dsTreeObject sel_leaf = (dsTreeObject) sel_node.getUserObject();
      sel_leaf.setName(name);
      mServerTree.updateUI();
    }
    else {
      //Nothing selected
    }

  }

  public dsDcmServerClass getSelectedDcmServer() {
    dsDcmServerClass result = null;
    DefaultMutableTreeNode sel_node = (DefaultMutableTreeNode)
        mServerTree.getLastSelectedPathComponent();

    if (sel_node != null) {
      dsTreeObject sel_leaf = (dsTreeObject) sel_node.getUserObject();
      result = (dsDcmServerClass) sel_leaf.getObject();

    }
    else {
      JOptionPane.showMessageDialog(null, lbls.getString("sel_err"));
    }

    return result;

  }

  public void RemoveSelSrvGUI() {
    DefaultMutableTreeNode sel_node = (DefaultMutableTreeNode)
        mServerTree.getLastSelectedPathComponent();

    int selRow = mServerTree.getRowForPath(mServerTree.getSelectionPath());
    selRow--;
    if (selRow > -1) {
      mServerTree.setSelectionRow(selRow);
    }

    ( (DefaultTreeModel) mServerTree.getModel()).removeNodeFromParent(sel_node);
  }

  public dbUser getSelectedUser() {
    dbUser result = null;
    DefaultMutableTreeNode sel_node = (DefaultMutableTreeNode)
        mUserTree.getLastSelectedPathComponent();
    if (sel_node != null) {
      dsTreeObject sel_leaf = (dsTreeObject) sel_node.getUserObject();

      // The dbUser is either the parent of selected smtp, pop, addr_book leafs
      // or selected leaf itself

      if (sel_leaf.toString().equals(lbls.getString("SMTP")) ||
          sel_leaf.toString().equals(lbls.getString("POP")) ||
          sel_leaf.toString().equals(lbls.getString("ADDR_BOOK"))) {

        dsTreeObject parent = (dsTreeObject) ( (DefaultMutableTreeNode)
                                              sel_node.
                                              getParent()).getUserObject();
        result = (dbUser) ( (userGUIObject) parent.getObject()).getObject();
      }
      else {
        result = (dbUser) ( (userGUIObject) sel_leaf.getObject()).getObject();
      }

    }
    else {
      JOptionPane.showMessageDialog(null, lbls.getString("sel_err"));
    }

    return result;
  }

  public void RemoveSelUserGUI() {
    DefaultMutableTreeNode sel_node = (DefaultMutableTreeNode)
        mUserTree.getLastSelectedPathComponent();
    dsTreeObject sel_leaf = (dsTreeObject) sel_node.getUserObject();

    TreePath path = mUserTree.getSelectionPath();
    int Row = mUserTree.getRowForPath(path);
    // The dbUser is either the parent of selected smtp, pop, addr_book leafs
    // or selected leaf itself

    if (sel_leaf.toString().equals(lbls.getString("SMTP")) ||
        sel_leaf.toString().equals(lbls.getString("POP")) ||
        sel_leaf.toString().equals(lbls.getString("ADDR_BOOK"))) {

      path = path.getParentPath();
      Row = mUserTree.getRowForPath(path);

      DefaultMutableTreeNode prev = (DefaultMutableTreeNode) sel_node.getParent();
      treeModel.removeNodeFromParent(prev);

    }
    else {
      treeModel.removeNodeFromParent(sel_node);
    }

    if (mUserTree.getRowCount() > -1) {
      Row--;
      mUserTree.setSelectionRow(Row);
    }

  }

//========================================================================
// From Sun Java "How to use tree" tutorial
// http://java.sun.com/docs/books/tutorial/uiswing/components/tree.html#dynamic
//========================================================================

  /** Remove the currently selected node. */
  public void removeCurrentNode(JTree tree) {
    TreePath currentSelection = tree.getSelectionPath();
    if (currentSelection != null) {
      DefaultMutableTreeNode currentNode = (DefaultMutableTreeNode)
          (currentSelection.getLastPathComponent());
      MutableTreeNode parent = (MutableTreeNode) (currentNode.getParent());
      if (parent != null) {
        treeModel.removeNodeFromParent(currentNode);
        return;
      }
    }

    // Either there was no selection, or the root was selected.
    //toolkit.beep();
  }

  public DefaultMutableTreeNode addObject(JTree tree,
                                          Object child,
                                          boolean shouldBeVisible) {

    DefaultMutableTreeNode parent = rootNode;
    DefaultMutableTreeNode childNode =
        new DefaultMutableTreeNode(child);

    if (parent == null) {
      parent = rootNode;
    }

    treeModel.insertNodeInto(childNode, parent,
                             parent.getChildCount());

    //Make sure the user can see the lovely new node.
    if (shouldBeVisible) {
      tree.scrollPathToVisible(new TreePath(childNode.getPath()));
    }
    return childNode;
  }

  class MyTreeModelListener
      implements TreeModelListener {
    public void treeNodesChanged(TreeModelEvent e) {
      DefaultMutableTreeNode node;
      node = (DefaultMutableTreeNode)
          (e.getTreePath().getLastPathComponent());

      /*
       * If the event lists children, then the changed
       * node is the child of the node we've already
       * gotten.  Otherwise, the changed node and the
       * specified node are the same.
       */
      try {
        int index = e.getChildIndices()[0];
        node = (DefaultMutableTreeNode)
            (node.getChildAt(index));
      }
      catch (NullPointerException exc) {}

      System.out.println("The user has finished editing the node.");
      System.out.println("New value: " + node.getUserObject());
    }

    public void treeNodesInserted(TreeModelEvent e) {
    }

    public void treeNodesRemoved(TreeModelEvent e) {
    }

    public void treeStructureChanged(TreeModelEvent e) {
    }
  }

  void jTabbedPane1_stateChanged(ChangeEvent e) {
    //
    // USERS TAB
    //
    if (jTabbedPane1.getSelectedIndex() == 0) {
      this.jspMainContainer.setActiveTree(null);
      mAdmTreeListener.valueChanged(null);
    }
    else if (jTabbedPane1.getSelectedIndex() == 1) {
      this.jspMainContainer.setActiveTree(mUserTree);
      jspMainContainer.valueChanged(null);
    }
    else if (jTabbedPane1.getSelectedIndex() == 2) {
      this.jspMainContainer.setActiveTree(mServerTree);
      jspMainContainer.valueChanged(null);
    }
    else {

    }

  }

//===== DEBUG ========================================================
  public static void main(String[] args) throws HeadlessException {
    dsMainForm dsMainForm1 = new dsMainForm();
    dsMainForm1.setVisible(true);
  }

//===================================================================

}

class dsMainForm_jTabbedPane1_changeAdapter
    implements javax.swing.event.ChangeListener {
  dsMainForm adaptee;

  dsMainForm_jTabbedPane1_changeAdapter(dsMainForm adaptee) {
    this.adaptee = adaptee;
  }

  public void stateChanged(ChangeEvent e) {
    adaptee.jTabbedPane1_stateChanged(e);
  }
}

class dsMainForm_windowAdapter
    extends java.awt.event.WindowAdapter {
  dsMainForm adaptee;

  dsMainForm_windowAdapter(dsMainForm adaptee) {
    this.adaptee = adaptee;
  }

  public void windowClosing(WindowEvent e) {
    adaptee.this_windowClosed(e);
  }
}
