package dbridge;

import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;
import javax.swing.JTree;
import java.awt.Container;
import java.util.ResourceBundle;
import javax.swing.*;
import java.awt.*;


/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

class dsTreeObject{

  private dsGUIInterface mGUI;
  private Object mDBObj;
  private String mName=null;

  public dsTreeObject(Object obj, dsGUIInterface gui){
    mDBObj = obj;
    mGUI =  gui;
  }

  public dsTreeObject(String name, Object obj, dsGUIInterface gui) {
    mName = name;
    mDBObj = obj;
    mGUI = gui;
  }

  public void setName(String name){
    mName=name;
  }


  public String toString() {
    String res = null;
    if (mName!=null) res = mName;
    else res = mDBObj.toString();
    return res;
  }

  public Container getGUI(){
    mGUI.setObject(mDBObj);
    return (Container) mGUI;
  }

  public void saveState(){
    mGUI.saveState();
  }

  public Object getObject(){
    return mDBObj;
  }
}


public class dsMainTreeSelListener extends JPanel implements TreeSelectionListener{
  private  dsTreeObject mLastSelection = null;
  private JTree mTree = null;

  public dsMainTreeSelListener() {
    this.setLayout(new GridLayout(1,1));
  }

  public void setActiveTree(JTree tree){
    mTree = tree;
  }

  public void valueChanged(TreeSelectionEvent e) {
    if (mTree!=null){
      DefaultMutableTreeNode node = (DefaultMutableTreeNode)
         mTree.getLastSelectedPathComponent();

     if (node == null)return;
     if (mLastSelection !=null) mLastSelection.saveState();
     mLastSelection = (dsTreeObject) node.getUserObject();

 //    this.getViewport().removeAll();
 //    this.getViewport().add(mLastSelection.getGUI());
 //    this.getViewport().updateUI();

     this.removeAll();
     this.add(mLastSelection.getGUI());
     this.updateUI();


    }
  }

}

class dsAdminTreeSelListener implements TreeSelectionListener{
  private JPanel mGui;
  private JTree mTree;
  private ResourceBundle lbls;
  private DBReloadInterface mGUIreloader;

  public dsAdminSettingsPan InfoPanel=null;
  //public dsIniFileEditFrame mimeEdit = null;
  public dsFileEditSettingsPan mimeEdit = null;
  public dsFileEditSettingsPan iniEdit = null;
  private XDERouter mXRouter = null;

  public dsAdminTreeSelListener(JTree tree,
                                JPanel gui_proc,
                                DBReloadInterface res_int){
    mGUIreloader = res_int;
    mGui = gui_proc;
    lbls = mGUIreloader.getResourceBundle();
    mTree = tree;
 }

  public void valueChanged(TreeSelectionEvent e){
    DefaultMutableTreeNode node = (DefaultMutableTreeNode)
        mTree.getLastSelectedPathComponent();

    if (node == null)return;

    dsTreeLeaf nodeInfo = (dsTreeLeaf) node.getUserObject();
    if (!nodeInfo.isInitiated()){
      Container m_pan1;
      if (nodeInfo.toString().equals(lbls.getString("settings"))) {
        InfoPanel = new dsAdminSettingsPan(mGUIreloader.getChangesTracker());
        m_pan1 = InfoPanel;
      }
      else if (nodeInfo.toString().equals(lbls.getString("mime"))) {
        //mimeEdit = new  dsIniFileEditFrame("mime.types");
        //mimeEdit.setPanelMode();
        //m_pan1 = mimeEdit.getContentPane();
        mimeEdit = new dsFileEditSettingsPan(lbls.getString("mime"), "mime.types");
        m_pan1 = mimeEdit;
        mGUIreloader.getChangesTracker().MIMEChanged = true;
      }
      else if (nodeInfo.toString().equals(lbls.getString("pgp"))) {
        dsGPGKeyDialog gpg = new dsGPGKeyDialog(null, false);
        gpg.setPanelMode();
        m_pan1 = gpg.getContentPane();
      }
      else if (nodeInfo.toString().equals(lbls.getString("iniFile"))) {
//        iniEdit = new  dsIniFileEditFrame("DBridge.ini");
//        iniEdit.setPanelMode();
//        m_pan1 = iniEdit.getContentPane();

        iniEdit = new dsFileEditSettingsPan(lbls.getString("iniFile"), "DBridge.ini");
        m_pan1 = iniEdit;
        mGUIreloader.getChangesTracker().INIChanged = true;
      }
      else if (nodeInfo.toString().equals(lbls.getString("backup"))) {
        dsBackupPan bckGUI = new dsBackupPan(new BackupBtnListener(mGUIreloader));
        m_pan1 = bckGUI;
      }
      else if (nodeInfo.toString().equals(lbls.getString("rout"))) {
        mXRouter = new XDERouter(mGUIreloader);
        m_pan1 = mXRouter.getContentPane();
      }

     else {
       if (nodeInfo.toString().equals(lbls.getString("rout"))) {
         mXRouter.updateDB();
       }

        m_pan1 = new Container();
      }

      mGui.removeAll();
      mGui.add(m_pan1);
      mGui.updateUI();


      nodeInfo.setContainer(m_pan1);

    }
    else {
      Container m_pan1 = nodeInfo.getContainer();
      mGui.removeAll();
      mGui.add(m_pan1);
      mGui.updateUI();
    }


  }
}
