package dbridge;

import java.util.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;

import javax.swing.tree.DefaultMutableTreeNode;
import java.util.Vector;
import java.io.File;
import java.text.SimpleDateFormat;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;
import javax.swing.tree.DefaultTreeCellEditor;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.TreeCellEditor;
import javax.swing.tree.TreeNode;

import javax.swing.JTable;
import javax.swing.table.AbstractTableModel;
//import java.util.*;

import javax.swing.DefaultCellEditor;
import javax.swing.text.*;


/**
 *
 * <p>Title: CFileFieds</p>
 * <p>Description: File with the attributes</p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: aITLab</p>
 * @author DcDi & Bob
 * @version 1.0
 */

class CFileFieds extends File
{
        public CFileFieds(File f)
        {
        		super(f.getAbsolutePath());

                mFields=new Vector(6);
                Vector vFileParts=FileTools.getExtensionAndName(f.getName());
                double dSizeKb=f.length();
                dSizeKb/=1024;
                // Name
                mFields.add(vFileParts.get(0));
                // Size
                mFields.add(new String(""+Math.round(dSizeKb)+"KB"));
                // Date
                mFields.add((new SimpleDateFormat()).format(new Date(f.lastModified())));
                // Type
                mFields.add(vFileParts.get(1));
                // TODO xtag
                mFields.add(FileTools.GetStudyId(f.getPath()));
                // File object
                //mFields.add(f);
                //mFile=f;
        }
/*
        public Object clone(){
          CFileFieds res = new CFileFieds(new File(this.getAbsolutePath()));
          res.setDisabled(this.isDisabled());
          return res;
        }
*/
        public Vector Fields() {return mFields;}
        public String GetXTagField() { return (String)mFields.get(XTAG); }
        public String GetNameField() { return (String)mFields.get(NAME); }
        public String GetTypeField() { return (String)mFields.get(TYPE); }
        public String toString() {return GetNameField();}

        public File GetFileObject() {return this;}
        public boolean isDisabled() {return mDisabled;}
        public void setDisabled (boolean disable) {mDisabled = disable;}
        //public static File GetFileObject(Vector vFields) { return (File)vFields.get(5); }
        private Vector mFields;
        //private File mFile;
        // Shows if the file allready in container or not
        private boolean mDisabled = false;
        public static final int NAME = 0;
        public static final int TYPE=3;
        public static final int XTAG = 4;
}


/**
 * <p>Title: dsSelFilesDlg</p>
 * <p>Description: Dialog to Select a files from folders with filters</p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: aITLab</p>
 * @author Bob
 * @version 1.0
 */

public class dsSelFilesDlg extends JDialog implements ListSelectionListener {

  private JDirectoryChooser mDirTree = null;
  private dsFileTable mFileTable = null;
  private File mInit_dir;
  private Vector selExts = null;
  private CFileFolder mCurrentFolder = new CFileFolder();
  private boolean m_Ok = false;

  private Vector m_saved_table_data = new Vector();

  private final static int CHOOSER_TAB = 0;
  private final static int CONTAINER_TAB = 1;

  private dsInfoPanel infoPan=null;
  private JTabbedPane tabber=null;
  private JDialog self = null;


  /**
   * array to temporary hold changed folders parameters
   */
  private Vector mStoredFolders = new Vector();

  private dsSelContainer mSelContainer= null;

  Locale currentLocale;
  ResourceBundle labels;

  JButton m_bOk = null;
  JButton m_bCancel = null;
  JButton m_bRefresh = null;

  JButton m_bFilter = null;
  JButton m_bStudyID = null;
  JButton m_bXTag = null;
  JButton m_bSelAll = null;
  JButton m_bAddToContainer = null;


  private JPopupMenu popup = null;
  JPopupMenu tree_popup = null;
  private JMenuItem miAdd = null;
  private JMenu menuAddTo = null;

  public Vector getXTagCollections(){
    return mSelContainer.getXTagCollections();
  }

  public long getSelectedSize(){
    return mSelContainer.getContainerSize();
  }

  public int getSelectedNum(){
    return mSelContainer.getFileNumber();
  }

  public Vector getAllSelectedFiles(){
    return mSelContainer.getAllFiles();
  }

  public dsSelFilesDlg(File initDir, java.awt.Frame parent, boolean modal) throws HeadlessException {
    super(parent, modal);
    try {
      mInit_dir = initDir;
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void initTableHeader(){
    mFileTable.setHeader();
  }


  public static void main(String[] args) {
   try
	{
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
	    dsSelFilesDlg dsSelFilesDlg1 = new dsSelFilesDlg(new File("/"), null, false);
	    dsSelFilesDlg1.setVisible(true);
            if (dsSelFilesDlg1.isOk()){
	      //Vector sel = dsSelFilesDlg1.getSelectedFiles();
	      //System.out.println(sel);

	    }
	}
  	catch (Exception e)
	{
	}
  }

  public void clearContainer() {
    mSelContainer.removeAll();
    ContainerSelected_action();
  }

  private void jbInit() throws Exception {

    currentLocale = BridgeApp.getCurrentLocale();
    //currentLocale = new Locale("en");
    labels = ResourceBundle.getBundle("dbridge.prop.dsSelFilesDlg",
                                      currentLocale);


    JPanel treePan = new JPanel();
    treePan.setLayout(new BorderLayout());

    this.addComponentListener(new ComponentAdapter(){
      public void componentShown(ComponentEvent e){
        if (mSelContainer.getXTagCollections().size()>0){
          int ret = JOptionPane.showConfirmDialog(null,
            labels.getString("sel_exist"), labels.getString("warning"),
            JOptionPane.YES_NO_OPTION);

          if (ret==JOptionPane.YES_OPTION){
            clearContainer();
           }

        }
      }
    });

    infoPan = new dsInfoPanel();
    mDirTree = new JDirectoryChooser();
    mDirTree.setSelectedDirectory(mInit_dir);
    mDirTree.tree.addTreeSelectionListener(new TreeSelectionListener() {
      public void valueChanged(TreeSelectionEvent e) {
        dir_changed();
      }
    });

    //m_SelTree = new JTree(new DefaultMutableTreeNode("Root Node"));
    mSelContainer= new dsSelContainer(labels, new TreeSelectionListener(){
      public void valueChanged(TreeSelectionEvent e){
        ContainerSelected_action();
      }
    });

    createTreePopupMenu();
    mSelContainer.addTreeMouseListener(new PopupListener());

    createTablePopupMenu();
    mFileTable = new dsFileTable(this, mCurrentFolder, labels);
    mFileTable.addTableMouseListener(new TablePopupListener());
    JScrollPane spTree = new JScrollPane();
    spTree.getViewport().add(mDirTree);

    tabber = new JTabbedPane();
    tabber.add(spTree, labels.getString("folders"));
    tabber.add(mSelContainer, labels.getString("selection"));
    tabber.addChangeListener(new ChangeListener(){
      public void stateChanged(ChangeEvent e) {
        TabSwitched(e);
      }
    });

    treePan.add(tabber, BorderLayout.CENTER);
    dsAlignments.CreateBorder(treePan, 10);


    Box leftBox = Box.createVerticalBox();
    leftBox.add(treePan);
    leftBox.add(infoPan);
    leftBox.add(Box.createVerticalStrut(10));



    this.setSize(dsAlignments.NORMAL_SIZE);
    this.setTitle(labels.getString("FormTitle"));

    BorderLayout main_layout = new BorderLayout();
    this.getContentPane().setLayout(main_layout);

    JPanel but_pane = new JPanel();
    JPanel r_pane = new JPanel();
    m_bOk = new JButton(labels.getString("Ok"));
    m_bOk.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        bOk_action();
      }
    });


    m_bCancel = new JButton(labels.getString("Cancel"));
    m_bCancel.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e){
        bCancel_action();
      }
    });

    m_bRefresh = new JButton(labels.getString("Refresh"));
    m_bRefresh.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e){
          bRefresh_action();
        }
      });

    m_bFilter = new JButton(labels.getString("filter"));
    m_bFilter.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e){
        bFilter_action();
      }
    });

    m_bXTag = new JButton(labels.getString("xtag"));
    m_bXTag.addActionListener(new ActionListener() {
       public void actionPerformed(ActionEvent e){
         bXTag_action();
       }
     });

     m_bStudyID = new JButton(labels.getString("StudyID"));
     m_bStudyID.addActionListener(new ActionListener() {
       public void actionPerformed(ActionEvent e) {
         bStudyID_action();
       }
     });


     m_bSelAll = new JButton(labels.getString("SelAll"));
     m_bSelAll.addActionListener(new ActionListener() {
       public void actionPerformed(ActionEvent e) {
         bSelAll_action();
       }
     });

     m_bAddToContainer = new JButton(labels.getString("AddToContainer"));
     m_bAddToContainer.addActionListener(new ActionListener() {
       public void actionPerformed(ActionEvent e) {
         bAddToContainer();
       }
     });


     JComponent[] a1 = {
         m_bFilter, m_bXTag, m_bSelAll, m_bStudyID, m_bAddToContainer};
     dsAlignments.MakeSameSize_max(a1);

     JComponent[] a2 = {m_bOk, m_bCancel, m_bRefresh};
     dsAlignments.MakeSameSize_max(a2);

     but_pane.add(m_bOk);
     but_pane.add(m_bCancel);
     but_pane.add(m_bRefresh);

    this.getContentPane().add(but_pane, BorderLayout.SOUTH);

    r_pane.setLayout(new FlowLayout());


    Box mainBox = Box.createVerticalBox();
    mainBox.add(Box.createVerticalStrut(40));
    mainBox.add(m_bFilter);
    mainBox.add(Box.createVerticalStrut(20));
    mainBox.add(m_bStudyID);
    mainBox.add(Box.createVerticalStrut(20));
    mainBox.add(m_bXTag);
    mainBox.add(Box.createVerticalStrut(20));
    mainBox.add(m_bSelAll);
    mainBox.add(Box.createVerticalStrut(20));
    mainBox.add(m_bAddToContainer);

    r_pane.add(mainBox);
//    r_pane.setBorder(BorderFactory.createEtchedBorder());

    this.getContentPane().add(r_pane, BorderLayout.EAST);
    this.getContentPane().add(leftBox, BorderLayout.WEST);
    this.getContentPane().add(mFileTable, BorderLayout.CENTER);

    mDirTree.setMinimumSize(new Dimension(mDirTree.getPreferredSize().width + 10,
                                           20));

    r_pane.setMaximumSize(new Dimension(m_bFilter.getWidth()+20, 10000));


    dir_changed();


    //
    // The method is added because of possible bug in TableSorter
    // when multimonitor system and Windoze L&F
    //
    this.addWindowListener(new WindowAdapter(){
      public void windowActivated(WindowEvent e)  {
        initTableHeader();
      }
    });

    self = this;
  }


  /**
   * class TablePopupListener
   */
  class TablePopupListener
      extends MouseAdapter {

    public void mousePressed(MouseEvent e) {
      maybeShowPopup(e);
    }

    public void mouseReleased(MouseEvent e) {
      maybeShowPopup(e);
    }

    private void maybeShowPopup(MouseEvent e) {
      if (e.isPopupTrigger()) {
        //add all the XTAGs into popup submenu
        createSubMenu();
        popup.show(e.getComponent(),
                   e.getX(), e.getY());
      }
    }

    //String curr_name = null;
    private void createSubMenu() {
      menuAddTo.removeAll();
      Vector xtags = mSelContainer.getXTagCollections();
      for (Iterator it = xtags.iterator(); it.hasNext(); ) {
        XTagCollection curr_coll = (XTagCollection) it.next();
        String curr_name = curr_coll.toString();
        JMenuItem curr_item = new JMenuItem(curr_name);
        curr_item.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent e) {
            //System.out.println("action" +  e.getActionCommand());
            AddToXTag(e.getActionCommand());

          }
        });
        menuAddTo.add(curr_item);
      }
    }
  }


  class PopupListener
      extends MouseAdapter {

    public void mousePressed(MouseEvent e) {
      maybeShowPopup(e);
    }

    public void mouseReleased(MouseEvent e) {
      maybeShowPopup(e);
    }

    protected void maybeShowPopup(MouseEvent e) {
      if (e.isPopupTrigger()) {
        tree_popup.show(e.getComponent(),
                        e.getX(), e.getY());
      }
    }
  }


  private void createTreePopupMenu() {

    tree_popup = new JPopupMenu();
    JMenuItem miNewXtag = new JMenuItem(labels.getString("new"));
    miNewXtag.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        mSelContainer.NewXTag();
      }
    });
    tree_popup.add(miNewXtag);

    JMenuItem miChangeXtag = new JMenuItem(labels.getString("change"));
    miChangeXtag.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        mSelContainer.ChangeXTag();
      }
    });
    tree_popup.add(miChangeXtag);

    JMenuItem miDelXtag = new JMenuItem(labels.getString("remove"));
    miDelXtag.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        mSelContainer.RemoveXTag();
        ContainerSelected_action();
      }
    });
    tree_popup.add(miDelXtag);
  }


  // Create popup menu for the FileTable
  private void createTablePopupMenu() {

    popup = new JPopupMenu();
    JMenuItem miXTag = new JMenuItem(labels.getString("xtag"));
    miXTag.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        bXTag_action();
      }
    });
    popup.add(miXTag);

    miAdd = new JMenuItem(labels.getString("AddToContainer"));
    miAdd.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        bAddToContainer();
      }
    });
    popup.add(miAdd);
    menuAddTo = new HorizontalMenu(labels.getString("AddToXTag"));
    popup.add(menuAddTo);
  }


  private void TabSwitched(ChangeEvent e){
    switch (tabber.getSelectedIndex()){
      case CHOOSER_TAB:
        m_bFilter.setEnabled(true);
        m_bStudyID.setEnabled(true);
        m_bXTag.setEnabled(true);

        m_bAddToContainer.setText(labels.getString("AddToContainer"));
        miAdd.setText(labels.getString("AddToContainer"));
        menuAddTo.setEnabled(true);
        //restore saved data
        mFileTable.updateAfterContainer(m_saved_table_data);
        break;
      case CONTAINER_TAB:
        // save current table data
        m_saved_table_data = mFileTable.getTableData();
        m_bFilter.setEnabled(false);
        m_bStudyID.setEnabled(false);
        m_bXTag.setEnabled(false);
        menuAddTo.setEnabled(false);

        m_bAddToContainer.setText(labels.getString("RemoveFromContainer"));
        miAdd.setText(labels.getString("RemoveFromContainer"));
        ContainerSelected_action();
       break;
    }
  }

  private void ContainerSelected_action(){


    XTagCollection curr = mSelContainer.getSelectedObject();
    if (curr!=null)
    mFileTable.applyContainerSelection(curr.getFileFields());
    else mFileTable.applyContainerSelection(mSelContainer.getAllFileFields());

  }

  /**
   *
   * <p>Worker Thread for searching files in the folder</p>
   *
   */


  class dsSelWorker extends Thread{
    private boolean isFinished = false;
    private boolean isRefresh = false;

    private File m_curr_folder = null;

    dsSelWorker(File curr_folder){
      m_curr_folder = curr_folder;
      isRefresh = false;
    }

    dsSelWorker(File curr_folder, boolean refresh){
        m_curr_folder = curr_folder;
        isRefresh = true;
      }

    public void run(){
      isFinished = false;

      if (!isRefresh){
      CFileFolder newFolder = new CFileFolder();
      newFolder.setFolder(m_curr_folder);

      CBobsSuperCollector oSuperCollector=new CBobsSuperCollector();
      newFolder.setFileFields(new Vector((new CFilesFiltering(
       new NotHiddenFilesFilter(),
          oSuperCollector,
          infoPan.getStatusObject())).FilterFiles(
         FileTools.ListFilesInFolder(m_curr_folder))));

       newFolder.setExtensionsFromStrings(oSuperCollector.GetExtsColl());
       newFolder.setStudyIDsFromStrings(oSuperCollector.GetStudyIdsColl());

       mCurrentFolder = newFolder;
      }else{
      	   CBobsSuperCollector oSuperCollector=new CBobsSuperCollector();
      	 mCurrentFolder.setFileFields(new Vector((new CFilesFiltering(
  	    	       new NotHiddenFilesFilter(),
  	    	          oSuperCollector,
  	    	          infoPan.getStatusObject())).FilterFiles(
  	    	         FileTools.ListFilesInFolder(m_curr_folder))));
  	     mCurrentFolder.setExtensionsFromStrings(oSuperCollector.GetExtsColl());
  	     mCurrentFolder.setStudyIDsFromStrings(oSuperCollector.GetStudyIdsColl());
      }

       mFileTable.applyFolderChange(mCurrentFolder);
       infoPan.setTotalFiles(mCurrentFolder.getFileFields().size());
       infoPan.setFilters(mCurrentFolder.restoreExtFilter());
       infoPan.setStudyIDs(mCurrentFolder.restoreStudyIDFilter());

        isFinished = true;
    }

    public boolean isFinished() {
      return isFinished;
    }

  }


  void dir_changed(){

    File curr = mDirTree.getSelectedDirectory();
    if (curr==null) return;

    boolean search4old = false;
    boolean found_old = false;
    File old_curr = mCurrentFolder.getFolder();
    if (old_curr != null){
      search4old = true;
    }
    //check if the Folder among the stored Folders
    boolean found = false;
    CFileFolder stored_folder = null;
    for (int i=0; i<mStoredFolders.size(); i++){
      File curr_st = ((CFileFolder) mStoredFolders.get(i)).getFolder();
      if (curr.equals(curr_st)){
        found = true;
        stored_folder = (CFileFolder) mStoredFolders.get(i);
      }

      // found old folder among stored
      if (search4old && old_curr.equals(curr_st)){
        mCurrentFolder.storeFilters(infoPan.getFilters(), infoPan.getStudyIDs());
        mCurrentFolder.setStoredFileFields(mFileTable.getTableData());
        found_old = true;
      }
    }

    if (search4old && (!found_old)){
      mStoredFolders.add(mCurrentFolder);
      mCurrentFolder.storeFilters(infoPan.getFilters(), infoPan.getStudyIDs());
      mCurrentFolder.setStoredFileFields(mFileTable.getTableData());
    }

    //Create a new CFileFolder
    if (!found) {

      //
      // Run worker thread to search and analize files in folder
      //
      dsSelWorker worker = new dsSelWorker(curr);
      worker.start();


    }else
    {
        mCurrentFolder = stored_folder;
        mFileTable.applyRestoreFolder(mCurrentFolder);
        infoPan.setTotalFiles(mCurrentFolder.getFileFields().size());
        infoPan.setFilters(mCurrentFolder.restoreExtFilter());
        infoPan.setStudyIDs(mCurrentFolder.restoreStudyIDFilter());

    }
  }

  public void bSelAll_action(){
    mFileTable.selectAll();
  }

  public void valueChanged(ListSelectionEvent e){
    infoPan.setSelFiles(mFileTable.getSelectedNum());
  }

  public void bXTag_action() {

    dsXTagDlg dlg = new dsXTagDlg(null, true, labels,
                                  mCurrentFolder.getStudyIDsAsStrings());
    dlg.setVisible(true);

    if (dlg.isOk()) {
      String xTag = dlg.getSelectedXTag().toString();
      Vector vFields = mFileTable.getSelectedFileFields();

      for (int i = 0; i < vFields.size(); i++) {
        ( (CFileFieds) vFields.get(i)).Fields().set(CFileFieds.XTAG, xTag);
      }

      mFileTable.applyXTagChange();
    }

  }

  public void bAddToContainer(){

    switch (tabber.getSelectedIndex()){
       case CHOOSER_TAB:
         //
         //  ADD action
         //
         mSelContainer.addFileFields(mFileTable.getSelectedFileFields());
         //mStoredFolders.add(mCurrentFolder);
         //mCurrentFolder.storeFilters(infoPan.getFilters(), infoPan.getStudyIDs());
         mFileTable.updateAfterContainer(mFileTable.getTableData());

         break;
       case CONTAINER_TAB:
          //
         // REMOVE action
         //
         mSelContainer.removeFields(mFileTable.getSelectedFileFields());
         ContainerSelected_action();
        break;
     }
  }


  public void AddToXTag(String xtag) {

    mSelContainer.addFileFieldsToXTag(mFileTable.getSelectedFileFields(), xtag);
    mFileTable.updateAfterContainer(mFileTable.getTableData());

  }


  public void bCancel_action(){
    m_Ok = false;
    this.setVisible(false);
  }

  public void bRefresh_action() {
		File curr = mDirTree.getSelectedDirectory();
		if (curr == null)
			return;

		//
		// Run worker thread to search and analize files in folder
		//
		dsSelWorker worker = new dsSelWorker(curr, true);
		worker.start();

	}

  public void bOk_action(){
    if (mFileTable.getSelectedFileFields().size()>0){
      mSelContainer.addFileFields(mFileTable.getSelectedFileFields());
    }
    m_Ok = true;
    this.setVisible(false);

//---- DEBUG (comment it) ----
/*    Vector res =  mSelContainer.getXTagCollections();
    for (Iterator it = res.iterator(); it.hasNext(); )
    {
      XTagCollection curr = (XTagCollection) it.next();
      System.out.println(curr);
      System.out.println(" Files: " + curr.getFileFields().size());
    }
 */
//------------------------------

  }

  public boolean isOk(){return m_Ok;}

  public File getCurrentDir(){
    return mDirTree.getSelectedDirectory();
  }

  public void bFilter_action(){
    mFileTable.clearSelection();
    dsFilterDlg dlg = new dsFilterDlg(null, true, labels, mCurrentFolder.getExtensions());
    dlg.setVisible(true);

    if (dlg.isOk()){
      selExts = dlg.getAllObjects();
      mCurrentFolder.setExtensions(selExts);

      //check if it really filters something
      if (mCurrentFolder.getSelectedExtensionsStrings().size() !=
          mCurrentFolder.getExtensions().size()) {
        mFileTable.appy_filters();
        infoPan.setFilters(true);
      }else{
        if (infoPan.getFilters()) mFileTable.appy_filters();
        infoPan.setFilters(false);
      }
    }
    dlg.dispose();
//  Changed 14.12.06
    //invalidate();
  }

  public void bStudyID_action(){
    mFileTable.clearSelection();

    dsFilterDlg dlg = new dsFilterDlg(null, true, labels, mCurrentFolder.getStudyIDs());
    dlg.setVisible(true);

    if (dlg.isOk()){
      mCurrentFolder.setStudyIDs(dlg.getAllObjects());

      //check if it really filters something
      if (mCurrentFolder.getSelectedStudyIDsStrings().size() !=
          mCurrentFolder.getStudyIDs().size()) {
        mFileTable.appy_filters();
        infoPan.setStudyIDs(true);
      }
      else {
        if (infoPan.getStudyIDs()) mFileTable.appy_filters();
        infoPan.setStudyIDs(false);
      }
    }
    dlg.dispose();
//  Changed 14.12.06
    //invalidate();

  }




  /**
   *  dsInfoPanel - Panel for information about files
   *
   */

  class dsInfoPanel extends JPanel {

    private JLabel v_total = new JLabel(Integer.toString(0));
    private JLabel v_sel = new JLabel(Integer.toString(0));
    private JLabel v_filter = new JLabel();
    private JLabel v_study = new JLabel();
    JProgressBar m_progress = new JProgressBar(0, 100);
    dsInfoStatusListener m_status = new dsInfoStatusListener();

    public void setTotalFiles(int num)
                {v_total.setText(Integer.toString(num));}
    public void setSelFiles(int num)
                {v_sel.setText(Integer.toString(num));}
    public void setFilters (boolean enable){
      if (enable) v_filter.setText(labels.getString("true_filter"));
      else v_filter.setText(labels.getString("false_filter")); }
    public boolean getFilters ()
    {return v_filter.getText().equals(labels.getString("true_filter"));}
    public void setStudyIDs (boolean enable){
      if (enable) v_study.setText(labels.getString("true_filter"));
      else v_study.setText(labels.getString("false_filter")); }
    public boolean getStudyIDs ()
    {return v_study.getText().equals(labels.getString("true_filter"));}

    private Box mainBox = null;

    public void setWidth (int num){

      mainBox.setMinimumSize(new Dimension(num, mainBox.getMinimumSize().height));
      mainBox.setPreferredSize(new Dimension(num,
                                             mainBox.getPreferredSize().height));
      mainBox.setMaximumSize(new Dimension(num, mainBox.getMaximumSize().height));
    }

    public dsInfoPanel(){

      JLabel total = new JLabel(labels.getString("total"));
      JLabel sel = new JLabel(labels.getString("selected"));
      JLabel filter = new JLabel(labels.getString("ifilter"));
      JLabel study = new JLabel(labels.getString("iStudyID"));


      JComponent [] a = {total, sel, filter, study};
      dsAlignments.MakeSameSize_max(a);

      v_filter.setText(labels.getString("false_filter"));
      v_study.setText(labels.getString("false_filter"));

      JComponent [] a1 = {v_total, v_sel, v_filter, v_study};
      dsAlignments.MakeSameSize_max(a1);

      int h_row_size = v_total.getPreferredSize().height;
      mainBox = Box.createVerticalBox();
      mainBox.add(Box.createVerticalStrut(10));
      Box row1 = Box.createHorizontalBox();
      row1.add(Box.createHorizontalStrut(10));
      row1.add(total);
      row1.add(Box.createHorizontalStrut(10));
      row1.add(v_total);
      row1.add(Box.createHorizontalStrut(10));
      mainBox.add(row1);
      Box row2 = Box.createHorizontalBox();
      row2.add(Box.createHorizontalStrut(10));
      row2.add(sel);
      row2.add(Box.createHorizontalStrut(10));
      row2.add(v_sel);
      row2.add(Box.createHorizontalStrut(10));
      mainBox.add(row2);
      Box row3 = Box.createHorizontalBox();
      row3.add(Box.createHorizontalStrut(10));
      row3.add(filter);
      row3.add(Box.createHorizontalStrut(10));
      row3.add(v_filter);
      row3.add(Box.createHorizontalStrut(10));
      mainBox.add(row3);
      Box row4 = Box.createHorizontalBox();
      row4.add(Box.createHorizontalStrut(10));
      row4.add(study);
      row4.add(Box.createHorizontalStrut(10));
      row4.add(v_study);
      row4.add(Box.createHorizontalStrut(10));
      mainBox.add(row4);
      Box row5 = Box.createHorizontalBox();
      row5.add(Box.createHorizontalStrut(10));
      row5.add(m_progress);
      row5.add(Box.createHorizontalStrut(10));
      mainBox.add(row5);
      mainBox.add(Box.createVerticalStrut(10));

      row1.setMaximumSize(new Dimension(10000, h_row_size));
      row2.setMaximumSize(new Dimension(10000, h_row_size));
      row3.setMaximumSize(new Dimension(10000, h_row_size));
      row4.setMaximumSize(new Dimension(10000, h_row_size));


      this.setLayout(new BorderLayout());
      this.add(mainBox, BorderLayout.CENTER);
      this.add(Box.createHorizontalStrut(10), BorderLayout.EAST);
      this.add(Box.createHorizontalStrut(10), BorderLayout.WEST);
      mainBox.setBorder(BorderFactory.createEtchedBorder());
    }

    public IStatusListener getStatusObject(){
      return m_status;
    }

//  TO CALL in THREAD
    private void showProgress(int progress) throws Exception {

      final int p = progress;
      Runnable updateProgressBar = new Runnable() {
        public void run() {
          m_progress.setValue(p);
          m_progress.updateUI();

        }
      };
      SwingUtilities.invokeLater(updateProgressBar);

    }


    class dsInfoStatusListener implements IStatusListener {
      public void StatusStart(int n){
        m_progress.setMaximum(n);
        m_progress.update(m_progress.getGraphics());

      }
      public void StatusNext(int i, int n){

        try{
          showProgress(i);
        }catch(Exception e){
         JOptionPane.showMessageDialog(null, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        }

      }
      public void StatusEnd(){
        try {
            showProgress(0);
          }
        catch (Exception e) {
        JOptionPane.showMessageDialog(null, e.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        }
      }

    }

  }

}
/**
 * <p>Title: dsFilterDlg</p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: aITLab</p>
 * @author Bob
 * @version 1.0
 */
class dsFilterDlg extends JDialog {

  private ResourceBundle labels;
  private JTable mTable = null;
  private Vector mExtensions = null;

  private dsFilterTableModel mTableModel;

  private boolean mOk = false;
  private boolean mAll = true;

  private JButton m_bOk;
  private JButton m_bCancel;
  private JButton m_bAll;

  public dsFilterDlg(java.awt.Frame parent, boolean modal, ResourceBundle Labels, Vector extensions)
      throws HeadlessException {
    super(parent, modal);
    labels = Labels;

    mExtensions = extensions;//(Vector) extensions.clone();

      mTableModel = new dsFilterTableModel(mExtensions);
      mTable = new JTable(mTableModel);
      TableColumn chk_column = mTable.getColumnModel().getColumn(0);
      chk_column.setPreferredWidth(5);

      JPanel mainPan = new JPanel();
      mainPan.setLayout(new BorderLayout());

     JScrollPane spTable = new JScrollPane();
     spTable.getViewport().add(mTable);
     mainPan.add(spTable, BorderLayout.CENTER);
     dsAlignments.CreateBorder(mainPan, 10);

     this.setSize(new Dimension(320, 200));
     this.setTitle(labels.getString("ExtDlgTitle"));

     BorderLayout main_layout = new BorderLayout();
     this.getContentPane().setLayout(main_layout);

     JPanel but_pane = new JPanel();
     m_bOk = new JButton(labels.getString("Ok"));
     m_bOk.addActionListener(new ActionListener(){
       public void actionPerformed(ActionEvent e){
        bOk_pressed();
       }

     });
     m_bCancel = new JButton(labels.getString("Cancel"));
     m_bCancel.addActionListener(new ActionListener(){
       public void actionPerformed(ActionEvent e){
        bCancel_pressed();
       }

     });

     m_bAll = new JButton(labels.getString("All"));
     m_bAll.addActionListener(new ActionListener(){
       public void actionPerformed(ActionEvent e){
        bAll_pressed();
       }
     });


     JComponent[] a2 = {m_bOk, m_bCancel};
     dsAlignments.MakeSameSize_max(a2);

     but_pane.add(m_bAll);
     but_pane.add(m_bOk);
     but_pane.add(m_bCancel);

     this.getContentPane().add(but_pane, BorderLayout.SOUTH);
     this.getContentPane().add(mainPan, BorderLayout.CENTER);

  }

  public Vector getSelectedStrings(){
    Vector res = new Vector();
    for (int i=0; i<mExtensions.size(); i++){
      if (((CSelectableString) mExtensions.get(i)).isSelected()){
        res.add(((CSelectableString) mExtensions.get(i)).get());
      }
    }
    return res;
  }

  public Vector getAllObjects() {
    return mExtensions;
  }

  public void  setObjects(Vector v){
    mExtensions = v;
    mTableModel.setTableData(mExtensions);
    mTable.updateUI();
  }


  public void setSelectedStrings(Vector vsel) {
    for (int i = 0; i < mExtensions.size(); i++) {
      CSelectableString curr = (CSelectableString) mExtensions.get(i);
      curr.setSelect(false);
      for (int j = 0; j < vsel.size(); j++) {
        curr.select_if_equal((String) vsel.get(j));
      }
    }
    mTable.updateUI();
  }


  void bOk_pressed() {
    mOk = true;
    this.setVisible(false);
  }

  void bCancel_pressed() {
    this.setVisible(false);
    mOk = false;
  }

  void bAll_pressed() {
    boolean s = false;
    if (mAll) {
      s = false;
      mAll = false;
    }else {
      s = true;
      mAll = true;
    }

    for (int i=0; i<mExtensions.size(); i++)
    {
      ((CSelectableString) mExtensions.get(i)).setSelect(s);
    }

    mTable.updateUI();
  }

  boolean isOk() {
    return mOk;
  }

  class dsFilterTableModel extends AbstractTableModel {
    private Vector table_data = null;
    private String[] columnNames = {
     labels.getString("select"),
     labels.getString("extension")};


    public dsFilterTableModel(Vector data) {
      super();
      table_data = data;
    }

    public void setTableData(Vector data){
      table_data = data;
      this.fireTableDataChanged();
    }

    public String getColumnName(int col) {
      return columnNames[col];
    }


    public int getColumnCount() {
      return 2;
    }

    public int getRowCount() {
      return table_data.size();
    }

    public Class getColumnClass(int c) {
        return getValueAt(0, c).getClass();
    }

    public Object getValueAt(int row, int col) {
      CSelectableString m_ext = (CSelectableString) table_data.get(row);
      if (col==0) return  new Boolean(m_ext.isSelected());
      return m_ext.get();
    }

    public boolean isCellEditable(int row, int col) {
      if (col==0) return true;
      return false;
    }

    public void setValueAt(Object value, int row, int col) {
      CSelectableString m_ext = (CSelectableString) table_data.get(row);
      if (col==0) m_ext.setSelect(((Boolean) value).booleanValue());
      fireTableCellUpdated(row, col);
    }

  }

}
/**
  * <p>Title: </p>
  * <p>Description: </p>
  * <p>Copyright: Copyright (c) 2005</p>
  * <p>Company: </p>
  * @author Bob & OOO
 * @version 1.0
 */

class dsXTagDlg extends JDialog {

   private Vector mTableData = null;
  private boolean mOk = false;
  private ResourceBundle labels;
  private JTable mTable = null;
  private XTag mSelectedXtag = new XTag();

  public dsXTagDlg(java.awt.Frame parent, boolean modal, ResourceBundle Labels,
                   Vector x_tags) throws HeadlessException {
    super(parent, modal);
    labels = Labels;

    mTableData = new Vector(x_tags);
    mTableData.add(labels.getString("newXTag"));

    mTable = new JTable(new dsXFilterTableModel(mTableData));
    mTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    mTable.setRowSelectionInterval(0, 0);

    //Set up real input validation for the left column.
    this.setUpCellEditor(mTable);

    JPanel mainPan = new JPanel();
    mainPan.setLayout(new BorderLayout());

    JScrollPane spTable = new JScrollPane();
    spTable.getViewport().add(mTable);
    mainPan.add(spTable, BorderLayout.CENTER);
    dsAlignments.CreateBorder(mainPan, 10);

    this.setSize(new Dimension(320, 200));
    this.setTitle(labels.getString("XtagDlgTitle"));

    BorderLayout main_layout = new BorderLayout();
    this.getContentPane().setLayout(main_layout);

    JPanel but_pane = new JPanel();
    JButton m_bOk = new JButton(labels.getString("Ok"));
    m_bOk.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        bOk_pressed();
      }

    });
    JButton m_bCancel = new JButton(labels.getString("Cancel"));
    m_bCancel.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        bCancel_pressed();
      }

    });

    JComponent[] a3 = {
        m_bOk, m_bCancel};
    dsAlignments.MakeSameSize_max(a3);

    but_pane.add(m_bOk);
    but_pane.add(m_bCancel);

    this.getContentPane().add(but_pane, BorderLayout.SOUTH);
    this.getContentPane().add(mainPan, BorderLayout.CENTER);


  }

  private void setUpCellEditor(JTable table) {
      //Set up the editor for the correct AET.
      final XTagField xTagField = new XTagField("", 0);

      //Construct a DefaultCellEditor that uses a text field.
      DefaultCellEditor xTagEditor = new DefaultCellEditor(xTagField) {
        //Override DefaultCellEditor's getCellEditorValue method
        //to return the correct String:
        public Object getCellEditorValue() {
          return new String(xTagField.getValue());
        }
      };
      mTable.setDefaultEditor(String.class, xTagEditor);
  }


  private String getSelectedData(){
    if (mTable.getCellEditor()!=null) mTable.getCellEditor().stopCellEditing();
    return (String) mTableData.get(mTable.getSelectedRow());
  }

  public XTag getSelectedXTag(){
    return mSelectedXtag;
  }

  void bOk_pressed() {
    mOk = true;

    String str=this.getSelectedData();
    mSelectedXtag.setTextGUI(str);

    this.setVisible(false);
  }

  void bCancel_pressed() {
    this.setVisible(false);
    mOk = false;
  }

  boolean isOk() {
    return mOk;
  }

//-------------Internal class--------------------------------------------------
  class dsXFilterTableModel
      extends AbstractTableModel {
    private Vector table_data = null;
    private String mHeader = labels.getString("XtagTableHeader");

    public dsXFilterTableModel(Vector data) {
      super();
      table_data = data;
    }

    public String getColumnName(int col) {
      return mHeader;
    }

    public int getColumnCount() {
      return 1;
    }

    public int getRowCount() {
      return table_data.size();
    }

    public Object getValueAt(int row, int col) {
      return table_data.get(row);
    }

    public boolean isCellEditable(int row, int col) {
      if (row == (table_data.size() - 1))return true;
      return false;
    }

    public void setValueAt(Object value, int row, int col) {
      table_data.set(row, value);
      fireTableCellUpdated(row, col);
    }

    /*
    * JTable uses this method to determine the default renderer/
    * editor for each cell.
    */
    public Class getColumnClass(int c) {
            return getValueAt(0, c).getClass();
    }

  }
  //-------------Internal Class------------------------------------------------

  /**
  * Table cell Corrector
  */

    class XTagField extends JTextField {
      private String mValue=new String();

      public XTagField(String value, int columns) {
        super(columns);
        setValue(value);
      }

      public String getValue() {
        mValue=new String(getText());
        return mValue;
      }

      public void setValue(String value) {
        mValue = value; // TODO correction here
        setText(mValue);
      }

      protected Document createDefaultModel() {
        return new XTagDocument();
      }
  }
  //--------------------------------------------------------------------------
}// end class


class CSelectableString {
  private String mString;
  private boolean mSel = false;

  public void set (String s){mString = s;}
  public String get() {return mString;}
  public void setSelect(boolean sel){mSel=sel;}
  public boolean isSelected() {return mSel;}
  public void select_if_equal(String other){
    if (mString.equals(other)) mSel = true;
  }

  public String toString(){return mString;}
}


/**
 * <p>Title: CFileFolder </p>
 * <p>Description: class for holding folder files, filters etc.</p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: aITLab </p>
 * @author Bob
 * @version 1.0
 */

class CFileFolder{
  private Vector mFileFields = new Vector();
  //Sorted file fields (to save the time for filterring when restoring)
  private Vector mStoredFileFields =null;
  private boolean mStoredExtFilter = false;
  private boolean mStoredStudyIDFilter = false;

  private File mFolder = null;
  private Vector mExtensions = null;
  private Vector  mStudyIDs = null;
  private Vector  mXTags = new Vector();

  public void storeFilters(boolean Ext, boolean studyID){
    mStoredExtFilter = Ext; mStoredStudyIDFilter = studyID;
  }
  public boolean restoreExtFilter(){return mStoredExtFilter;}
  public boolean restoreStudyIDFilter(){return mStoredStudyIDFilter;}

  public void setStudyIDs (Vector vStudyIDs) {mStudyIDs = vStudyIDs;}
  public Vector getStudyIDs () { return mStudyIDs;}

  public void addXTag (XTag oXTag) {mXTags.add(oXTag);}
  public Vector getXTags () { return mXTags;}

  public void setExtensions (Vector vExtensions) {mExtensions = vExtensions;}
  public Vector getExtensions () { return mExtensions;}

  public void setFileFields (Vector vFileFields){mFileFields = vFileFields;}
  public Vector getFileFields (){return mFileFields;}

  public void setStoredFileFields (Vector vFileFields){mStoredFileFields = vFileFields;}
  public Vector getStoredFileFields (){return mStoredFileFields;}

  public void setFolder(File fFolder){mFolder = fFolder;}
  public File getFolder () {return mFolder;}

  public void setExtensionsFromStrings(Collection cExts) {
    mExtensions = getDataFromStrings(cExts);
  }

  public void setStudyIDsFromStrings(Collection study_IDs) {
    mStudyIDs = getDataFromStrings(study_IDs);
  }

  public Vector getStudyIDsAsStrings(){
    Vector res = new Vector();
    for (int i=0; i<mStudyIDs.size(); i++)
    {
      res.add(mStudyIDs.get(i).toString());
    }

    return res;
  }

  public Vector getSelectedExtensionsStrings() {
    return getSelectedDataStrings(mExtensions);
  }

  public Vector getSelectedStudyIDsStrings() {
    return getSelectedDataStrings(mStudyIDs);
  }


  public String toString(){return mFolder.getName();}

  private Vector getDataFromStrings(Collection cStr){
    Vector result = new Vector();
    for (Iterator it = cStr.iterator(); it.hasNext(); ) {
      CSelectableString curr = new CSelectableString();
      curr.set( (String) it.next());
      curr.setSelect(true);
      result.add(curr);
    }
    return result;
  }

  private Vector getSelectedDataStrings(Vector data){
    Vector res = new Vector();
//    int c = 0;
    for (int i = 0; i < data.size(); i++) {
      if ( ( (CSelectableString) data.get(i)).isSelected())
      {
        res.add(data.get(i).toString());
      }
    }
    return res;
  }
}








/**
 *
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */


class dsSelContainer extends JPanel{

  private ResourceBundle labels = null;
  private JTree mSelTree = null;
  private DefaultMutableTreeNode mTreeRoot = null;
  private TreeSelectionListener mListener = null;
  private TreeCellEditor editor = null;
  private int m_file_num = 0;
  private long m_files_size = 0;
  private boolean edit_event = false;



  /**
   * Vector of XTagCollections
   */
  private Vector m_XTagCollections = new Vector();





  class LeafCellEditor
      extends DefaultTreeCellEditor {

    private Object m_editedObject = null;

    public LeafCellEditor(JTree tree, DefaultTreeCellRenderer renderer) {
      super(tree, renderer);
    }

    public LeafCellEditor(JTree tree, DefaultTreeCellRenderer renderer,
                          TreeCellEditor editor) {
      super(tree, renderer, editor);
    }

    public boolean isCellEditable(EventObject event) {
      // Get initial setting
      boolean returnValue = super.isCellEditable(event);
      //boolean returnValue = edit_event;
      // If still possible, check if current tree node is a leaf
      if (returnValue) {
        Object node = tree.getLastSelectedPathComponent();
        if ( (node != null) && (node instanceof TreeNode)) {
          TreeNode treeNode = (TreeNode) node;
          returnValue = treeNode.isLeaf();
          if (mSelTree.getRowCount() < 2) returnValue = false;

        }
      }

      return returnValue;
    }

    public Component getTreeCellEditorComponent(JTree tree, Object value,
                                                boolean isSelected,
                                                boolean expanded, boolean leaf,
                                                int row) {
      Component c = super.getTreeCellEditorComponent(tree, value,
          isSelected, expanded, leaf, row);
      m_editedObject = ((DefaultMutableTreeNode) value).getUserObject();
      return c;
    }

    public Object getCellEditorValue() {
      Object val = super.getCellEditorValue();
      // setting xtag value with an action-validation
      ((XTagCollection) m_editedObject).getXTag().setText((String) val);
      return m_editedObject;
    }


  }


  public Vector getXTagCollections(){
    return m_XTagCollections;
  }

  public long getContainerSize(){
   return  m_files_size;
  }

  public int getFileNumber(){
    return m_file_num;
  }

  public void addTreeMouseListener(MouseListener listener){
    mSelTree.addMouseListener(listener);
  }

  public dsSelContainer (ResourceBundle Labels, TreeSelectionListener listener){
    labels = Labels;
    mListener = listener;
    try {
      InitGUI();
    }
    catch (Exception e) {
      e.printStackTrace();
    }

  }

  private void InitGUI() throws HeadlessException {

    mTreeRoot = new DefaultMutableTreeNode(labels.getString("xtag"));
    mSelTree = new JTree(mTreeRoot);
    mSelTree.addTreeSelectionListener(mListener);

    DefaultTreeCellRenderer renderer = (DefaultTreeCellRenderer) mSelTree
            .getCellRenderer();
        editor = new LeafCellEditor(mSelTree, renderer);
        mSelTree.setCellEditor(editor);

    mSelTree.setEditable(true);



    JScrollPane jspMain = new JScrollPane();

    jspMain.getViewport().add(mSelTree);
    this.setLayout(new BorderLayout());
    this.add(jspMain, BorderLayout.CENTER);

//    this.add(Box.createVerticalStrut(10), BorderLayout.NORTH);
//    this.add(Box.createVerticalStrut(10), BorderLayout.SOUTH);

  }

  private void checkName(XTagCollection coll, int index){
    //Check for the same name
    for (Iterator it = m_XTagCollections.iterator(); it.hasNext(); ) {
      String curr_name = ( (XTagCollection) it.next()).getXTag().toString();
      if (curr_name.equals(coll.getXTag().toString())) {
        String a = coll.getXTag().toString();
        String b;
        if (a.endsWith("_" + Integer.toString(index-1))){
          b = a.replaceFirst(new String("_"+Integer.toString(index-1)), new String("_"+Integer.toString(index)));
          //System.out.println(b);
        }else{
          b = a + "_" + Integer.toString(index);
        }
        coll.getXTag().setText(b);
        checkName(coll, index+1);
      }
    }
  }

  public void NewXTag (){
    XTagCollection new_coll = new XTagCollection(new XTag());

    checkName(new_coll, 1);

    m_XTagCollections.add(new_coll);
    addTreeNode(new_coll);
    mSelTree.updateUI();

    int row = mSelTree.getRowCount()-1;
    mSelTree.expandRow(row);
    mSelTree.setSelectionRow(row);
    mSelTree.startEditingAtPath(mSelTree.getSelectionPath());

  }

  public void ChangeXTag() {
    mSelTree.startEditingAtPath(mSelTree.getSelectionPath());
  }

  public void RemoveXTag() {
    XTagCollection sel = getSelectedObject();
    if (sel != null) {
      removeCollection(sel);
    }
  }


  public void addFileFieldsToXTag(Vector vFields, String xtag){
    boolean bFound = false;
    //System.out.println("searching for = " + xtag);
    for (int j = 0; j < m_XTagCollections.size(); j++){
      XTagCollection curr_coll = (XTagCollection) m_XTagCollections.get(j);
      String sXtag = curr_coll.getXTag().toString();
      if (sXtag.equals(xtag)) {
        bFound = true;
        addVecToSelCollection(vFields, curr_coll);
        //System.out.println("found " + sXtag);
      }
    }
    if (!bFound){
      XTagCollection curr_coll = new XTagCollection(new XTag());
      addTreeNode(curr_coll);
      addVecToSelCollection(vFields, curr_coll);
      //System.out.println("!found");
    }
  }

  private void addVecToSelCollection (Vector vFields, XTagCollection coll){
    for (Iterator it = vFields.iterator(); it.hasNext(); ) {
      CFileFieds curr = (CFileFieds) it.next();
      curr.Fields().set(CFileFieds.XTAG, coll.getXTag().toString());
      coll.addField(curr);
      curr.setDisabled(true);
      m_file_num++;
      m_files_size += curr.GetFileObject().length();
    }
  }

  public void addFileFields(Vector vFields){

    //
    // Loop over all Fields to sort by XTag
    //
    for (int i = 0; i < vFields.size(); i++) {
      CFileFieds curr = (CFileFieds) vFields.get(i);

      // if Field is disabled skip processing
      if (!curr.isDisabled()) {
        String curr_xtag = curr.GetXTagField();
        if (curr_xtag.equals("")) {
          curr_xtag = (new XTag(labels.getString("newXTag"))).toString();
          curr.Fields().set(CFileFieds.XTAG, curr_xtag);
        }
//System.out.println("compare = " + curr_xtag);
        //Loop over XTag collections to find similar
        boolean bFound = false;
        for (int j = 0; j < m_XTagCollections.size(); j++) {
          XTagCollection curr_coll = (XTagCollection) m_XTagCollections.get(j);
          String xtag = curr_coll.toString();
//System.out.println(" with = " + xtag);
          if (xtag.equals(curr_xtag)) {
            curr_coll.addField(curr);
            bFound = true;
            m_file_num++;
            m_files_size += curr.GetFileObject().length();
//System.out.println("equals");
          }
        }
        //if current XTag is not found in collection then create new one
        if (!bFound) {
          XTagCollection curr_coll = new XTagCollection(new XTag(curr_xtag));
          curr_coll.addField(curr);
          m_XTagCollections.add(curr_coll);
          addTreeNode(curr_coll);
          m_file_num++;
          m_files_size += curr.GetFileObject().length();

        }

        //Disable Field to prevent double include
        curr.setDisabled(true);
        //System.out.println("disable = " + curr);
      }
    }

    //update tree data
    mSelTree.updateUI();


  }

  public void removeCollection(XTagCollection coll){
    for (Iterator it_f = coll.getFileFields().iterator(); it_f.hasNext(); ) {
           CFileFieds curr_f = (CFileFieds) it_f.next();
           curr_f.setDisabled(false);
           coll.removeField(curr_f);
           m_file_num--;
           m_files_size -= curr_f.GetFileObject().length();
    }
    int ind = 0;
    for (Iterator it_c = m_XTagCollections.iterator(); it_c.hasNext(); ) {
        XTagCollection curr_coll = (XTagCollection) it_c.next();
        if (curr_coll.toString().equals(coll.toString())){
          mTreeRoot.remove(ind);

        }
        ind++;
    }

    m_XTagCollections.remove(coll);
    mSelTree.updateUI();

  }

  public void removeAll(){
    Vector toRemoveTree = new Vector();
    int index = 0;
    for (Iterator it_c = m_XTagCollections.iterator(); it_c.hasNext(); ) {
        XTagCollection curr_coll = (XTagCollection) it_c.next();
        for (Iterator it_f = curr_coll.getFileFields().iterator(); it_f.hasNext(); ) {
          CFileFieds curr_f = (CFileFieds) it_f.next();
          curr_f.setDisabled(false);
          curr_coll.removeField(curr_f);
        }
        toRemoveTree.add(mTreeRoot.getChildAt(index));
        index++;
    }


    for (Iterator it = toRemoveTree.iterator(); it.hasNext(); ) {
      DefaultMutableTreeNode curr = (DefaultMutableTreeNode) it.next();
      m_XTagCollections.remove( (XTagCollection) curr.getUserObject());
      mTreeRoot.remove(curr);
    }

    m_file_num=0;
    m_files_size=0;

    mSelTree.updateUI();


  }

  public void removeFields(Vector vFields){

     Vector toRemoveTree = new Vector();
     boolean remove_coll = true;
     int index = 0;
     for (Iterator it_c = m_XTagCollections.iterator(); it_c.hasNext(); ) {
       XTagCollection curr_coll = (XTagCollection) it_c.next();
         for (Iterator it_f = curr_coll.getFileFields().iterator(); it_f.hasNext(); ) {
           CFileFieds curr_f = (CFileFieds) it_f.next();

           for (Iterator it = vFields.iterator(); it.hasNext(); ) {
             CFileFieds curr = (CFileFieds) it.next();
             if (curr.equals(curr_f)) {
               curr_coll.removeField(curr);
               curr.setDisabled(false);
               m_file_num--;
               m_files_size -= curr.GetFileObject().length();
               remove_coll = true;
             }
           }
         }

        if (curr_coll.getFileFields().size()==0 && remove_coll){
          toRemoveTree.add(mTreeRoot.getChildAt(index));

        }
        remove_coll = false;
        index++;
      }




    for (Iterator it = toRemoveTree.iterator(); it.hasNext();){
      DefaultMutableTreeNode curr = (DefaultMutableTreeNode)it.next();
      m_XTagCollections.remove((XTagCollection) curr.getUserObject());
      mTreeRoot.remove(curr);
    }

     mSelTree.updateUI();
  }




  public XTagCollection getSelectedObject(){
    DefaultMutableTreeNode node = (DefaultMutableTreeNode)
                          mSelTree.getLastSelectedPathComponent();

   if (node==null) return null;
   if (node.isRoot()) return null;
   return (XTagCollection) node.getUserObject();

  }

  public void verifySelection(){
    DefaultMutableTreeNode node = (DefaultMutableTreeNode)
                          mSelTree.getLastSelectedPathComponent();


     if (node == null) return;
     if (node.isRoot()) {
       if (node.getChildCount()>0){
         mSelTree.setSelectionRow(node.getNextNode().getLevel());
       }
     }
  }

  public Vector getAllFileFields(){
    Vector res = new Vector();
    for (int j = 0; j < m_XTagCollections.size(); j++) {
      XTagCollection curr_coll = (XTagCollection) m_XTagCollections.get(j);
      res.addAll(curr_coll.getFileFields());
    }

    return res;
  }

  public Vector getAllFiles(){
    Vector res = new Vector();
    for (int j = 0; j < m_XTagCollections.size(); j++) {
      XTagCollection curr_coll = (XTagCollection) m_XTagCollections.get(j);
      res.addAll(curr_coll.getFiles());
    }

    return res;
  }



  private void addTreeNode(XTagCollection oXTagColl){
    DefaultMutableTreeNode curr = new DefaultMutableTreeNode(oXTagColl);
    mTreeRoot.add(curr);
  }

}

/**
 * Class HorizontalMenu taken from
 * http://java.sun.com/docs/books/tutorial/uiswing/components/example-1dot4/MenuLayoutDemo.java
 *
 */

class HorizontalMenu extends JMenu {
    HorizontalMenu(String label) {
        super(label);
        JPopupMenu pm = getPopupMenu();
        pm.setLayout(new BoxLayout(pm, BoxLayout.Y_AXIS));
    }

    public Dimension getMinimumSize() {
        return getPreferredSize();
    }

    public Dimension getMaximumSize() {
        return getPreferredSize();
    }

    public void setPopupMenuVisible(boolean b) {
        boolean isVisible = isPopupMenuVisible();
        if (b != isVisible) {
            if ((b==true) && isShowing()) {
                //Set location of popupMenu (pulldown or pullright).
                //Perhaps this should be dictated by L&F.
                int x = 0;
                int y = 0;
                //Container parent = getParent();
                //if (parent instanceof JPopupMenu) {
                //    x = 0;
                //    y = getHeight();
                //} else {
                    x = getWidth();
                    y = 0;
                //}
                getPopupMenu().show(this, x, y);
            } else {
                getPopupMenu().setVisible(false);
            }
        }
    }
}
