package dbridge;

import java.util.Vector;
import java.awt.Component;
import java.util.ResourceBundle;
import java.util.Locale;
import javax.swing.table.AbstractTableModel;
import javax.swing.JTable;
import javax.swing.table.TableCellRenderer;
import javax.swing.table.TableColumn;



/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Dzmitry Stsepankou
 * @version 1.0
 */

/*
* Created 28.11.2004
*/

interface dsServersTable{
  public Object getSelection();
  public void updateUI();
}

class dsSMTPTable extends JTable implements dsServersTable{

  private ResourceBundle lbls;
  private dbSmtpTable mData;

/////////////////////////////////////////////////////////////////////////////
//       Table Model subclass
/////////////////////////////////////////////////////////////////////////////

    class dsSMTPTableModel
        extends AbstractTableModel {
        private Vector table_data = new Vector();

        public dsSMTPTableModel(Vector data) {
          super();
          table_data = data;
        }

        private String[] columnNames = {
            lbls.getString("server"),
            lbls.getString("login"),
            lbls.getString("port")};

        public final Object[] longValues = {
            "XXX.XXX.XXX.XXX",
            "XXXXXXXXXX", "XXXX"};

        public int getColumnCount() {
          return columnNames.length;
        }

        public int getRowCount() {
          return table_data.size();
        }

        public String getColumnName(int col) {
          return columnNames[col];
        }

        public Object getValueAt(int row, int col) {
          String res = null;
          switch (col){
            case 0:
              res = ( (dbSmtpRecord) table_data.get(row)).getIP(); break;
            case 1:
              res = ( (dbSmtpRecord) table_data.get(row)).getLogin(); break;
            case 2:
              res = Integer.toString(((dbSmtpRecord) table_data.get(row)).getPort()); break;
          }

          return res;
        }

        public boolean isCellEditable(int row, int col) {
          return false;
        }
     }
///////////////////////////////////////////////////////////////////////////////
  public dsSMTPTable(dbSmtpTable data) {

    //Read the resources
    // RELEASE
    //Locale currentLocale = BridgeApp.getCurrentLocale();

    // DEBUG
    Locale currentLocale = new Locale("en");

    mData = data;
    lbls = ResourceBundle.getBundle("dbridge.prop.dsServerTablesBundle",
                                    currentLocale);

    this.setModel(new dsSMTPTableModel( data.getVector()));
    this.initColumnSizes();

  }

  public void setData(dbSmtpTable data){
    mData = data;
    this.setModel(new dsSMTPTableModel( data.getVector()));
    this.initColumnSizes();
    this.updateUI();
  }

  public Object getSelection(){
    dbSmtpRecord res;

    int index = this.getSelectedRow();
    if (index==-1) res=null;
    else res= mData.getRecord(index);

    return res;
  }

  private void initColumnSizes(){
    dsSMTPTableModel model = (dsSMTPTableModel) this.getModel();
    TableColumn column = null;
    Component comp = null;
    int headerWidth = 0;
    int cellWidth = 0;
    Object[] longValues = model.longValues;
    TableCellRenderer headerRenderer =
        this.getTableHeader().getDefaultRenderer();

    for (int i = 0; i < 3; i++) {
      column = this.getColumnModel().getColumn(i);

      comp = headerRenderer.getTableCellRendererComponent(
          null, column.getHeaderValue(),
          false, false, 0, 0);
      headerWidth = comp.getPreferredSize().width;

      comp = this.getDefaultRenderer(model.getColumnClass(i)).
          getTableCellRendererComponent(
          this, longValues[i],
          false, false, 0, i);

      cellWidth = comp.getPreferredSize().width;

      //XXX: Before Swing 1.1 Beta 2, use setMinWidth instead.
      column.setPreferredWidth(Math.max(headerWidth, cellWidth));
      column.setMinWidth(Math.max(headerWidth, cellWidth));
    }

  }

}

//============================================================================
//    JTable POP/IMAP
//===========================================================================
class dsPOPTable extends JTable implements dsServersTable{

  private ResourceBundle lbls;
  private dbMailTable mData;

/////////////////////////////////////////////////////////////////////////////
//       Table Model subclass
/////////////////////////////////////////////////////////////////////////////

    class dsPOPTableModel
        extends AbstractTableModel {
        private Vector table_data = new Vector();

        public dsPOPTableModel(Vector data) {
          super();
          table_data = data;
        }

        private String[] columnNames = {
            lbls.getString("server"),
            lbls.getString("type"),
            lbls.getString("login"),
            lbls.getString("port")};

        public final Object[] longValues = {
            "XXX.XXX.XXX.XXX", "XXXX",
            "XXXXXXXXXX", "XXXX"};

        public int getColumnCount() {
          return columnNames.length;
        }

        public int getRowCount() {
          return table_data.size();
        }

        public String getColumnName(int col) {
          return columnNames[col];
        }

        public Object getValueAt(int row, int col) {
          String res = null;
          switch (col){
            case 0:
              res = ( (dbMailRecord) table_data.get(row)).getDomain(); break;
            case 1: {
              if ( ( (dbMailRecord) table_data.get(row)).isImap())
                res = new String(lbls.getString("imap"));
              else res = new String(lbls.getString("pop"));
            }
              break;
            case 2:
              res = ( (dbMailRecord) table_data.get(row)).getMail(); break;
            case 3:
              res = Integer.toString(((dbMailRecord) table_data.get(row)).getPort()); break;
          }

          return res;
        }

        public boolean isCellEditable(int row, int col) {
          return false;
        }
     }
///////////////////////////////////////////////////////////////////////////////
  public dsPOPTable(dbMailTable data) {

    //Read the resources
    // RELEASE
    //Locale currentLocale = BridgeApp.getCurrentLocale();

    // DEBUG
    Locale currentLocale = new Locale("en");

    mData = data;
    lbls = ResourceBundle.getBundle("dbridge.prop.dsServerTablesBundle",
                                    currentLocale);

    this.setModel(new dsPOPTableModel( data.getVectorPtr()));
    this.initColumnSizes();

  }

  public void setData(dbMailTable data){
    mData = data;
    this.setModel(new dsPOPTableModel( data.getVectorPtr()));
    this.initColumnSizes();
    this.updateUI();
  }

  public Object getSelection(){
    return mData.getRecord(this.getSelectedRow());
  }

  private void initColumnSizes(){
    dsPOPTableModel model = (dsPOPTableModel) this.getModel();
    TableColumn column = null;
    Component comp = null;
    int headerWidth = 0;
    int cellWidth = 0;
    Object[] longValues = model.longValues;
    TableCellRenderer headerRenderer =
        this.getTableHeader().getDefaultRenderer();

    for (int i = 0; i < 4; i++) {
      column = this.getColumnModel().getColumn(i);

      comp = headerRenderer.getTableCellRendererComponent(
          null, column.getHeaderValue(),
          false, false, 0, 0);
      headerWidth = comp.getPreferredSize().width;

      comp = this.getDefaultRenderer(model.getColumnClass(i)).
          getTableCellRendererComponent(
          this, longValues[i],
          false, false, 0, i);

      cellWidth = comp.getPreferredSize().width;

      //XXX: Before Swing 1.1 Beta 2, use setMinWidth instead.
      column.setPreferredWidth(Math.max(headerWidth, cellWidth));
      column.setMinWidth(Math.max(headerWidth, cellWidth));
    }

  }

}

//============================================================================
//    JTable ADDR BOOK
//===========================================================================
class dsAddrBookTable extends JTable  implements dsServersTable{

  private ResourceBundle lbls;
  private dbMailTable mData;

/////////////////////////////////////////////////////////////////////////////
//       Table Model subclass
/////////////////////////////////////////////////////////////////////////////

    class dsAddrBookTableModel
        extends AbstractTableModel {
        private dbMailTable table_data = null;
        private dbSmtpTable smtp_data = null;

        public dsAddrBookTableModel(dbMailTable addr_book, dbSmtpTable smtp_table) {
          super();
          table_data = addr_book;
          smtp_data=smtp_table;
        }

        private String[] columnNames = {
            lbls.getString("addr"),
            lbls.getString("smtp"),
            lbls.getString("key")};

        public final Object[] longValues = {
            "XXX.XXX.XXX.XXX",
            "XXXXXXXXXX", "XXXXXXX"};

        public int getColumnCount() {
          return columnNames.length;
        }

        public int getRowCount() {
          return table_data.getSize();
        }

        public String getColumnName(int col) {
          return columnNames[col];
        }

        public Object getValueAt(int row, int col) {
          String res = null;
          switch (col){
            case 0:
              res = table_data.getRecord(row).getMailDomainAddr(); break;
            case 1: {
              int iDefSmtp = table_data.getRecord(row).getSrvIndex();
              //TODO: fixed (BOB) testing
              if (smtp_data.getRecord(iDefSmtp) != null) res = smtp_data.getRecord(iDefSmtp).getIP();
              else res = lbls.getString("no_data");
              break;
              //( (dbMailRecord) table_data.get(row)).break;
            }
            case 2:
              res = table_data.getRecord(row).getPubKeyN(); break;
          }

          return res;
        }

        public boolean isCellEditable(int row, int col) {
          return false;
        }
     }
///////////////////////////////////////////////////////////////////////////////
  public dsAddrBookTable(dbMailTable data, dbSmtpTable smtpdata) {

    //Read the resources
    // RELEASE
    //Locale currentLocale = BridgeApp.getCurrentLocale();

    // DEBUG
    Locale currentLocale = new Locale("en");

    mData = data;
    lbls = ResourceBundle.getBundle("dbridge.prop.dsServerTablesBundle",
                                    currentLocale);

    this.setModel(new dsAddrBookTableModel( data, smtpdata));
    this.initColumnSizes();

  }

  public void setData(dbMailTable data, dbSmtpTable smtpdata){
    mData = data;
    this.setModel(new dsAddrBookTableModel( data, smtpdata));
    this.initColumnSizes();
    this.updateUI();
  }

  public Object getSelection(){
    return mData.getRecord(this.getSelectedRow());
  }

  private void initColumnSizes(){
    dsAddrBookTableModel model = (dsAddrBookTableModel) this.getModel();
    TableColumn column = null;
    Component comp = null;
    int headerWidth = 0;
    int cellWidth = 0;
    Object[] longValues = model.longValues;
    TableCellRenderer headerRenderer =
        this.getTableHeader().getDefaultRenderer();

    for (int i = 0; i < 3; i++) {
      column = this.getColumnModel().getColumn(i);

      comp = headerRenderer.getTableCellRendererComponent(
          null, column.getHeaderValue(),
          false, false, 0, 0);
      headerWidth = comp.getPreferredSize().width;

      comp = this.getDefaultRenderer(model.getColumnClass(i)).
          getTableCellRendererComponent(
          this, longValues[i],
          false, false, 0, i);

      cellWidth = comp.getPreferredSize().width;

      //XXX: Before Swing 1.1 Beta 2, use setMinWidth instead.
      column.setPreferredWidth(Math.max(headerWidth, cellWidth));
      column.setMinWidth(Math.max(headerWidth, cellWidth));
    }

  }

}

