package dbridge;

import java.awt.*;
import java.io.*;
import java.util.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Locale;
import java.util.ResourceBundle;

//
/**
 * <p>Title: </p> User Send Files Dialog
 * <p>Description: </p>
 * Shows how many files available,
 * choose email accounts and send ...
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author
 * @version 1.0
 * <p> last modification: 22.12.2004 </p>
 * <p> last modification: 3.03.05-15.04.05 </p>
 */
interface ISenderControl{
  public void stop_send();
  }

public class dsUserDlg1Frame
    extends JFrame implements IGuiWithFolderChecker,
    IProcessOwner {

  /**
  *  Thread to send files
  */



  class dsSMTP_sender
      extends Thread implements ISenderControl{
    private CSmtpFilesSender mSmtpSender = null;
//    private Vector mFiles = null;
    private boolean isFinished = false;
    private Vector mXTagCollections_copy = null;
    private boolean mDelFiles = false;
    private IProcessOwner mStatusProcessor = null;
    private boolean m_stop = false;

    /**
     *  Constructor with Status monitor dialog
     */

    dsSMTP_sender(dbUser user,
                  boolean DelAfterSent,
                  boolean eraseName,
                  String comments,
                  dsSendStatusDlg StatusDlg,
                  Vector TO_Records,
                  Vector vXTagCollections) {

      mDelFiles = DelAfterSent;
      mSmtpSender = new CSmtpFilesSender(user);
      mSmtpSender.SetDeleteAfterSend(DelAfterSent);
      mSmtpSender.setEraseNames(eraseName);
      mSmtpSender.SetComments(comments);
      mSmtpSender.setRecords(TO_Records);
      mXTagCollections_copy = vXTagCollections;
      //mSmtpSender.setXTag(x_tag);

      if (StatusDlg != null) {
        mStatusProcessor = StatusDlg.addStatusProcessor();
        mSmtpSender.SetProcessOwner(mStatusProcessor);
        ((dsSMTPStatusPanel) mStatusProcessor).setProcController(this);
      }

      //mFiles = vFiles;
    }

    /**
     *  Constructor for IProcessOwner
     */

    dsSMTP_sender(dbUser user,
                  boolean DelAfterSent,
                  boolean eraseName,
                  String comments,
                  IProcessOwner owner,
                  Vector TO_Records,
                  Vector vXTagCollections) {

      mDelFiles = DelAfterSent;
      mSmtpSender = new CSmtpFilesSender(user);
      mSmtpSender.SetDeleteAfterSend(DelAfterSent);
      mSmtpSender.setEraseNames(eraseName);
      mSmtpSender.SetComments(comments);
      mSmtpSender.setRecords(TO_Records);
      //mSmtpSender.setXTag(x_tag);

      mSmtpSender.SetProcessOwner(owner);
      mXTagCollections_copy = vXTagCollections;
      //mFiles = vFiles;
    }

    public void run() {
      System.out.println("Send thread started!");
      isFinished = false;

      if (mDelFiles) {
        try {
          enableSelectButton(false);
        }
        catch (Exception e) {
          System.out.println("Error while sending");
          e.printStackTrace();
        }
      }
      //
      // Send files by XTag collections
      //
      //Vector f_names = new Vector();
      //System.out.println("XTAGS to send: " + mXTagCollections_copy.size());
      int counter = 0;
      int size = mXTagCollections_copy.size();
      if (size>1){
        mSmtpSender.allowFinishStatus(false);
      }

      for (Iterator it = mXTagCollections_copy.iterator(); it.hasNext() && !m_stop; ) {
        XTagCollection curr = (XTagCollection) it.next();

        //Send the comments only with the first XTAG collection
        if (counter>0) mSmtpSender.SetComments("");

        if (mStatusProcessor!=null){
           ((dsSMTPStatusPanel) mStatusProcessor).XtagProgress(counter+1, size+1);
           //show final status only on the last loop step
           if (counter == size-1) mSmtpSender.allowFinishStatus(true);
        }

        mSmtpSender.setXTag(curr.getXTag());
        mSmtpSender.ProcessFiles(curr.getFileNames());
        counter++;
      }

      isFinished = true;
      if (mDelFiles) {
        try {
          enableSelectButton(true);
        }
        catch (Exception e) {
          BridgeApp.LogDebug(Logs.GUI.SetText("dsSMTP_sender.run: enableSelectButton failed"));
          BridgeApp.LogDebug(Logs.GUI.SetText("Exception: " + e.getMessage()));

        }
      }

      //System.out.println("Send thread stoped!");
    }

    public boolean isFinished() {
      return isFinished;
    }

    public void stop_send(){
      m_stop = true;
      mSmtpSender.Stop();
    }
  }

  dsSendStatusDlg mStatusDlg = null;
  //----- GUI part begin --------------------------------
  //----- main panel -------
  JPanel contentPane;
  BorderLayout borderLayout5 = new BorderLayout();

  //------ 1. information panel (NORTH) --------
  JPanel info_panel = new JPanel();
  GridLayout gridLayout3 = new GridLayout();

  JLabel jlNumFilesX = new JLabel();
  JLabel lNumFiles = new JLabel();
  JLabel jlSelFilesX = new JLabel();
  JLabel jlNumSelFiles = new JLabel();
  JLabel jlSelSizeX = new JLabel();
  JLabel jlSelSize = new JLabel();

  //----- 2. accounts pannel (CENTER) ----------
  JPanel Accounts_panel = new JPanel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();

    //---- 2.1. LEFT --------------------
    JPanel Left_panel = new JPanel();
    BorderLayout borderLayout2 = new BorderLayout();

      JPanel stub_panel_accounts = new JPanel();
      GridLayout gridLayout1 = new GridLayout();
      JLabel jlAccountsX = new JLabel();

      JScrollPane jspAccounts_pane = new JScrollPane();
      JList jlAccounts_list = new JList();

    //----- 2.2. MIDDLE ------------------
    JPanel Middle_panel = new JPanel();
    FlowLayout flowLayout2 = new FlowLayout();

      JPanel stub_panelX = new JPanel();
      JButton bGoLeft = new JButton();
      JButton bGoRight = new JButton();


    //----- 2.3. RIGHT -------------------
    JPanel Right_panel = new JPanel();
    BorderLayout borderLayout3 = new BorderLayout();

        JPanel stub_panel_send = new JPanel();
        GridLayout gridLayout2 = new GridLayout();
        JLabel jlSendX = new JLabel();

        JScrollPane jspSendTo_pane = new JScrollPane();
        JList jlSendTo_list = new JList();


  //------ 3. Comments panel (SOUTH) -------
  JLabel jlXtag;
  JTextField jtfXTag = new JTextField();
  JPanel comments_panel = new JPanel();
  BorderLayout borderLayout4 = new BorderLayout();

    //----- 3.1. north -----------
    JPanel slub_panel_comments = new JPanel();
    GridLayout gridLayout4 = new GridLayout(0,1,1,1);
    JLabel jlCommentsX = new JLabel();

    //----- 3.2. center ----------
    JScrollPane jspComments = new JScrollPane();
    JTextArea jtaComments = new JTextArea();

    //----- 3.3. south -----------
    JPanel jpComments_south = new JPanel();
    BorderLayout borderLayout1 = new BorderLayout();

      //-- 3.3.1. north ---
      JPanel jpSettings = new JPanel();
      FlowLayout flowLayout3 = new FlowLayout();
      JCheckBox jcbDelFiles = new JCheckBox();
      JCheckBox jcbEraseName = new JCheckBox();

      //-- 3.3.2. center ---
      JPanel Buttons_panel = new JPanel();
      FlowLayout flowLayout1 = new FlowLayout();

      JButton bSelect = new JButton();
      JButton bSend = new JButton();
      JButton bClose = new JButton();

      //-- 3.3.3. south ---
      JPanel jpStatusPanel = new JPanel();
      GridLayout gridLayout5 = new GridLayout();

      JLabel jlFilesSent = new JLabel();
      JProgressBar jpbSendProgress = new JProgressBar(0, 100);

//---- end of GUI part -----------------------------------------------

//===  PRIVATE PROPERTIES ======

 private  dbUser mUser;
// private  File Dir;
 //private  Vector FileList;
 //private  Vector selFileList = new Vector();
 //private  HashMap selFileMap = new HashMap();

 //TODO: Fixed to don't get NPE (when press Send without any files selected) bob
 private Vector mXTagCollections = new Vector();

 private  Vector emailList;
 private  Vector emailList2;
 //private  String Folder_name;
 private  CFolderChecker mCheckLoc;
 private  String mTitle;

 private ResourceBundle labels;
 private dsSelFilesDlg mSelFilesDlg = null;
 private boolean mSentDlgInit = false;

//=============================

  public String toString(){
    return mTitle;
  }

  public void setPanelMode(){
    this.bClose.setVisible(false);
    ///jpStatusPanel.setVisible(false);
  }

//------------------------------------------------------------------------
  public dsUserDlg1Frame(String title, dbUser oUser) {

    this.mUser = oUser;
    this.mTitle = title;

    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
      BridgeApp.LogDebug(Logs.GUI.SetText("dsUserDlg1Frame.jbInit()"));
      BridgeApp.LogDebug(Logs.GUI.SetText("Exception: " + e.getMessage()));
    }

    // this code stores selected directories during one client section
    String mail_dir=mUser.getMailDirPath();
    if ( mail_dir==null || mail_dir.compareTo("")==0 ){
      //flash is not necessary
      mUser.setMailDirPath(mUser.getLocDirPath());
    }

   // this.Dir = new File(mUser.getMailDirPath());
    this.emailList = mUser.getAddressBook().getVectorCopy();
    lNumFiles.setText(Integer.toString(0));
    jlSendTo_list.setListData(emailList2);
    jlAccounts_list.setListData(emailList);

    mCheckLoc = new CGuiFolderChecker( mUser.getLocDirPath(), this);
    mCheckLoc.StartChecking(5);
  }

  //-----------------------------------------------------------------------
  private void jbInit() throws Exception  {

    Locale currentLocale = BridgeApp.getCurrentLocale();
    labels = ResourceBundle.getBundle("dbridge.prop.dsUserDlg1LabelsBundle",currentLocale);

    // -- Window settings
    this.setSize(dsAlignments.NORMAL_SIZE);

    // -- main panel settings
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(borderLayout5);
    contentPane.setPreferredSize(new Dimension(400, 58));

    info_panel.setMinimumSize(new Dimension(1022, 25));
    info_panel.setPreferredSize(new Dimension(1022, 25));
    //comments_panel.setBorder(BorderFactory.createEtchedBorder());
    contentPane.add(info_panel, BorderLayout.NORTH);
    contentPane.add(Accounts_panel, BorderLayout.CENTER);
    contentPane.add(comments_panel, BorderLayout.SOUTH);

    //-- 1.0. panel (NORTH) ---
    info_panel.setBorder(BorderFactory.createEtchedBorder());
    info_panel.setLayout(gridLayout3);

      info_panel.add(jlNumFilesX, null);
      info_panel.add(lNumFiles, null);
      info_panel.add(jlSelFilesX, null);
      info_panel.add(jlNumSelFiles, null);
      info_panel.add(jlSelSizeX, null);
      info_panel.add(jlSelSize, null);

      jlNumFilesX.setText(labels.getString("NumberOfFiles"));
      jlNumFilesX.setIcon(new ImageIcon("./lib/res/data.gif"));
      jlNumFilesX.setMaximumSize(new Dimension(250, 17));
      jlNumFilesX.setMinimumSize(new Dimension(170, 17));
      jlNumFilesX.setPreferredSize(new Dimension(250, 17));

      lNumFiles.setMaximumSize(new Dimension(7, 10));
      lNumFiles.setMinimumSize(new Dimension(7, 10));
      lNumFiles.setPreferredSize(new Dimension(7, 10));
      lNumFiles.setText("0");

      jlSelFilesX.setText(labels.getString("SelectedFiles"));
      jlSelFilesX.setIcon(new ImageIcon("./lib/res/folderin.png"));
      jlSelFilesX.setMaximumSize(new Dimension(170, 17));
      jlSelFilesX.setMinimumSize(new Dimension(170, 17));
      jlSelFilesX.setPreferredSize(new Dimension(170, 17));
      jlNumSelFiles.setText("0");

      jlSelSizeX.setText(labels.getString("SelectedSize"));
      jlSelSizeX.setIcon(new ImageIcon("./lib/res/calculator.png"));
      jlSelSizeX.setMaximumSize(new Dimension(170, 17));
      jlSelSizeX.setMinimumSize(new Dimension(170, 17));
      jlSelSizeX.setPreferredSize(new Dimension(170, 17));

      jlSelSize.setMaximumSize(new Dimension(170, 17));
      jlSelSize.setMinimumSize(new Dimension(170, 17));
      jlSelSize.setPreferredSize(new Dimension(170, 17));
      jlSelSize.setText("0");

    //-- 2.0. panel (CENTER) ---
    Accounts_panel.setLayout(gridBagLayout1);
    //Accounts_panel.setBorder(BorderFactory.createEtchedBorder());
    Accounts_panel.setMinimumSize(new Dimension(352, 50));
    Accounts_panel.setPreferredSize(new Dimension(372, 50));
    Accounts_panel.setMaximumSize(new Dimension(372, 50));

    Accounts_panel.add( Left_panel,
                        new GridBagConstraints(0, 0, 1, 1, 100.0, 50.0,
                        GridBagConstraints.CENTER, GridBagConstraints.BOTH,
                        new Insets(0, 0, 0, 0), 0, 0));

    Accounts_panel.add( Middle_panel,
                        new GridBagConstraints(1, 0, 1, 1, 1.0, 1.0,
                        GridBagConstraints.CENTER, GridBagConstraints.VERTICAL,
                        new Insets(0, 0, 0, 0), 20, 20));

    Accounts_panel.add( Right_panel,
                        new GridBagConstraints(2, 0, 1, 1, 100.0, 50.0,
                        GridBagConstraints.CENTER, GridBagConstraints.BOTH,
                        new Insets(0, 0, 0, 0), 0, 0));

    final Dimension ADDR_SIZE = new Dimension(150, 50);

    Left_panel.setMinimumSize(ADDR_SIZE);
    Left_panel.setPreferredSize(ADDR_SIZE);
    Left_panel.setMaximumSize(ADDR_SIZE);
    Left_panel.setLayout(borderLayout2);

    Left_panel.add(stub_panel_accounts, BorderLayout.NORTH);
    Left_panel.add(jspAccounts_pane, BorderLayout.CENTER);

      stub_panel_accounts.setLayout(gridLayout1);
      stub_panel_accounts.add(jlAccountsX, null);

      jspAccounts_pane.setAutoscrolls(true);
      jspAccounts_pane.setMinimumSize(new Dimension(100, 80));
      jspAccounts_pane.setPreferredSize(new Dimension(100, 80));
      jspAccounts_pane.setMaximumSize(new Dimension(100, 80));
      jspAccounts_pane.getViewport().add(jlAccounts_list, null);

      jlAccounts_list.setMaximumSize(new Dimension(32767, 32767));

      jlAccountsX.setText(labels.getString("AvailableAccounts"));
      jlAccountsX.setIcon(new ImageIcon("./lib/res/usermagnify.gif"));

    Middle_panel.setMaximumSize(new Dimension(50, 31));
    Middle_panel.setMinimumSize(new Dimension(30, 31));
    Middle_panel.setPreferredSize(new Dimension(50, 31));
    Middle_panel.setLayout(flowLayout2);
    flowLayout2.setVgap(0);

    Middle_panel.add(stub_panelX, null);
    Middle_panel.add(bGoLeft, null);
    Middle_panel.add(bGoRight, null);

      stub_panelX.setMinimumSize(new Dimension(10, 20));
      stub_panelX.setPreferredSize(new Dimension(70, 20));

      bGoLeft.setMaximumSize(new Dimension(120, 20));
      bGoLeft.setMinimumSize(new Dimension(20, 20));
      bGoLeft.setPreferredSize(new Dimension(70, 20));
      bGoLeft.setToolTipText("");
      bGoLeft.setText(">>");
      bGoLeft.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(ActionEvent e) {
          bGoLeft_actionPerformed(e);
        }
      });

      bGoRight.setMaximumSize(new Dimension(200, 20));
      bGoRight.setMinimumSize(new Dimension(27, 20));
      bGoRight.setPreferredSize(new Dimension(70, 20));
      bGoRight.setText("<<");
      bGoRight.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(ActionEvent e) {
          bGoRight_actionPerformed(e);
        }
      });

    Right_panel.setMinimumSize(ADDR_SIZE);
    Right_panel.setPreferredSize(ADDR_SIZE);
    Right_panel.setMaximumSize(ADDR_SIZE);
    Right_panel.setLayout(borderLayout3);

    Right_panel.add(jspSendTo_pane, BorderLayout.CENTER);
    Right_panel.add(stub_panel_send, BorderLayout.NORTH);

      jspSendTo_pane.setMinimumSize(new Dimension(100, 80));
      jspSendTo_pane.getViewport().add(jlSendTo_list, null);

      stub_panel_send.setLayout(gridLayout2);
      stub_panel_send.add(jlSendX, null);
      jlSendX.setText(labels.getString("SendTo"));
      jlSendX.setIcon(new ImageIcon("./lib/res/forwardall.png"));

   //-- 3.0. south ---
    comments_panel.setMinimumSize(new Dimension(100, 400));
    comments_panel.setPreferredSize(new Dimension(100, 400));
    comments_panel.setMaximumSize(new Dimension(1000, 4000));
    comments_panel.setLayout(borderLayout4);

    comments_panel.add(slub_panel_comments, BorderLayout.NORTH);
    comments_panel.add(jspComments, BorderLayout.CENTER);
    comments_panel.add(jpComments_south, BorderLayout.SOUTH);

    slub_panel_comments.setLayout(gridLayout4);


//    Box box = Box.createHorizontalBox();
//    jlXtag=new JLabel(labels.getString("x_tag_label"));
//    jlXtag.setIcon(new ImageIcon("./lib/res/newpin.png"));
//    jtfXTag.addActionListener(new java.awt.event.ActionListener() {
//        public void actionPerformed(ActionEvent e) {
//          jtfXTag_actionPerformed(e);
//        }
//    });


//    box.add(jlXtag);
//    box.add(Box.createHorizontalStrut(20));
//    box.add(jtfXTag);

//    slub_panel_comments.add(box, null);
    slub_panel_comments.add(jlCommentsX, null);
    jlCommentsX.setText(labels.getString("Comments"));
    jlCommentsX.setIcon(new ImageIcon("./lib/res/documentdraw.png"));

    jspComments.getViewport().add(jtaComments, null);
    jtaComments.setMinimumSize(new Dimension(0, 0));
    jtaComments.setPreferredSize(new Dimension(100, 100));

    jpComments_south.setLayout(borderLayout1);

    jpComments_south.add(jpSettings,  BorderLayout.NORTH);
    jpComments_south.add(Buttons_panel, BorderLayout.CENTER);

    jpSettings.setLayout(flowLayout3);
    jpSettings.add(jcbDelFiles, null);
    jpSettings.add(jcbEraseName,null);
    flowLayout3.setAlignment(FlowLayout.LEFT);

    jcbDelFiles.setSelected(false);
    jcbDelFiles.setText(labels.getString("Delete"));
    jcbEraseName.setSelected(false);
    jcbEraseName.setText(labels.getString("EraseName"));

    Buttons_panel.setLayout(flowLayout1);
    //Buttons_panel.setBorder(BorderFactory.createEtchedBorder());

    Buttons_panel.add(bSelect, null);
    Buttons_panel.add(bSend, null);
    Buttons_panel.add(bClose, null);

    bSelect.setText(labels.getString("SelectFiles"));
    bSelect.setIcon(new ImageIcon("./lib/res/open.png"));
    bSelect.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        bSelect_actionPerformed(e);
      }
    });

    bSend.setText(labels.getString("Send"));
    bSend.setIcon(new ImageIcon("./lib/res/enter.gif"));
    bSend.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        bSend_actionPerformed(e);
      }
    });

    bClose.setText(labels.getString("Close"));
    bClose.setIcon(new ImageIcon("./lib/res/thumbdown.gif"));
    bClose.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        bClose_actionPerformed(e);
      }
    });

/*    jpStatusPanel.setLayout(gridLayout5);
    //jpStatusPanel.setBorder(BorderFactory.createEtchedBorder());
    jpStatusPanel.setMaximumSize(new Dimension(302, 30));
    jpStatusPanel.setMinimumSize(new Dimension(302, 30));

    jpStatusPanel.add(jlFilesSent, null);
    jpStatusPanel.add(jpbSendProgress, null);

    gridLayout5.setHgap(2);*/

    jpbSendProgress.setBorder(BorderFactory.createLoweredBevelBorder());
    jpbSendProgress.setMaximumSize(new Dimension(32767, 25));
    jpbSendProgress.setMinimumSize(new Dimension(100, 25));
    jpbSendProgress.setPreferredSize(new Dimension(150, 25));

    jlFilesSent.setBorder(BorderFactory.createLoweredBevelBorder());
    jlFilesSent.setMaximumSize(new Dimension(100, 25));
    jlFilesSent.setMinimumSize(new Dimension(100, 25));
    jlFilesSent.setPreferredSize(new Dimension(100, 25));
    jlFilesSent.setText(labels.getString("FilesSent")+ " 0");


    //this.FileList = new Vector();
    this.emailList = new Vector();
    this.emailList2 = new Vector();

    //System.out.println("dsUserDlg1Frame :: EXT= " + mUser.getExtDirPath() + " " + (new File(mUser.getExtDirPath()).getAbsolutePath()));
    mSentDlgInit = false;
    //mSelFilesDlg = new dsSelFilesDlg(new File(mUser.getExtDirPath()), null, true);
}
//-------------------------------------------------------------------------
  void jtfXTag_actionPerformed(ActionEvent e) {
       // correct xtag if Enter has been pressed
       String str=jtfXTag.getText();
       XTag xtag=new XTag();
       if ( !xtag.isCorrect(str) ){
         xtag.setText(str);
         jtfXTag.setText(xtag.toString());
         System.out.println(str);
         Object[] options = {
             "OK", "CANCEL"};
         JOptionPane.showOptionDialog(null, "X-Tag:"+ str + " >> " +xtag.toString()+"\n"+
                                      "<Symbol> = - | _ | . | , | 0 | ... 9 | a | ... | z | A | ... Z", "Warning",
                                      JOptionPane.DEFAULT_OPTION,
                                      JOptionPane.WARNING_MESSAGE, null,
                                      options, options[0]);
       }
    }


//-------------------------------------------------------------------------
  void bGoLeft_actionPerformed(ActionEvent e) {

    Vector temp_v = new Vector(emailList);
    for (int i=0; i<jlAccounts_list.getSelectedValues().length; i++)
    {
      emailList2.add(jlAccounts_list.getSelectedValues()[i]);
      temp_v.remove(jlAccounts_list.getSelectedValues()[i]);
    }
      emailList = temp_v;
      jlAccounts_list.setListData(emailList);
      jlSendTo_list.setListData(emailList2);

  }
//----------------------------------------------------------------------------
  void bGoRight_actionPerformed(ActionEvent e) {

    Vector temp_v = new Vector(emailList2);
    for (int i=0; i<jlSendTo_list.getSelectedValues().length; i++)
    {
      emailList.add(jlSendTo_list.getSelectedValues()[i]);
      temp_v.remove(jlSendTo_list.getSelectedValues()[i]);
    }

      emailList2 = temp_v;
      jlAccounts_list.setListData(emailList);
      jlSendTo_list.setListData(emailList2);

  }

  private void showStatusDlg(){
          if (mStatusDlg==null){
          mStatusDlg=new dsSendStatusDlg(this, labels.getString("MessageBoxTitle"), false, true);
        }
        mStatusDlg.setVisible(true);
  }

  //---- Send button pressed ----------------
  void bSend_actionPerformed(ActionEvent e) {

    BridgeApp.LogDebug(Logs.GUI.SetText("--- Send Button pressed -----"));

    //XTag x_tag= new XTag(jtfXTag.getText());
    //jtfXTag.setText(x_tag.toString());
    Locale currentLocale = BridgeApp.getCurrentLocale();
    ResourceBundle labels = ResourceBundle.getBundle("dbridge.prop.dsUserDlg1LabelsBundle",currentLocale);

    //String To_list = "";
    Vector TO_Records = new Vector();
    //String [] Key_list = null;
    //String FileName = "";

    if (mXTagCollections.size()<1){
      JOptionPane.showMessageDialog(this, labels.getString("NoFilesSelected"));
      return;
    }

    if (emailList2.size() > 0) {
      BridgeApp.LogDebug(Logs.GUI.SetText("EMAILS to send =" + emailList2.size()));
      TO_Records.add( (dbMailRecord) emailList2.elementAt(0));
      for (int i = 1; i < emailList2.size(); i++) {
        dbMailRecord curr = (dbMailRecord) emailList2.elementAt(i);
        TO_Records.add(curr);

        BridgeApp.LogDebug(Logs.GUI.SetText("RECORD:"+curr.toString()));
      }
    }
    else {
      JOptionPane.showMessageDialog(this, labels.getString("NoRecipient"));
      return;
    }

   //
   // Create Send Thread
   //
   if (mXTagCollections.size()>0 && TO_Records.size()>0){
       showStatusDlg();

      Vector xtag_coll_copy = new Vector(); //Vector) mXTagCollections.clone();
      // make a copy of mXTagCollections
      for (Iterator it= mXTagCollections.iterator(); it.hasNext();){
        xtag_coll_copy.add(((XTagCollection) it.next()).clone());
      }

      dsSMTP_sender send_thread = new dsSMTP_sender(mUser,
                                                    this.jcbDelFiles.isSelected(),
                                                    this.jcbEraseName.isSelected(),
                                                    this.jtaComments.getText(),
                                                    mStatusDlg,
                                                    //this,
                                                    TO_Records,
                                                    xtag_coll_copy);
      mStatusDlg.setVisible(true);
      send_thread.start();

      mSelFilesDlg.clearContainer();
      jlNumSelFiles.setText("0");
      jlSelSize.setText("0 bytes");

    }else{
      JOptionPane.showMessageDialog(this, labels.getString("NoSelection"),labels.getString("MessageBoxTitle"), 1);
    }

  }


  //  TO CALL in THREAD
    private void enableSelectButton(boolean enable) throws Exception {

      final boolean p = enable;
      Runnable updateButton = new Runnable() {
        public void run() {
          bSelect.setEnabled(p);
          bSelect.updateUI();
        }
      };
      SwingUtilities.invokeLater(updateButton);

    }



//------------------------------------------
  void bSelect_actionPerformed(ActionEvent e) {

     if (!mSentDlgInit){
      mSelFilesDlg = new dsSelFilesDlg(new File(mUser.getExtDirPath()), null, true);
      mSentDlgInit = true;
    }
    mSelFilesDlg.setVisible(true);
    long size = 0;  //size of selected in bytes
    if (mSelFilesDlg.isOk()){
      mXTagCollections = mSelFilesDlg.getXTagCollections();

     }


    //
    // SIZEs from selection dialog
    //
      size = mSelFilesDlg.getSelectedSize();

      jlNumSelFiles.setText(Integer.toString(mSelFilesDlg.getSelectedNum()));
      jlSelSize.setText(Long.toString(size/1024) + "Kb");

  }

  void bClose_actionPerformed(ActionEvent e) {
    this.setVisible(false);
    if (mSelFilesDlg!=null) mSelFilesDlg.dispose();
//  Changed 14.12.06
    //.invalidate();
  }

  //-------------------------------------------
  public void UpdateFiles(Vector vFiles, String sFolder)
  {
    this.lNumFiles.setText(Integer.toString(vFiles.size()));
  }
  //-----------------------------------------------------------
  //SOME FUNCTION THAT WILL SHOW THE PROGRESS
  public void ProcessProgress(int i, int n){
    Locale currentLocale = BridgeApp.getCurrentLocale();
    ResourceBundle labels = ResourceBundle.getBundle("dbridge.prop.dsUserDlg1LabelsBundle",currentLocale);

    jlFilesSent.setText(labels.getString("FilesSent") +" "+ (i+1));
    int progress = (int) 100.0*(i+1)/n;
    this.jpbSendProgress.setValue(progress);
    if (jpbSendProgress.getGraphics()!=null){
      jpbSendProgress.update(jpbSendProgress.getGraphics());
    }

 //   this.update(this.getGraphics());
  }
  //----------------------------------------------------------
   public void ProcessFinished(int size, String msg)
   {
    Locale currentLocale = BridgeApp.getCurrentLocale();
    ResourceBundle labels = ResourceBundle.getBundle("dbridge.prop.dsUserDlg1LabelsBundle",currentLocale);

    this.jpbSendProgress.setValue(0);
    //this.selFileList.clear();
    jlNumSelFiles.setText("0");
    jlSelSize.setText("0 bytes");
    if (size>0){
      jlFilesSent.setText(labels.getString("FilesFailed") +" "+ size);
      JOptionPane.showMessageDialog(this, msg, labels.getString("SendError"), JOptionPane.ERROR_MESSAGE);
    }
   }

   //--------------------------------------------------------------
}
