package dbridge;

import java.awt.*;
import javax.swing.*;
import java.io.*;
import java.util.*;
import java.awt.event.*;
import javax.swing.border.*;
import java.util.Locale;
import java.util.ResourceBundle;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

//=========================================================================
//  Thread to send files
//=========================================================================
/*
 *  Note all text constants will be loaded from dbridge.prop.dsUserDlg1LabelsBundle
 */

class dsDCM_sender extends Thread{
  private CDicomFilesSender mDicomSender = null;
  private Vector mFiles = null;
  private boolean isFinished = false;

  dsDCM_sender(dbUser user,
                boolean DelAfterSent,
                dsDcmServerClass server,
                IProcessOwner obj,
                Vector vFiles){

    mDicomSender = new CDicomFilesSender(DBridgeClient.Bank(), user);
    mDicomSender.SetDeleteAfterSend(DelAfterSent);
    mDicomSender.SetServer(server.getDcmServer());
    mDicomSender.SetAeTitleC(server.getDcmAeTitle());
    mDicomSender.SetPort(server.getDcmPort());
    mDicomSender.SetProcessOwner(obj);

    mFiles = vFiles;
  }

  dsDCM_sender(dbUser user,
              boolean DelAfterSent,
              dsDcmServerClass server,
              dsSendStatusDlg obj,
              Vector vFiles){

  mDicomSender = new CDicomFilesSender(DBridgeClient.Bank(), user);
  mDicomSender.SetDeleteAfterSend(DelAfterSent);
  mDicomSender.SetServer(server.getDcmServer());
  mDicomSender.SetAeTitleC(server.getDcmAeTitle());
  mDicomSender.SetPort(server.getDcmPort());
  mDicomSender.SetProcessOwner(obj.addStatusProcessor());

  mFiles = vFiles;
}


  public void run(){
    isFinished = false;
    mDicomSender.ProcessFiles(mFiles);
    isFinished = true;
  }

  public boolean isFinished(){
    return isFinished;
  }
}



public class dsUserDlg2Frame extends JFrame implements IGuiWithFolderChecker,
                                                        IProcessOwner {

  //--  my stuff -------------
  File Dir;
  String Folder_name; // TODO: remove
  String Folder_name_txt;
  ResourceBundle labels;

  dbUser mUser;
  Vector mDCMServers;
  dbBank mBank=null;
  String mTitle=null;
  dsSendStatusDlg mStatusDlg = null;

  Vector FileList = new Vector();
  Vector TextFileList = new Vector();
  //------------------------------------------------
  JPanel pMailsPane = new JPanel();
  JPanel jPanel2 = new JPanel();
  JLabel jlSelFiles = new JLabel();
  GridLayout gridLayout1 = new GridLayout();
  JScrollPane jScrollPane1 = new JScrollPane();
  JList jList1 = new JList();
  JPanel jPanel3 = new JPanel();
  JPanel jPanel4 = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JLabel jLabel2 = new JLabel();
  GridLayout gridLayout2 = new GridLayout();
  JScrollPane jScrollPane2 = new JScrollPane();
  JTextArea jTextArea1 = new JTextArea();
  JPanel jPanel5 = new JPanel();
  JButton bSendToServer = new JButton();
  JButton bClose = new JButton();
  BorderLayout borderLayout1 = new BorderLayout();
  JButton jButton1 = new JButton();
  BorderLayout borderLayout3 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JPanel jPanel6 = new JPanel();
  JCheckBox jcbDelAfterSend = new JCheckBox();
  FlowLayout flowLayout1 = new FlowLayout();
  BorderLayout borderLayout4 = new BorderLayout();
  JProgressBar jpbSendProgress = new JProgressBar(0, 100);
  JLabel jlFilesSent = new JLabel();
  GridLayout gridLayout5 = new GridLayout();
  JPanel jpStatusPanel = new JPanel();
  TitledBorder titledBorder1;
  TitledBorder titledBorder2;
  TitledBorder titledBorder3;

  public String toString(){
    return mTitle;
  }

  public void setPanelMode(){
    this.bClose.setVisible(false);
    //jpStatusPanel.setVisible(false);
  }

  public dsUserDlg2Frame(String title, dbUser oUser) {
    try {
      mTitle = title;
      this.mUser = oUser;
      this.mBank = DBridgeClient.Bank();   // copy of the DB
      // this code stores selected directories during one client section
      String dcm_dir=mUser.getDcmDirPath();
      if (dcm_dir == null || dcm_dir.compareTo("") == 0) {
        //flash is not necessary
        mUser.setDcmDirPath(mUser.getDecryptedDirPath());
      }
      this.Dir=new File(mUser.getDcmDirPath());
      Folder_name = this.mUser.getDecryptedDirPath();  // TODO: remove
      Folder_name_txt = this.mUser.getWaitDirPath();
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }


  private void showStatusDlg(){
        if (mStatusDlg==null){
        mStatusDlg=new dsSendStatusDlg(this, labels.getString("DICOMMessageBoxTitle"), false, false);
      }
      mStatusDlg.setVisible(true);
}



  private void jbInit() throws Exception {

    Locale currentLocale = BridgeApp.getCurrentLocale();
    try {
    labels = ResourceBundle.getBundle("dbridge.prop.dsUserDlg1LabelsBundle",currentLocale);
    } catch (MissingResourceException ex){
       JOptionPane.showMessageDialog(this, "MissingResourceException", "Resource for the key " + ex.getKey()+" is not found", JOptionPane.ERROR_MESSAGE);
    }

    titledBorder1 = BorderFactory.createTitledBorder(labels.getString("AnnotationFiles"));
    titledBorder2 = new TitledBorder("");
    titledBorder3 = new TitledBorder("");
    this.setSize(new Dimension(400, 347));
    this.setTitle(labels.getString("Login") +" "+ mUser.getLogin());
    pMailsPane.setMinimumSize(new Dimension(81, 100));
    pMailsPane.setPreferredSize(new Dimension(100, 120));
    pMailsPane.setLayout(borderLayout1);
    this.getContentPane().setLayout(borderLayout3);
    jPanel2.setBorder(BorderFactory.createEtchedBorder());
    jPanel2.setLayout(gridLayout1);
    jlSelFiles.setMaximumSize(new Dimension(77, 15));
    jlSelFiles.setMinimumSize(new Dimension(77, 25));
    jlSelFiles.setPreferredSize(new Dimension(77, 25));
    jlSelFiles.setText(labels.getString("SelectedFiles") +" 0");
    gridLayout1.setHgap(10);
    jPanel3.setLayout(borderLayout2);
    jPanel4.setBorder(BorderFactory.createEtchedBorder());
    jPanel4.setLayout(gridLayout2);
    jLabel2.setText(labels.getString("Label2Text"));
    jTextArea1.setText(labels.getString("CommentsText"));
    jPanel5.setMinimumSize(new Dimension(100, 80));
    jPanel5.setPreferredSize(new Dimension(100, 80));
    jPanel5.setMaximumSize(new Dimension(100, 80));
    jPanel5.setLayout(borderLayout4);
    bSendToServer.setText(labels.getString("bSendToServerTxt"));
    bSendToServer.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        bSendToServer_actionPerformed(e);
      }
    });
    bClose.setText(labels.getString("bCloseTxt"));
    bClose.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        bClose_actionPerformed(e);
      }
    });
    borderLayout2.setHgap(2);
    borderLayout2.setVgap(2);
    jList1.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        jList1_mouseClicked(e);
      }
    });

    jButton1.setText(labels.getString("SelectFiles"));
    jButton1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton1_actionPerformed(e);
      }
    });
    jPanel6.setLayout(flowLayout1);
    jcbDelAfterSend.setToolTipText("");
    jcbDelAfterSend.setSelected(false);
    jcbDelAfterSend.setText(labels.getString("Delete"));
    flowLayout1.setAlignment(FlowLayout.LEFT);
    jPanel1.setBorder(BorderFactory.createEtchedBorder());
    jPanel1.setMinimumSize(new Dimension(317, 27));
    jPanel1.setPreferredSize(new Dimension(317, 27));
    jpbSendProgress.setBorder(BorderFactory.createLoweredBevelBorder());
    jpbSendProgress.setMaximumSize(new Dimension(32767, 25));
    jpbSendProgress.setMinimumSize(new Dimension(100, 25));
    jpbSendProgress.setPreferredSize(new Dimension(150, 25));
    jlFilesSent.setBorder(BorderFactory.createLoweredBevelBorder());
    jlFilesSent.setMaximumSize(new Dimension(100, 25));
    jlFilesSent.setMinimumSize(new Dimension(100, 25));
    jlFilesSent.setPreferredSize(new Dimension(100, 25));
    jlFilesSent.setText(labels.getString("FilesSent") + " 0");
    gridLayout5.setHgap(2);
    jpStatusPanel.setLayout(gridLayout5);
    jpStatusPanel.setBorder(BorderFactory.createEtchedBorder());
    jpStatusPanel.setMaximumSize(new Dimension(302, 30));
    jpStatusPanel.setMinimumSize(new Dimension(302, 30));
    jScrollPane1.setBorder(titledBorder1);
    jPanel6.setBorder(BorderFactory.createEtchedBorder());
    pMailsPane.add(jScrollPane1, BorderLayout.CENTER);
    pMailsPane.add(jPanel2, BorderLayout.NORTH);
    jPanel2.add(jlSelFiles, null);
    jScrollPane1.getViewport().add(jList1, null);
    this.getContentPane().add(jPanel3,  BorderLayout.CENTER);
    jPanel3.add(jPanel4, BorderLayout.NORTH);
    jPanel4.add(jLabel2, null);
    jPanel3.add(jScrollPane2,  BorderLayout.CENTER);
    this.getContentPane().add(jPanel5, BorderLayout.SOUTH);
    jPanel5.add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(jButton1, null);
    jPanel1.add(bSendToServer, null);
    jPanel1.add(bClose, null);
    jPanel5.add(jPanel6,  BorderLayout.NORTH);
    jPanel6.add(jcbDelAfterSend, null);
    //jPanel5.add(jpStatusPanel,  BorderLayout.SOUTH);
    //jpStatusPanel.add(jlFilesSent, null);
    //jpStatusPanel.add(jpbSendProgress, null);
    this.getContentPane().add(pMailsPane, BorderLayout.NORTH);
    jScrollPane2.getViewport().add(jTextArea1, null);

     fillTxtList();
    //------------------------------------------------
  }

  //Overridden so we can exit when window is closed
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      this.setVisible(false);
    }
  }

  void bClose_actionPerformed(ActionEvent e) {
   this.setVisible(false);
  }

  void jList1_mouseClicked(MouseEvent e) {

     String sel = (String) jList1.getSelectedValue();
     String selPath = Folder_name_txt + File.separator + sel;
     try {
        InputStream fileIn = new FileInputStream(selPath);
        byte buff[] = new byte [fileIn.available()];
        int i = fileIn.read(buff);
        fileIn.close();
        jTextArea1.setText(new String(buff));
       }
     catch(FileNotFoundException ex) {}
     catch(IOException ex) {}
  }

  void jButton1_actionPerformed(ActionEvent e) {

    //************************************************
    //     New experimental code
    //  Oleg said that I have to use old code (Simple FileChooser)
    //************************************************
/*
    dsSelFilesDlg mSelFilesDlg = new dsSelFilesDlg(Dir, this, true);
    mSelFilesDlg.setVisible(true);
    long size = 0;  //size of selected in bytes
    if (mSelFilesDlg.isOk()){
      Vector selFiles = mSelFilesDlg.getAllSelectedFiles();
      FileList.clear();

      for (int i = 0; i < selFiles.size(); i++) {
        FileList.add( ( (File) selFiles.get(i)).getPath());
        size = size + ( (File) selFiles.get(i)).length();
      }

      Dir = mSelFilesDlg.getCurrentDir();
      this.jlSelFiles.setText(labels.getString("SelectedFiles")
                              +" " + selFiles.size());
    }
*/
    //**************************************
    //  Old code
    //*************************************


       JFileChooser jFileChooser1 = new JFileChooser();
        jFileChooser1.setMultiSelectionEnabled(true);
        File selFiles [];
        //this.Dir = new File(Folder_name);
        jFileChooser1.setCurrentDirectory(this.Dir);

        if (JFileChooser.APPROVE_OPTION == jFileChooser1.showDialog(this, labels.getString("SelectDlgTitle"))) {
          selFiles = jFileChooser1.getSelectedFiles();
          this.Dir = jFileChooser1.getCurrentDirectory();
          //System.out.println("New DIR : "+ this.Dir.getPath());
          mUser.setDcmDirPath(this.Dir.getPath());
          //flash is not necessary

          FileList.clear();
          for (int i=0; i<selFiles.length; i++) {
            FileList.add(selFiles[i].getPath());
          }
          this.jlSelFiles.setText(labels.getString("SelectedFiles") +" " + selFiles.length);
        }
  }

  void bSendToServer_actionPerformed(ActionEvent e) {
//FileList - selected files vector
   if (this.FileList.size()>0){
      dsSelDCMSrvDlg dlg = new dsSelDCMSrvDlg(this, true, mDCMServers);

      dlg.setVisible(true);
      if (dlg.isOk()) {

        showStatusDlg();
        dsDcmServerClass srv = dlg.getSelectedServer();
        dsDCM_sender sender_thread = new dsDCM_sender(mUser,
                                                      this.jcbDelAfterSend.isSelected(),
                                                      srv,
                                                      //this,
                                                      mStatusDlg,
                                                      FileList);
        sender_thread.start();

        //this.FileList.clear();
        this.jlSelFiles.setText(labels.getString("SelectedFiles") + " 0");
      }
    }else{
      JOptionPane.showMessageDialog(this, labels.getString("NoSelection"), labels.getString("DICOMMessageBoxTitle"), 1);
    }


   }
//***** Implementation of IGuiWithFolderChecker ******************************
   public void UpdateFiles(Vector vFiles, String sFolder)
  {
    //Update file number
    fillTxtList();
  }
//------------------------------------------------------------------------
//***** Implementation of IProcessOwner *****************************************
  public void ProcessProgress(int i, int n){
    jlFilesSent.setText(labels.getString("FilesSent") +" " + (i+1));
    int progress = (int) 100.0*(i+1)/n;
    this.jpbSendProgress.setValue(progress);
    if (jpbSendProgress.getGraphics()!=null){
      jpbSendProgress.update(jpbSendProgress.getGraphics());
    }
//    this.update(this.getGraphics());
  }
  //----------------------------------------------------------
   public void ProcessFinished(int size, String msg)
   {
    this.jpbSendProgress.setValue(0);
    this.FileList.clear();
    this.jlSelFiles.setText(labels.getString("SelectedFiles")+" 0");
    if (size>0)
      jlFilesSent.setText(labels.getString("FilesFailed")+" " + size);
   }
//******************************************************************************
//--------------------------------------------------------------

  public void setDCMServers(Vector vDCMServers){
    mDCMServers = vDCMServers;
  }

  //------------------------------------------------------------------------
  private void fillTxtList(){
    File Dir_txt = new File(Folder_name_txt);

    TextFileList.clear();
    if (Dir_txt.list() != null){
        //Scan folder for files ...
        for (int i=0; i<Dir_txt.list().length; i++)
        {
         if (Dir_txt.listFiles()[i].isFile())
              {

                if (Dir_txt.list()[i].endsWith(".txt"))
                TextFileList.add(Dir_txt.list()[i]);
              }
        }
        jList1.setListData(TextFileList);
        if (jList1.getFirstVisibleIndex()>-1)
            {
                jList1.setSelectedIndex(0);
                jList1_mouseClicked(null);
            }
     }
  }

  //-------------------------------------------------------------------------
}
