package dbridge;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import dbridge.dbUser;
//import dbridge.dbMailTable;
//import dbridge.dbMailRecord;
import javax.swing.border.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

 // * Modified 17.08.04
 // * Modified 01.11.04 BOB

//----------------------------------------------------------------------------


public class dsUserInfoFrame
    extends JFrame
    implements IGuiWithFolderChecker {

  JPanel jPanel1 = new JPanel();
  JPanel jPanel2 = new JPanel();

  JLabel jLabel3 = new JLabel();

  TitledBorder titledBorder1;
  TitledBorder titledBorder2;

  JButton bSendByEmail = new JButton();
  JButton bSendToServer = new JButton();

  Box box1;
  JLabel jLabel4 = new JLabel();
  JCheckBox jcbAutoSend = new JCheckBox();
  BorderLayout borderLayout1 = new BorderLayout();

  Box box2;
  FlowLayout flowLayout1 = new FlowLayout();
  Box box3;
  FlowLayout flowLayout2 = new FlowLayout();

  JPanel jPanel3 = new JPanel();
  JButton jbClose = new JButton();
  JPanel jPanel4 = new JPanel();
  JButton bApp = new JButton();
  TitledBorder titledBorder3;
  FlowLayout flowLayout3 = new FlowLayout();
  Box box4;
  JCheckBox jcbExecute = new JCheckBox();

  private CFolderChecker mCheckExt;
  private CFolderChecker mCheckLoc;
  private CFolderChecker mCheckDecr;
  private CAppExecutorService mAppExecutor = null;
  private String msUserHome;

  //private dsUserDlg1Frame send_emailFrame;
  //private dsUserDlg2Frame send_servFrame;
  private dbUser mUser;
  private dbBank mBank;

  File Dir_loc, Dir_ext, Dir_decr;
  String num_files_loc, num_files_ext, num_files_decr;

  public dsUserInfoFrame(dbUser User_data, String root_dir, dbBank oBank) {
    try {
      mUser = User_data;
      if (root_dir == null || root_dir == "") {
        JOptionPane.showMessageDialog(this,
                                      "The root dir is not specified, please contact administrator!");
        return;
      }

      mBank = oBank;
      //---- Verify user folders-----------
      //   num_files_loc=0;
      //  num_files_ext=0;
      // Local folder name
      // String Loc_folder = root_dir + "\\" + User_data.getLogin() + "_Loc";
      String Loc_folder = User_data.getLocDirPath();
      //Ext Folder
      // String Ext_folder = root_dir + "\\" + User_data.getLogin()  + "_Ext";
      String Ext_folder = User_data.getExtDirPath();
      String Decr_folder = User_data.getDecryptedDirPath();

      Dir_loc = new File(Loc_folder);
      Dir_ext = new File(Ext_folder);
      Dir_decr = new File(Decr_folder);

      if (!Dir_loc.exists() || !Dir_ext.exists() || !Dir_decr.exists()) {
        JOptionPane.showMessageDialog(this,
                                      "Error: User folder does not exist!");
        return;
      }

      num_files_loc = Integer.toString(0);
      num_files_ext = Integer.toString(0);
      num_files_decr = Integer.toString(0);
      //num_files_loc = Integer.toString(Dir_loc.list().length);
      //num_files_ext = Integer.toString(Dir_ext.list().length);

      //---- Create Send by email User Dialog ---------------
      // Get user address book
      /*
           Vector emails = new Vector();
           for (int i=0; i<User_data.getAddressBook().getSize(); i++)
           {
        emails.add(User_data.getAddressBook().getRecord(i).getMail());
           }

           String From = new String();
           if (User_data.getMailTable().getSize()>0)
        From = User_data.getMailTable().getRecord(0).getMail();
           else {
          JOptionPane.showMessageDialog(this,
          "You have no From address, please contact your administrator!");
          return;
           }*/

      mCheckExt = new CGuiFolderChecker(Dir_ext.getAbsolutePath(), this);
      mCheckExt.StartChecking(10);
      mCheckDecr = new CGuiFolderChecker(Dir_decr.getAbsolutePath(), this);
      mCheckDecr.StartChecking(10);
      mCheckLoc = new CGuiFolderChecker(Dir_loc.getAbsolutePath(), this);
      mCheckLoc.StartChecking(10);

      //Create AppExecutor service for this user
      //
      // Read the XML file first
      //
      dsXMLAppTable m_TableIO = new dsXMLAppTable();

      msUserHome = new String(mBank.getBox().getTmpDir() + File.separator +
                              mUser.getLogin() + File.separator +
                              "applications.xml");
      Vector mTableData = m_TableIO.ReadTableData(msUserHome);

      mAppExecutor = new CAppExecutorService(mTableData);

      //Init the GUI data
      jbInit();
      if (mUser.getAutoDCMSendFlag()) {
        jcbAutoSend.setSelected(true);
      }
      else {
        jcbAutoSend.setSelected(false);
      }
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  //===========================================================================
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      //Change for final version
      this.setVisible(false);
    }
  }

  //===========================================================================

  private void jbInit() throws Exception {
    box1 = Box.createVerticalBox();
    titledBorder1 = new TitledBorder(BorderFactory.createEtchedBorder
                                     (new Color(240, 217, 205),
                                      new Color(117, 106, 100)),
                                     "Files from DICOM server");

    titledBorder2 = new TitledBorder(BorderFactory.createEtchedBorder
                                     (new Color(240, 217, 205),
                                      new Color(117, 106, 100)),
                                     "Files from E-MAIL");

    box2 = Box.createVerticalBox();
    box3 = Box.createVerticalBox();

    titledBorder3 = new TitledBorder(BorderFactory.createEtchedBorder(new Color(
        240, 217, 205), new Color(117, 106, 100)), "Applications for files");
    box4 = Box.createVerticalBox();
    this.getContentPane().setLayout(borderLayout1);
    this.setSize(new Dimension(282, 423));
    this.setTitle("User Tools " + "Login: " + mUser.getLogin());
    this.addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosed(WindowEvent e) {
        this_windowClosed(e);
      }
    });
    jPanel1.setBorder(titledBorder1);
    jPanel1.setMinimumSize(new Dimension(100, 50));
    jPanel1.setPreferredSize(new Dimension(100, 80));
    jPanel1.setLayout(flowLayout1);
    jLabel3.setMaximumSize(new Dimension(150, 30));
    jLabel3.setMinimumSize(new Dimension(150, 30));
    jLabel3.setPreferredSize(new Dimension(150, 30));
    jLabel3.setText("You have: " + num_files_loc + " files ");
    bSendByEmail.setMaximumSize(new Dimension(120, 30));
    bSendByEmail.setMinimumSize(new Dimension(120, 30));
    bSendByEmail.setPreferredSize(new Dimension(120, 30));
    bSendByEmail.setText("Send by Email ...");
    bSendByEmail.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        bSendByEmail_actionPerformed(e);
      }
    });
    jLabel4.setMaximumSize(new Dimension(180, 30));
    jLabel4.setMinimumSize(new Dimension(180, 30));
    jLabel4.setPreferredSize(new Dimension(180, 30));
    jLabel4.setText("You have: " + num_files_ext + " files ");
    bSendToServer.setMaximumSize(new Dimension(180, 30));
    bSendToServer.setMinimumSize(new Dimension(180, 30));
    bSendToServer.setPreferredSize(new Dimension(180, 30));
    bSendToServer.setText("Send to DICOM Server ...");
    bSendToServer.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        bSendToServer_actionPerformed(e);
      }
    });
    jcbAutoSend.setMaximumSize(new Dimension(180, 30));
    jcbAutoSend.setMinimumSize(new Dimension(180, 30));
    jcbAutoSend.setPreferredSize(new Dimension(180, 30));
    jcbAutoSend.setText("Auto Send to server");
    jcbAutoSend.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jcbAutoSend_actionPerformed(e);
      }
    });
    jPanel2.setBorder(titledBorder2);
    jPanel2.setMinimumSize(new Dimension(100, 100));
    jPanel2.setPreferredSize(new Dimension(100, 100));
    jPanel2.setLayout(flowLayout2);
    flowLayout1.setAlignment(FlowLayout.LEFT);
    flowLayout2.setAlignment(FlowLayout.LEFT);
    flowLayout2.setVgap(0);
    jbClose.setText("Exit");
    jbClose.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbClose_actionPerformed(e);
      }
    });
    jPanel3.setBorder(BorderFactory.createEtchedBorder());
    bApp.setText("Define ...");
    bApp.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        bApp_actionPerformed(e);
      }
    });
    jPanel4.setBorder(titledBorder3);
    jPanel4.setMinimumSize(new Dimension(95, 100));
    jPanel4.setPreferredSize(new Dimension(95, 100));
    jPanel4.setLayout(flowLayout3);
    flowLayout3.setAlignment(FlowLayout.LEFT);
    flowLayout3.setHgap(5);
    flowLayout3.setVgap(0);
    jcbExecute.setText("Auto Execute Applications");
    jcbExecute.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jcbExecute_actionPerformed(e);
      }
    });
    jbExplore.setText("Explore Wait folder ...");
    jbExplore.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jbExplore_actionPerformed(e);
      }
    });
    box2.add(jLabel3, null);
    box2.add(bSendByEmail, null);
    box1.add(jPanel1, null);
    jPanel1.add(box2, null);
    box1.add(jPanel2, null);
    jPanel2.add(box3, null);
    box3.add(jLabel4, null);
    box3.add(bSendToServer, null);
    box3.add(jcbAutoSend, null);
    box1.add(jPanel4, null);
    box4.add(jPanel5, null);
    jPanel5.add(bApp, null);
    jPanel5.add(jbExplore, null);
    jPanel4.add(box4, null);
    this.getContentPane().add(jPanel3, BorderLayout.SOUTH);
    jPanel3.add(jbClose, null);
    this.getContentPane().add(box1, BorderLayout.CENTER);
    box4.add(jPanel6, null);
    jPanel6.add(jcbExecute, null);
  }

  void bSendByEmail_actionPerformed(ActionEvent e) {

    dsUserDlg1Frame send_emailFrame = new dsUserDlg1Frame("send by EMAIL", mUser);
    send_emailFrame.validate();
    send_emailFrame.setVisible(true);
  }

  void bSendToServer_actionPerformed(ActionEvent e) {
    // if (this.ChkPass()){
    if (jcbAutoSend.isSelected()) {
      jcbAutoSend.setSelected(false);

//        if (BridgeApp.Services().IsAutoDicomSend(mUser))
//          BridgeApp.Services().StopAutoDicomSend(mUser);

      mUser.setAutoDCMSendFlag(false);
      mBank.flush(); //!!!!!

      int index = DBridgeClient.Bank().getUserContainer().getUserIndex(mUser);
      DBridgeClient.sendRequest("DBSTOPAUTODCMSEND$" + Integer.toString(index));

    }
    //---- Create Send To DCM Server DLG --------------
    dsUserDlg2Frame send_servFrame = new dsUserDlg2Frame("Send to DICOM", mUser);
    send_servFrame.setDCMServers(mBank.getDcmServerList());

    send_servFrame.validate();
    send_servFrame.setVisible(true);
    //}
  }

  void this_windowClosed(WindowEvent e) {
    //System.exit(0);
    this.setVisible(false);
  }

  public void UpdateFiles(Vector vFiles, String sFolder) {

    if (sFolder.compareTo(Dir_loc.getAbsolutePath()) == 0) {
      num_files_loc = Integer.toString(vFiles.size());
      jLabel3.setText("You have: " + num_files_loc + " files ");
      //     send_emailFrame.UpdateFiles(vFiles, sFolder);
    }

    else if (sFolder.compareTo(Dir_decr.getAbsolutePath()) == 0) {
      num_files_decr = Integer.toString(vFiles.size());
      jLabel4.setText("You have: " + num_files_decr + " files ");
//      send_servFrame.UpdateFiles(vFiles, sFolder);
    }
    //BridgeApp.LogError(new CLogMsg("client","Updating files() in folder " + sFolder));
  }

  //TEMP FUNCTION have to be in constructor
  void setBank(dbBank oBank) {
    mBank = oBank;
  }

  void jcbAutoSend_actionPerformed(ActionEvent e) {
    if (jcbAutoSend.isSelected()) {
      //this.ChkPass();
      dsSelDCMSrvDlg dlg = new dsSelDCMSrvDlg(this, true,
                                              mBank.getDcmServerList());
      dlg.setVisible(true);
      if (dlg.isOk()) {
        dsDcmServerClass srv = dlg.getSelectedServer();
        mUser.setDefDCMsrv(srv);
        //BridgeApp.Services().StartAutoDicomSend(mUser);
        mUser.setAutoDCMSendFlag(true);
        mBank.flush(); //!!!!!
        int index = DBridgeClient.Bank().getUserContainer().getUserIndex(mUser);
        DBridgeClient.sendRequest("DBSTARTAUTODCMSEND$" +
                                  Integer.toString(index));
      }
      else {
        jcbAutoSend.setSelected(false);
      }
    }
    else {
      mUser.setAutoDCMSendFlag(false);
      mBank.flush(); //!!!!!
      //BridgeApp.Services().StopAutoDicomSend(mUser);
      int index = DBridgeClient.Bank().getUserContainer().getUserIndex(mUser);
      DBridgeClient.sendRequest("DBSTOPAUTODCMSEND$" + Integer.toString(index));
    }
  }

//--------------------------------------------------------------------------
  void jbClose_actionPerformed(ActionEvent e) {
    this.setVisible(false);
    this.invalidate();
  }

  void bApp_actionPerformed(ActionEvent e) {
    dsAppChooserDlg mDlg = new dsAppChooserDlg("App chooser", this, true);
    mDlg.setFilename(msUserHome);
    mDlg.setVisible(true);
    if (mDlg.isOk()) {
      dsXMLAppTable m_TableIO = new dsXMLAppTable();
      Vector mTableData = m_TableIO.ReadTableData(msUserHome);
      mAppExecutor.setNewData(mTableData);
      if (mAppExecutor.HasUserTask(mUser)) {
        mAppExecutor.RemoveUserTask(mUser);
        mAppExecutor.AddUserTask(mUser);
      }
    }
  }

  //--------------------------------------------------------------------------

  void jcbExecute_actionPerformed(ActionEvent e) {
    if (jcbExecute.isSelected()) {
      if (mAppExecutor != null) {
        if (!mAppExecutor.HasUserTask(mUser)) {
         mAppExecutor.AddUserTask(mUser);
        }
      }
    }
    else {
      if (mAppExecutor != null) {
        if (mAppExecutor.HasUserTask(mUser)) {
          mAppExecutor.Terminate();
          mAppExecutor.RemoveUserTask(mUser);
        }
      }
    }
  }

  JPanel jPanel5 = new JPanel();
  JButton jbExplore = new JButton();
  JPanel jPanel6 = new JPanel();

  void jbExplore_actionPerformed(ActionEvent e) {
    JFileChooser jFileChooser1 = new JFileChooser();
    jFileChooser1.setCurrentDirectory(new File(mUser.getWaitDirPath()));
    jFileChooser1.setMultiSelectionEnabled(false);

    if (JFileChooser.APPROVE_OPTION == jFileChooser1.showDialog(this, "Select")) {
      //Execute the selected file if ext supported
      File f_sel = jFileChooser1.getSelectedFile();
      dsXMLAppTable m_TableIO = new dsXMLAppTable();
      Vector mTableData = m_TableIO.ReadTableData(msUserHome);
      /*CAppExecutor mFilesProcessor = new CAppExecutor(mTableData, mUser);
      Vector v_files = new Vector();
      v_files.add(f_sel.getPath());
      mFilesProcessor.ProcessFiles(v_files);
      if (mFilesProcessor.isUnsupportedFile()) {
        JOptionPane.showMessageDialog(this,
                                      "Please define the application for this file",
                                      "Unsupported file type!",
                                      JOptionPane.ERROR_MESSAGE);
      }
*/
    AppFileProcessor mProcessor = new AppFileProcessor(mTableData, mUser);
    mProcessor.processFile(f_sel.getPath());
    }

  }

}
