package dbridge;

import javax.swing.*;
import javax.swing.border.*;
import java.awt.*;
import java.util.*;
import java.io.*;
import java.awt.event.*;


import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreeSelectionModel;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;


/**
 * <p>Title: dsUserInfoTree</p>
 * <p>Description: Manual User interface main class</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Dzmitry Stsepankou
 * @version 1.0
 */

  //01.10.2004 Created by BOB

public class dsUserInfoTree extends JFrame implements TreeSelectionListener, IGuiWithFolderChecker{

  JPanel jPanel1 = new JPanel();
  JPanel jPanel2 = new JPanel();
  JScrollPane jScrollPane1 = new JScrollPane();
  JScrollPane jScrollPane2 = new JScrollPane();
  BorderLayout borderLayout1 = new BorderLayout();

  JTree jTree1 = null;
  BorderLayout borderLayout2 = new BorderLayout();

  ResourceBundle lbls;
  ResourceBundle lbls_gen;

  JPanel jPanel3 = new JPanel();
  JButton jbHelp = new JButton();
  JButton jbOk = new JButton();

  private CFolderChecker mCheckExt;
  private CFolderChecker mCheckLoc;
  private CFolderChecker mCheckDecr;
  private CAppExecutorService mAppExecutor = null;
  private String msUserHome;
  private String msRootDir;

  private dbUser mUser;

  //GUI components
  private dsUserGeneralInfo mInfoPanel = null;
  private dsUserDlg1Frame mEmailSendFrame = null;
  private dsUserDlg2Frame mDCMSendFrame = null;
  private dsAppChooserDlg mAppChooserDlg = null;


  File Dir_loc, Dir_ext, Dir_decr;
  String num_files_loc, num_files_ext, num_files_decr;


  //========================================================
  private class dsUserGeneralInfo extends JPanel{

    Box box1;

    JPanel jpUser = new JPanel();
    JPanel jpEmail = new JPanel();
    JPanel jpDCM = new JPanel();
    JPanel jpAutoOptions = new JPanel();

    TitledBorder tbEmail;
    TitledBorder tbDCM;
    TitledBorder tbAutoOptions;

    JLabel jlEmail_files = new JLabel();
    JLabel jlDcm_files = new JLabel();
    JLabel jlUserName = new JLabel();
    JLabel jlUser = new JLabel();

    Box box2;
    JCheckBox jcbAutoSend = new JCheckBox();
    JCheckBox jcbAutoExecute = new JCheckBox();
    JPanel jpDCMServers = new JPanel();
    // comment if debug GUI
    JComboBox jcbDCMServers = new JComboBox(DBridgeClient.Bank().getDcmServerList());
    //JComboBox jcbDCMServers = new JComboBox();

    JButton jbExploreWait = new JButton();

    private String sTitle = null;

    public dsUserGeneralInfo(String title){
         sTitle = title;
         String sUserName = mUser.getName();

         // comment if debug GUI
         Locale currentLocale = BridgeApp.getCurrentLocale();
         //Locale currentLocale = new Locale("en");
         ResourceBundle labels = ResourceBundle.getBundle("dbridge.prop.dsUserGenInfoPanelBundle",currentLocale);
         lbls_gen = labels;

         box1 = Box.createVerticalBox();
         tbEmail = new TitledBorder(BorderFactory.createEtchedBorder
                                          (new Color(240, 217, 205),
                                           new Color(117, 106, 100)),
                                          labels.getString("EMAILfiles"));

         tbDCM = new TitledBorder(BorderFactory.createEtchedBorder
                                          (new Color(240, 217, 205),
                                           new Color(117, 106, 100)),
                                          labels.getString("DCMfilesTitle"));

         tbAutoOptions = new TitledBorder(BorderFactory.createEtchedBorder
                                          (new Color(240, 217, 205),
                                           new Color(117, 106, 100)),
                                          labels.getString("OptionsTitle"));

         jlUser.setText(labels.getString("UserName"));
         jlUser.setText(jlUser.getText() + " " + sUserName);
         jpUser.setBorder(BorderFactory.createLoweredBevelBorder());
         jpUser.add(jlUser);
         box1.add(jpUser);

         jpDCM.setBorder(tbDCM);
         jlDcm_files.setText(labels.getString("HaveFiles"));
         jpDCM.add(jlDcm_files);
         box1.add(jpDCM);

         jpEmail.setBorder(tbEmail);
         jlEmail_files.setText(labels.getString("HaveFiles"));
         jpEmail.add(jlEmail_files);
         box1.add(jpEmail);

         box2 = Box.createVerticalBox();
         jpAutoOptions.setBorder(tbAutoOptions);

         jcbAutoSend.addActionListener(new java.awt.event.ActionListener() {
           public void actionPerformed(ActionEvent e) {
             jcbAutoSend_actionPerformed(e);
           }
         });
         jcbAutoSend.setText(labels.getString("cbAutoDCMSend"));
         jcbAutoExecute.setText(labels.getString("cdAutoOpen"));
         jcbAutoExecute.addActionListener(new java.awt.event.ActionListener() {
          public void actionPerformed(ActionEvent e) {
            jcbAutoExecute_actionPerformed(e);
          }
        });



         jbExploreWait.setText(labels.getString("bExplore"));

         //jpDCMServers.add(new JLabel("      "));
         jpDCMServers.add(jcbDCMServers);
         jcbDCMServers.addActionListener(new java.awt.event.ActionListener() {
           public void actionPerformed(ActionEvent e) {
             jcbDCMServers_actionPerformed(e);
           }
         });


         box2.add(jcbAutoSend);
         box2.add(jpDCMServers);
         box2.add(jcbAutoExecute);
         box2.add(jbExploreWait);
         jbExploreWait.addActionListener(new java.awt.event.ActionListener() {
           public void actionPerformed(ActionEvent e) {
             jbExploreWait_actionPerformed(e);
           }
         });

         jpAutoOptions.add(box2);
         box1.add(jpAutoOptions);

         this.add(box1);

         //
         // Auto DCM send stuff
         //
         if (mUser.getAutoDCMSendFlag()) {
           jcbAutoSend.setSelected(true);
         }
         else {
           jcbAutoSend.setSelected(false);
         }

         // comment if debug GUI
         jcbDCMServers.setSelectedItem(mUser.getDefDCMsrv());


    }

    //
    // Auto send files to DICOM server selected
    //
    void jcbAutoSend_actionPerformed(ActionEvent e){
      if (jcbAutoSend.isSelected()){
        //
        // Start auto send to DICOM
        //
        mUser.setAutoDCMSendFlag(true);
        //
        // QUESTION: Do I need to flush() Bank here?
        //

        int index = DBridgeClient.Bank().getUserContainer().getUserIndex(mUser);
        DBridgeClient.sendRequest("DBSTARTAUTODCMSEND$" +
                                  Integer.toString(index));


      }else{
        //
        // Stop Auto send to DICOM
        //
        mUser.setAutoDCMSendFlag(false);
        int index = DBridgeClient.Bank().getUserContainer().getUserIndex(mUser);
        DBridgeClient.sendRequest("DBSTOPAUTODCMSEND$" + Integer.toString(index));

      }
    }

    //
    // Auto open files check box selected
    //

    void jcbAutoExecute_actionPerformed(ActionEvent e){
      if (jcbAutoExecute.isSelected()){
        if (mAppExecutor != null) {
          if (!mAppExecutor.HasUserTask(mUser)) {
            mAppExecutor.AddUserTask(mUser);
          }
        }
      }else{
        if (mAppExecutor != null) {
          if (mAppExecutor.HasUserTask(mUser)) {
            mAppExecutor.Terminate();
            mAppExecutor.RemoveUserTask(mUser);
          }
        }
      }
    }


    //
    // Explore Wait folder
    //

    void jbExploreWait_actionPerformed(ActionEvent e){
      JFileChooser jFileChooser1 = new JFileChooser();
      jFileChooser1.setCurrentDirectory(new File(mUser.getWaitDirPath()));
      jFileChooser1.setMultiSelectionEnabled(false);

      if (JFileChooser.APPROVE_OPTION == jFileChooser1.showDialog(this, "Select")) {
        //Execute the selected file if ext supported
        File f_sel = jFileChooser1.getSelectedFile();
        dsXMLAppTable m_TableIO = new dsXMLAppTable();
        Vector mTableData = m_TableIO.ReadTableData(msUserHome);
        AppFileProcessor mProcessor = new AppFileProcessor(mTableData, mUser);
        mProcessor.processFile(f_sel.getPath());
      }

    }

    //
    //   Select Auto send DICOM server
    //

    void jcbDCMServers_actionPerformed(ActionEvent e){
      mUser.setDefDCMsrv((dsDcmServerClass) jcbDCMServers.getSelectedItem());
    }

    public String toString(){
      return sTitle;
    }
  }
  //========================================================================


  public dsUserInfoTree(dbUser User_data, String root_dir) throws HeadlessException {

    mUser = User_data;
    msRootDir =root_dir;

    try {
      // RELEASE
      Locale currentLocale = BridgeApp.getCurrentLocale();

      // DEBUG
      //Locale currentLocale = new Locale("en");

      lbls = ResourceBundle.getBundle("dbridge.prop.dsUserInfoFrameBundle",
                                      currentLocale);

      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void createNodes(DefaultMutableTreeNode top) {

   DefaultMutableTreeNode sendMail_node = null;
   DefaultMutableTreeNode sendDCM_node = null;
   DefaultMutableTreeNode autoOpen_node = null;

   sendMail_node = new DefaultMutableTreeNode(mEmailSendFrame);
   top.add(sendMail_node);

   sendDCM_node = new DefaultMutableTreeNode(mDCMSendFrame);
   top.add(sendDCM_node);

   autoOpen_node = new DefaultMutableTreeNode(mAppChooserDlg);
   top.add(autoOpen_node);
}

 public void valueChanged(TreeSelectionEvent e) {
   DefaultMutableTreeNode node = (DefaultMutableTreeNode)
                          jTree1.getLastSelectedPathComponent();

    if (node == null) return;

    Object nodeInfo = node.getUserObject();
     if ((nodeInfo.toString().compareTo(lbls.getString("Main")))==0){
        JPanel m_pan1 = (JPanel) nodeInfo;
        jScrollPane2.getViewport().removeAll();
        jScrollPane2.getViewport().add(m_pan1);
        jScrollPane2.getViewport().updateUI();
      }
      else if ( (nodeInfo.toString().compareTo(lbls.getString("sendEmail"))) == 0) {
        Container m_pan1 = ((JFrame) nodeInfo).getContentPane();
        jScrollPane2.getViewport().removeAll();
        jScrollPane2.getViewport().add(m_pan1);
        jScrollPane2.getViewport().updateUI();
      }
      else if ( (nodeInfo.toString().compareTo(lbls.getString("sendDICOM"))) == 0) {
        Container m_pan1 = ((JFrame) nodeInfo).getContentPane();
        jScrollPane2.getViewport().removeAll();
        jScrollPane2.getViewport().add(m_pan1);
        jScrollPane2.getViewport().updateUI();
      }
      else if ( (nodeInfo.toString().compareTo(lbls.getString("AutoExec"))) == 0) {
        Container m_pan1 = ((JDialog) nodeInfo).getContentPane();
        jScrollPane2.getViewport().removeAll();
        jScrollPane2.getViewport().add(m_pan1);
        jScrollPane2.getViewport().updateUI();
      }
      else
      {
          jScrollPane2.getViewport().removeAll();
          jScrollPane2.getViewport().updateUI();
      }


 }


  public static void main(String[] args) throws HeadlessException {
    dsUserInfoTree test1 = new dsUserInfoTree(new dbUser(), "");
    test1.setVisible(true);
  }


  private void jbInit() throws Exception {

    this.setSize(new Dimension(640, 480));
    this.setTitle(lbls.getString("FormTitle"));

    jPanel1.setBorder(BorderFactory.createEtchedBorder());
    jPanel1.setMinimumSize(new Dimension(200, 200));
    jPanel1.setPreferredSize(new Dimension(200, 200));
    jPanel1.setLayout(borderLayout1);
    jPanel2.setLayout(borderLayout2);
    jPanel2.setBorder(BorderFactory.createEtchedBorder());
    jPanel3.setBorder(BorderFactory.createEtchedBorder());
    jbHelp.setText(lbls.getString("bHelp"));
    jbOk.setText(lbls.getString("bClose"));
    jbOk.addActionListener(new dsUserInfoTree_jbOk_actionAdapter(this));
    this.getContentPane().add(jPanel1, BorderLayout.WEST);
    jPanel1.add(jScrollPane1, BorderLayout.CENTER);
    this.getContentPane().add(jPanel2,  BorderLayout.CENTER);
    jPanel2.add(jScrollPane2,  BorderLayout.CENTER);
    this.getContentPane().add(jPanel3,  BorderLayout.SOUTH);
    jPanel3.add(jbOk, null);
    jPanel3.add(jbHelp, null);

//Create AppExecutor service for this user
    dsXMLAppTable m_TableIO = new dsXMLAppTable();

    msUserHome = new String(DBridgeClient.Bank().getBox().getTmpDir() + File.separator +
                            mUser.getLogin() + File.separator +
                            "applications.xml");

    Vector mTableData = m_TableIO.ReadTableData(msUserHome);

    mAppExecutor = new CAppExecutorService(mTableData);


    //
    // Create tree components GUI
    //

    mInfoPanel = new dsUserGeneralInfo(lbls.getString("Main"));
    mEmailSendFrame = new dsUserDlg1Frame(lbls.
                                          getString("sendEmail"), mUser);
    mEmailSendFrame.setPanelMode();

    mDCMSendFrame = new dsUserDlg2Frame(lbls.
                                        getString("sendDICOM"), mUser);
    mDCMSendFrame.setDCMServers(DBridgeClient.Bank().getDcmServerList());
    mDCMSendFrame.setPanelMode();

    mAppChooserDlg = new dsAppChooserDlg(lbls.getString("AutoExec"), this, false);
    mAppChooserDlg.setPanelMode();
    mAppChooserDlg.setFilename(msUserHome);

    DefaultMutableTreeNode top = new DefaultMutableTreeNode(mInfoPanel);

    //
    // Assign the components GUI to the tree structure
    //
    this.createNodes(top);

    jTree1 = new JTree(top);
    jTree1.getSelectionModel().setSelectionMode
            (TreeSelectionModel.SINGLE_TREE_SELECTION);

        //Listen for when the selection changes.
        jTree1.addTreeSelectionListener(this);
        jTree1.setSelectionRow(0);

    jScrollPane1.getViewport().add(jTree1, null);

    if (msRootDir == null || msRootDir == "") {
      JOptionPane.showMessageDialog(this,
                                    lbls.getString("RootDirProblem"));
      return;
    }

    String Loc_folder = mUser.getLocDirPath();
    String Ext_folder = mUser.getExtDirPath();
    String Decr_folder = mUser.getDecryptedDirPath();

    Dir_loc = new File(Loc_folder);
    Dir_ext = new File(Ext_folder);
    Dir_decr = new File(Decr_folder);

    if (!Dir_loc.exists() || !Dir_ext.exists() || !Dir_decr.exists()) {
      JOptionPane.showMessageDialog(this,
                                    lbls.getString("UserDirProblem"));
      return;
    }

    num_files_loc = Integer.toString(0);
    num_files_ext = Integer.toString(0);
    num_files_decr = Integer.toString(0);

    mCheckExt = new CGuiFolderChecker(Dir_ext.getAbsolutePath(), this);
    mCheckExt.StartChecking(10);
    mCheckDecr = new CGuiFolderChecker(Dir_decr.getAbsolutePath(), this);
    mCheckDecr.StartChecking(10);
    mCheckLoc = new CGuiFolderChecker(Dir_loc.getAbsolutePath(), this);
    mCheckLoc.StartChecking(10);

}
  //------------------------------------------------------------------------

  protected void processWindowEvent(WindowEvent e) {
  super.processWindowEvent(e);
  if (e.getID() == WindowEvent.WINDOW_CLOSING) {
    //Change for final version
    this.setVisible(false);
  }
}
//------------------------------------------------------------------------

public void UpdateFiles(Vector vFiles, String sFolder) {
  if (sFolder.compareTo(Dir_loc.getAbsolutePath()) == 0) {
    num_files_loc = Integer.toString(vFiles.size());
    this.mInfoPanel.jlDcm_files.setText(lbls_gen.getString("HaveFiles") + " " +
                                        num_files_loc);
  }

  else if (sFolder.compareTo(Dir_decr.getAbsolutePath()) == 0) {
    num_files_decr = Integer.toString(vFiles.size());
    this.mInfoPanel.jlEmail_files.setText(lbls_gen.getString("HaveFiles") +
                                          " " +
                                          num_files_decr);
  }

}

  void jbOk_actionPerformed(ActionEvent e) {
    this.setVisible(false);
    this.invalidate();
  }

}

class dsUserInfoTree_jbOk_actionAdapter implements java.awt.event.ActionListener {
  dsUserInfoTree adaptee;

  dsUserInfoTree_jbOk_actionAdapter(dsUserInfoTree adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.jbOk_actionPerformed(e);
  }
}
