package dbridge;

/**
 * <p>Title: DicomBridge</p>
 * <p>Description: Transfer  Images over e-mail</p>
 * <p>Copyright: Copyright (c) 2003</p>
 * <p>Company: a</p>
 * @author unknown
 * @version 1.0
 *
 * This class is a reader of ini files. Key fields and values are stored
 * into Properties object.
 */

//import java.lang.*;
import java.io.*;
import java.util.*;

public class iniReader {
  Properties mProps;        // properties object
  String mPattern;          // concern symbols like " " to be removed from fields
  boolean mCleanByPattern;  // remove symbols if the value is true
  // constructor
  public iniReader() {
    mProps=new Properties();
    mPattern = "\"";  // remove " by default
    mCleanByPattern = true; // permit the delete
  }

  // Set/Get methods
  public void setCleanByPattern(boolean on){
    mCleanByPattern = on;
  }
  public boolean getCleanByPattern(){
    return mCleanByPattern;
  }
  public void setPattern(String pattern){
    mPattern = new String (pattern);
  }
  public String getPattern(){
    return mPattern;
  }

    // Get all properties
    public Properties getProperies(){
      return mProps;
    };
    // Get field value. If does not exists, take default value "val"
    public String getField(String key, String val){
      return mProps.getProperty(key,val);
    };
    // Get field value
    public String getField(String key){
      System.out.println("Key = " + key);
      String str=mProps.getProperty(key);
      System.out.print(mProps);
      System.out.println(str);
      return mProps.getProperty(key);
    };
    // Read file and extract properies
    public int readFile(String filename){
      BufferedReader inifile=null;
      String buf=null;
      String section=null;
      String var=null;
      String v=null;

      if (filename.length()==0 ){
        System.out.println("Error: wrong file name");
        return 0;
      }

      // open file
      try {
        inifile = new BufferedReader(new InputStreamReader(new FileInputStream(filename)));
      } catch(FileNotFoundException e){
          System.out.println("Error: file is not found");
          return 0;
      }

      // read first line
      boolean done=false;
      int pos;
      try{
        buf=inifile.readLine();
      } catch(IOException e){
        done=true;
      }
      // line analysis
      while (!done && buf!=null){
        // section
        if ( buf.startsWith("[")){
          section=buf.substring(1,buf.lastIndexOf("]"));
        } else{
          // data
          if ( !buf.startsWith(";") && !buf.startsWith("#") ){
            // delimiters are "=", ",", " "
            StringTokenizer token=new StringTokenizer(buf,"=, ");

            pos=buf.indexOf("=");
            if ( pos>0 ){ // indicates existance of "="
              var = new String(section + "." + token.nextToken() );
              // a string after "="
              v = new String(token.nextToken());
              int n=1;
              int m=0;
              if ( nQuotation(v)%2 == n ){// quotation is not correct
                m=1;
                String val = new String(token.nextToken());
                while ( val!=null ){
                  if ( nQuotation(val) % 2 != n ){
                      v = v + " " + val;
                      if ( token.hasMoreTokens()) {
                        val =  new String(token.nextToken());
                      } else {
                        val=null;
                      }
                  } else {
                      v = v + " " + val;
                      m=(m+1)%2;
                      val=null;
                  }

                }// end while
                if ( m==1 ) v=v+mPattern;
              }

              if ( mCleanByPattern ) v=deleteChars(v);
              mProps.setProperty(var,v);
            }// end if
          }// end if
        }// end else
        // read next line
        try{
          buf=inifile.readLine();
        } catch(IOException e){
           done=true;
        }
      }// end while
      return 1;
  }// end readFile

  // calculate a number how many times the pattern is included into the token
  private int nQuotation(String token){
     int pos=token.indexOf(mPattern);
     int res=0;
     while ( pos >=0 ){
       res++;
       pos++;                         // count all quotation symbols
       pos=token.indexOf(mPattern, pos);
     }
     return res;
  }
/*
 * Remove special symbols (ex. "\"") that can be not recognizer correctly by an
 * operation system
 */
  private String deleteChars(String buf){
    StringTokenizer token=new StringTokenizer(buf,mPattern);
    String v = new String(token.nextToken());
    if ( token.hasMoreTokens()) {
      String val = new String(token.nextToken());
      while ( val!=null ){
        v = v + val;
        if ( token.hasMoreTokens()) val = new String(token.nextToken());
        else val=null;
      }
    }
    return v;
  }

  // Debug
  public static void main(String[] args) {
    iniReader iniReader1 = new iniReader();
    System.out.println(" read file ...");
    int res=iniReader1.readFile("DBridge.ini");
    if ( res==0 ){
     System.out.print("Error: ini file is bad or missed");
    } else {
      String id,val;
      id=iniReader1.getField("COMMON.Id");
      System.out.println(id);
      val="0";
      id=iniReader1.getField("GPG.Path",val);
      System.out.println(id);
      System.out.println(val);
      //System.out.println("New string ="+iniReader1.deleteChars(id));
    }
  }// end main
}
